/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/network","vs/base/common/async","electron","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/resources","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/errors","vs/base/common/strings","vs/base/common/buffer","fs","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/base/common/uuid","vs/platform/workspaces/common/workspaces","vs/base/common/extpath","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/base/parts/ipc/common/ipc","vs/base/common/arrays","vs/base/common/process","vs/base/common/map","vs/platform/registry/common/platform","vs/platform/state/node/state","vs/base/common/labels","vs/platform/request/common/request","vs/platform/update/common/update","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","child_process","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/node/argvHelper","vs/platform/protocol/electron-main/protocol","vs/platform/remote/common/tunnel","vs/base/parts/ipc/node/ipc.net","vs/base/common/keyCodes","vs/base/common/stream","crypto","net","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/common/errorMessage","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/environment/node/shellEnv","vs/platform/instantiation/common/serviceCollection","vs/platform/remote/common/remoteHosts","vs/platform/sign/common/sign","vs/platform/theme/electron-main/themeMainService","vs/platform/webview/common/resourceLoader","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/common/scanCode","vs/base/common/hash","vs/base/common/glob","vs/base/node/decoder","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/io","vs/platform/files/node/watcher/watcher","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/product/common/product","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetryUtils","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/keybindingParser","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/node/crypto","vs/base/node/macAddress","vs/base/node/extpath","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/mimeTypes","vs/platform/webview/common/webviewManagerService","vs/platform/webview/common/webviewPortMapping","vs/platform/webview/electron-main/webviewPortMappingProvider","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/backup/electron-main/backupMainService","vs/code/electron-main/auth","vs/platform/driver/electron-main/driver","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.snap","vs/platform/update/electron-main/updateService.win32","vs/platform/issue/electron-main/issueMainService","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","stream","vs/code/electron-main/main"],Q=function(j){for(var e=[],v=0,R=j.length;v<R;v++)e[v]=X[j[v]];return e};define(X[100],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=v}),define(X[52],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createMemoizer=e.createDecorator=void 0;function v(y){return(i,L,g)=>{let E=null,w=null;if(typeof g.value=="function"?(E="value",w=g.value):typeof g.get=="function"&&(E="get",w=g.get),!w)throw new Error("not supported");g[E]=y(w,L)}}e.createDecorator=v;let R=0;function D(){const y=`$memoize${R++}`;let i;const L=function(E,w,d){let m=null,b=null;if(typeof d.value=="function"?(m="value",b=d.value,b.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(m="get",b=d.get),!b)throw new Error("not supported");const p=`${y}:${w}`;d[m]=function(...a){return i=this,this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!0,enumerable:!1,writable:!0,value:b.apply(this,a)}),this[p]}};return L.clear=()=>{typeof i!="undefined"&&Object.getOwnPropertyNames(i).forEach(g=>{g.indexOf(y)===0&&delete i[g]})},L}e.createMemoizer=D;function S(y,i,L){return D()(y,i,L)}e.memoize=S;function k(y,i,L){return v((g,E)=>{const w=`$debounce$${E}`,d=`$debounce$result$${E}`;return function(...m){this[d]||(this[d]=L?L():void 0),clearTimeout(this[w]),i&&(this[d]=i(this[d],...m),m=[this[d]]),this[w]=setTimeout(()=>{g.apply(this,m),this[d]=L?L():void 0},y)}})}e.debounce=k;function n(y,i,L){return v((g,E)=>{const w=`$throttle$timer$${E}`,d=`$throttle$result$${E}`,m=`$throttle$lastRun$${E}`,b=`$throttle$pending$${E}`;return function(...p){if(this[d]||(this[d]=L?L():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),i&&(this[d]=i(this[d],...p)),!this[b]){const a=this[m]+y;a<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[d]]),this[d]=L?L():void 0):(this[b]=!0,this[w]=setTimeout(()=>{this[b]=!1,this[m]=Date.now(),g.apply(this,[this[d]]),this[d]=L?L():void 0},a-Date.now()))}}})}e.throttle=n}),define(X[19],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function R(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=R;function D(s){y(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=D;function S(s){y(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=S;function k(s){if(s instanceof Error){let{name:t,message:r}=s;const o=s.stacktrace||s.stack;return{$isError:!0,name:t,message:r,stack:o}}return s}e.transformErrorForSerialization=k;const n="Canceled";function y(s){return s instanceof Error&&s.name===n&&s.message===n}e.isPromiseCanceledError=y;class i extends Error{constructor(){super(n);this.name=this.message}}e.CancellationError=i;function L(){const s=new Error(n);return s.name=s.message,s}e.canceled=L;function g(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=g;function E(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=E;function w(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=w;function d(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function m(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=m;class b extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=b;class p extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=p;class a extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=a;function c(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=c;function l(s,t=Object.create(null)){const r=new Error(s);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=l}),define(X[34],Q([0,1,19]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(W,$=0){return W[W.length-(1+$)]}e.tail=R;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function S(W,$,C=(P,M)=>P===M){if(W===$)return!0;if(!W||!$||W.length!==$.length)return!1;for(let P=0,M=W.length;P<M;P++)if(!C(W[P],$[P]))return!1;return!0}e.equals=S;function k(W,$,C){let P=0,M=W.length-1;for(;P<=M;){const _=(P+M)/2|0,T=C(W[_],$);if(T<0)P=_+1;else if(T>0)M=_-1;else return _}return-(P+1)}e.binarySearch=k;function n(W,$){let C=0,P=W.length;if(P===0)return 0;for(;C<P;){const M=Math.floor((C+P)/2);$(W[M])?P=M:C=M+1}return C}e.findFirstInSorted=n;function y(W,$,C){if(W=W|0,W>=$.length)throw new TypeError("invalid index");let P=$[Math.floor($.length*Math.random())],M=[],_=[],T=[];for(let O of $){const B=C(O,P);B<0?M.push(O):B>0?_.push(O):T.push(O)}return W<M.length?y(W,M,C):W<M.length+T.length?T[0]:y(W-(M.length+T.length),_,C)}e.quickSelect=y;function i(W,$){const C=[];let P;for(const M of W.slice(0).sort($))!P||$(P[0],M)!==0?(P=[M],C.push(P)):P.push(M);return C}e.groupBy=i;function L(W,$,C){const P=[];function M(O,B,K){if(!(B===0&&K.length===0)){const G=P[P.length-1];G&&G.start+G.deleteCount===O?(G.deleteCount+=B,G.toInsert.push(...K)):P.push({start:O,deleteCount:B,toInsert:K})}}let _=0,T=0;for(;;){if(_===W.length){M(_,0,$.slice(T));break}if(T===$.length){M(_,W.length-_,[]);break}const O=W[_],B=$[T],K=C(O,B);K===0?(_+=1,T+=1):K<0?(M(_,1,[]),_+=1):K>0&&(M(_,0,[B]),T+=1)}return P}e.sortedDiff=L;function g(W,$,C){const P=L(W,$,C),M=[],_=[];for(const T of P)M.push(...W.slice(T.start,T.start+T.deleteCount)),_.push(...T.toInsert);return{removed:M,added:_}}e.delta=g;function E(W,$,C){if(C===0)return[];const P=W.slice(0,C).sort($);return d(W,$,P,C,W.length),P}e.top=E;function w(W,$,C,P,M){return C===0?Promise.resolve([]):new Promise((_,T)=>{(async()=>{const O=W.length,B=W.slice(0,C).sort($);for(let K=C,G=Math.min(C+P,O);K<O;K=G,G=Math.min(G+P,O)){if(K>C&&await new Promise(J=>setTimeout(J)),M&&M.isCancellationRequested)throw(0,v.canceled)();d(W,$,B,K,G)}return B})().then(_,T)})}e.topAsync=w;function d(W,$,C,P,M){for(const _=C.length;P<M;P++){const T=W[P];if($(T,C[_-1])<0){C.pop();const O=n(C,B=>$(T,B)<0);C.splice(O,0,T)}}}function m(W){return W.filter($=>!!$)}e.coalesce=m;function b(W){let $=0;for(let C=0;C<W.length;C++)W[C]&&(W[$]=W[C],$+=1);W.length=$}e.coalesceInPlace=b;function p(W,$,C){W.splice(C,0,W.splice($,1)[0])}e.move=p;function a(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=a;function c(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=c;function l(W,$){if(!$)return W.filter((P,M)=>W.indexOf(P)===M);const C=Object.create(null);return W.filter(P=>{const M=$(P);return C[M]?!1:(C[M]=!0,!0)})}e.distinct=l;function s(W){const $=new Set;return W.filter(C=>$.has(C)?!1:($.add(C),!0))}e.distinctES6=s;function t(W){const $=Object.create(null);return C=>{const P=W(C);return $[P]?!1:($[P]=!0,!0)}}e.uniqueFilter=t;function r(W,$){for(let C=W.length-1;C>=0;C--){const P=W[C];if($(P))return C}return-1}e.lastIndex=r;function o(W,$){return W.length>0?W[0]:$}e.firstOrDefault=o;function u(W,$,C=(P,M)=>P===M){let P=0;for(let M=0,_=Math.min(W.length,$.length);M<_&&C(W[M],$[M]);M++)P++;return P}e.commonPrefixLength=u;function h(W){return[].concat(...W)}e.flatten=h;function f(W,$){let C=typeof $=="number"?W:0;typeof $=="number"?C=W:(C=0,$=W);const P=[];if(C<=$)for(let M=C;M<$;M++)P.push(M);else for(let M=C;M>$;M--)P.push(M);return P}e.range=f;function I(W,$,C){return W.reduce((P,M)=>(P[$(M)]=C?C(M):M,P),Object.create(null))}e.index=I;function A(W,$){return W.push($),()=>F(W,$)}e.insert=A;function F(W,$){const C=W.indexOf($);if(C>-1)return W.splice(C,1),$}e.remove=F;function U(W,$,C){const P=W.slice(0,$),M=W.slice($);return P.concat(C,M)}e.arrayInsert=U;function q(W,$){let C;if(typeof $=="number"){let P=$;C=()=>{const M=Math.sin(P++)*179426549;return M-Math.floor(M)}}else C=Math.random;for(let P=W.length-1;P>0;P-=1){const M=Math.floor(C()*(P+1)),_=W[P];W[P]=W[M],W[M]=_}}e.shuffle=q;function Y(W,$){const C=W.indexOf($);C>-1&&(W.splice(C,1),W.unshift($))}e.pushToStart=Y;function ie(W,$){const C=W.indexOf($);C>-1&&(W.splice(C,1),W.push($))}e.pushToEnd=ie;function ae(W,$){return Array.isArray(W)?W.map($):$(W)}e.mapArrayOrNot=ae;function V(W){return Array.isArray(W)?W:[W]}e.asArray=V;function N(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=N;function z(W,$){for(const C of W){const P=$(C);if(P!==void 0)return P}}e.mapFind=z}),define(X[43],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(R){const D=this;let S=!1,k;return function(){return S||(S=!0,k=R.apply(D,arguments)),k}}e.once=v}),define(X[63],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(R){function D(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}R.is=D;const S=Object.freeze([]);function k(){return S}R.empty=k;function*n(s){yield s}R.single=n;function y(s){return s||S}R.from=y;function i(s){return!s||s[Symbol.iterator]().next().done===!0}R.isEmpty=i;function L(s){return s[Symbol.iterator]().next().value}R.first=L;function g(s,t){for(const r of s)if(t(r))return!0;return!1}R.some=g;function E(s,t){for(const r of s)if(t(r))return r}R.find=E;function*w(s,t){for(const r of s)t(r)&&(yield r)}R.filter=w;function*d(s,t){for(const r of s)yield t(r)}R.map=d;function*m(...s){for(const t of s)for(const r of t)yield r}R.concat=m;function*b(s){for(const t of s)for(const r of t)yield r}R.concatNested=b;function p(s,t,r){let o=r;for(const u of s)o=t(o,u);return o}R.reduce=p;function*a(s,t,r=s.length){for(t<0&&(t+=s.length),r<0?r+=s.length:r>s.length&&(r=s.length);t<r;t++)yield s[t]}R.slice=a;function c(s,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,s];const o=s[Symbol.iterator]();for(let u=0;u<t;u++){const h=o.next();if(h.done)return[r,R.empty()];r.push(h.value)}return[r,{[Symbol.iterator](){return o}}]}R.consume=c;function l(s,t,r=(o,u)=>o===u){const o=s[Symbol.iterator](),u=t[Symbol.iterator]();for(;;){const h=o.next(),f=u.next();if(h.done!==f.done)return!1;if(h.done)return!0;if(!r(h.value,f.value))return!1}}R.equals=l})(v=e.Iterable||(e.Iterable={}))}),define(X[44],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let o=0,u=t.length,h="",f=0,I=16,A=0;function F(N){let z=0,W=0;for(;z<N;){const $=t.charCodeAt(o);if($>=48&&$<=57)W=W*16+$-48;else if($>=65&&$<=70)W=W*16+$-65+10;else if($>=97&&$<=102)W=W*16+$-97+10;else break;o++,z++}return z<N&&(W=-1),W}function U(N){o=N,h="",f=0,I=16,A=0}function q(){const N=o;if(t.charCodeAt(o)===48)o++;else for(o++;o<t.length&&i(t.charCodeAt(o));)o++;if(o<t.length&&t.charCodeAt(o)===46)if(o++,o<t.length&&i(t.charCodeAt(o)))for(o++;o<t.length&&i(t.charCodeAt(o));)o++;else return A=3,t.substring(N,o);let z=o;if(o<t.length&&(t.charCodeAt(o)===69||t.charCodeAt(o)===101))if(o++,(o<t.length&&t.charCodeAt(o)===43||t.charCodeAt(o)===45)&&o++,o<t.length&&i(t.charCodeAt(o))){for(o++;o<t.length&&i(t.charCodeAt(o));)o++;z=o}else A=3;return t.substring(N,z)}function Y(){let N="",z=o;for(;;){if(o>=u){N+=t.substring(z,o),A=2;break}const W=t.charCodeAt(o);if(W===34){N+=t.substring(z,o),o++;break}if(W===92){if(N+=t.substring(z,o),o++,o>=u){A=2;break}switch(t.charCodeAt(o++)){case 34:N+='"';break;case 92:N+="\\";break;case 47:N+="/";break;case 98:N+="\b";break;case 102:N+="\f";break;case 110:N+=`
`;break;case 114:N+="\r";break;case 116:N+="	";break;case 117:const C=F(4);C>=0?N+=String.fromCharCode(C):A=4;break;default:A=5}z=o;continue}if(W>=0&&W<=31)if(y(W)){N+=t.substring(z,o),A=2;break}else A=6;o++}return N}function ie(){if(h="",A=0,f=o,o>=u)return f=u,I=17;let N=t.charCodeAt(o);if(n(N)){do o++,h+=String.fromCharCode(N),N=t.charCodeAt(o);while(n(N));return I=15}if(y(N))return o++,h+=String.fromCharCode(N),N===13&&t.charCodeAt(o)===10&&(o++,h+=`
`),I=14;switch(N){case 123:return o++,I=1;case 125:return o++,I=2;case 91:return o++,I=3;case 93:return o++,I=4;case 58:return o++,I=6;case 44:return o++,I=5;case 34:return o++,h=Y(),I=10;case 47:const z=o-1;if(t.charCodeAt(o+1)===47){for(o+=2;o<u&&!y(t.charCodeAt(o));)o++;return h=t.substring(z,o),I=12}if(t.charCodeAt(o+1)===42){o+=2;const W=u-1;let $=!1;for(;o<W;){if(t.charCodeAt(o)===42&&t.charCodeAt(o+1)===47){o+=2,$=!0;break}o++}return $||(o++,A=1),h=t.substring(z,o),I=13}return h+=String.fromCharCode(N),o++,I=16;case 45:if(h+=String.fromCharCode(N),o++,o===u||!i(t.charCodeAt(o)))return I=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return h+=q(),I=11;default:for(;o<u&&ae(N);)o++,N=t.charCodeAt(o);if(f!==o){switch(h=t.substring(f,o),h){case"true":return I=8;case"false":return I=9;case"null":return I=7}return I=16}return h+=String.fromCharCode(N),o++,I=16}}function ae(N){if(n(N)||y(N))return!1;switch(N){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let N;do N=ie();while(N>=12&&N<=15);return N}return{setPosition:U,getPosition:()=>o,scan:r?V:ie,getToken:()=>I,getTokenValue:()=>h,getTokenOffset:()=>f,getTokenLength:()=>o-f,getTokenError:()=>A}}e.createScanner=k;function n(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function i(t){return t>=48&&t<=57}var L;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(L||(L={}));function g(t,r){const o=[],u=new Object;let h;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let I=!1;function A(F,U,q,Y){f.value=F,f.offset=U,f.length=q,f.type=Y,f.colonOffset=void 0,h=f}try{c(t,{onObjectBegin:(F,U)=>{if(r<=F)throw u;h=void 0,I=r>F,o.push("")},onObjectProperty:(F,U,q)=>{if(r<U||(A(F,U,q,"property"),o[o.length-1]=F,r<=U+q))throw u},onObjectEnd:(F,U)=>{if(r<=F)throw u;h=void 0,o.pop()},onArrayBegin:(F,U)=>{if(r<=F)throw u;h=void 0,o.push(0)},onArrayEnd:(F,U)=>{if(r<=F)throw u;h=void 0,o.pop()},onLiteralValue:(F,U,q)=>{if(r<U||(A(F,U,q,s(F)),r<=U+q))throw u},onSeparator:(F,U,q)=>{if(r<=U)throw u;if(F===":"&&h&&h.type==="property")h.colonOffset=U,I=!1,h=void 0;else if(F===","){const Y=o[o.length-1];typeof Y=="number"?o[o.length-1]=Y+1:(I=!0,o[o.length-1]=""),h=void 0}}})}catch(F){if(F!==u)throw F}return{path:o,previousNode:h,isAtPropertyKey:I,matches:F=>{let U=0;for(let q=0;U<F.length&&q<o.length;q++)if(F[U]===o[q]||F[U]==="*")U++;else if(F[U]!=="**")return!1;return U===F.length}}}e.getLocation=g;function E(t,r=[],o=S.DEFAULT){let u=null,h=[];const f=[];function I(F){Array.isArray(h)?h.push(F):u!==null&&(h[u]=F)}return c(t,{onObjectBegin:()=>{const F={};I(F),f.push(h),h=F,u=null},onObjectProperty:F=>{u=F},onObjectEnd:()=>{h=f.pop()},onArrayBegin:()=>{const F=[];I(F),f.push(h),h=F,u=null},onArrayEnd:()=>{h=f.pop()},onLiteralValue:I,onError:(F,U,q)=>{r.push({error:F,offset:U,length:q})}},o),h[0]}e.parse=E;function w(t,r=[],o=S.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function h(F){u.type==="property"&&(u.length=F-u.offset,u=u.parent)}function f(F){return u.children.push(F),F}c(t,{onObjectBegin:F=>{u=f({type:"object",offset:F,length:-1,parent:u,children:[]})},onObjectProperty:(F,U,q)=>{u=f({type:"property",offset:U,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:F,offset:U,length:q,parent:u})},onObjectEnd:(F,U)=>{u.length=F+U-u.offset,u=u.parent,h(F+U)},onArrayBegin:(F,U)=>{u=f({type:"array",offset:F,length:-1,parent:u,children:[]})},onArrayEnd:(F,U)=>{u.length=F+U-u.offset,u=u.parent,h(F+U)},onLiteralValue:(F,U,q)=>{f({type:s(F),offset:U,length:q,parent:u,value:F}),h(U+q)},onSeparator:(F,U,q)=>{u.type==="property"&&(F===":"?u.colonOffset=U:F===","&&h(U))},onError:(F,U,q)=>{r.push({error:F,offset:U,length:q})}},o);const A=u.children[0];return A&&delete A.parent,A}e.parseTree=w;function d(t,r){if(!!t){let o=t;for(let u of r)if(typeof u=="string"){if(o.type!=="object"||!Array.isArray(o.children))return;let h=!1;for(const f of o.children)if(Array.isArray(f.children)&&f.children[0].value===u){o=f.children[1],h=!0;break}if(!h)return}else{const h=u;if(o.type!=="array"||h<0||!Array.isArray(o.children)||h>=o.children.length)return;o=o.children[h]}return o}}e.findNodeAtLocation=d;function m(t){if(!t.parent||!t.parent.children)return[];const r=m(t.parent);if(t.parent.type==="property"){const o=t.parent.children[0].value;r.push(o)}else if(t.parent.type==="array"){const o=t.parent.children.indexOf(t);o!==-1&&r.push(o)}return r}e.getNodePath=m;function b(t){switch(t.type){case"array":return t.children.map(b);case"object":const r=Object.create(null);for(let o of t.children){const u=o.children[1];u&&(r[o.children[0].value]=b(u))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=b;function p(t,r,o=!1){return r>=t.offset&&r<t.offset+t.length||o&&r===t.offset+t.length}e.contains=p;function a(t,r,o=!1){if(p(t,r,o)){const u=t.children;if(Array.isArray(u))for(let h=0;h<u.length&&u[h].offset<=r;h++){const f=a(u[h],r,o);if(f)return f}return t}}e.findNodeAtOffset=a;function c(t,r,o=S.DEFAULT){const u=k(t,!1);function h(B){return B?()=>B(u.getTokenOffset(),u.getTokenLength()):()=>!0}function f(B){return B?K=>B(K,u.getTokenOffset(),u.getTokenLength()):()=>!0}const I=h(r.onObjectBegin),A=f(r.onObjectProperty),F=h(r.onObjectEnd),U=h(r.onArrayBegin),q=h(r.onArrayEnd),Y=f(r.onLiteralValue),ie=f(r.onSeparator),ae=h(r.onComment),V=f(r.onError),N=o&&o.disallowComments,z=o&&o.allowTrailingComma;function W(){for(;;){const B=u.scan();switch(u.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:N||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(B){case 12:case 13:N?$(10):ae();break;case 16:$(1);break;case 15:case 14:break;default:return B}}}function $(B,K=[],G=[]){if(V(B),K.length+G.length>0){let J=u.getToken();for(;J!==17;){if(K.indexOf(J)!==-1){W();break}else if(G.indexOf(J)!==-1)break;J=W()}}}function C(B){const K=u.getTokenValue();return B?Y(K):A(K),W(),!0}function P(){switch(u.getToken()){case 11:let B=0;try{B=JSON.parse(u.getTokenValue()),typeof B!="number"&&($(2),B=0)}catch(K){$(2)}Y(B);break;case 7:Y(null);break;case 8:Y(!0);break;case 9:Y(!1);break;default:return!1}return W(),!0}function M(){return u.getToken()!==10?($(3,[],[2,5]),!1):(C(!1),u.getToken()===6?(ie(":"),W(),O()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function _(){I(),W();let B=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(B||$(4,[],[]),ie(","),W(),u.getToken()===2&&z)break}else B&&$(6,[],[]);M()||$(4,[],[2,5]),B=!0}return F(),u.getToken()!==2?$(7,[2],[]):W(),!0}function T(){U(),W();let B=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(B||$(4,[],[]),ie(","),W(),u.getToken()===4&&z)break}else B&&$(6,[],[]);O()||$(4,[],[4,5]),B=!0}return q(),u.getToken()!==4?$(8,[4],[]):W(),!0}function O(){switch(u.getToken()){case 3:return T();case 1:return _();case 10:return C(!0);default:return P()}}return W(),u.getToken()===17?o.allowEmptyContent?!0:($(4,[],[]),!1):O()?(u.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=c;function l(t,r){let o=k(t),u=[],h,f=0,I;do switch(I=o.getPosition(),h=o.scan(),h){case 12:case 13:case 17:f!==I&&u.push(t.substring(f,I)),r!==void 0&&u.push(o.getTokenValue().replace(/[^\r\n]/g,r)),f=o.getPosition();break}while(h!==17);return u.join("")}e.stripComments=l;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(X[101],Q([0,1,44]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(y,i,L){let g,E,w,d,m;if(i){for(d=i.offset,m=d+i.length,w=d;w>0&&!n(y,w-1);)w--;let f=m;for(;f<y.length&&!n(y,f);)f++;E=y.substring(w,f),g=S(E,L)}else E=y,g=0,w=0,d=0,m=y.length;const b=k(L,y);let p=!1,a=0,c;L.insertSpaces?c=D(" ",L.tabSize||4):c="	";const l=(0,v.createScanner)(E,!1);let s=!1;function t(){return b+D(c,g+a)}function r(){let f=l.scan();for(p=!1;f===15||f===14;)p=p||f===14,f=l.scan();return s=f===16||l.getTokenError()!==0,f}const o=[];function u(f,I,A){!s&&I<m&&A>d&&y.substring(I,A)!==f&&o.push({offset:I,length:A-I,content:f})}let h=r();if(h!==17){const f=l.getTokenOffset()+w,I=D(c,g);u(I,w,f)}for(;h!==17;){let f=l.getTokenOffset()+l.getTokenLength()+w,I=r(),A="";for(;!p&&(I===12||I===13);){const U=l.getTokenOffset()+w;u(" ",f,U),f=l.getTokenOffset()+l.getTokenLength()+w,A=I===12?t():"",I=r()}if(I===2)h!==1&&(a--,A=t());else if(I===4)h!==3&&(a--,A=t());else{switch(h){case 3:case 1:a++,A=t();break;case 5:case 12:A=t();break;case 13:p?A=t():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(s=!0);break;case 16:s=!0;break}p&&(I===12||I===13)&&(A=t())}const F=l.getTokenOffset()+w;u(A,f,F),h=I}return o}e.format=R;function D(y,i){let L="";for(let g=0;g<i;g++)L+=y;return L}function S(y,i){let L=0,g=0;const E=i.tabSize||4;for(;L<y.length;){const w=y.charAt(L);if(w===" ")g++;else if(w==="	")g+=E;else break;L++}return Math.floor(g/E)}function k(y,i){for(let L=0;L<i.length;L++){const g=i.charAt(L);if(g==="\r")return L+1<i.length&&i.charAt(L+1)===`
`?`\r
`:"\r";if(g===`
`)return`
`}return y&&y.eol||`
`}e.getEOL=k;function n(y,i){return`\r
`.indexOf(y.charAt(i))!==-1}e.isEOL=n}),define(X[102],Q([0,1,44,101]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(i,L,g){return S(i,L,void 0,g)}e.removeProperty=D;function S(i,L,g,E,w){const d=L.slice(),m=[],b=(0,v.parseTree)(i,m);let p,a;for(;d.length>0&&(a=d.pop(),p=(0,v.findNodeAtLocation)(b,d),p===void 0&&g!==void 0);)typeof a=="string"?g={[a]:g}:g=[g];if(p)if(p.type==="object"&&typeof a=="string"&&Array.isArray(p.children)){const c=(0,v.findNodeAtLocation)(p,[a]);if(c!==void 0)if(g===void 0){if(!c.parent)throw new Error("Malformed AST");const l=p.children.indexOf(c.parent);let s,t=c.parent.offset+c.parent.length;if(l>0){const r=p.children[l-1];s=r.offset+r.length}else s=p.offset+1,p.children.length>1&&(t=p.children[1].offset);return k(i,{offset:s,length:t-s,content:""},E)}else return k(i,{offset:c.offset,length:c.length,content:JSON.stringify(g)},E);else{if(g===void 0)return[];const l=`${JSON.stringify(a)}: ${JSON.stringify(g)}`,s=w?w(p.children.map(r=>r.children[0].value)):p.children.length;let t;if(s>0){const r=p.children[s-1];t={offset:r.offset+r.length,length:0,content:","+l}}else p.children.length===0?t={offset:p.offset+1,length:0,content:l}:t={offset:p.offset+1,length:0,content:l+","};return k(i,t,E)}}else if(p.type==="array"&&typeof a=="number"&&Array.isArray(p.children))if(g!==void 0){const c=`${JSON.stringify(g)}`;let l;if(p.children.length===0||a===0)l={offset:p.offset+1,length:0,content:p.children.length===0?c:c+","};else{const s=a===-1||a>p.children.length?p.children.length:a,t=p.children[s-1];l={offset:t.offset+t.length,length:0,content:","+c}}return k(i,l,E)}else{const c=a,l=p.children[c];let s;if(p.children.length===1)s={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===c){const t=p.children[c-1],r=t.offset+t.length,o=p.offset+p.length;s={offset:r,length:o-2-r,content:""}}else s={offset:l.offset,length:p.children[c+1].offset-l.offset,content:""};return k(i,s,E)}else throw new Error(`Can not add ${typeof a!="number"?"index":"property"} to parent of type ${p.type}`);else{if(g===void 0)throw new Error("Can not delete in empty document");return k(i,{offset:b?b.offset:0,length:b?b.length:0,content:JSON.stringify(g)},E)}}e.setProperty=S;function k(i,L,g){let E=n(i,L),w=L.offset,d=L.offset+L.content.length;if(L.length===0||L.content.length===0){for(;w>0&&!(0,R.isEOL)(E,w-1);)w--;for(;d<E.length&&!(0,R.isEOL)(E,d);)d++}const m=(0,R.format)(E,{offset:w,length:d-w},g);for(let p=m.length-1;p>=0;p--){const a=m[p];E=n(E,a),w=Math.min(w,a.offset),d=Math.max(d,a.offset+a.length),d+=a.content.length-a.length}const b=i.length-(E.length-d)-w;return[{offset:w,length:b,content:E.substring(w,d)}]}e.withFormatting=k;function n(i,L){return i.substring(0,L.offset)+L.content+i.substring(L.offset+L.length)}e.applyEdit=n;function y(i,L){let g=L.slice(0).sort((w,d)=>{const m=w.offset-d.offset;return m===0?w.length-d.length:m}),E=i.length;for(let w=g.length-1;w>=0;w--){let d=g[w];if(d.offset+d.length<=E)i=n(i,d);else throw new Error("Overlapping edit");E=d.offset}return i}e.applyEdits=y}),define(X[57],Q([0,1,19]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.KeyCode=void 0;var R;(function(a){a[a.DependsOnKbLayout=-1]="DependsOnKbLayout",a[a.Unknown=0]="Unknown",a[a.Backspace=1]="Backspace",a[a.Tab=2]="Tab",a[a.Enter=3]="Enter",a[a.Shift=4]="Shift",a[a.Ctrl=5]="Ctrl",a[a.Alt=6]="Alt",a[a.PauseBreak=7]="PauseBreak",a[a.CapsLock=8]="CapsLock",a[a.Escape=9]="Escape",a[a.Space=10]="Space",a[a.PageUp=11]="PageUp",a[a.PageDown=12]="PageDown",a[a.End=13]="End",a[a.Home=14]="Home",a[a.LeftArrow=15]="LeftArrow",a[a.UpArrow=16]="UpArrow",a[a.RightArrow=17]="RightArrow",a[a.DownArrow=18]="DownArrow",a[a.Insert=19]="Insert",a[a.Delete=20]="Delete",a[a.KEY_0=21]="KEY_0",a[a.KEY_1=22]="KEY_1",a[a.KEY_2=23]="KEY_2",a[a.KEY_3=24]="KEY_3",a[a.KEY_4=25]="KEY_4",a[a.KEY_5=26]="KEY_5",a[a.KEY_6=27]="KEY_6",a[a.KEY_7=28]="KEY_7",a[a.KEY_8=29]="KEY_8",a[a.KEY_9=30]="KEY_9",a[a.KEY_A=31]="KEY_A",a[a.KEY_B=32]="KEY_B",a[a.KEY_C=33]="KEY_C",a[a.KEY_D=34]="KEY_D",a[a.KEY_E=35]="KEY_E",a[a.KEY_F=36]="KEY_F",a[a.KEY_G=37]="KEY_G",a[a.KEY_H=38]="KEY_H",a[a.KEY_I=39]="KEY_I",a[a.KEY_J=40]="KEY_J",a[a.KEY_K=41]="KEY_K",a[a.KEY_L=42]="KEY_L",a[a.KEY_M=43]="KEY_M",a[a.KEY_N=44]="KEY_N",a[a.KEY_O=45]="KEY_O",a[a.KEY_P=46]="KEY_P",a[a.KEY_Q=47]="KEY_Q",a[a.KEY_R=48]="KEY_R",a[a.KEY_S=49]="KEY_S",a[a.KEY_T=50]="KEY_T",a[a.KEY_U=51]="KEY_U",a[a.KEY_V=52]="KEY_V",a[a.KEY_W=53]="KEY_W",a[a.KEY_X=54]="KEY_X",a[a.KEY_Y=55]="KEY_Y",a[a.KEY_Z=56]="KEY_Z",a[a.Meta=57]="Meta",a[a.ContextMenu=58]="ContextMenu",a[a.F1=59]="F1",a[a.F2=60]="F2",a[a.F3=61]="F3",a[a.F4=62]="F4",a[a.F5=63]="F5",a[a.F6=64]="F6",a[a.F7=65]="F7",a[a.F8=66]="F8",a[a.F9=67]="F9",a[a.F10=68]="F10",a[a.F11=69]="F11",a[a.F12=70]="F12",a[a.F13=71]="F13",a[a.F14=72]="F14",a[a.F15=73]="F15",a[a.F16=74]="F16",a[a.F17=75]="F17",a[a.F18=76]="F18",a[a.F19=77]="F19",a[a.NumLock=78]="NumLock",a[a.ScrollLock=79]="ScrollLock",a[a.US_SEMICOLON=80]="US_SEMICOLON",a[a.US_EQUAL=81]="US_EQUAL",a[a.US_COMMA=82]="US_COMMA",a[a.US_MINUS=83]="US_MINUS",a[a.US_DOT=84]="US_DOT",a[a.US_SLASH=85]="US_SLASH",a[a.US_BACKTICK=86]="US_BACKTICK",a[a.US_OPEN_SQUARE_BRACKET=87]="US_OPEN_SQUARE_BRACKET",a[a.US_BACKSLASH=88]="US_BACKSLASH",a[a.US_CLOSE_SQUARE_BRACKET=89]="US_CLOSE_SQUARE_BRACKET",a[a.US_QUOTE=90]="US_QUOTE",a[a.OEM_8=91]="OEM_8",a[a.OEM_102=92]="OEM_102",a[a.NUMPAD_0=93]="NUMPAD_0",a[a.NUMPAD_1=94]="NUMPAD_1",a[a.NUMPAD_2=95]="NUMPAD_2",a[a.NUMPAD_3=96]="NUMPAD_3",a[a.NUMPAD_4=97]="NUMPAD_4",a[a.NUMPAD_5=98]="NUMPAD_5",a[a.NUMPAD_6=99]="NUMPAD_6",a[a.NUMPAD_7=100]="NUMPAD_7",a[a.NUMPAD_8=101]="NUMPAD_8",a[a.NUMPAD_9=102]="NUMPAD_9",a[a.NUMPAD_MULTIPLY=103]="NUMPAD_MULTIPLY",a[a.NUMPAD_ADD=104]="NUMPAD_ADD",a[a.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",a[a.NUMPAD_SUBTRACT=106]="NUMPAD_SUBTRACT",a[a.NUMPAD_DECIMAL=107]="NUMPAD_DECIMAL",a[a.NUMPAD_DIVIDE=108]="NUMPAD_DIVIDE",a[a.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",a[a.ABNT_C1=110]="ABNT_C1",a[a.ABNT_C2=111]="ABNT_C2",a[a.MAX_VALUE=112]="MAX_VALUE"})(R=e.KeyCode||(e.KeyCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,l){this._keyCodeToStr[c]=l,this._strToKeyCode[l.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const S=new D,k=new D,n=new D;(function(){function a(c,l,s=l,t=s){S.define(c,l),k.define(c,s),n.define(c,t)}a(0,"unknown"),a(1,"Backspace"),a(2,"Tab"),a(3,"Enter"),a(4,"Shift"),a(5,"Ctrl"),a(6,"Alt"),a(7,"PauseBreak"),a(8,"CapsLock"),a(9,"Escape"),a(10,"Space"),a(11,"PageUp"),a(12,"PageDown"),a(13,"End"),a(14,"Home"),a(15,"LeftArrow","Left"),a(16,"UpArrow","Up"),a(17,"RightArrow","Right"),a(18,"DownArrow","Down"),a(19,"Insert"),a(20,"Delete"),a(21,"0"),a(22,"1"),a(23,"2"),a(24,"3"),a(25,"4"),a(26,"5"),a(27,"6"),a(28,"7"),a(29,"8"),a(30,"9"),a(31,"A"),a(32,"B"),a(33,"C"),a(34,"D"),a(35,"E"),a(36,"F"),a(37,"G"),a(38,"H"),a(39,"I"),a(40,"J"),a(41,"K"),a(42,"L"),a(43,"M"),a(44,"N"),a(45,"O"),a(46,"P"),a(47,"Q"),a(48,"R"),a(49,"S"),a(50,"T"),a(51,"U"),a(52,"V"),a(53,"W"),a(54,"X"),a(55,"Y"),a(56,"Z"),a(57,"Meta"),a(58,"ContextMenu"),a(59,"F1"),a(60,"F2"),a(61,"F3"),a(62,"F4"),a(63,"F5"),a(64,"F6"),a(65,"F7"),a(66,"F8"),a(67,"F9"),a(68,"F10"),a(69,"F11"),a(70,"F12"),a(71,"F13"),a(72,"F14"),a(73,"F15"),a(74,"F16"),a(75,"F17"),a(76,"F18"),a(77,"F19"),a(78,"NumLock"),a(79,"ScrollLock"),a(80,";",";","OEM_1"),a(81,"=","=","OEM_PLUS"),a(82,",",",","OEM_COMMA"),a(83,"-","-","OEM_MINUS"),a(84,".",".","OEM_PERIOD"),a(85,"/","/","OEM_2"),a(86,"`","`","OEM_3"),a(110,"ABNT_C1"),a(111,"ABNT_C2"),a(87,"[","[","OEM_4"),a(88,"\\","\\","OEM_5"),a(89,"]","]","OEM_6"),a(90,"'","'","OEM_7"),a(91,"OEM_8"),a(92,"OEM_102"),a(93,"NumPad0"),a(94,"NumPad1"),a(95,"NumPad2"),a(96,"NumPad3"),a(97,"NumPad4"),a(98,"NumPad5"),a(99,"NumPad6"),a(100,"NumPad7"),a(101,"NumPad8"),a(102,"NumPad9"),a(103,"NumPad_Multiply"),a(104,"NumPad_Add"),a(105,"NumPad_Separator"),a(106,"NumPad_Subtract"),a(107,"NumPad_Decimal"),a(108,"NumPad_Divide")})();var y;(function(a){function c(o){return S.keyCodeToStr(o)}a.toString=c;function l(o){return S.strToKeyCode(o)}a.fromString=l;function s(o){return k.keyCodeToStr(o)}a.toUserSettingsUS=s;function t(o){return n.keyCodeToStr(o)}a.toUserSettingsGeneral=t;function r(o){return k.strToKeyCode(o)||n.strToKeyCode(o)}a.fromUserSettings=r})(y=e.KeyCodeUtils||(e.KeyCodeUtils={}));var i;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl",a[a.KeyCode=255]="KeyCode"})(i||(i={}));var L;(function(a){a[a.CtrlCmd=2048]="CtrlCmd",a[a.Shift=1024]="Shift",a[a.Alt=512]="Alt",a[a.WinCtrl=256]="WinCtrl"})(L=e.KeyMod||(e.KeyMod={}));function g(a,c){const l=(c&65535)<<16>>>0;return(a|l)>>>0}e.KeyChord=g;function E(a,c){if(a===0)return null;const l=(a&65535)>>>0,s=(a&4294901760)>>>16;return s!==0?new m([w(l,c),w(s,c)]):new m([w(l,c)])}e.createKeybinding=E;function w(a,c){const l=!!(a&2048),s=!!(a&256),t=c===2?s:l,r=!!(a&1024),o=!!(a&512),u=c===2?l:s,h=a&255;return new d(t,r,o,u,h)}e.createSimpleKeybinding=w;class d{constructor(c,l,s,t,r){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyCode=r}equals(c){return this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",s=this.altKey?"1":"0",t=this.metaKey?"1":"0";return`${c}${l}${s}${t}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=d;class m{constructor(c){if(c.length===0)throw(0,v.illegalArgument)("parts");this.parts=c}getHashCode(){let c="";for(let l=0,s=this.parts.length;l<s;l++)l!==0&&(c+=";"),c+=this.parts[l].getHashCode();return c}equals(c){if(c===null||this.parts.length!==c.parts.length)return!1;for(let l=0;l<this.parts.length;l++)if(!this.parts[l].equals(c.parts[l]))return!1;return!0}}e.ChordKeybinding=m;class b{constructor(c,l,s,t,r,o){this.ctrlKey=c,this.shiftKey=l,this.altKey=s,this.metaKey=t,this.keyLabel=r,this.keyAriaLabel=o}}e.ResolvedKeybindingPart=b;class p{}e.ResolvedKeybinding=p}),define(X[2],Q([0,1,43,63]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let S=null;function k(c){S=c}if(e.setDisposableTracker=k,D){const c="__is_disposable_tracked__";S=new class{trackDisposable(l){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[c]||console.log(s)},3e3)}markTracked(l){if(l&&l!==m.None)try{l[c]=!0}catch(s){}}}}function n(c){!S||S.markTracked(c)}function y(c){return S&&S.trackDisposable(c),c}e.trackDisposable=y;class i extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=i;function L(c){return typeof c.dispose=="function"&&c.dispose.length===0}e.isDisposable=L;function g(c){if(R.Iterable.is(c)){let l=[];for(const s of c)if(s){n(s);try{s.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new i(l);return Array.isArray(c)?[]:c}else if(c)return n(c),c.dispose(),c}e.dispose=g;function E(...c){return c.forEach(n),w(()=>g(c))}e.combinedDisposable=E;function w(c){const l=y({dispose:()=>{n(l),c()}});return l}e.toDisposable=w;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(n(this),this._isDisposed=!0,this.clear())}clear(){try{g(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return n(l),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class m{constructor(){this._store=new d,y(this)}dispose(){n(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=m,m.None=Object.freeze({dispose(){}});class b{constructor(){this._isDisposed=!1,y(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var s;this._isDisposed||l===this._value||((s=this._value)===null||s===void 0||s.dispose(),l&&n(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,n(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=b;class p{constructor(){this.references=new Map}acquire(l,...s){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...s)},this.references.set(l,t));const{object:r}=t,o=(0,v.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:r,dispose:o}}}e.ReferenceCollection=p;class a{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=a}),define(X[76],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(S){this.element=S,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class R{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,k){const n=new v(S);if(this._first===v.Undefined)this._first=n,this._last=n;else if(k){const i=this._last;this._last=n,n.prev=i,i.next=n}else{const i=this._first;this._first=n,n.next=i,i.prev=n}this._size+=1;let y=!1;return()=>{y||(y=!0,this._remove(n))}}shift(){if(this._first!==v.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==v.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==v.Undefined&&S.next!==v.Undefined){const k=S.prev;k.next=S.next,S.next.prev=k}else S.prev===v.Undefined&&S.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):S.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):S.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==v.Undefined;)yield S.element,S=S.next}}e.LinkedList=R});"use strict";(function(){function j(D){const S=[];typeof D=="number"&&S.push("code/timeOrigin",D);function k(y){S.push(y,Date.now())}function n(){const y=[];for(let i=0;i<S.length;i+=2)y.push({name:S[i],startTime:S[i+1]});return y}return{mark:k,getMarks:n}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const k of performance.getEntriesByType("mark"))S.push({name:k.name,startTime:Math.round(D+k.startTime)});return S}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function v(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=v(R))})(),define(X[3],Q([0,1]),function(j,e){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let D=!1,S=!1,k=!1,n=!1,y=!1,i=!1,L=!1,g,E=R,w,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof process!="undefined"?m=process:typeof e.globals.vscode!="undefined"&&(m=e.globals.vscode.process);const b=typeof((v=m==null?void 0:m.versions)===null||v===void 0?void 0:v.electron)=="string"&&m.type==="renderer";if(e.isElectronSandboxed=b&&(m==null?void 0:m.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const u=m==null?void 0:m.env.ENABLE_VSCODE_BROWSER_CODE_LOADING;if(typeof u=="string")return u==="none"||u==="code"||u==="bypassHeatCheck"||u==="bypassHeatCheckAndEagerCompile"?u:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!b)d=navigator.userAgent,D=d.indexOf("Windows")>=0,S=d.indexOf("Macintosh")>=0,L=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=d.indexOf("Linux")>=0,i=!0,g=navigator.language,E=g;else if(typeof m=="object"){D=m.platform==="win32",S=m.platform==="darwin",k=m.platform==="linux",n=k&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,g=R,E=R;const u=m.env.VSCODE_NLS_CONFIG;if(u)try{const h=JSON.parse(u),f=h.availableLanguages["*"];g=h.locale,E=f||R,w=h._translationsConfigFile}catch(h){}y=!0}else console.error("Unable to resolve platform.");var p;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(p=e.Platform||(e.Platform={}));function a(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=a;let c=0;S?c=1:D?c=3:k&&(c=2),e.isWindows=D,e.isMacintosh=S,e.isLinux=k,e.isLinuxSnap=n,e.isNative=y,e.isWeb=i,e.isIOS=L,e.platform=c,e.userAgent=d,e.language=E;var l;(function(u){function h(){return e.language}u.value=h;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function I(){return e.language==="en"}u.isDefault=I})(l=e.Language||(e.Language={})),e.locale=g,e.translationsConfigFile=w,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let f=[];e.globals.addEventListener("message",A=>{if(A.data&&A.data.vscodeSetImmediateId)for(let F=0,U=f.length;F<U;F++){const q=f[F];if(q.id===A.data.vscodeSetImmediateId){f.splice(F,1),q.callback();return}}});let I=0;return A=>{const F=++I;f.push({id:F,callback:A}),e.globals.postMessage({vscodeSetImmediateId:F},"*")}}if(typeof(m==null?void 0:m.nextTick)=="function")return m.nextTick.bind(m);const h=Promise.resolve();return f=>h.then(f)}();var s;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||L?2:D?1:3;let t=!0,r=!1;function o(){if(!r){r=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,t=new Uint16Array(u.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=o}),define(X[35],Q([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof process!="undefined")R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}};else if(typeof v.globals.vscode!="undefined"){const D=v.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(S){return(0,v.setImmediate)(S)}}}else R={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(D){return(0,v.setImmediate)(D)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(X[8],Q([0,1,35]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,S=90,k=122,n=46,y=47,i=92,L=58,g=63;class E extends Error{constructor(l,s,t){let r;typeof s=="string"&&s.indexOf("not ")===0?(r="must not be",s=s.replace(/^not /,"")):r="must be";const o=l.indexOf(".")!==-1?"property":"argument";let u=`The "${l}" ${o} ${r} of type ${s}`;u+=`. Received type ${typeof t}`,super(u),this.code="ERR_INVALID_ARG_TYPE"}}function w(c,l){if(typeof c!="string")throw new E(l,"string",c)}function d(c){return c===y||c===i}function m(c){return c===y}function b(c){return c>=R&&c<=S||c>=D&&c<=k}function p(c,l,s,t){let r="",o=0,u=-1,h=0,f=0;for(let I=0;I<=c.length;++I){if(I<c.length)f=c.charCodeAt(I);else{if(t(f))break;f=y}if(t(f)){if(!(u===I-1||h===1))if(h===2){if(r.length<2||o!==2||r.charCodeAt(r.length-1)!==n||r.charCodeAt(r.length-2)!==n){if(r.length>2){const A=r.lastIndexOf(s);A===-1?(r="",o=0):(r=r.slice(0,A),o=r.length-1-r.lastIndexOf(s)),u=I,h=0;continue}else if(r.length!==0){r="",o=0,u=I,h=0;continue}}l&&(r+=r.length>0?`${s}..`:"..",o=2)}else r.length>0?r+=`${s}${c.slice(u+1,I)}`:r=c.slice(u+1,I),o=I-u-1;u=I,h=0}else f===n&&h!==-1?++h:h=-1}return r}function a(c,l){if(l===null||typeof l!="object")throw new E("pathObject","Object",l);const s=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return s?s===l.root?`${s}${t}`:`${s}${c}${t}`:t}e.win32={resolve(...c){let l="",s="",t=!1;for(let r=c.length-1;r>=-1;r--){let o;if(r>=0){if(o=c[r],w(o,"path"),o.length===0)continue}else l.length===0?o=v.cwd():(o=v.env[`=${l}`]||v.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==l.toLowerCase()&&o.charCodeAt(2)===i)&&(o=`${l}\\`));const u=o.length;let h=0,f="",I=!1;const A=o.charCodeAt(0);if(u===1)d(A)&&(h=1,I=!0);else if(d(A))if(I=!0,d(o.charCodeAt(1))){let F=2,U=F;for(;F<u&&!d(o.charCodeAt(F));)F++;if(F<u&&F!==U){const q=o.slice(U,F);for(U=F;F<u&&d(o.charCodeAt(F));)F++;if(F<u&&F!==U){for(U=F;F<u&&!d(o.charCodeAt(F));)F++;(F===u||F!==U)&&(f=`\\\\${q}\\${o.slice(U,F)}`,h=F)}}}else h=1;else b(A)&&o.charCodeAt(1)===L&&(f=o.slice(0,2),h=2,u>2&&d(o.charCodeAt(2))&&(I=!0,h=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(t){if(l.length>0)break}else if(s=`${o.slice(h)}\\${s}`,t=I,I&&l.length>0)break}return s=p(s,!t,"\\",d),t?`${l}\\${s}`:`${l}${s}`||"."},normalize(c){w(c,"path");const l=c.length;if(l===0)return".";let s=0,t,r=!1;const o=c.charCodeAt(0);if(l===1)return m(o)?"\\":c;if(d(o))if(r=!0,d(c.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(c.charCodeAt(h));)h++;if(h<l&&h!==f){const I=c.slice(f,h);for(f=h;h<l&&d(c.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(c.charCodeAt(h));)h++;if(h===l)return`\\\\${I}\\${c.slice(f)}\\`;h!==f&&(t=`\\\\${I}\\${c.slice(f,h)}`,s=h)}}}else s=1;else b(o)&&c.charCodeAt(1)===L&&(t=c.slice(0,2),s=2,l>2&&d(c.charCodeAt(2))&&(r=!0,s=3));let u=s<l?p(c.slice(s),!r,"\\",d):"";return u.length===0&&!r&&(u="."),u.length>0&&d(c.charCodeAt(l-1))&&(u+="\\"),t===void 0?r?`\\${u}`:u:r?`${t}\\${u}`:`${t}${u}`},isAbsolute(c){w(c,"path");const l=c.length;if(l===0)return!1;const s=c.charCodeAt(0);return d(s)||l>2&&b(s)&&c.charCodeAt(1)===L&&d(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let l,s;for(let o=0;o<c.length;++o){const u=c[o];w(u,"path"),u.length>0&&(l===void 0?l=s=u:l+=`\\${u}`)}if(l===void 0)return".";let t=!0,r=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++r;const o=s.length;o>1&&d(s.charCodeAt(1))&&(++r,o>2&&(d(s.charCodeAt(2))?++r:t=!1))}if(t){for(;r<l.length&&d(l.charCodeAt(r));)r++;r>=2&&(l=`\\${l.slice(r)}`)}return e.win32.normalize(l)},relative(c,l){if(w(c,"from"),w(l,"to"),c===l)return"";const s=e.win32.resolve(c),t=e.win32.resolve(l);if(s===t||(c=s.toLowerCase(),l=t.toLowerCase(),c===l))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===i;)r++;let o=c.length;for(;o-1>r&&c.charCodeAt(o-1)===i;)o--;const u=o-r;let h=0;for(;h<l.length&&l.charCodeAt(h)===i;)h++;let f=l.length;for(;f-1>h&&l.charCodeAt(f-1)===i;)f--;const I=f-h,A=u<I?u:I;let F=-1,U=0;for(;U<A;U++){const Y=c.charCodeAt(r+U);if(Y!==l.charCodeAt(h+U))break;Y===i&&(F=U)}if(U!==A){if(F===-1)return t}else{if(I>A){if(l.charCodeAt(h+U)===i)return t.slice(h+U+1);if(U===2)return t.slice(h+U)}u>A&&(c.charCodeAt(r+U)===i?F=U:U===2&&(F=3)),F===-1&&(F=0)}let q="";for(U=r+F+1;U<=o;++U)(U===o||c.charCodeAt(U)===i)&&(q+=q.length===0?"..":"\\..");return h+=F,q.length>0?`${q}${t.slice(h,f)}`:(t.charCodeAt(h)===i&&++h,t.slice(h,f))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const l=e.win32.resolve(c);if(l.length<=2)return c;if(l.charCodeAt(0)===i){if(l.charCodeAt(1)===i){const s=l.charCodeAt(2);if(s!==g&&s!==n)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(b(l.charCodeAt(0))&&l.charCodeAt(1)===L&&l.charCodeAt(2)===i)return`\\\\?\\${l}`;return c},dirname(c){w(c,"path");const l=c.length;if(l===0)return".";let s=-1,t=0;const r=c.charCodeAt(0);if(l===1)return d(r)?c:".";if(d(r)){if(s=t=1,d(c.charCodeAt(1))){let h=2,f=h;for(;h<l&&!d(c.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&d(c.charCodeAt(h));)h++;if(h<l&&h!==f){for(f=h;h<l&&!d(c.charCodeAt(h));)h++;if(h===l)return c;h!==f&&(s=t=h+1)}}}}else b(r)&&c.charCodeAt(1)===L&&(s=l>2&&d(c.charCodeAt(2))?3:2,t=s);let o=-1,u=!0;for(let h=l-1;h>=t;--h)if(d(c.charCodeAt(h))){if(!u){o=h;break}}else u=!1;if(o===-1){if(s===-1)return".";o=s}return c.slice(0,o)},basename(c,l){l!==void 0&&w(l,"ext"),w(c,"path");let s=0,t=-1,r=!0,o;if(c.length>=2&&b(c.charCodeAt(0))&&c.charCodeAt(1)===L&&(s=2),l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let u=l.length-1,h=-1;for(o=c.length-1;o>=s;--o){const f=c.charCodeAt(o);if(d(f)){if(!r){s=o+1;break}}else h===-1&&(r=!1,h=o+1),u>=0&&(f===l.charCodeAt(u)?--u==-1&&(t=o):(u=-1,t=h))}return s===t?t=h:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=s;--o)if(d(c.charCodeAt(o))){if(!r){s=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){w(c,"path");let l=0,s=-1,t=0,r=-1,o=!0,u=0;c.length>=2&&c.charCodeAt(1)===L&&b(c.charCodeAt(0))&&(l=t=2);for(let h=c.length-1;h>=l;--h){const f=c.charCodeAt(h);if(d(f)){if(!o){t=h+1;break}continue}r===-1&&(o=!1,r=h+1),f===n?s===-1?s=h:u!==1&&(u=1):s!==-1&&(u=-1)}return s===-1||r===-1||u===0||u===1&&s===r-1&&s===t+1?"":c.slice(s,r)},format:a.bind(null,"\\"),parse(c){w(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.length;let t=0,r=c.charCodeAt(0);if(s===1)return d(r)?(l.root=l.dir=c,l):(l.base=l.name=c,l);if(d(r)){if(t=1,d(c.charCodeAt(1))){let F=2,U=F;for(;F<s&&!d(c.charCodeAt(F));)F++;if(F<s&&F!==U){for(U=F;F<s&&d(c.charCodeAt(F));)F++;if(F<s&&F!==U){for(U=F;F<s&&!d(c.charCodeAt(F));)F++;F===s?t=F:F!==U&&(t=F+1)}}}}else if(b(r)&&c.charCodeAt(1)===L){if(s<=2)return l.root=l.dir=c,l;if(t=2,d(c.charCodeAt(2))){if(s===3)return l.root=l.dir=c,l;t=3}}t>0&&(l.root=c.slice(0,t));let o=-1,u=t,h=-1,f=!0,I=c.length-1,A=0;for(;I>=t;--I){if(r=c.charCodeAt(I),d(r)){if(!f){u=I+1;break}continue}h===-1&&(f=!1,h=I+1),r===n?o===-1?o=I:A!==1&&(A=1):o!==-1&&(A=-1)}return h!==-1&&(o===-1||A===0||A===1&&o===h-1&&o===u+1?l.base=l.name=c.slice(u,h):(l.name=c.slice(u,o),l.base=c.slice(u,h),l.ext=c.slice(o,h))),u>0&&u!==t?l.dir=c.slice(0,u-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let l="",s=!1;for(let t=c.length-1;t>=-1&&!s;t--){const r=t>=0?c[t]:v.cwd();w(r,"path"),r.length!==0&&(l=`${r}/${l}`,s=r.charCodeAt(0)===y)}return l=p(l,!s,"/",m),s?`/${l}`:l.length>0?l:"."},normalize(c){if(w(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===y,s=c.charCodeAt(c.length-1)===y;return c=p(c,!l,"/",m),c.length===0?l?"/":s?"./":".":(s&&(c+="/"),l?`/${c}`:c)},isAbsolute(c){return w(c,"path"),c.length>0&&c.charCodeAt(0)===y},join(...c){if(c.length===0)return".";let l;for(let s=0;s<c.length;++s){const t=c[s];w(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(c,l){if(w(c,"from"),w(l,"to"),c===l||(c=e.posix.resolve(c),l=e.posix.resolve(l),c===l))return"";const s=1,t=c.length,r=t-s,o=1,u=l.length-o,h=r<u?r:u;let f=-1,I=0;for(;I<h;I++){const F=c.charCodeAt(s+I);if(F!==l.charCodeAt(o+I))break;F===y&&(f=I)}if(I===h)if(u>h){if(l.charCodeAt(o+I)===y)return l.slice(o+I+1);if(I===0)return l.slice(o+I)}else r>h&&(c.charCodeAt(s+I)===y?f=I:I===0&&(f=0));let A="";for(I=s+f+1;I<=t;++I)(I===t||c.charCodeAt(I)===y)&&(A+=A.length===0?"..":"/..");return`${A}${l.slice(o+f)}`},toNamespacedPath(c){return c},dirname(c){if(w(c,"path"),c.length===0)return".";const l=c.charCodeAt(0)===y;let s=-1,t=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===y){if(!t){s=r;break}}else t=!1;return s===-1?l?"/":".":l&&s===1?"//":c.slice(0,s)},basename(c,l){l!==void 0&&w(l,"ext"),w(c,"path");let s=0,t=-1,r=!0,o;if(l!==void 0&&l.length>0&&l.length<=c.length){if(l===c)return"";let u=l.length-1,h=-1;for(o=c.length-1;o>=0;--o){const f=c.charCodeAt(o);if(f===y){if(!r){s=o+1;break}}else h===-1&&(r=!1,h=o+1),u>=0&&(f===l.charCodeAt(u)?--u==-1&&(t=o):(u=-1,t=h))}return s===t?t=h:t===-1&&(t=c.length),c.slice(s,t)}for(o=c.length-1;o>=0;--o)if(c.charCodeAt(o)===y){if(!r){s=o+1;break}}else t===-1&&(r=!1,t=o+1);return t===-1?"":c.slice(s,t)},extname(c){w(c,"path");let l=-1,s=0,t=-1,r=!0,o=0;for(let u=c.length-1;u>=0;--u){const h=c.charCodeAt(u);if(h===y){if(!r){s=u+1;break}continue}t===-1&&(r=!1,t=u+1),h===n?l===-1?l=u:o!==1&&(o=1):l!==-1&&(o=-1)}return l===-1||t===-1||o===0||o===1&&l===t-1&&l===s+1?"":c.slice(l,t)},format:a.bind(null,"/"),parse(c){w(c,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return l;const s=c.charCodeAt(0)===y;let t;s?(l.root="/",t=1):t=0;let r=-1,o=0,u=-1,h=!0,f=c.length-1,I=0;for(;f>=t;--f){const A=c.charCodeAt(f);if(A===y){if(!h){o=f+1;break}continue}u===-1&&(h=!1,u=f+1),A===n?r===-1?r=f:I!==1&&(I=1):r!==-1&&(I=-1)}if(u!==-1){const A=o===0&&s?1:o;r===-1||I===0||I===1&&r===u-1&&r===o+1?l.base=l.name=c.slice(A,u):(l.name=c.slice(A,r),l.base=c.slice(A,u),l.ext=c.slice(r,u))}return o>0?l.dir=c.slice(0,o-1):s&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[77],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ScanCodeBinding=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.ScanCode=void 0;var v;(function(n){n[n.DependsOnKbLayout=-1]="DependsOnKbLayout",n[n.None=0]="None",n[n.Hyper=1]="Hyper",n[n.Super=2]="Super",n[n.Fn=3]="Fn",n[n.FnLock=4]="FnLock",n[n.Suspend=5]="Suspend",n[n.Resume=6]="Resume",n[n.Turbo=7]="Turbo",n[n.Sleep=8]="Sleep",n[n.WakeUp=9]="WakeUp",n[n.KeyA=10]="KeyA",n[n.KeyB=11]="KeyB",n[n.KeyC=12]="KeyC",n[n.KeyD=13]="KeyD",n[n.KeyE=14]="KeyE",n[n.KeyF=15]="KeyF",n[n.KeyG=16]="KeyG",n[n.KeyH=17]="KeyH",n[n.KeyI=18]="KeyI",n[n.KeyJ=19]="KeyJ",n[n.KeyK=20]="KeyK",n[n.KeyL=21]="KeyL",n[n.KeyM=22]="KeyM",n[n.KeyN=23]="KeyN",n[n.KeyO=24]="KeyO",n[n.KeyP=25]="KeyP",n[n.KeyQ=26]="KeyQ",n[n.KeyR=27]="KeyR",n[n.KeyS=28]="KeyS",n[n.KeyT=29]="KeyT",n[n.KeyU=30]="KeyU",n[n.KeyV=31]="KeyV",n[n.KeyW=32]="KeyW",n[n.KeyX=33]="KeyX",n[n.KeyY=34]="KeyY",n[n.KeyZ=35]="KeyZ",n[n.Digit1=36]="Digit1",n[n.Digit2=37]="Digit2",n[n.Digit3=38]="Digit3",n[n.Digit4=39]="Digit4",n[n.Digit5=40]="Digit5",n[n.Digit6=41]="Digit6",n[n.Digit7=42]="Digit7",n[n.Digit8=43]="Digit8",n[n.Digit9=44]="Digit9",n[n.Digit0=45]="Digit0",n[n.Enter=46]="Enter",n[n.Escape=47]="Escape",n[n.Backspace=48]="Backspace",n[n.Tab=49]="Tab",n[n.Space=50]="Space",n[n.Minus=51]="Minus",n[n.Equal=52]="Equal",n[n.BracketLeft=53]="BracketLeft",n[n.BracketRight=54]="BracketRight",n[n.Backslash=55]="Backslash",n[n.IntlHash=56]="IntlHash",n[n.Semicolon=57]="Semicolon",n[n.Quote=58]="Quote",n[n.Backquote=59]="Backquote",n[n.Comma=60]="Comma",n[n.Period=61]="Period",n[n.Slash=62]="Slash",n[n.CapsLock=63]="CapsLock",n[n.F1=64]="F1",n[n.F2=65]="F2",n[n.F3=66]="F3",n[n.F4=67]="F4",n[n.F5=68]="F5",n[n.F6=69]="F6",n[n.F7=70]="F7",n[n.F8=71]="F8",n[n.F9=72]="F9",n[n.F10=73]="F10",n[n.F11=74]="F11",n[n.F12=75]="F12",n[n.PrintScreen=76]="PrintScreen",n[n.ScrollLock=77]="ScrollLock",n[n.Pause=78]="Pause",n[n.Insert=79]="Insert",n[n.Home=80]="Home",n[n.PageUp=81]="PageUp",n[n.Delete=82]="Delete",n[n.End=83]="End",n[n.PageDown=84]="PageDown",n[n.ArrowRight=85]="ArrowRight",n[n.ArrowLeft=86]="ArrowLeft",n[n.ArrowDown=87]="ArrowDown",n[n.ArrowUp=88]="ArrowUp",n[n.NumLock=89]="NumLock",n[n.NumpadDivide=90]="NumpadDivide",n[n.NumpadMultiply=91]="NumpadMultiply",n[n.NumpadSubtract=92]="NumpadSubtract",n[n.NumpadAdd=93]="NumpadAdd",n[n.NumpadEnter=94]="NumpadEnter",n[n.Numpad1=95]="Numpad1",n[n.Numpad2=96]="Numpad2",n[n.Numpad3=97]="Numpad3",n[n.Numpad4=98]="Numpad4",n[n.Numpad5=99]="Numpad5",n[n.Numpad6=100]="Numpad6",n[n.Numpad7=101]="Numpad7",n[n.Numpad8=102]="Numpad8",n[n.Numpad9=103]="Numpad9",n[n.Numpad0=104]="Numpad0",n[n.NumpadDecimal=105]="NumpadDecimal",n[n.IntlBackslash=106]="IntlBackslash",n[n.ContextMenu=107]="ContextMenu",n[n.Power=108]="Power",n[n.NumpadEqual=109]="NumpadEqual",n[n.F13=110]="F13",n[n.F14=111]="F14",n[n.F15=112]="F15",n[n.F16=113]="F16",n[n.F17=114]="F17",n[n.F18=115]="F18",n[n.F19=116]="F19",n[n.F20=117]="F20",n[n.F21=118]="F21",n[n.F22=119]="F22",n[n.F23=120]="F23",n[n.F24=121]="F24",n[n.Open=122]="Open",n[n.Help=123]="Help",n[n.Select=124]="Select",n[n.Again=125]="Again",n[n.Undo=126]="Undo",n[n.Cut=127]="Cut",n[n.Copy=128]="Copy",n[n.Paste=129]="Paste",n[n.Find=130]="Find",n[n.AudioVolumeMute=131]="AudioVolumeMute",n[n.AudioVolumeUp=132]="AudioVolumeUp",n[n.AudioVolumeDown=133]="AudioVolumeDown",n[n.NumpadComma=134]="NumpadComma",n[n.IntlRo=135]="IntlRo",n[n.KanaMode=136]="KanaMode",n[n.IntlYen=137]="IntlYen",n[n.Convert=138]="Convert",n[n.NonConvert=139]="NonConvert",n[n.Lang1=140]="Lang1",n[n.Lang2=141]="Lang2",n[n.Lang3=142]="Lang3",n[n.Lang4=143]="Lang4",n[n.Lang5=144]="Lang5",n[n.Abort=145]="Abort",n[n.Props=146]="Props",n[n.NumpadParenLeft=147]="NumpadParenLeft",n[n.NumpadParenRight=148]="NumpadParenRight",n[n.NumpadBackspace=149]="NumpadBackspace",n[n.NumpadMemoryStore=150]="NumpadMemoryStore",n[n.NumpadMemoryRecall=151]="NumpadMemoryRecall",n[n.NumpadMemoryClear=152]="NumpadMemoryClear",n[n.NumpadMemoryAdd=153]="NumpadMemoryAdd",n[n.NumpadMemorySubtract=154]="NumpadMemorySubtract",n[n.NumpadClear=155]="NumpadClear",n[n.NumpadClearEntry=156]="NumpadClearEntry",n[n.ControlLeft=157]="ControlLeft",n[n.ShiftLeft=158]="ShiftLeft",n[n.AltLeft=159]="AltLeft",n[n.MetaLeft=160]="MetaLeft",n[n.ControlRight=161]="ControlRight",n[n.ShiftRight=162]="ShiftRight",n[n.AltRight=163]="AltRight",n[n.MetaRight=164]="MetaRight",n[n.BrightnessUp=165]="BrightnessUp",n[n.BrightnessDown=166]="BrightnessDown",n[n.MediaPlay=167]="MediaPlay",n[n.MediaRecord=168]="MediaRecord",n[n.MediaFastForward=169]="MediaFastForward",n[n.MediaRewind=170]="MediaRewind",n[n.MediaTrackNext=171]="MediaTrackNext",n[n.MediaTrackPrevious=172]="MediaTrackPrevious",n[n.MediaStop=173]="MediaStop",n[n.Eject=174]="Eject",n[n.MediaPlayPause=175]="MediaPlayPause",n[n.MediaSelect=176]="MediaSelect",n[n.LaunchMail=177]="LaunchMail",n[n.LaunchApp2=178]="LaunchApp2",n[n.LaunchApp1=179]="LaunchApp1",n[n.SelectTask=180]="SelectTask",n[n.LaunchScreenSaver=181]="LaunchScreenSaver",n[n.BrowserSearch=182]="BrowserSearch",n[n.BrowserHome=183]="BrowserHome",n[n.BrowserBack=184]="BrowserBack",n[n.BrowserForward=185]="BrowserForward",n[n.BrowserStop=186]="BrowserStop",n[n.BrowserRefresh=187]="BrowserRefresh",n[n.BrowserFavorites=188]="BrowserFavorites",n[n.ZoomToggle=189]="ZoomToggle",n[n.MailReply=190]="MailReply",n[n.MailForward=191]="MailForward",n[n.MailSend=192]="MailSend",n[n.MAX_VALUE=193]="MAX_VALUE"})(v=e.ScanCode||(e.ScanCode={}));const R=[],D=Object.create(null),S=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:n=>S[n]||0,toEnum:n=>D[n]||0,toString:n=>R[n]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];class k{constructor(y,i,L,g,E){this.ctrlKey=y,this.shiftKey=i,this.altKey=L,this.metaKey=g,this.scanCode=E}equals(y){return this.ctrlKey===y.ctrlKey&&this.shiftKey===y.shiftKey&&this.altKey===y.altKey&&this.metaKey===y.metaKey&&this.scanCode===y.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=k,function(){function n(y,i){R[y]=i,D[i]=y,S[i.toLowerCase()]=y}n(0,"None"),n(1,"Hyper"),n(2,"Super"),n(3,"Fn"),n(4,"FnLock"),n(5,"Suspend"),n(6,"Resume"),n(7,"Turbo"),n(8,"Sleep"),n(9,"WakeUp"),n(10,"KeyA"),n(11,"KeyB"),n(12,"KeyC"),n(13,"KeyD"),n(14,"KeyE"),n(15,"KeyF"),n(16,"KeyG"),n(17,"KeyH"),n(18,"KeyI"),n(19,"KeyJ"),n(20,"KeyK"),n(21,"KeyL"),n(22,"KeyM"),n(23,"KeyN"),n(24,"KeyO"),n(25,"KeyP"),n(26,"KeyQ"),n(27,"KeyR"),n(28,"KeyS"),n(29,"KeyT"),n(30,"KeyU"),n(31,"KeyV"),n(32,"KeyW"),n(33,"KeyX"),n(34,"KeyY"),n(35,"KeyZ"),n(36,"Digit1"),n(37,"Digit2"),n(38,"Digit3"),n(39,"Digit4"),n(40,"Digit5"),n(41,"Digit6"),n(42,"Digit7"),n(43,"Digit8"),n(44,"Digit9"),n(45,"Digit0"),n(46,"Enter"),n(47,"Escape"),n(48,"Backspace"),n(49,"Tab"),n(50,"Space"),n(51,"Minus"),n(52,"Equal"),n(53,"BracketLeft"),n(54,"BracketRight"),n(55,"Backslash"),n(56,"IntlHash"),n(57,"Semicolon"),n(58,"Quote"),n(59,"Backquote"),n(60,"Comma"),n(61,"Period"),n(62,"Slash"),n(63,"CapsLock"),n(64,"F1"),n(65,"F2"),n(66,"F3"),n(67,"F4"),n(68,"F5"),n(69,"F6"),n(70,"F7"),n(71,"F8"),n(72,"F9"),n(73,"F10"),n(74,"F11"),n(75,"F12"),n(76,"PrintScreen"),n(77,"ScrollLock"),n(78,"Pause"),n(79,"Insert"),n(80,"Home"),n(81,"PageUp"),n(82,"Delete"),n(83,"End"),n(84,"PageDown"),n(85,"ArrowRight"),n(86,"ArrowLeft"),n(87,"ArrowDown"),n(88,"ArrowUp"),n(89,"NumLock"),n(90,"NumpadDivide"),n(91,"NumpadMultiply"),n(92,"NumpadSubtract"),n(93,"NumpadAdd"),n(94,"NumpadEnter"),n(95,"Numpad1"),n(96,"Numpad2"),n(97,"Numpad3"),n(98,"Numpad4"),n(99,"Numpad5"),n(100,"Numpad6"),n(101,"Numpad7"),n(102,"Numpad8"),n(103,"Numpad9"),n(104,"Numpad0"),n(105,"NumpadDecimal"),n(106,"IntlBackslash"),n(107,"ContextMenu"),n(108,"Power"),n(109,"NumpadEqual"),n(110,"F13"),n(111,"F14"),n(112,"F15"),n(113,"F16"),n(114,"F17"),n(115,"F18"),n(116,"F19"),n(117,"F20"),n(118,"F21"),n(119,"F22"),n(120,"F23"),n(121,"F24"),n(122,"Open"),n(123,"Help"),n(124,"Select"),n(125,"Again"),n(126,"Undo"),n(127,"Cut"),n(128,"Copy"),n(129,"Paste"),n(130,"Find"),n(131,"AudioVolumeMute"),n(132,"AudioVolumeUp"),n(133,"AudioVolumeDown"),n(134,"NumpadComma"),n(135,"IntlRo"),n(136,"KanaMode"),n(137,"IntlYen"),n(138,"Convert"),n(139,"NonConvert"),n(140,"Lang1"),n(141,"Lang2"),n(142,"Lang3"),n(143,"Lang4"),n(144,"Lang5"),n(145,"Abort"),n(146,"Props"),n(147,"NumpadParenLeft"),n(148,"NumpadParenRight"),n(149,"NumpadBackspace"),n(150,"NumpadMemoryStore"),n(151,"NumpadMemoryRecall"),n(152,"NumpadMemoryClear"),n(153,"NumpadMemoryAdd"),n(154,"NumpadMemorySubtract"),n(155,"NumpadClear"),n(156,"NumpadClearEntry"),n(157,"ControlLeft"),n(158,"ShiftLeft"),n(159,"AltLeft"),n(160,"MetaLeft"),n(161,"ControlRight"),n(162,"ShiftRight"),n(163,"AltRight"),n(164,"MetaRight"),n(165,"BrightnessUp"),n(166,"BrightnessDown"),n(167,"MediaPlay"),n(168,"MediaRecord"),n(169,"MediaFastForward"),n(170,"MediaRewind"),n(171,"MediaTrackNext"),n(172,"MediaTrackPrevious"),n(173,"MediaStop"),n(174,"Eject"),n(175,"MediaPlayPause"),n(176,"MediaSelect"),n(177,"LaunchMail"),n(178,"LaunchApp2"),n(179,"LaunchApp1"),n(180,"SelectTask"),n(181,"LaunchScreenSaver"),n(182,"BrowserSearch"),n(183,"BrowserHome"),n(184,"BrowserBack"),n(185,"BrowserForward"),n(186,"BrowserStop"),n(187,"BrowserRefresh"),n(188,"BrowserFavorites"),n(189,"ZoomToggle"),n(190,"MailReply"),n(191,"MailForward"),n(192,"MailSend")}(),function(){for(let y=0;y<=193;y++)e.IMMUTABLE_CODE_TO_KEY_CODE[y]=-1;for(let y=0;y<=112;y++)e.IMMUTABLE_KEY_CODE_TO_CODE[y]=-1;function n(y,i){e.IMMUTABLE_CODE_TO_KEY_CODE[y]=i,i!==0&&i!==3&&i!==5&&i!==4&&i!==6&&i!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[i]=y)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46,n(0,0),n(1,0),n(2,0),n(3,0),n(4,0),n(5,0),n(6,0),n(7,0),n(8,0),n(9,0),n(46,3),n(47,9),n(48,1),n(49,2),n(50,10),n(63,8),n(64,59),n(65,60),n(66,61),n(67,62),n(68,63),n(69,64),n(70,65),n(71,66),n(72,67),n(73,68),n(74,69),n(75,70),n(76,0),n(77,79),n(78,7),n(79,19),n(80,14),n(81,11),n(82,20),n(83,13),n(84,12),n(85,17),n(86,15),n(87,18),n(88,16),n(89,78),n(90,108),n(91,103),n(92,106),n(93,104),n(94,3),n(95,94),n(96,95),n(97,96),n(98,97),n(99,98),n(100,99),n(101,100),n(102,101),n(103,102),n(104,93),n(105,107),n(107,58),n(108,0),n(109,0),n(110,71),n(111,72),n(112,73),n(113,74),n(114,75),n(115,76),n(116,77),n(117,0),n(118,0),n(119,0),n(120,0),n(121,0),n(122,0),n(123,0),n(124,0),n(125,0),n(126,0),n(127,0),n(128,0),n(129,0),n(130,0),n(131,0),n(132,0),n(133,0),n(134,105),n(136,0),n(138,0),n(139,0),n(140,0),n(141,0),n(142,0),n(143,0),n(144,0),n(145,0),n(146,0),n(147,0),n(148,0),n(149,0),n(150,0),n(151,0),n(152,0),n(153,0),n(154,0),n(155,0),n(156,0),n(157,5),n(158,4),n(159,6),n(160,57),n(161,5),n(162,4),n(163,6),n(164,57),n(165,0),n(166,0),n(167,0),n(168,0),n(169,0),n(170,0),n(171,0),n(172,0),n(173,0),n(174,0),n(175,0),n(176,0),n(177,0),n(178,0),n(179,0),n(180,0),n(181,0),n(182,0),n(183,0),n(184,0),n(185,0),n(186,0),n(187,0),n(188,0),n(189,0),n(190,0),n(191,0),n(192,0)}()}),define(X[103],Q([0,1,57,77]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(k){k=k.toLowerCase().trim();let n=!1,y=!1,i=!1,L=!1,g;do g=!1,/^ctrl(\+|\-)/.test(k)&&(n=!0,k=k.substr("ctrl-".length),g=!0),/^shift(\+|\-)/.test(k)&&(y=!0,k=k.substr("shift-".length),g=!0),/^alt(\+|\-)/.test(k)&&(i=!0,k=k.substr("alt-".length),g=!0),/^meta(\+|\-)/.test(k)&&(L=!0,k=k.substr("meta-".length),g=!0),/^win(\+|\-)/.test(k)&&(L=!0,k=k.substr("win-".length),g=!0),/^cmd(\+|\-)/.test(k)&&(L=!0,k=k.substr("cmd-".length),g=!0);while(g);let E;const w=k.indexOf(" ");return w>0?(E=k.substring(0,w),k=k.substring(w)):(E=k,k=""),{remains:k,ctrl:n,shift:y,alt:i,meta:L,key:E}}static parseSimpleKeybinding(k){const n=this._readModifiers(k),y=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,y),n.remains]}static parseKeybinding(k,n){if(!k)return null;const y=[];let i;do[i,k]=this.parseSimpleKeybinding(k),y.push(i);while(k.length>0);return new v.ChordKeybinding(y)}static parseSimpleUserBinding(k){const n=this._readModifiers(k),y=n.key.match(/^\[([^\]]+)\]$/);if(y){const L=y[1],g=R.ScanCodeUtils.lowerCaseToEnum(L);return[new R.ScanCodeBinding(n.ctrl,n.shift,n.alt,n.meta,g),n.remains]}const i=v.KeyCodeUtils.fromUserSettings(n.key);return[new v.SimpleKeybinding(n.ctrl,n.shift,n.alt,n.meta,i),n.remains]}static parseUserBinding(k){if(!k)return[];const n=[];let y;for(;k.length>0;)[y,k]=this.parseSimpleUserBinding(k),n.push(y);return n}}e.KeybindingParser=D}),define(X[104],Q([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=v.globals.performance&&typeof v.globals.performance.now=="function";class D{constructor(k){this._highResolution=R&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new D(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=D}),define(X[5],Q([0,1,19,43,2,76,104]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var n;(function(p){p.None=()=>D.Disposable.None;function a(V){return(N,z=null,W)=>{let $=!1,C;return C=V(P=>{if(!$)return C?C.dispose():$=!0,N.call(z,P)},null,W),$&&C.dispose(),C}}p.once=a;function c(V,N){return u((z,W=null,$)=>V(C=>z.call(W,N(C)),null,$))}p.map=c;function l(V,N){return u((z,W=null,$)=>V(C=>{N(C),z.call(W,C)},null,$))}p.forEach=l;function s(V,N){return u((z,W=null,$)=>V(C=>N(C)&&z.call(W,C),null,$))}p.filter=s;function t(V){return V}p.signal=t;function r(...V){return(N,z=null,W)=>(0,D.combinedDisposable)(...V.map($=>$(C=>N.call(z,C),null,W)))}p.any=r;function o(V,N,z){let W=z;return c(V,$=>(W=N(W,$),W))}p.reduce=o;function u(V){let N;const z=new E({onFirstListenerAdd(){N=V(z.fire,z)},onLastListenerRemove(){N.dispose()}});return z.event}p.snapshot=u;function h(V,N,z=100,W=!1,$){let C,P,M,_=0;const T=new E({leakWarningThreshold:$,onFirstListenerAdd(){C=V(O=>{_++,P=N(P,O),W&&!M&&(T.fire(P),P=void 0),clearTimeout(M),M=setTimeout(()=>{const B=P;P=void 0,M=void 0,(!W||_>1)&&T.fire(B),_=0},z)})},onLastListenerRemove(){C.dispose()}});return T.event}p.debounce=h;function f(V){const N=new Date().getTime();return c(a(V),z=>new Date().getTime()-N)}p.stopwatch=f;function I(V){let N=!0,z;return s(V,W=>{const $=N||W!==z;return N=!1,z=W,$})}p.latch=I;function A(V,N=!1,z=[]){let W=z.slice(),$=V(M=>{W?W.push(M):P.fire(M)});const C=()=>{W&&W.forEach(M=>P.fire(M)),W=null},P=new E({onFirstListenerAdd(){$||($=V(M=>P.fire(M)))},onFirstListenerDidAdd(){W&&(N?setTimeout(C):C())},onLastListenerRemove(){$&&$.dispose(),$=null}});return P.event}p.buffer=A;class F{constructor(N){this.event=N}map(N){return new F(c(this.event,N))}forEach(N){return new F(l(this.event,N))}filter(N){return new F(s(this.event,N))}reduce(N,z){return new F(o(this.event,N,z))}latch(){return new F(I(this.event))}debounce(N,z=100,W=!1,$){return new F(h(this.event,N,z,W,$))}on(N,z,W){return this.event(N,z,W)}once(N,z,W){return a(this.event)(N,z,W)}}function U(V){return new F(V)}p.chain=U;function q(V,N,z=W=>W){const W=(...M)=>P.fire(z(...M)),$=()=>V.on(N,W),C=()=>V.removeListener(N,W),P=new E({onFirstListenerAdd:$,onLastListenerRemove:C});return P.event}p.fromNodeEventEmitter=q;function Y(V,N,z=W=>W){const W=(...M)=>P.fire(z(...M)),$=()=>V.addEventListener(N,W),C=()=>V.removeEventListener(N,W),P=new E({onFirstListenerAdd:$,onLastListenerRemove:C});return P.event}p.fromDOMEventEmitter=Y;function ie(V){const N=new E;let z=!1;return V.then(void 0,()=>null).then(()=>{z?N.fire(void 0):setTimeout(()=>N.fire(void 0),0)}),z=!0,N.event}p.fromPromise=ie;function ae(V){return new Promise(N=>a(V)(N))}p.toPromise=ae})(n=e.Event||(e.Event={}));class y{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${y._idPool++}`}start(a){this._stopWatch=new k.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}y._idPool=0;let i=-1;function L(p){const a=i;return i=p,{dispose(){i=a}}}e.setGlobalLeakWarningThreshold=L;class g{constructor(a,c=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=c,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a){let c=i;if(typeof this.customThreshold=="number"&&(c=this.customThreshold),!(c<=0||a<c)){this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(l)||0;if(this._stacks.set(l,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=c*.5;let t,r=0;for(const[o,u]of this._stacks)(!t||r<u)&&(t=o,r=u);console.warn(`[${this.name}] potential listener LEAK detected, having ${a} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}}class E{constructor(a){var c;this._disposed=!1,this._options=a,this._leakageMon=i>0?new g(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((c=this._options)===null||c===void 0?void 0:c._profName)?new y(this._options._profName):void 0}get event(){return this._event||(this._event=(a,c,l)=>{var s;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(c?[a,c]:a);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,c);const o=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let u;return u={dispose:()=>{o&&o(),u.dispose=E._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof D.DisposableStore?l.add(u):Array.isArray(l)&&l.push(u),u}),this._event}fire(a){var c,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,a]);for((c=this._perfMon)===null||c===void 0||c.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(r){(0,v.onUnexpectedError)(r)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var a,c,l;(a=this._listeners)===null||a===void 0||a.clear(),(c=this._deliveryQueue)===null||c===void 0||c.clear(),(l=this._leakageMon)===null||l===void 0||l.dispose(),this._disposed=!0}}e.Emitter=E,E._noop=function(){};class w extends E{constructor(a){super(a);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=a==null?void 0:a.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=w;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new E({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const c={event:a,listener:null};this.events.push(c),this.hasListeners&&this.hook(c);const l=()=>{this.hasListeners&&this.unhook(c);const s=this.events.indexOf(c);this.events.splice(s,1)};return(0,D.toDisposable)((0,R.once)(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(c=>this.emitter.fire(c))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class m{constructor(){this.buffers=[]}wrapEvent(a){return(c,l,s)=>a(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>c.call(l,t)):c.call(l,t)},void 0,s)}bufferEvents(a){const c=[];this.buffers.push(c);const l=a();return this.buffers.pop(),c.forEach(s=>s()),l}}e.EventBufferer=m;class b{constructor(){this.listening=!1,this.inputEvent=n.None,this.inputEventListener=D.Disposable.None,this.emitter=new E({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=b}),define(X[25],Q([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(n,y){const i=setTimeout(n.bind(y),0);return{dispose(){clearTimeout(i)}}});var D;(function(n){function y(i){return i===n.None||i===n.Cancelled||i instanceof S?!0:!i||typeof i!="object"?!1:typeof i.isCancellationRequested=="boolean"&&typeof i.onCancellationRequested=="function"}n.isCancellationToken=y,n.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),n.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(y){this._token=void 0,this._parentListener=void 0,this._parentListener=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=D.Cancelled}dispose(y=!1){y&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=k}),define(X[105],Q([0,1,5]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(L){const g=this._icons.get(L.id);g?L.description?g.description=L.description:console.error(`Duplicate registration of codicon ${L.id}`):(this._icons.set(L.id,L),this._onDidRegister.fire(L))}get(L){return this._icons.get(L)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function S(i,L){return new k(i,L)}e.registerCodicon=S;class k{constructor(L,g,E){this.id=L,this.definition=g,this.description=E,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=k;function n(i,L){const g=["codicon","codicon-"+i];return L&&g.push("codicon-modifier-"+L),g}e.getClassNamesArray=n;var y;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const L=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function g(d){if(d instanceof k)return["codicon","codicon-"+d.id];const m=L.exec(d.id);if(!m)return g(k.error);let[,b,p]=m;const a=["codicon","codicon-"+b];return p&&a.push("codicon-modifier-"+p.substr(1)),a}i.asClassNameArray=g;function E(d){return g(d).join(" ")}i.asClassName=E;function w(d){return"."+g(d).join(".")}i.asCSSSelector=w})(y=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personAdd=new i("person-add",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnknown=new i("workspace-unknown",{fontCharacter:"\\ebc3"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(k=e.Codicon||(e.Codicon={}))}),define(X[58],Q([0,1,19,2]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transform=e.toReadable=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(b){const p=b;return p&&[p.on,p.pause,p.resume,p.destroy].every(a=>typeof a=="function")}e.isReadableStream=D;function S(b){const p=b;return p&&D(p.stream)&&Array.isArray(p.buffer)&&typeof p.ended=="boolean"}e.isReadableBufferedStream=S;function k(b,p){return new n(b,p)}e.newWriteableStream=k;class n{constructor(p,a){this.reducer=p,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(p){var a;if(!this.state.destroyed){if(this.state.flowing)this.emitData(p);else if(this.buffer.data.push(p),typeof((a=this.options)===null||a===void 0?void 0:a.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(p){this.state.destroyed||(this.state.flowing?this.emitError(p):this.buffer.error.push(p))}end(p){this.state.destroyed||(typeof p!="undefined"&&this.write(p),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(p){this.listeners.data.slice(0).forEach(a=>a(p))}emitError(p){this.listeners.error.length===0?(0,v.onUnexpectedError)(p):this.listeners.error.slice(0).forEach(a=>a(p))}emitEnd(){this.listeners.end.slice(0).forEach(p=>p())}on(p,a){if(!this.state.destroyed)switch(p){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(p,a){if(!this.state.destroyed){let c;switch(p){case"data":c=this.listeners.data;break;case"end":c=this.listeners.end;break;case"error":c=this.listeners.error;break}if(c){const l=c.indexOf(a);l>=0&&c.splice(l,1)}}}flowData(){if(this.buffer.data.length>0){const p=this.reducer(this.buffer.data);this.emitData(p),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(c=>c())}}flowErrors(){if(this.listeners.error.length>0){for(const p of this.buffer.error)this.emitError(p);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(b,p){const a=[];let c;for(;(c=b.read())!==null;)a.push(c);return p(a)}e.consumeReadable=y;function i(b,p,a){const c=[];let l;for(;(l=b.read())!==null&&c.length<a;)c.push(l);return l===null&&c.length>0?p(c):{read:()=>{if(c.length>0)return c.shift();if(typeof l!="undefined"){const s=l;return l=void 0,s}return b.read()}}}e.peekReadable=i;function L(b,p){return new Promise((a,c)=>{const l=[];g(b,{onData:s=>{p&&l.push(s)},onError:s=>{p?c(s):a(void 0)},onEnd:()=>{a(p?p(l):void 0)}})})}e.consumeStream=L;function g(b,p){b.on("error",a=>p.onError(a)),b.on("end",()=>p.onEnd()),b.on("data",a=>p.onData(a))}e.listenStream=g;function E(b,p){return new Promise((a,c)=>{const l=new R.DisposableStore,s=[],t=u=>{if(s.push(u),s.length>p)return l.dispose(),b.pause(),a({stream:b,buffer:s,ended:!1})},r=u=>c(u),o=()=>a({stream:b,buffer:s,ended:!0});l.add((0,R.toDisposable)(()=>b.removeListener("error",r))),b.on("error",r),l.add((0,R.toDisposable)(()=>b.removeListener("end",o))),b.on("end",o),l.add((0,R.toDisposable)(()=>b.removeListener("data",t))),b.on("data",t)})}e.peekStream=E;function w(b,p){const a=k(p);return a.end(b),a}e.toStream=w;function d(b){let p=!1;return{read:()=>p?null:(p=!0,b)}}e.toReadable=d;function m(b,p,a){const c=k(a);return g(b,{onData:l=>c.write(p.data(l)),onError:l=>c.error(p.error?p.error(l):l),onEnd:()=>c.end()}),c}e.transform=m}),define(X[20],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function v(H){return!H||typeof H!="string"?!0:H.trim().length===0}e.isFalsyOrWhitespace=v;const R=/{(\d+)}/g;function D(H,...te){return te.length===0?H:H.replace(R,function(se,le){const fe=parseInt(le,10);return isNaN(fe)||fe<0||fe>=te.length?se:te[fe]})}e.format=D;function S(H){return H.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=S;function k(H){return H.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function n(H,te){let se=0;const le=te.charCodeAt(0);for(let fe=H.length-1;fe>=0;fe--)H.charCodeAt(fe)===le&&se++;return se}e.count=n;function y(H,te,se="\u2026"){return H.length<=te?H:`${H.substr(0,te)}${se}`}e.truncate=y;function i(H,te=" "){const se=L(H,te);return g(se,te)}e.trim=i;function L(H,te){if(!H||!te)return H;const se=te.length;if(se===0||H.length===0)return H;let le=0;for(;H.indexOf(te,le)===le;)le=le+se;return H.substring(le)}e.ltrim=L;function g(H,te){if(!H||!te)return H;const se=te.length,le=H.length;if(se===0||le===0)return H;let fe=le,pe=-1;for(;pe=H.lastIndexOf(te,fe-1),!(pe===-1||pe+se!==fe);){if(pe===0)return"";fe=pe}return H.substring(0,fe)}e.rtrim=g;function E(H){return H.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=E;function w(H){return H.replace(/\*/g,"")}e.stripWildcards=w;function d(H,te,se={}){if(!H)throw new Error("Cannot create regex from empty string");te||(H=k(H)),se.wholeWord&&(/\B/.test(H.charAt(0))||(H="\\b"+H),/\B/.test(H.charAt(H.length-1))||(H=H+"\\b"));let le="";return se.global&&(le+="g"),se.matchCase||(le+="i"),se.multiline&&(le+="m"),se.unicode&&(le+="u"),new RegExp(H,le)}e.createRegExp=d;function m(H){return H.source==="^"||H.source==="^$"||H.source==="$"||H.source==="^\\s*$"?!1:!!(H.exec("")&&H.lastIndex===0)}e.regExpLeadsToEndlessLoop=m;function b(H){return!!H.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=b;function p(H){return(H.global?"g":"")+(H.ignoreCase?"i":"")+(H.multiline?"m":"")+(H.unicode?"u":"")}e.regExpFlags=p;function a(H){return H.split(/\r\n|\r|\n/)}e.splitLines=a;function c(H){for(let te=0,se=H.length;te<se;te++){const le=H.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=c;function l(H,te=0,se=H.length){for(let le=te;le<se;le++){const fe=H.charCodeAt(le);if(fe!==32&&fe!==9)return H.substring(te,le)}return H.substring(te,se)}e.getLeadingWhitespace=l;function s(H,te=H.length-1){for(let se=te;se>=0;se--){const le=H.charCodeAt(se);if(le!==32&&le!==9)return se}return-1}e.lastNonWhitespaceIndex=s;function t(H,te){return H<te?-1:H>te?1:0}e.compare=t;function r(H,te,se=0,le=H.length,fe=0,pe=te.length){for(;se<le&&fe<pe;se++,fe++){let Oe=H.charCodeAt(se),Ue=te.charCodeAt(fe);if(Oe<Ue)return-1;if(Oe>Ue)return 1}const be=le-se,Te=pe-fe;return be<Te?-1:be>Te?1:0}e.compareSubstring=r;function o(H,te){return u(H,te,0,H.length,0,te.length)}e.compareIgnoreCase=o;function u(H,te,se=0,le=H.length,fe=0,pe=te.length){for(;se<le&&fe<pe;se++,fe++){let Oe=H.charCodeAt(se),Ue=te.charCodeAt(fe);if(Oe!==Ue){const je=Oe-Ue;if(!(je===32&&f(Ue))&&!(je===-32&&f(Oe)))return h(Oe)&&h(Ue)?je:r(H.toLowerCase(),te.toLowerCase(),se,le,fe,pe)}}const be=le-se,Te=pe-fe;return be<Te?-1:be>Te?1:0}e.compareSubstringIgnoreCase=u;function h(H){return H>=97&&H<=122}e.isLowerAsciiLetter=h;function f(H){return H>=65&&H<=90}e.isUpperAsciiLetter=f;function I(H){return h(H)||f(H)}function A(H,te){return H.length===te.length&&F(H,te)}e.equalsIgnoreCase=A;function F(H,te,se=H.length){for(let le=0;le<se;le++){const fe=H.charCodeAt(le),pe=te.charCodeAt(le);if(fe!==pe){if(I(fe)&&I(pe)){const be=Math.abs(fe-pe);if(be!==0&&be!==32)return!1}else if(String.fromCharCode(fe).toLowerCase()!==String.fromCharCode(pe).toLowerCase())return!1}}return!0}function U(H,te){const se=te.length;return te.length>H.length?!1:F(H,te,se)}e.startsWithIgnoreCase=U;function q(H,te){let se,le=Math.min(H.length,te.length);for(se=0;se<le;se++)if(H.charCodeAt(se)!==te.charCodeAt(se))return se;return le}e.commonPrefixLength=q;function Y(H,te){let se,le=Math.min(H.length,te.length);const fe=H.length-1,pe=te.length-1;for(se=0;se<le;se++)if(H.charCodeAt(fe-se)!==te.charCodeAt(pe-se))return se;return le}e.commonSuffixLength=Y;function ie(H){return 55296<=H&&H<=56319}e.isHighSurrogate=ie;function ae(H){return 56320<=H&&H<=57343}e.isLowSurrogate=ae;function V(H,te){return(H-55296<<10)+(te-56320)+65536}e.computeCodePoint=V;function N(H,te,se){const le=H.charCodeAt(se);if(ie(le)&&se+1<te){const fe=H.charCodeAt(se+1);if(ae(fe))return V(le,fe)}return le}e.getNextCodePoint=N;function z(H,te){const se=H.charCodeAt(te-1);if(ae(se)&&te>1){const le=H.charCodeAt(te-2);if(ie(le))return V(le,se)}return se}function W(H,te){const se=Be.getInstance(),le=te,fe=H.length,pe=N(H,fe,te);te+=pe>=65536?2:1;let be=se.getGraphemeBreakType(pe);for(;te<fe;){const Te=N(H,fe,te),Oe=se.getGraphemeBreakType(Te);if(Ge(be,Oe))break;te+=Te>=65536?2:1,be=Oe}return te-le}e.nextCharLength=W;function $(H,te){const se=Be.getInstance(),le=te,fe=z(H,te);te-=fe>=65536?2:1;let pe=se.getGraphemeBreakType(fe);for(;te>0;){const be=z(H,te),Te=se.getGraphemeBreakType(be);if(Ge(Te,pe))break;te-=be>=65536?2:1,pe=Te}return le-te}e.prevCharLength=$;function C(H,te){const se=Be.getInstance(),le=H.length,fe=te,pe=N(H,le,te),be=se.getGraphemeBreakType(pe);te+=pe>=65536?2:1;let Te=be;for(;te<le;){const Ue=N(H,le,te),je=se.getGraphemeBreakType(Ue);if(Ge(Te,je))break;te+=Ue>=65536?2:1,Te=je}const Oe=te;for(te=fe,Te=be;te>0;){const Ue=z(H,te),je=se.getGraphemeBreakType(Ue);if(Ge(je,Te))break;te-=Ue>=65536?2:1,Te=je}return[te,Oe]}function P(H,te){return te>0&&ae(H.charCodeAt(te))?C(H,te-1):C(H,te)}e.getCharContainingOffset=P;function M(H){const te=H.length;let se=0,le=0;for(;le<te;){const be=N(H,te,le);le+=be>=65536?2:1,be<128?se+=1:be<2048?se+=2:be<65536?se+=3:se+=4}const fe=new Uint8Array(se);le=0;let pe=0;for(;le<te;){const be=N(H,te,le);le+=be>=65536?2:1,be<128?fe[pe++]=be:be<2048?(fe[pe++]=192|(be&1984)>>>6,fe[pe++]=128|(be&63)>>>0):be<65536?(fe[pe++]=224|(be&61440)>>>12,fe[pe++]=128|(be&4032)>>>6,fe[pe++]=128|(be&63)>>>0):(fe[pe++]=240|(be&1835008)>>>18,fe[pe++]=128|(be&258048)>>>12,fe[pe++]=128|(be&4032)>>>6,fe[pe++]=128|(be&63)>>>0)}return fe}e.encodeUTF8=M;function _(H){const te=H.byteLength,se=[];let le=0;for(;le<te;){const fe=H[le];let pe;if(fe>=240&&le+3<te?pe=(H[le++]&7)<<18>>>0|(H[le++]&63)<<12>>>0|(H[le++]&63)<<6>>>0|(H[le++]&63)<<0>>>0:fe>=224&&le+2<te?pe=(H[le++]&15)<<12>>>0|(H[le++]&63)<<6>>>0|(H[le++]&63)<<0>>>0:fe>=192&&le+1<te?pe=(H[le++]&31)<<6>>>0|(H[le++]&63)<<0>>>0:pe=H[le++],pe>=0&&pe<=55295||pe>=57344&&pe<=65535)se.push(String.fromCharCode(pe));else if(pe>=65536&&pe<=1114111){const be=pe-65536,Te=55296+((be&1047552)>>>10),Oe=56320+((be&1023)>>>0);se.push(String.fromCharCode(Te)),se.push(String.fromCharCode(Oe))}else se.push(String.fromCharCode(65533))}return se.join("")}e.decodeUTF8=_;const T=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function O(H){return T.test(H)}e.containsRTL=O;const B=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function K(H){return B.test(H)}e.containsEmoji=K;const G=/^[\t\n\r\x20-\x7E]*$/;function J(H){return G.test(H)}e.isBasicASCII=J,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ee(H){return e.UNUSUAL_LINE_TERMINATORS.test(H)}e.containsUnusualLineTerminators=ee;function re(H){for(let te=0,se=H.length;te<se;te++)if(x(H.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=re;function x(H){return H=+H,H>=11904&&H<=55215||H>=63744&&H<=64255||H>=65281&&H<=65374}e.isFullWidthCharacter=x;function ne(H){return H>=127462&&H<=127487||H===8986||H===8987||H===9200||H===9203||H>=9728&&H<=10175||H===11088||H===11093||H>=127744&&H<=128591||H>=128640&&H<=128764||H>=128992&&H<=129003||H>=129280&&H<=129535||H>=129648&&H<=129750}e.isEmojiImprecise=ne;function oe(H,te){if(H.length<te)return H;const se=/\b/g;let le=0;for(;se.test(H)&&!(H.length-se.lastIndex<te);)le=se.lastIndex,se.lastIndex+=1;return H.substring(le).replace(/^\s/,"")}e.lcut=oe;const ue=/\x1B\x5B[12]?K/g,ye=/\x1b\[\d+m/g,me=/\x1b\[0?m/g;function de(H){return H&&(H=H.replace(ue,""),H=H.replace(ye,""),H=H.replace(me,"")),H}e.removeAnsiEscapeCodes=de,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(H){return!!(H&&H.length>0&&H.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function De(H){return we(H)?H.substr(1):H}e.stripUTF8BOM=De;function Le(H,te){if(!H||!te||H.length<te.length)return!1;const se=te.length,le=H.toLowerCase();let fe=0,pe=-1;for(;fe<se;){const be=le.indexOf(te[fe],pe+1);if(be<0)return!1;pe=be,fe++}return!0}e.fuzzyContains=Le;function We(H,te=!1){return H?(te&&(H=H.replace(/\\./g,"")),H.toLowerCase()!==H):!1}e.containsUppercaseCharacter=We;function Ne(H){return H.charAt(0).toUpperCase()+H.slice(1)}e.uppercaseFirstLetter=Ne;function Ve(H,te=1){if(te===0)return"";let se=-1;do se=H.indexOf(`
`,se+1),te--;while(te>0&&se>=0);return se===-1?H:(H[se-1]==="\r"&&se--,H.substr(0,se))}e.getNLines=Ve;function xe(H){const te=90-65+1;return H=H%(2*te),H<te?String.fromCharCode(97+H):String.fromCharCode(65+H-te)}e.singleLetterHash=xe;function Xe(H){return Be.getInstance().getGraphemeBreakType(H)}e.getGraphemeBreakType=Xe;function Ge(H,te){return H===0?te!==5&&te!==7:H===2&&te===3?!1:H===4||H===2||H===3||te===4||te===2||te===3?!0:!(H===8&&(te===8||te===9||te===11||te===12)||(H===11||H===9)&&(te===9||te===10)||(H===12||H===10)&&te===10||te===5||te===13||te===7||H===1||H===13&&te===14||H===6&&te===6)}e.breakBetweenGraphemeBreakType=Ge;var st;(function(H){H[H.Other=0]="Other",H[H.Prepend=1]="Prepend",H[H.CR=2]="CR",H[H.LF=3]="LF",H[H.Control=4]="Control",H[H.Extend=5]="Extend",H[H.Regional_Indicator=6]="Regional_Indicator",H[H.SpacingMark=7]="SpacingMark",H[H.L=8]="L",H[H.V=9]="V",H[H.T=10]="T",H[H.LV=11]="LV",H[H.LVT=12]="LVT",H[H.ZWJ=13]="ZWJ",H[H.Extended_Pictographic=14]="Extended_Pictographic"})(st=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=it()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const se=this._data,le=se.length/3;let fe=1;for(;fe<=le;)if(te<se[3*fe])fe=2*fe;else if(te>se[3*fe+1])fe=2*fe+1;else return se[3*fe+2];return 0}}Be._INSTANCE=null;function it(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}}),define(X[21],Q([0,1,20,58]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let n,y;class i{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return D?new i(Buffer.allocUnsafe(h)):new i(new Uint8Array(h))}static wrap(h){return D&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new i(h)}static fromString(h,f){return!((f==null?void 0:f.dontUseNodeBuffer)||!1)&&D?new i(Buffer.from(h)):S?(n||(n=new TextEncoder),new i(n.encode(h))):new i(v.encodeUTF8(h))}static concat(h,f){if(typeof f=="undefined"){f=0;for(let F=0,U=h.length;F<U;F++)f+=h[F].byteLength}const I=i.alloc(f);let A=0;for(let F=0,U=h.length;F<U;F++){const q=h[F];I.set(q,A),A+=q.byteLength}return I}toString(){return D?this.buffer.toString():k?(y||(y=new TextDecoder),y.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(h,f){return new i(this.buffer.subarray(h,f))}set(h,f){h instanceof i?this.buffer.set(h.buffer,f):this.buffer.set(h,f)}readUInt32BE(h){return E(this.buffer,h)}writeUInt32BE(h,f){w(this.buffer,h,f)}readUInt32LE(h){return d(this.buffer,h)}writeUInt32LE(h,f){m(this.buffer,h,f)}readUInt8(h){return b(this.buffer,h)}writeUInt8(h,f){p(this.buffer,h,f)}}e.VSBuffer=i;function L(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0}e.readUInt16LE=L;function g(u,h,f){u[f+0]=h&255,h=h>>>8,u[f+1]=h&255}e.writeUInt16LE=g;function E(u,h){return u[h]*2**24+u[h+1]*2**16+u[h+2]*2**8+u[h+3]}e.readUInt32BE=E;function w(u,h,f){u[f+3]=h,h=h>>>8,u[f+2]=h,h=h>>>8,u[f+1]=h,h=h>>>8,u[f]=h}e.writeUInt32BE=w;function d(u,h){return u[h+0]<<0>>>0|u[h+1]<<8>>>0|u[h+2]<<16>>>0|u[h+3]<<24>>>0}e.readUInt32LE=d;function m(u,h,f){u[f+0]=h&255,h=h>>>8,u[f+1]=h&255,h=h>>>8,u[f+2]=h&255,h=h>>>8,u[f+3]=h&255}e.writeUInt32LE=m;function b(u,h){return u[h]}e.readUInt8=b;function p(u,h,f){u[f]=h}e.writeUInt8=p;function a(u){return R.consumeReadable(u,h=>i.concat(h))}e.readableToBuffer=a;function c(u){return R.toReadable(u)}e.bufferToReadable=c;function l(u){return R.consumeStream(u,h=>i.concat(h))}e.streamToBuffer=l;async function s(u){return u.ended?i.concat(u.buffer):i.concat([...u.buffer,await l(u.stream)])}e.bufferedStreamToBuffer=s;function t(u){return R.toStream(u,h=>i.concat(h))}e.bufferToStream=t;function r(u){return R.transform(u,{data:h=>typeof h=="string"?i.fromString(h):i.wrap(h)},h=>i.concat(h))}e.streamToBufferReadableStream=r;function o(u){return R.newWriteableStream(h=>i.concat(h),u)}e.newWriteableBufferStream=o}),define(X[78],Q([0,1,20]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(p){return D(p,0)}e.hash=R;function D(p,a){switch(typeof p){case"object":return p===null?S(349,a):Array.isArray(p)?y(p,a):i(p,a);case"string":return n(p,a);case"boolean":return k(p,a);case"number":return S(p,a);case"undefined":return S(937,a);default:return S(617,a)}}e.doHash=D;function S(p,a){return(a<<5)-a+p|0}function k(p,a){return S(p?433:863,a)}function n(p,a){a=S(149417,a);for(let c=0,l=p.length;c<l;c++)a=S(p.charCodeAt(c),a);return a}e.stringHash=n;function y(p,a){return a=S(104579,a),p.reduce((c,l)=>D(l,c),a)}function i(p,a){return a=S(181387,a),Object.keys(p).sort().reduce((c,l)=>(c=n(l,c),D(p[l],c)),a)}class L{constructor(){this._value=0}get value(){return this._value}hash(a){return this._value=D(a,this._value),this._value}}e.Hasher=L;var g;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(g||(g={}));function E(p,a,c=32){const l=c-a,s=~((1<<l)-1);return(p<<a|(s&p)>>>l)>>>0}function w(p,a=0,c=p.byteLength,l=0){for(let s=0;s<c;s++)p[a+s]=l}function d(p,a,c="0"){for(;p.length<a;)p=c+p;return p}function m(p,a=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(c=>c.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),a/4)}e.toHexString=m;class b{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(a){const c=a.length;if(c!==0){const l=this._buff;let s=this._buffLen,t=this._leftoverHighSurrogate,r,o;for(t!==0?(r=t,o=-1,t=0):(r=a.charCodeAt(0),o=0);;){let u=r;if(v.isHighSurrogate(r))if(o+1<c){const h=a.charCodeAt(o+1);v.isLowSurrogate(h)?(o++,u=v.computeCodePoint(r,h)):u=65533}else{t=r;break}else v.isLowSurrogate(r)&&(u=65533);if(s=this._push(l,s,u),o++,o<c)r=a.charCodeAt(o);else break}this._buffLen=s,this._leftoverHighSurrogate=t}}_push(a,c,l){return l<128?a[c++]=l:l<2048?(a[c++]=192|(l&1984)>>>6,a[c++]=128|(l&63)>>>0):l<65536?(a[c++]=224|(l&61440)>>>12,a[c++]=128|(l&4032)>>>6,a[c++]=128|(l&63)>>>0):(a[c++]=240|(l&1835008)>>>18,a[c++]=128|(l&258048)>>>12,a[c++]=128|(l&4032)>>>6,a[c++]=128|(l&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,a[0]=a[64+0],a[1]=a[64+1],a[2]=a[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,w(this._buff,this._buffLen),this._buffLen>56&&(this._step(),w(this._buff));const a=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(a/4294967296),!1),this._buffDV.setUint32(60,a%4294967296,!1),this._step()}_step(){const a=b._bigBlock32,c=this._buffDV;for(let I=0;I<64;I+=4)a.setUint32(I,c.getUint32(I,!1),!1);for(let I=64;I<320;I+=4)a.setUint32(I,E(a.getUint32(I-12,!1)^a.getUint32(I-32,!1)^a.getUint32(I-56,!1)^a.getUint32(I-64,!1),1),!1);let l=this._h0,s=this._h1,t=this._h2,r=this._h3,o=this._h4,u,h,f;for(let I=0;I<80;I++)I<20?(u=s&t|~s&r,h=1518500249):I<40?(u=s^t^r,h=1859775393):I<60?(u=s&t|s&r|t&r,h=2400959708):(u=s^t^r,h=3395469782),f=E(l,5)+u+o+h+a.getUint32(I*4,!1)&4294967295,o=r,r=t,t=E(s,30),s=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+o&4294967295}}e.StringSHA1=b,b._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[13],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(f){return Array.isArray(f)}e.isArray=v;function R(f){return typeof f=="string"}e.isString=R;function D(f){return Array.isArray(f)&&f.every(I=>R(I))}e.isStringArray=D;function S(f){return typeof f=="object"&&f!==null&&!Array.isArray(f)&&!(f instanceof RegExp)&&!(f instanceof Date)}e.isObject=S;function k(f){return typeof f=="number"&&!isNaN(f)}e.isNumber=k;function n(f){return!!f&&typeof f[Symbol.iterator]=="function"}e.isIterable=n;function y(f){return f===!0||f===!1}e.isBoolean=y;function i(f){return typeof f=="undefined"}e.isUndefined=i;function L(f){return!g(f)}e.isDefined=L;function g(f){return i(f)||f===null}e.isUndefinedOrNull=g;function E(f,I){if(!f)throw new Error(I?`Unexpected type, expected '${I}'`:"Unexpected type")}e.assertType=E;function w(f){if(g(f))throw new Error("Assertion Failed: argument is undefined or null");return f}e.assertIsDefined=w;function d(...f){const I=[];for(let A=0;A<f.length;A++){const F=f[A];if(g(F))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);I.push(F)}return I}e.assertAllDefined=d;const m=Object.prototype.hasOwnProperty;function b(f){if(!S(f))return!1;for(let I in f)if(m.call(f,I))return!1;return!0}e.isEmptyObject=b;function p(f){return typeof f=="function"}e.isFunction=p;function a(...f){return f.length>0&&f.every(p)}e.areFunctions=a;function c(f,I){const A=Math.min(f.length,I.length);for(let F=0;F<A;F++)l(f[F],I[F])}e.validateConstraints=c;function l(f,I){if(R(I)){if(typeof f!==I)throw new Error(`argument does not match constraint: typeof ${I}`)}else if(p(I)){try{if(f instanceof I)return}catch(A){}if(!g(f)&&f.constructor===I||I.length===1&&I.call(void 0,f)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function s(f){let I=[],A=Object.getPrototypeOf(f);for(;Object.prototype!==A;)I=I.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return I}e.getAllPropertyNames=s;function t(f){const I=[];for(const A of s(f))typeof f[A]=="function"&&I.push(A);return I}e.getAllMethodNames=t;function r(f,I){const A=U=>function(){const q=Array.prototype.slice.call(arguments,0);return I(U,q)};let F={};for(const U of f)F[U]=A(U);return F}e.createProxyObject=r;function o(f){return f===null?void 0:f}e.withNullAsUndefined=o;function u(f){return typeof f=="undefined"?null:f}e.withUndefinedAsNull=u;function h(f){return class{constructor(){return new Proxy({},{get(I,A){if(I[A])return I[A];throw new Error(`Not Implemented: ${f}->${String(A)}`)}})}}}e.NotImplementedProxy=h}),define(X[30],Q([0,1,3,20,8,13]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toSlashes=e.isPathSeparator=void 0;function k(r){return r===47||r===92}e.isPathSeparator=k;function n(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=n;function y(r,o=D.posix.sep){if(!r)return"";const u=r.length,h=r.charCodeAt(0);if(k(h)){if(k(r.charCodeAt(1))&&!k(r.charCodeAt(2))){let I=3;const A=I;for(;I<u&&!k(r.charCodeAt(I));I++);if(A!==I&&!k(r.charCodeAt(I+1))){for(I+=1;I<u;I++)if(k(r.charCodeAt(I)))return r.slice(0,I+1).replace(/[\\/]/g,o)}}return o}else if(b(h)&&r.charCodeAt(1)===58)return k(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let f=r.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(k(r.charCodeAt(f)))return r.slice(0,f+1)}return""}e.getRoot=y;function i(r){if(!v.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let u=2;const h=u;for(;u<r.length&&(o=r.charCodeAt(u),o!==92);u++);return!(h===u||(o=r.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=i;const L=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function w(r,o=v.isWindows){const u=o?L:g;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||o&&E.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=w;function d(r,o,u){const h=r===o;return!u||h?h:!r||!o?!1:(0,R.equalsIgnoreCase)(r,o)}e.isEqual=d;function m(r,o,u,h=D.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let I=o.length;return o.charAt(o.length-1)===h&&I--,r.charAt(I)===h}return o.charAt(o.length-1)!==h&&(o+=h),r.indexOf(o)===0}e.isEqualOrParent=m;function b(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=b;function p(r,o){return v.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(o,r)),r=(0,D.normalize)(r),v.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=p;function a(r){const o=(0,D.normalize)(r);return v.isWindows?r.length>3?!1:c(o)&&(r.length===2||o.charCodeAt(2)===92):o===D.posix.sep}e.isRootOrDriveLetter=a;function c(r){return v.isWindows?b(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=c;function l(r){return c(r)?r[0]:void 0}e.getDriveLetter=l;function s(r,o,u){return o.length>r.length?-1:r===o?0:(u&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=s;function t(r){const o=r.split(":");let u,h,f;if(o.forEach(I=>{const A=Number(I);(0,S.isNumber)(A)?h===void 0?h=A:f===void 0&&(f=A):u=u?[u,I].join(":"):I}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:h!==void 0?h:void 0,column:f!==void 0?f:h!==void 0?1:void 0}}e.parseLineAndColumnAware=t}),define(X[45],Q([0,1,13]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const m=Array.isArray(d)?[]:{};return Object.keys(d).forEach(b=>{d[b]&&typeof d[b]=="object"?m[b]=R(d[b]):m[b]=d[b]}),m}e.deepClone=R;function D(d){if(!d||typeof d!="object")return d;const m=[d];for(;m.length>0;){const b=m.shift();Object.freeze(b);for(const p in b)if(S.call(b,p)){const a=b[p];typeof a=="object"&&!Object.isFrozen(a)&&m.push(a)}}return d}e.deepFreeze=D;const S=Object.prototype.hasOwnProperty;function k(d,m){return n(d,m,new Set)}e.cloneAndChange=k;function n(d,m,b){if((0,v.isUndefinedOrNull)(d))return d;const p=m(d);if(typeof p!="undefined")return p;if((0,v.isArray)(d)){const a=[];for(const c of d)a.push(n(c,m,b));return a}if((0,v.isObject)(d)){if(b.has(d))throw new Error("Cannot clone recursive data-structure");b.add(d);const a={};for(let c in d)S.call(d,c)&&(a[c]=n(d[c],m,b));return b.delete(d),a}return d}function y(d,m,b=!0){return(0,v.isObject)(d)?((0,v.isObject)(m)&&Object.keys(m).forEach(p=>{p in d?b&&((0,v.isObject)(d[p])&&(0,v.isObject)(m[p])?y(d[p],m[p],b):d[p]=m[p]):d[p]=m[p]}),d):m}e.mixin=y;function i(d,m){if(d===m)return!0;if(d==null||m===null||m===void 0||typeof d!=typeof m||typeof d!="object"||Array.isArray(d)!==Array.isArray(m))return!1;let b,p;if(Array.isArray(d)){if(d.length!==m.length)return!1;for(b=0;b<d.length;b++)if(!i(d[b],m[b]))return!1}else{const a=[];for(p in d)a.push(p);a.sort();const c=[];for(p in m)c.push(p);if(c.sort(),!i(a,c))return!1;for(b=0;b<a.length;b++)if(!i(d[a[b]],m[a[b]]))return!1}return!0}e.equals=i;function L(d){const m=new Set;return JSON.stringify(d,(b,p)=>{if((0,v.isObject)(p)||Array.isArray(p)){if(m.has(p))return"[Circular]";m.add(p)}return p})}e.safeStringify=L;function g(d,m,b){const p=m(d);return typeof p=="undefined"?b:p}e.getOrDefault=g;function E(d,m){const b=Object.create(null);return!d||!m||Object.keys(m).forEach(a=>{const c=d[a],l=m[a];i(c,l)||(b[a]=l)}),b}e.distinct=E;function w(d,m){const b=m.toLowerCase(),p=Object.keys(d).find(a=>a.toLowerCase()===b);return p?d[p]:d[m]}e.getCaseInsensitive=w}),define(X[7],Q([0,1,3,8]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,S=/^\//,k=/^\/\//;function n(o,u){if(!o.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${o.authority}", path: "${o.path}", query: "${o.query}", fragment: "${o.fragment}"}`);if(o.scheme&&!D.test(o.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(o.path){if(o.authority){if(!S.test(o.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(o.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(o,u){return!o&&!u?"file":o}function i(o,u){switch(o){case"https":case"http":case"file":u?u[0]!==g&&(u=g+u):u=g;break}return u}const L="",g="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class w{constructor(u,h,f,I,A,F=!1){typeof u=="object"?(this.scheme=u.scheme||L,this.authority=u.authority||L,this.path=u.path||L,this.query=u.query||L,this.fragment=u.fragment||L):(this.scheme=y(u,F),this.authority=h||L,this.path=i(this.scheme,f||L),this.query=I||L,this.fragment=A||L,n(this,F))}static isUri(u){return u instanceof w?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}get fsPath(){return c(this,!1)}with(u){if(!u)return this;let{scheme:h,authority:f,path:I,query:A,fragment:F}=u;return h===void 0?h=this.scheme:h===null&&(h=L),f===void 0?f=this.authority:f===null&&(f=L),I===void 0?I=this.path:I===null&&(I=L),A===void 0?A=this.query:A===null&&(A=L),F===void 0?F=this.fragment:F===null&&(F=L),h===this.scheme&&f===this.authority&&I===this.path&&A===this.query&&F===this.fragment?this:new m(h,f,I,A,F)}static parse(u,h=!1){const f=E.exec(u);return f?new m(f[2]||L,r(f[4]||L),r(f[5]||L),r(f[7]||L),r(f[9]||L),h):new m(L,L,L,L,L)}static file(u){let h=L;if(v.isWindows&&(u=u.replace(/\\/g,g)),u[0]===g&&u[1]===g){const f=u.indexOf(g,2);f===-1?(h=u.substring(2),u=g):(h=u.substring(2,f),u=u.substring(f)||g)}return new m("file",h,u,L,L)}static from(u){return new m(u.scheme,u.authority,u.path,u.query,u.fragment)}static joinPath(u,...h){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return v.isWindows&&u.scheme==="file"?f=w.file(R.win32.join(c(u,!0),...h)).path:f=R.posix.join(u.path,...h),u.with({path:f})}toString(u=!1){return l(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof w)return u;{const h=new m(u);return h._formatted=u.external,h._fsPath=u._sep===d?u.fsPath:null,h}}else return u}}e.URI=w;const d=v.isWindows?1:void 0;class m extends w{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(u=!1){return u?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=d),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const b={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(o,u){let h,f=-1;for(let I=0;I<o.length;I++){const A=o.charCodeAt(I);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||u&&A===47)f!==-1&&(h+=encodeURIComponent(o.substring(f,I)),f=-1),h!==void 0&&(h+=o.charAt(I));else{h===void 0&&(h=o.substr(0,I));const F=b[A];F!==void 0?(f!==-1&&(h+=encodeURIComponent(o.substring(f,I)),f=-1),h+=F):f===-1&&(f=I)}}return f!==-1&&(h+=encodeURIComponent(o.substring(f))),h!==void 0?h:o}function a(o){let u;for(let h=0;h<o.length;h++){const f=o.charCodeAt(h);f===35||f===63?(u===void 0&&(u=o.substr(0,h)),u+=b[f]):u!==void 0&&(u+=o[h])}return u!==void 0?u:o}function c(o,u){let h;return o.authority&&o.path.length>1&&o.scheme==="file"?h=`//${o.authority}${o.path}`:o.path.charCodeAt(0)===47&&(o.path.charCodeAt(1)>=65&&o.path.charCodeAt(1)<=90||o.path.charCodeAt(1)>=97&&o.path.charCodeAt(1)<=122)&&o.path.charCodeAt(2)===58?u?h=o.path.substr(1):h=o.path[1].toLowerCase()+o.path.substr(2):h=o.path,v.isWindows&&(h=h.replace(/\//g,"\\")),h}e.uriToFsPath=c;function l(o,u){const h=u?a:p;let f="",{scheme:I,authority:A,path:F,query:U,fragment:q}=o;if(I&&(f+=I,f+=":"),(A||I==="file")&&(f+=g,f+=g),A){let Y=A.indexOf("@");if(Y!==-1){const ie=A.substr(0,Y);A=A.substr(Y+1),Y=ie.indexOf(":"),Y===-1?f+=h(ie,!1):(f+=h(ie.substr(0,Y),!1),f+=":",f+=h(ie.substr(Y+1),!1)),f+="@"}A=A.toLowerCase(),Y=A.indexOf(":"),Y===-1?f+=h(A,!1):(f+=h(A.substr(0,Y),!1),f+=A.substr(Y))}if(F){if(F.length>=3&&F.charCodeAt(0)===47&&F.charCodeAt(2)===58){const Y=F.charCodeAt(1);Y>=65&&Y<=90&&(F=`/${String.fromCharCode(Y+32)}:${F.substr(3)}`)}else if(F.length>=2&&F.charCodeAt(1)===58){const Y=F.charCodeAt(0);Y>=65&&Y<=90&&(F=`${String.fromCharCode(Y+32)}:${F.substr(2)}`)}f+=h(F,!0)}return U&&(f+="?",f+=h(U,!1)),q&&(f+="#",f+=u?q:p(q,!1)),f}function s(o){try{return decodeURIComponent(o)}catch(u){return o.length>3?o.substr(0,3)+s(o.substr(3)):o}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(o){return o.match(t)?o.replace(t,u=>s(u)):o}}),define(X[106],Q([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function R(i){const L=i;return L&&typeof L.type=="string"&&typeof L.severity=="string"}e.isRemoteConsoleLog=R;function D(i){const L=[];let g;try{const E=JSON.parse(i.arguments),w=E[E.length-1];w&&w.__$stack&&(E.pop(),g=w.__$stack),L.push(...E)}catch(E){L.push("Unable to log remote console arguments",i.arguments)}return{args:L,stack:g}}e.parse=D;function S(i){if(typeof i!="string")return S(D(i).stack);const L=i;if(L){const g=k(L),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(g||"");if(E&&E.length===4)return{uri:v.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}e.getFirstFrame=S;function k(i){if(!i)return i;const L=i.indexOf(`
`);return L===-1?i:i.substring(0,L)}function n(i,L){const{args:g,stack:E}=D(i),w=typeof g[0]=="string"&&g.length===1;let d=k(E);d&&(d=`(${d.trim()})`);let m=[];if(typeof g[0]=="string"?d&&w?m=[`%c[${L}] %c${g[0]} %c${d}`,y("blue"),y(""),y("grey")]:m=[`%c[${L}] %c${g[0]}`,y("blue"),y(""),...g.slice(1)]:m=[`%c[${L}]%`,y("blue"),...g],d&&!w&&m.push(d),typeof console[i.severity]!="function")throw new Error("Unknown console method");console[i.severity].apply(console,m)}e.log=n;function y(i){return`color: ${i}`}}),define(X[36],Q([0,1,7,20]),function(j,e,v,R){"use strict";var D,S;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function k(l,s,t){let r=l.get(s);return r===void 0&&(r=t,l.set(s,r)),r}e.getOrSet=k;function n(l){const s=[];return l.forEach((t,r)=>{s.push(`${r} => ${t}`)}),`Map(${l.size}) {${s.join(", ")}}`}e.mapToString=n;function y(l){const s=[];return l.forEach(t=>{s.push(t)}),`Set(${l.size}) {${s.join(", ")}}`}e.setToString=y;class i{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const t=s.charCodeAt(0),r=this._value.charCodeAt(this._pos);return t-r}value(){return this._value[this._pos]}}e.StringIterator=i;class L{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=L;class g{constructor(s=!0,t=!0){this._splitOnBackslash=s,this._caseSensitive=t}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(t===47||this._splitOnBackslash&&t===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,R.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=g;var E;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(E||(E={}));class w{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new g(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,R.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=w;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class m{constructor(s){this._iter=s}static forUris(s=()=>!1){return new m(new w(s))}static forPaths(){return new m(new g)}static forStrings(){return new m(new i)}static forConfigKeys(){return new m(new L)}clear(){this._root=void 0}set(s,t){const r=this._iter.reset(s);let o;for(this._root||(this._root=new d,this._root.segment=r.value()),o=this._root;;){const h=r.cmp(o.segment);if(h>0)o.left||(o.left=new d,o.left.segment=r.value()),o=o.left;else if(h<0)o.right||(o.right=new d,o.right.segment=r.value()),o=o.right;else if(r.hasNext())r.next(),o.mid||(o.mid=new d,o.mid.segment=r.value()),o=o.mid;else break}const u=o.value;return o.value=t,o.key=s,u}get(s){var t;return(t=this._getNode(s))===null||t===void 0?void 0:t.value}_getNode(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else break}return r}has(s){const t=this._getNode(s);return!((t==null?void 0:t.value)===void 0&&(t==null?void 0:t.mid)===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,t){const r=this._iter.reset(s),o=[];let u=this._root;for(;u;){const h=r.cmp(u.segment);if(h>0)o.push([1,u]),u=u.left;else if(h<0)o.push([-1,u]),u=u.right;else if(r.hasNext())r.next(),o.push([0,u]),u=u.mid;else{for(t?(u.left=void 0,u.mid=void 0,u.right=void 0):u.value=void 0;o.length>0&&u.isEmpty();){let[f,I]=o.pop();switch(f){case 1:I.left=void 0;break;case 0:I.mid=void 0;break;case-1:I.right=void 0;break}u=I}break}}}findSubstr(s){const t=this._iter.reset(s);let r=this._root,o;for(;r;){const u=t.cmp(r.segment);if(u>0)r=r.left;else if(u<0)r=r.right;else if(t.hasNext())t.next(),o=r.value||o,r=r.mid;else break}return r&&r.value||o}findSuperstr(s){const t=this._iter.reset(s);let r=this._root;for(;r;){const o=t.cmp(r.segment);if(o>0)r=r.left;else if(o<0)r=r.right;else if(t.hasNext())t.next(),r=r.mid;else return r.mid?this._entries(r.mid):void 0}}forEach(s){for(const[t,r]of this)s(r,t)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){s&&(yield*this._entries(s.left),s.value&&(yield[s.key,s.value]),yield*this._entries(s.mid),yield*this._entries(s.right))}}e.TernarySearchTree=m;class b{constructor(s,t){this[D]="ResourceMap",s instanceof b?(this.map=new Map(s.map),this.toKey=t!=null?t:b.defaultToKey):(this.map=new Map,this.toKey=s!=null?s:b.defaultToKey)}set(s,t){return this.map.set(this.toKey(s),t),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,t){typeof t!="undefined"&&(s=s.bind(t));for(let[r,o]of this.map)s(o,v.URI.parse(r),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield v.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[v.URI.parse(s[0]),s[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[v.URI.parse(s[0]),s[1]]}}e.ResourceMap=b,b.defaultToKey=l=>l.toString();var p;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class a{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var s;return(s=this._head)===null||s===void 0?void 0:s.value}get last(){var s;return(s=this._tail)===null||s===void 0?void 0:s.value}has(s){return this._map.has(s)}get(s,t=0){const r=this._map.get(s);if(!!r)return t!==0&&this.touch(r,t),r.value}set(s,t,r=0){let o=this._map.get(s);if(o)o.value=t,r!==0&&this.touch(o,r);else{switch(o={key:s,value:t,next:void 0,previous:void 0},r){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(s,o),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const t=this._map.get(s);if(!!t)return this._map.delete(s),this.removeItem(t),this._size--,t.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}}forEach(s,t){const r=this._state;let o=this._head;for(;o;){if(t?s.bind(t)(o.value,o.key,this):s(o.value,o.key,this),this._state!==r)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const s=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:r.key,done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return o}values(){const s=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:r.value,done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return o}entries(){const s=this,t=this._state;let r=this._head;const o={[Symbol.iterator](){return o},next(){if(s._state!==t)throw new Error("LinkedMap got modified during iteration.");if(r){const u={value:[r.key,r.value],done:!1};return r=r.next,u}else return{value:void 0,done:!0}}};return o}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(!(s>=this.size)){if(s===0){this.clear();return}let t=this._head,r=this.size;for(;t&&r>s;)this._map.delete(t.key),t=t.next,r--;this._head=t,this._size=r,t&&(t.previous=void 0),this._state++}}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const t=s.next,r=s.previous;if(!t||!r)throw new Error("Invalid list");t.previous=r,r.next=t}s.next=void 0,s.previous=void 0,this._state++}touch(s,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(s===this._head)return;const r=s.next,o=s.previous;s===this._tail?(o.next=void 0,this._tail=o):(r.previous=o,o.next=r),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(t===2){if(s===this._tail)return;const r=s.next,o=s.previous;s===this._head?(r.previous=void 0,this._head=r):(r.previous=o,o.next=r),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((t,r)=>{s.push([r,t])}),s}fromJSON(s){this.clear();for(const[t,r]of s)this.set(t,r)}}e.LinkedMap=a;class c extends a{constructor(s,t=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,t),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,t=2){return super.get(s,t)}peek(s){return super.get(s,0)}set(s,t){return super.set(s,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=c}),define(X[107],Q([0,1,21,20,7]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(i){return JSON.stringify(i,n)}e.stringify=S;function k(i){let L=JSON.parse(i);return L=y(L),L}e.parse=k;function n(i,L){return L instanceof RegExp?{$mid:2,source:L.source,flags:(0,R.regExpFlags)(L)}:L}function y(i,L=0){if(!i||L>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof v.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let g=0;g<i.length;++g)i[g]=y(i[g],L+1);else for(const g in i)Object.hasOwnProperty.call(i,g)&&(i[g]=y(i[g],L+1))}return i}e.revive=y}),define(X[9],Q([0,1,7,3]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(n){n.inMemory="inmemory",n.vscode="vscode",n.internal="private",n.walkThrough="walkThrough",n.walkThroughSnippet="walkThroughSnippet",n.http="http",n.https="https",n.file="file",n.mailto="mailto",n.untitled="untitled",n.data="data",n.command="command",n.vscodeRemote="vscode-remote",n.vscodeRemoteResource="vscode-remote-resource",n.userData="vscode-userdata",n.vscodeCustomEditor="vscode-custom-editor",n.vscodeNotebook="vscode-notebook",n.vscodeNotebookCell="vscode-notebook-cell",n.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",n.vscodeSettings="vscode-settings",n.vscodeWorkspaceTrust="vscode-workspace-trust",n.webviewPanel="webview-panel",n.vscodeWebview="vscode-webview",n.vscodeWebviewResource="vscode-webview-resource",n.extension="extension",n.vscodeFileResource="vscode-file"})(D=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,i,L){this._hosts[y]=i,this._ports[y]=L}setConnectionToken(y,i){this._connectionTokens[y]=i}rewrite(y){if(this._delegate)return this._delegate(y);const i=y.authority;let L=this._hosts[i];L&&L.indexOf(":")!==-1&&(L=`[${L}]`);const g=this._ports[i],E=this._connectionTokens[i];let w=`path=${encodeURIComponent(y.path)}`;return typeof E=="string"&&(w+=`&tkn=${encodeURIComponent(E)}`),v.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${L}:${g}`,path:"/vscode-remote-resource",query:w})}}e.RemoteAuthorities=new S;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(y,i,L){const g=this.toUri(y,i);return g.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(g):R.isNative&&(L||R.isPreferringBrowserCodeLoad)&&g.scheme===D.file?g.with({scheme:D.vscodeFileResource,authority:g.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):g}asFileUri(y,i){const L=this.toUri(y,i);return L.scheme===D.vscodeFileResource?L.with({scheme:D.file,authority:L.authority!==this.FALLBACK_AUTHORITY?L.authority:null,query:null,fragment:null}):L}toUri(y,i){return v.URI.isUri(y)?y:v.URI.parse(i.toUrl(y))}}e.FileAccess=new k}),define(X[64],Q([0,1,36]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new v.LRUCache(1e4);function D(i){return y(i,"NFC",R)}e.normalizeNFC=D;const S=new v.LRUCache(1e4);function k(i){return y(i,"NFD",S)}e.normalizeNFD=k;const n=/[^\u0000-\u0080]/;function y(i,L,g){if(!e.canNormalize||!i)return i;const E=g.get(i);if(E)return E;let w;return n.test(i)?w=i.normalize(L):w=i,g.set(i,w),w}e.removeAccents=function(){if(e.canNormalize){const i=/[\u0300-\u036f]/g;return function(L){return k(L).replace(i,"")}}else return function(i){return i}}()}),define(X[15],Q([0,1,30,8,7,20,9,3]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(w){return(0,D.uriToFsPath)(w,!0)}e.originalFSPath=y;class i{constructor(d){this._ignorePathCasing=d}compare(d,m,b=!1){return d===m?0:(0,S.compare)(this.getComparisonKey(d,b),this.getComparisonKey(m,b))}isEqual(d,m,b=!1){return d===m?!0:!d||!m?!1:this.getComparisonKey(d,b)===this.getComparisonKey(m,b)}getComparisonKey(d,m=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:m?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,m,b=!1){if(d.scheme===m.scheme){if(d.scheme===k.Schemas.file)return v.isEqualOrParent(y(d),y(m),this._ignorePathCasing(d))&&d.query===m.query&&(b||d.fragment===m.fragment);if((0,e.isEqualAuthority)(d.authority,m.authority))return v.isEqualOrParent(d.path,m.path,this._ignorePathCasing(d),"/")&&d.query===m.query&&(b||d.fragment===m.fragment)}return!1}joinPath(d,...m){return D.URI.joinPath(d,...m)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return R.posix.basename(d.path)}extname(d){return R.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let m;return d.scheme===k.Schemas.file?m=D.URI.file(R.dirname(y(d))).path:(m=R.posix.dirname(d.path),d.authority&&m.length&&m.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),m="/")),d.with({path:m})}normalizePath(d){if(!d.path.length)return d;let m;return d.scheme===k.Schemas.file?m=D.URI.file(R.normalize(y(d))).path:m=R.posix.normalize(d.path),d.with({path:m})}relativePath(d,m){if(!(d.scheme!==m.scheme||!(0,e.isEqualAuthority)(d.authority,m.authority))){if(d.scheme===k.Schemas.file){const a=R.relative(y(d),y(m));return n.isWindows?v.toSlashes(a):a}let b=d.path||"/",p=m.path||"/";if(this._ignorePathCasing(d)){let a=0;for(const c=Math.min(b.length,p.length);a<c&&!(b.charCodeAt(a)!==p.charCodeAt(a)&&b.charAt(a).toLowerCase()!==p.charAt(a).toLowerCase());a++);b=p.substr(0,a)+b.substr(a)}return R.posix.relative(b,p)}}resolvePath(d,m){if(d.scheme===k.Schemas.file){const b=D.URI.file(R.resolve(y(d),m));return d.with({authority:b.authority,path:b.path})}return m.indexOf("/")===-1&&(m=v.toSlashes(m),/^[a-zA-Z]:(\/|$)/.test(m)&&(m="/"+m)),d.with({path:R.posix.resolve(d.path,m)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,m){return d===m||(0,S.equalsIgnoreCase)(d,m)}hasTrailingPathSeparator(d,m=R.sep){if(d.scheme===k.Schemas.file){const b=y(d);return b.length>v.getRoot(b).length&&b[b.length-1]===m}else{const b=d.path;return b.length>1&&b.charCodeAt(b.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,m=R.sep){return(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,m=R.sep){let b=!1;if(d.scheme===k.Schemas.file){const p=y(d);b=p!==void 0&&p.length===v.getRoot(p).length&&p[p.length-1]===m}else{m="/";const p=d.path;b=p.length===1&&p.charCodeAt(p.length-1)===47}return!b&&!(0,e.hasTrailingPathSeparator)(d,m)?d.with({path:d.path+"/"}):d}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(w=>w.scheme===k.Schemas.file?!n.isLinux:!0),e.extUriIgnorePathCase=new i(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function L(w,d){const m=[];for(let b=0;b<w.length;b++){const p=d(w[b]);w.some((a,c)=>c===b?!1:(0,e.isEqualOrParent)(p,d(a)))||m.push(w[b])}return m}e.distinctParents=L;var g;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function d(m){const b=new Map;m.path.substring(m.path.indexOf(";")+1,m.path.lastIndexOf(";")).split(";").forEach(c=>{const[l,s]=c.split(":");l&&s&&b.set(l,s)});const a=m.path.substring(0,m.path.indexOf(";"));return a&&b.set(w.META_DATA_MIME,a),b}w.parseMetaData=d})(g=e.DataUri||(e.DataUri={}));function E(w,d,m){if(d){let b=w.path;return b&&b[0]!==R.posix.sep&&(b=R.posix.sep+b),w.with({scheme:m,authority:d,path:b})}return w.with({scheme:m})}e.toLocalResource=E}),define(X[10],Q([0,1,25,19,5,2,76,15]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function y(C){return!!C&&typeof C.then=="function"}e.isThenable=y;function i(C){const P=new v.CancellationTokenSource,M=C(P.token),_=new Promise((T,O)=>{P.token.onCancellationRequested(()=>{O((0,R.canceled)())}),Promise.resolve(M).then(B=>{P.dispose(),T(B)},B=>{P.dispose(),O(B)})});return new class{cancel(){P.cancel()}then(T,O){return _.then(T,O)}catch(T){return this.then(void 0,T)}finally(T){return _.finally(T)}}}e.createCancelablePromise=i;function L(C,P,M){return Promise.race([C,new Promise(_=>P.onCancellationRequested(()=>_(M)))])}e.raceCancellation=L;async function g(C){let P=-1;const M=C.map((T,O)=>T.then(B=>(P=O,B))),_=await Promise.race(M);return C.forEach((T,O)=>{O!==P&&T.cancel()}),_}e.raceCancellablePromises=g;function E(C,P,M){let _;const T=setTimeout(()=>{_==null||_(void 0),M==null||M()},P);return Promise.race([C.finally(()=>clearTimeout(T)),new Promise(O=>_=O)])}e.raceTimeout=E;function w(C){return new Promise((P,M)=>{const _=C();y(_)?_.then(P,M):P(_)})}e.asPromise=w;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(P){if(this.activePromise){if(this.queuedPromiseFactory=P,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const _=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,_};this.queuedPromise=new Promise(_=>{this.activePromise.then(M,M).then(_)})}return new Promise((M,_)=>{this.queuedPromise.then(M,_)})}return this.activePromise=P(),new Promise((M,_)=>{this.activePromise.then(T=>{this.activePromise=null,M(T)},T=>{this.activePromise=null,_(T)})})}}e.Throttler=d;class m{constructor(){this.current=Promise.resolve(null)}queue(P){return this.current=this.current.then(()=>P(),()=>P())}}e.Sequencer=m;class b{constructor(){this.promiseMap=new Map}queue(P,M){var _;const O=((_=this.promiseMap.get(P))!==null&&_!==void 0?_:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(P)===O&&this.promiseMap.delete(P)});return this.promiseMap.set(P,O),O}}e.SequencerByKey=b;class p{constructor(P){this.defaultDelay=P,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(P,M=this.defaultDelay){return this.task=P,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((_,T)=>{this.doResolve=_,this.doReject=T}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const _=this.task;return this.task=null,_()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=p;class a{constructor(P){this.delayer=new p(P),this.throttler=new d}trigger(P,M){return this.delayer.trigger(()=>this.throttler.queue(P),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=a;class c{constructor(){this._isOpen=!1,this._promise=new Promise((P,M)=>{this._completePromise=P})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=c;class l extends c{constructor(P){super();this._timeout=setTimeout(()=>this.open(),P)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function s(C,P){return P?new Promise((M,_)=>{const T=setTimeout(M,C);P.onCancellationRequested(()=>{clearTimeout(T),_((0,R.canceled)())})}):i(M=>s(C,M))}e.timeout=s;function t(C,P=0){const M=setTimeout(C,P);return(0,S.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=t;function r(C){return C.then(void 0,P=>{})}e.ignoreErrors=r;function o(C){const P=[];let M=0;const _=C.length;function T(){return M<_?C[M++]():null}function O(B){B!=null&&P.push(B);const K=T();return K?K.then(O):Promise.resolve(P)}return Promise.resolve(null).then(O)}e.sequence=o;function u(C,P=_=>!!_,M=null){let _=0;const T=C.length,O=()=>{if(_>=T)return Promise.resolve(M);const B=C[_++];return Promise.resolve(B()).then(G=>P(G)?Promise.resolve(G):O())};return O()}e.first=u;function h(C,P=_=>!!_,M=null){if(C.length===0)return Promise.resolve(M);let _=C.length;const T=()=>{var O,B;_=-1;for(const K of C)(B=(O=K).cancel)===null||B===void 0||B.call(O)};return new Promise((O,B)=>{for(const K of C)K.then(G=>{--_>=0&&P(G)?(T(),O(G)):_===0&&O(M)}).catch(G=>{--_>=0&&(T(),B(G))})})}e.firstParallel=h;class f{constructor(P){this._size=0,this.maxDegreeOfParalellism=P,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(P){return this._size++,new Promise((M,_)=>{this.outstandingPromises.push({factory:P,c:M,e:_}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const P=this.outstandingPromises.shift();this.runningPromises++;const M=P.factory();M.then(P.c,P.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=f;class I extends f{constructor(){super(1)}}e.Queue=I;class A{constructor(){this.queues=new Map}queueFor(P,M=n.extUri){const _=M.getComparisonKey(P);let T=this.queues.get(_);return T||(T=new I,D.Event.once(T.onFinished)(()=>{T==null||T.dispose(),this.queues.delete(_)}),this.queues.set(_,T)),T}dispose(){this.queues.forEach(P=>P.dispose()),this.queues.clear()}}e.ResourceQueue=A;class F{constructor(P,M){this._token=-1,typeof P=="function"&&typeof M=="number"&&this.setIfNotSet(P,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(P,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,P()},M)}setIfNotSet(P,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,P()},M))}}e.TimeoutTimer=F;class U{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(P,M){this.cancel(),this._token=setInterval(()=>{P()},M)}}e.IntervalTimer=U;class q{constructor(P,M){this.timeoutToken=-1,this.runner=P,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(P=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,P)}get delay(){return this.timeout}set delay(P){this.timeout=P}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=q;class Y extends q{constructor(P,M){super(P,M);this.units=[]}work(P){this.units.push(P),this.isScheduled()||this.schedule()}doRun(){const P=this.units;this.units=[],this.runner&&this.runner(P)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=Y,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const C=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=P=>{const M=setTimeout(()=>P(C));let _=!1;return{dispose(){_||(_=!0,clearTimeout(M))}}}}else e.runWhenIdle=(C,P)=>{const M=requestIdleCallback(C,typeof P=="number"?{timeout:P}:void 0);let _=!1;return{dispose(){_||(_=!0,cancelIdleCallback(M))}}}}();class ie{constructor(P){this._didRun=!1,this._executor=()=>{try{this._value=P()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=ie;async function ae(C,P,M){let _;for(let T=0;T<M;T++)try{return await C()}catch(O){_=O,await s(P)}throw _}e.retry=ae;class V{hasPending(P){return this._pending?typeof P=="number"?this._pending.taskId===P:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var P;(P=this._pending)===null||P===void 0||P.cancel()}setPending(P,M,_){return this._pending={taskId:P,cancel:()=>_==null?void 0:_(),promise:M},M.then(()=>this.donePending(P),()=>this.donePending(P)),M}donePending(P){this._pending&&P===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const P=this._next;this._next=void 0,P.run().then(P.promiseResolve,P.promiseReject)}}setNext(P){if(this._next)this._next.run=P;else{let M,_;const T=new Promise((O,B)=>{M=O,_=B});this._next={run:P,promise:T,promiseResolve:M,promiseReject:_}}return this._next.promise}}e.TaskSequentializer=V;class N{constructor(P){this.interval=P,this.lastIncrementTime=0,this.value=0}increment(){const P=Date.now();return P-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=P,this.value=0),this.value++,this.value}}e.IntervalCounter=N;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((P,M)=>{this.completeCallback=P,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(P){return new Promise(M=>{this.completeCallback(P),this.resolved=!0,M()})}error(P){return new Promise(M=>{this.errorCallback(P),this.rejected=!0,M()})}cancel(){new Promise(P=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,P()})}}e.DeferredPromise=z;class W extends D.Emitter{async fireAsync(P,M,_){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const T of this._listeners)this._asyncDeliveryQueue.push([T,P]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[T,O]=this._asyncDeliveryQueue.shift(),B=[],K=Object.assign(Object.assign({},O),{waitUntil:G=>{if(Object.isFrozen(B))throw new Error("waitUntil can NOT be called asynchronous");_&&(G=_(G,typeof T=="function"?T:T[0])),B.push(G)}});try{typeof T=="function"?T.call(void 0,K):T[0].call(T[1],K)}catch(G){(0,R.onUnexpectedError)(G);continue}Object.freeze(B),await $.settled(B).catch(G=>(0,R.onUnexpectedError)(G))}}}}e.AsyncEmitter=W;var $;(function(C){async function P(O){return typeof Promise.allSettled=="function"?M(O):_(O)}C.allSettled=P;async function M(O){return Promise.allSettled(O)}async function _(O){return Promise.all(O.map(B=>B.then(K=>({status:"fulfilled",value:K}),K=>({status:"rejected",reason:K}))))}async function T(O){let B;const K=await Promise.all(O.map(G=>G.then(J=>J,J=>{B||(B=J)})));if(typeof B!="undefined")throw B;return K}C.settled=T})($=e.Promises||(e.Promises={}))}),define(X[79],Q([0,1,20,30,8,36,10]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function n(){return Object.create(null)}e.getEmptyExpression=n;const y="**",i="/",L="[/\\\\]",g="[^/\\\\]",E=/\//g;function w(M){switch(M){case 0:return"";case 1:return`${g}*?`;default:return`(?:${L}|${g}+${L}|${L}${g}+)*?`}}function d(M,_){if(!M)return[];const T=[];let O=!1,B=!1,K="";for(const G of M){switch(G){case _:if(!O&&!B){T.push(K),K="";continue}break;case"{":O=!0;break;case"}":O=!1;break;case"[":B=!0;break;case"]":B=!1;break}K+=G}return K&&T.push(K),T}e.splitGlobAware=d;function m(M){if(!M)return"";let _="";const T=d(M,i);if(T.every(O=>O===y))_=".*";else{let O=!1;T.forEach((B,K)=>{if(B===y){O||(_+=w(2),O=!0);return}let G=!1,J="",ee=!1,re="";for(const x of B){if(x!=="}"&&G){J+=x;continue}if(ee&&(x!=="]"||!re)){let ne;x==="-"?ne=x:(x==="^"||x==="!")&&!re?ne="^":x===i?ne="":ne=v.escapeRegExpCharacters(x),re+=ne;continue}switch(x){case"{":G=!0;continue;case"[":ee=!0;continue;case"}":_+=`(?:${d(J,",").map(ue=>m(ue)).join("|")})`,G=!1,J="";break;case"]":_+="["+re+"]",ee=!1,re="";break;case"?":_+=g;continue;case"*":_+=w(1);continue;default:_+=v.escapeRegExpCharacters(x)}}K<T.length-1&&(T[K+1]!==y||K+2<T.length)&&(_+=L),O=!1})}return _}const b=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,a=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),r=function(){return!1},o=function(){return null};function u(M,_){if(!M)return o;let T;typeof M!="string"?T=M.pattern:T=M,T=T.trim();const O=`${T}_${!!_.trimForExclusions}`;let B=t.get(O);if(B)return h(B,M);let K;if(b.test(T)){const G=T.substr(4);B=function(J,ee){return typeof J=="string"&&J.endsWith(G)?T:null}}else(K=p.exec(f(T,_)))?B=I(K[1],T):(_.trimForExclusions?c:a).test(T)?B=A(T,_):(K=l.exec(f(T,_)))?B=F(K[1].substr(1),T,!0):(K=s.exec(f(T,_)))?B=F(K[1],T,!1):B=U(T);return t.set(O,B),h(B,M)}function h(M,_){return typeof _=="string"?M:function(T,O){return R.isEqualOrParent(T,_.base)?M(D.relative(_.base,T),O):null}}function f(M,_){return _.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function I(M,_){const T=`/${M}`,O=`\\${M}`,B=function(G,J){return typeof G!="string"?null:J?J===M?_:null:G===M||G.endsWith(T)||G.endsWith(O)?_:null},K=[M];return B.basenames=K,B.patterns=[_],B.allBasenames=K,B}function A(M,_){const T=P(M.slice(1,-1).split(",").map(J=>u(J,_)).filter(J=>J!==o),M),O=T.length;if(!O)return o;if(O===1)return T[0];const B=function(J,ee){for(let re=0,x=T.length;re<x;re++)if(T[re](J,ee))return M;return null},K=T.find(J=>!!J.allBasenames);K&&(B.allBasenames=K.allBasenames);const G=T.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return G.length&&(B.allPaths=G),B}function F(M,_,T){const O=D.sep===D.posix.sep,B=O?M:M.replace(E,D.sep),K=D.sep+B,G=D.posix.sep+M,J=T?function(ee,re){return typeof ee=="string"&&(ee===B||ee.endsWith(K)||!O&&(ee===M||ee.endsWith(G)))?_:null}:function(ee,re){return typeof ee=="string"&&(ee===B||!O&&ee===M)?_:null};return J.allPaths=[(T?"*/":"./")+M],J}function U(M){try{const _=new RegExp(`^${m(M)}$`);return function(T){return _.lastIndex=0,typeof T=="string"&&_.test(T)?M:null}}catch(_){return o}}function q(M,_,T){return!M||typeof _!="string"?!1:Y(M)(_,void 0,T)}e.match=q;function Y(M,_={}){if(!M)return r;if(typeof M=="string"||N(M)){const T=u(M,_);if(T===o)return r;const O=function(B,K){return!!T(B,K)};return T.allBasenames&&(O.allBasenames=T.allBasenames),T.allPaths&&(O.allPaths=T.allPaths),O}return $(M,_)}e.parse=Y;function ie(M){if(!!M){let _;return T=>(_||(_=(M()||Promise.resolve([])).then(O=>O?V(O):{})),_.then(O=>!!O[T]))}}e.hasSiblingPromiseFn=ie;function ae(M){if(!!M){let _;return T=>{if(!_){const O=M();_=O?V(O):{}}return!!_[T]}}}e.hasSiblingFn=ae;function V(M){const _={};for(const T of M)_[T]=!0;return _}function N(M){const _=M;return _&&typeof _.base=="string"&&typeof _.pattern=="string"}e.isRelativePattern=N;function z(M){return M.allBasenames||[]}e.getBasenameTerms=z;function W(M){return M.allPaths||[]}e.getPathTerms=W;function $(M,_){const T=P(Object.getOwnPropertyNames(M).map(J=>C(J,M[J],_)).filter(J=>J!==o)),O=T.length;if(!O)return o;if(!T.some(J=>!!J.requiresSiblings)){if(O===1)return T[0];const J=function(x,ne){for(let oe=0,ue=T.length;oe<ue;oe++){const ye=T[oe](x,ne);if(ye)return ye}return null},ee=T.find(x=>!!x.allBasenames);ee&&(J.allBasenames=ee.allBasenames);const re=T.reduce((x,ne)=>ne.allPaths?x.concat(ne.allPaths):x,[]);return re.length&&(J.allPaths=re),J}const B=function(J,ee,re){let x;for(let ne=0,oe=T.length;ne<oe;ne++){const ue=T[ne];ue.requiresSiblings&&re&&(ee||(ee=D.basename(J)),x||(x=ee.substr(0,ee.length-D.extname(J).length)));const ye=ue(J,ee,x,re);if(ye)return ye}return null},K=T.find(J=>!!J.allBasenames);K&&(B.allBasenames=K.allBasenames);const G=T.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return G.length&&(B.allPaths=G),B}function C(M,_,T){if(_===!1)return o;const O=u(M,T);if(O===o)return o;if(typeof _=="boolean")return O;if(_){const B=_.when;if(typeof B=="string"){const K=(G,J,ee,re)=>{if(!re||!O(G,J))return null;const x=B.replace("$(basename)",ee),ne=re(x);return(0,k.isThenable)(ne)?ne.then(oe=>oe?M:null):ne?M:null};return K.requiresSiblings=!0,K}}return O}function P(M,_){const T=M.filter(J=>!!J.basenames);if(T.length<2)return M;const O=T.reduce((J,ee)=>{const re=ee.basenames;return re?J.concat(re):J},[]);let B;if(_){B=[];for(let J=0,ee=O.length;J<ee;J++)B.push(_)}else B=T.reduce((J,ee)=>{const re=ee.patterns;return re?J.concat(re):J},[]);const K=function(J,ee){if(typeof J!="string")return null;if(!ee){let x;for(x=J.length;x>0;x--){const ne=J.charCodeAt(x-1);if(ne===47||ne===92)break}ee=J.substr(x)}const re=O.indexOf(ee);return re!==-1?B[re]:null};K.basenames=O,K.patterns=B,K.allBasenames=O;const G=M.filter(J=>!J.basenames);return G.push(K),G}}),define(X[39],Q([0,1,7,8,20,9,3,15,30]),function(j,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function i(u,h,f){if(typeof u=="string"&&(u=v.URI.file(u)),f){const A=f.getWorkspaceFolder(u);if(A){const F=f.getWorkspace().folders.length>1;let U;if((0,n.isEqual)(A.uri,u)?U="":U=(0,n.relativePath)(A.uri,u),F){const q=A.name?A.name:(0,n.basename)(A.uri);U=U?q+" \u2022 "+U:q}return U}}if(u.scheme!==S.Schemas.file&&u.scheme!==S.Schemas.untitled)return u.with({query:null,fragment:null}).toString(!0);if((0,y.hasDriveLetter)(u.fsPath))return(0,R.normalize)(g(u.fsPath));let I=(0,R.normalize)(u.fsPath);return!k.isWindows&&(h==null?void 0:h.userHome)&&(I=w(I,h.userHome.fsPath)),I}e.getPathLabel=i;function L(u){if(!!u){typeof u=="string"&&(u=v.URI.file(u));const h=(0,n.basename)(u)||(u.scheme===S.Schemas.file?u.fsPath:u.path);return k.isWindows&&(0,y.isRootOrDriveLetter)(h)?g(h):h}}e.getBaseLabel=L;function g(u){return(0,y.hasDriveLetter)(u)?u.charAt(0).toUpperCase()+u.slice(1):u}e.normalizeDriveLetter=g;let E=Object.create(null);function w(u,h){if(k.isWindows||!u||!h)return u;let f=E.original===h?E.normalized:void 0;return f||(f=`${(0,D.rtrim)(h,R.posix.sep)}${R.posix.sep}`,E={original:h,normalized:f}),(k.isLinux?u.startsWith(f):(0,D.startsWithIgnoreCase)(u,f))&&(u=`~/${u.substr(f.length)}`),u}e.tildify=w;function d(u,h){return u.replace(/^~($|\/|\\)/,`${h}$1`)}e.untildify=d;const m="\u2026",b="\\\\",p="~";function a(u,h=R.sep){const f=new Array(u.length);let I=!1;for(let A=0;A<u.length;A++){let F=u[A];if(F===""){f[A]=`.${h}`;continue}if(!F){f[A]=F;continue}I=!0;let U="";F.indexOf(b)===0?(U=F.substr(0,F.indexOf(b)+b.length),F=F.substr(F.indexOf(b)+b.length)):F.indexOf(h)===0?(U=F.substr(0,F.indexOf(h)+h.length),F=F.substr(F.indexOf(h)+h.length)):F.indexOf(p)===0&&(U=F.substr(0,F.indexOf(p)+p.length),F=F.substr(F.indexOf(p)+p.length));const q=F.split(h);for(let Y=1;I&&Y<=q.length;Y++)for(let ie=q.length-Y;I&&ie>=0;ie--){I=!1;let ae=q.slice(ie,ie+Y).join(h);for(let V=0;!I&&V<u.length;V++)if(V!==A&&u[V]&&u[V].indexOf(ae)>-1){const N=ie+Y===q.length,z=ie>0&&u[V].indexOf(h)>-1?h+ae:ae,W=u[V].endsWith(z);I=!N||W}if(!I){let V="";(q[0].endsWith(":")||U!=="")&&(ie===1&&(ie=0,Y++,ae=q[0]+h+ae),ie>0&&(V=q[0]+h),V=U+V),ie>0&&(V=V+m+h),V=V+ae,ie+Y<q.length&&(V=V+h+m),f[A]=V}}I&&(f[A]=F)}return f}e.shorten=a;var c;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function l(u,h=Object.create(null)){const f=[];let I=!1,A="";for(const F of u)if(F==="$"||I&&F==="{")A&&f.push({value:A,type:c.TEXT}),A="",I=!0;else if(F==="}"&&I){const U=h[A];if(typeof U=="string")U.length&&f.push({value:U,type:c.VARIABLE});else if(U){const q=f[f.length-1];(!q||q.type!==c.SEPARATOR)&&f.push({value:U.label,type:c.SEPARATOR})}A="",I=!1}else A+=F;return A&&!I&&f.push({value:A,type:c.TEXT}),f.filter((F,U)=>{if(F.type===c.SEPARATOR){const q=f[U-1],Y=f[U+1];return[q,Y].every(ie=>ie&&(ie.type===c.VARIABLE||ie.type===c.TEXT)&&ie.value.length>0)}return!0}).map(F=>F.value).join("")}e.template=l;function s(u,h){return k.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):u.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=s;function t(u,h){return k.isMacintosh||h?u.replace(/\(&&\w\)|&&/g,""):k.isWindows?u.replace(/&&|&/g,f=>f==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(u){return u.replace(/&/g,"&&")}e.unmnemonicLabel=r;function o(u){const h=u.indexOf("/")!==-1?R.posix:R.win32,f=h.basename(u),I=h.dirname(u);return f.length?{name:f,parentPath:I}:{name:I,parentPath:""}}e.splitName=o}),define(X[108],Q([0,1,8,20,79,9,15]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let n=[],y=[],i=[];function L(l,s=!1){const t=g(l);n.push(t),t.userConfigured?i.push(t):y.push(t),s&&!t.userConfigured&&n.forEach(r=>{r.mime===t.mime||r.userConfigured||(t.extension&&r.extension===t.extension&&console.warn(`Overwriting extension <<${t.extension}>> to now point to mime <<${t.mime}>>`),t.filename&&r.filename===t.filename&&console.warn(`Overwriting filename <<${t.filename}>> to now point to mime <<${t.mime}>>`),t.filepattern&&r.filepattern===t.filepattern&&console.warn(`Overwriting filepattern <<${t.filepattern}>> to now point to mime <<${t.mime}>>`),t.firstline&&r.firstline===t.firstline&&console.warn(`Overwriting firstline <<${t.firstline}>> to now point to mime <<${t.mime}>>`))})}e.registerTextMime=L;function g(l){return{id:l.id,mime:l.mime,filename:l.filename,extension:l.extension,filepattern:l.filepattern,firstline:l.firstline,userConfigured:l.userConfigured,filenameLowercase:l.filename?l.filename.toLowerCase():void 0,extensionLowercase:l.extension?l.extension.toLowerCase():void 0,filepatternLowercase:l.filepattern?l.filepattern.toLowerCase():void 0,filepatternOnPath:l.filepattern?l.filepattern.indexOf(v.posix.sep)>=0:!1}}function E(l){l?(n=n.filter(s=>!s.userConfigured),i=[]):(n=[],y=[],i=[])}e.clearTextMimes=E;function w(l,s){let t;if(l)switch(l.scheme){case S.Schemas.file:t=l.fsPath;break;case S.Schemas.data:t=k.DataUri.parseMetaData(l).get(k.DataUri.META_DATA_LABEL);break;default:t=l.path}if(!t)return[e.MIME_UNKNOWN];t=t.toLowerCase();const r=(0,v.basename)(t),o=d(t,r,i);if(o)return[o,e.MIME_TEXT];const u=d(t,r,y);if(u)return[u,e.MIME_TEXT];if(s){const h=m(s);if(h)return[h,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=w;function d(l,s,t){let r=null,o=null,u=null;for(let h=t.length-1;h>=0;h--){const f=t[h];if(s===f.filenameLowercase){r=f;break}if(f.filepattern&&(!o||f.filepattern.length>o.filepattern.length)){const I=f.filepatternOnPath?l:s;(0,D.match)(f.filepatternLowercase,I)&&(o=f)}f.extension&&(!u||f.extension.length>u.extension.length)&&s.endsWith(f.extensionLowercase)&&(u=f)}return r?r.mime:o?o.mime:u?u.mime:null}function m(l){if((0,R.startsWithUTF8BOM)(l)&&(l=l.substr(1)),l.length>0)for(let s=n.length-1;s>=0;s--){const t=n[s];if(!!t.firstline){const r=l.match(t.firstline);if(r&&r.length>0)return t.mime}}return null}function b(l){return l?typeof l=="string"?l===e.MIME_BINARY||l===e.MIME_TEXT||l===e.MIME_UNKNOWN:l.length===1&&b(l[0]):!0}e.isUnspecific=b;const p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function a(l){const s=(0,v.extname)(l);return p[s.toLowerCase()]}e.getMediaMime=a;function c(l){for(const s in p)if(p[s]===l)return s}e.getExtensionForMimeType=c}),define(X[28],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(y){return v.test(y)}e.isUUID=R;const D=new Uint8Array(16),S=[];for(let y=0;y<256;y++)S.push(y.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(y){for(let i=0;i<y.length;i++)y[i]=Math.floor(Math.random()*256);return y};function n(){k(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let y=0,i="";return i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+="-",i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i+=S[D[y++]],i}e.generateUuid=n}),define(X[109],Q([0,1,22,59,43]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function S(k,n){if(await new Promise((L,g)=>{const E=v.createReadStream(k),w=R.createHash("sha1");E.pipe(w);const d=(0,D.once)((m,b)=>{E.removeAllListeners(),w.removeAllListeners(),m?g(m):L(b)});E.once("error",d),E.once("end",d),w.once("error",d),w.once("data",m=>d(void 0,m.toString("hex")))})!==n)throw new Error("Hash mismatch")}e.checksum=S}),define(X[80],Q([0,1,235]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new v.StringDecoder(S),this.remaining=null}write(S){const k=[],n=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(n.length<1)return k;let y=0,i,L=y;for(;L<n.length;)if(i=n.charCodeAt(L),i===13||i===10){if(k.push(n.substring(y,L)),L++,L<n.length){const g=i;i=n.charCodeAt(L),(g===13&&i===10||g===10&&i===13)&&L++}y=L}else L++;return this.remaining=y<n.length?n.substr(y):null,k}end(){return this.remaining}}e.LineDecoder=R}),define(X[110],Q([0,1,27]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(n){const y=n.replace(/\-/g,":").toLowerCase();return!R.has(y)}function S(){return new Promise(async(n,y)=>{const i=setTimeout(()=>y("Unable to retrieve mac address (timeout after 10s)"),1e4);try{n(await k())}catch(L){y(L)}finally{clearTimeout(i)}})}e.getMac=S;function k(){return new Promise((n,y)=>{try{const i=(0,v.networkInterfaces)();for(const[,L]of Object.entries(i))for(const g of L)if(D(g.mac))return n(g.mac);y("Unable to retrieve mac address (unexpected format)")}catch(i){y(i)}})}}),define(X[65],Q([0,1,19,28,27,36,110]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(L){return this._virtualMachineOUIs||(this._virtualMachineOUIs=S.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(L)}value(){if(this._value===void 0){let L=0,g=0;const E=(0,D.networkInterfaces)();for(let w in E)if(Object.prototype.hasOwnProperty.call(E,w))for(const{mac:d,internal:m}of E[w])m||(g+=1,this._isVirtualMachineMacAdress(d.toUpperCase())&&(L+=1));this._value=g>0?L/g:0}return this._value}};let n;async function y(){return n||(n=(async()=>await i()||R.generateUuid())()),n}e.getMachineId=y;async function i(){try{const L=await new Promise((E,w)=>{j(["crypto"],E,w)}),g=await(0,k.getMac)();return L.createHash("sha256").update(g,"utf8").digest("hex")}catch(L){v.onUnexpectedError(L);return}}}),define(X[23],Q([0,1,22,27,8,10,3,30,28,64,15,7]),function(j,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var E;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(E=e.RimRafMode||(e.RimRafMode={}));async function w(z,W=E.UNLINK){if((0,n.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return W===E.UNLINK?m(z):d(z)}e.rimraf=w;async function d(z){try{const W=(0,D.join)((0,R.tmpdir)(),(0,y.generateUuid)());try{await v.promises.rename(z,W)}catch($){return m(z)}m(W).catch($=>{})}catch(W){if(W.code!=="ENOENT")throw W}}async function m(z){return v.promises.rmdir(z,{recursive:!0,maxRetries:3})}function b(z){if((0,n.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(z,{recursive:!0})}e.rimrafSync=b;async function p(z,W){return l(await(W?a(z):v.promises.readdir(z)))}e.readdir=p;async function a(z){try{return await v.promises.readdir(z,{withFileTypes:!0})}catch(C){console.warn("[node.js fs] readdir with filetypes failed with error: ",C)}const W=[],$=await p(z);for(const C of $){let P=!1,M=!1,_=!1;try{const T=await v.promises.lstat((0,D.join)(z,C));P=T.isFile(),M=T.isDirectory(),_=T.isSymbolicLink()}catch(T){console.warn("[node.js fs] unexpected error from lstat after readdir: ",T)}W.push({name:C,isFile:()=>P,isDirectory:()=>M,isSymbolicLink:()=>_})}return W}function c(z){return l(v.readdirSync(z))}e.readdirSync=c;function l(z){return z.map(W=>typeof W=="string"?k.isMacintosh?(0,i.normalizeNFC)(W):W:(W.name=k.isMacintosh?(0,i.normalizeNFC)(W.name):W.name,W))}async function s(z){const W=await p(z),$=[];for(const C of W)await r.existsDirectory((0,D.join)(z,C))&&$.push(C);return $}e.readDirsInDir=s;function t(z,W=1e3){return new Promise($=>{let C=!1;const P=setInterval(()=>{C||(C=!0,v.access(z,M=>{C=!1,M&&(clearInterval(P),$(void 0))}))},W)})}e.whenDeleted=t;var r;(function(z){async function W(P){let M;try{if(M=await v.promises.lstat(P),!M.isSymbolicLink())return{stat:M}}catch(_){}try{return{stat:await v.promises.stat(P),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(_){if(_.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(k.isWindows&&_.code==="EACCES")try{return{stat:await v.promises.stat(await v.promises.readlink(P)),symbolicLink:{dangling:!1}}}catch(T){if(T.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw T}throw _}}z.stat=W;async function $(P){try{const{stat:M,symbolicLink:_}=await z.stat(P);return M.isFile()&&(_==null?void 0:_.dangling)!==!0}catch(M){}return!1}z.existsFile=$;async function C(P){try{const{stat:M,symbolicLink:_}=await z.stat(P);return M.isDirectory()&&(_==null?void 0:_.dangling)!==!0}catch(M){}return!1}z.existsDirectory=C})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new S.ResourceQueue;function u(z,W,$){return o.queueFor(g.URI.file(z),L.extUriBiasedIgnorePathCase).queue(()=>{const C=A($);return new Promise((P,M)=>f(z,W,C,_=>_?M(_):P()))})}e.writeFile=u;let h=!0;function f(z,W,$,C){if(!h)return v.writeFile(z,W,{mode:$.mode,flag:$.flag},C);v.open(z,$.flag,$.mode,(P,M)=>{if(P)return C(P);v.writeFile(M,W,_=>{if(_)return v.close(M,()=>C(_));v.fdatasync(M,T=>(T&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",T),h=!1),v.close(M,O=>C(O))))})})}function I(z,W,$){const C=A($);if(!h)return v.writeFileSync(z,W,{mode:C.mode,flag:C.flag});const P=v.openSync(z,C.flag,C.mode);try{v.writeFileSync(P,W);try{v.fdatasyncSync(P)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),h=!1}}finally{v.closeSync(P)}}e.writeFileSync=I;function A(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function F(z,W){if(z!==W){async function $(C){try{const P=await v.promises.lstat(C);if(P.isDirectory()||P.isSymbolicLink())return;const M=await v.promises.open(C,"a");try{await M.utimes(P.atime,new Date)}finally{await M.close()}}catch(P){}}try{await v.promises.rename(z,W),await $(W)}catch(C){if(z.toLowerCase()!==W.toLowerCase()&&C.code==="EXDEV"||z.endsWith("."))await U(z,W,{preserveSymlinks:!1}),await w(z,E.MOVE),await $(W);else throw C}}}e.move=F;async function U(z,W,$){return Y(z,W,{root:{source:z,target:W},options:$,handledSourcePaths:new Set})}e.copy=U;const q=511;async function Y(z,W,$){if(!$.handledSourcePaths.has(z)){$.handledSourcePaths.add(z);const{stat:C,symbolicLink:P}=await r.stat(z);if(P){if($.options.preserveSymlinks)try{return await V(z,W,$)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(P.dangling)return}return C.isDirectory()?ie(z,W,C.mode&q,$):ae(z,W,C.mode&q)}}async function ie(z,W,$,C){await v.promises.mkdir(W,{recursive:!0,mode:$});const P=await p(z);for(const M of P)await Y((0,D.join)(z,M),(0,D.join)(W,M),C)}async function ae(z,W,$){await v.promises.copyFile(z,W),await v.promises.chmod(W,$)}async function V(z,W,$){let C=await v.promises.readlink(z);(0,n.isEqualOrParent)(C,$.root.source,!k.isLinux)&&(C=(0,D.join)($.root.target,C.substr($.root.source.length+1))),await v.promises.symlink(C,W)}async function N(z){try{return await v.promises.access(z),!0}catch(W){return!1}}e.exists=N}),define(X[111],Q([0,1,22,112,20,8,23]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function n(g){const E=(0,S.dirname)(g);if(g===E)return g;const w=((0,S.basename)(g)||g).toLowerCase();try{const m=(0,k.readdirSync)(E).filter(b=>b.toLowerCase()===w);if(m.length===1){const b=n(E);if(b)return(0,S.join)(b,m[0])}else if(m.length>1){const b=m.indexOf(w);if(b>=0){const p=n(E);if(p)return(0,S.join)(p,m[b])}}}catch(d){}return null}e.realcaseSync=n;async function y(g){try{return await(0,R.promisify)(v.realpath)(g)}catch(E){const w=L(g);return await v.promises.access(w,v.constants.R_OK),w}}e.realpath=y;function i(g){try{return v.realpathSync(g)}catch(E){const w=L(g);return v.accessSync(w,v.constants.R_OK),w}}e.realpathSync=i;function L(g){return(0,D.rtrim)((0,S.normalize)(g),S.sep)}}),define(X[113],Q([0,1,60]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=e.randomPort=void 0;function R(){const y=1025;return y+Math.floor((65535-y)*Math.random())}e.randomPort=R;function D(y,i,L){let g=!1;return new Promise(E=>{const w=setTimeout(()=>{if(!g)return g=!0,E(0)},L);S(y,i,d=>{if(!g)return g=!0,clearTimeout(w),E(d)})})}e.findFreePort=D;function S(y,i,L){if(i===0)return L(0);const g=new v.Socket;g.once("connect",()=>(n(g),S(y+1,i-1,L))),g.once("data",()=>{}),g.once("error",E=>(n(g),E.code!=="ECONNREFUSED"?S(y+1,i-1,L):L(y))),g.connect(y,"127.0.0.1")}function k(y,i,L){let g=!1,E,w=1;const d=v.createServer({pauseOnConnect:!0});function m(b,p){g||(g=!0,d.removeAllListeners(),d.close(),E&&clearTimeout(E),p(b))}return new Promise(b=>{E=setTimeout(()=>{m(0,b)},L),d.on("listening",()=>{m(y,b)}),d.on("error",p=>{p&&(p.code==="EADDRINUSE"||p.code==="EACCES")&&w<i?(y++,w++,d.listen(y,"127.0.0.1")):m(0,b)}),d.on("close",()=>{m(0,b)}),d.listen(y,"127.0.0.1")})}e.findFreePortFaster=k;function n(y){try{y.removeAllListeners("connect"),y.removeAllListeners("error"),y.end(),y.destroy(),y.unref()}catch(i){console.error(i)}}});var Ae=this&&this.__await||function(j){return this instanceof Ae?(this.v=j,this):new Ae(j)},dt=this&&this.__asyncGenerator||function(j,e,v){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var R=v.apply(j,e||[]),D,S=[];return D={},k("next"),k("throw"),k("return"),D[Symbol.asyncIterator]=function(){return this},D;function k(E){R[E]&&(D[E]=function(w){return new Promise(function(d,m){S.push([E,w,d,m])>1||n(E,w)})})}function n(E,w){try{y(R[E](w))}catch(d){g(S[0][3],d)}}function y(E){E.value instanceof Ae?Promise.resolve(E.value.v).then(i,L):g(S[0][2],E)}function i(E){n("next",E)}function L(E){n("throw",E)}function g(E,w){E(w),S.shift(),S.length&&n(S[0][0],S[0][1])}},ft=this&&this.__asyncValues||function(j){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=j[Symbol.asyncIterator],v;return e?e.call(j):(j=typeof __values=="function"?__values(j):j[Symbol.iterator](),v={},R("next"),R("throw"),R("return"),v[Symbol.asyncIterator]=function(){return this},v);function R(S){v[S]=j[S]&&function(k){return new Promise(function(n,y){k=j[S](k),D(n,y,k.done,k.value)})}}function D(S,k,n,y){Promise.resolve(y).then(function(i){S({value:i,done:n})},k)}};define(X[114],Q([0,1,23,27,8]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const S=/^\d+$/,k=/^Microsoft.PowerShell_.*/,n=/^Microsoft.PowerShellPreview_.*/;var y;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(y||(y={}));let i;switch(process.arch){case"ia32":case"x32":i=1;break;case"arm":case"arm64":i=2;break;default:i=0;break}let L;process.env.PROCESSOR_ARCHITEW6432?L=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?L=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?L=1:L=0;class g{constructor(s,t,r){this.exePath=s,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function E({useAlternateBitness:l=!1}={}){return l?i===0?process.env["ProgramFiles(x86)"]||null:L===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function w({useAlternateBitness:l=!1,findPreview:s=!1}={}){const t=E({useAlternateBitness:l});if(!t)return null;const r=D.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let o=-1,u=null;for(const I of await v.readdir(r)){let A=-1;if(s){const U=I.indexOf("-");if(U<0)continue;const q=I.substring(0,U);if(!S.test(q)||I.substring(U+1)!=="preview")continue;A=parseInt(q,10)}else{if(!S.test(I))continue;A=parseInt(I,10)}if(!(A<=o)){const F=D.join(r,I,"pwsh.exe");!await v.SymlinkSupport.existsFile(F)||(u=F,o=A)}}if(!u)return null;const h=t.includes("x86")?" (x86)":"",f=s?" Preview":"";return new g(u,`PowerShell${f}${h}`,!0)}async function d({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const s=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=l?{pwshMsixDirRegex:n,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:k,pwshMsixName:"PowerShell (Store)"};for(const o of await v.readdir(s))if(t.test(o)){const u=D.join(s,o,"pwsh.exe");return new g(u,r)}return null}function m(){const l=D.join(R.homedir(),".dotnet","tools","pwsh.exe");return new g(l,".NET Core PowerShell Global Tool")}function b(){const l=D.join(process.env.windir,i===1&&L!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new g(l,"Windows PowerShell",!0)}function p(){return dt(this,arguments,function*(){let s=yield Ae(w());s&&(yield yield Ae(s)),s=yield Ae(w({useAlternateBitness:!0})),s&&(yield yield Ae(s)),s=yield Ae(d()),s&&(yield yield Ae(s)),s=m(),s&&(yield yield Ae(s)),s=yield Ae(w({findPreview:!0})),s&&(yield yield Ae(s)),s=yield Ae(d({findPreview:!0})),s&&(yield yield Ae(s)),s=yield Ae(w({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Ae(s)),s=b(),s&&(yield yield Ae(s))})}function a(){return dt(this,arguments,function*(){var s,t;try{for(var r=ft(p()),o;o=yield Ae(r.next()),!o.done;){const u=o.value;(yield Ae(u.exists()))&&(yield yield Ae(u))}}catch(u){s={error:u}}finally{try{o&&!o.done&&(t=r.return)&&(yield Ae(t.call(r)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=a;async function c(){var l,s;try{for(var t=ft(a()),r;r=await t.next(),!r.done;)return r.value}catch(o){l={error:o}}finally{try{r&&!r.done&&(s=t.return)&&await s.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=c}),define(X[81],Q([0,1,46,9]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(k){return new Promise((n,y)=>{let i;const L=new Map;function g(d,m,b,p,a){const c=L.get(m);if(d===k||c){const l={name:E(b),cmd:b,pid:d,ppid:m,load:p,mem:a};L.set(d,l),d===k&&(i=l),c&&(c.children||(c.children=[]),c.children.push(l),c.children.length>1&&(c.children=c.children.sort((s,t)=>s.pid-t.pid)))}}function E(d){const m=/--disable-blink-features=Auxclick/,b=/\\watcher\\win32\\CodeHelper\.exe/,p=/--crashes-directory/,a=/\\pipe\\winpty-control/,c=/conhost\.exe/,l=/--type=([a-zA-Z-]+)/;if(b.exec(d))return"watcherService ";if(p.exec(d))return"electron-crash-reporter";if(a.exec(d))return"winpty-process";if(c.exec(d))return"console-window-host (Windows internal process)";let s=l.exec(d);if(s&&s.length===2)return s[1]==="renderer"?m.exec(d)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let r="";do s=t.exec(d),s&&(r+=s+" ");while(s);return r&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${r}`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,b)=>{j(["windows-process-tree"],m,b)}).then(m=>{m.getProcessList(k,b=>{m.getProcessCpuUsage(b,p=>{const a=new Map;p.forEach(c=>{const l=d(c.commandLine||"");a.set(c.pid,{name:E(l),cmd:l,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),i=a.get(k),i?(a.forEach(c=>{const l=a.get(c.ppid);l&&(l.children||(l.children=[]),l.children.push(c))}),a.forEach(c=>{c.children&&(c.children=c.children.sort((l,s)=>l.pid-s.pid))}),n(i)):y(new Error(`Root process ${k} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{function w(){let d=[i];const m=[];for(;d.length;){const p=d.shift();p&&(m.push(p.pid),p.children&&(d=d.concat(p.children)))}let b=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);b+=" "+m.join(" "),(0,v.exec)(b,{},(p,a,c)=>{if(p||c)y(p||new Error(c.toString()));else{const l=a.toString().split(`
`);for(let s=0;s<m.length;s++){const t=L.get(m[s]);t.load=parseFloat(l[s])}if(!i){y(new Error(`Root process ${k} not found`));return}n(i)}})}(0,v.exec)("which ps",{},(d,m,b)=>{if(d||b)if(process.platform!=="linux")y(d||new Error(b.toString()));else{const p=JSON.stringify(R.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,v.exec)(p,{},(a,c,l)=>{a||l?y(a||new Error(l.toString())):(S(c,g),w())})}else{const p=m.toString().trim(),a="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,v.exec)(`${p} ${a}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,l,s)=>{c||s&&!s.includes("screen size is bogus")?y(c||new Error(s.toString())):(S(l,g),process.platform==="linux"?w():i?n(i):y(new Error(`Root process ${k} not found`)))})}})}})}e.listProcesses=D;function S(k,n){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,i=k.toString().split(`
`);for(const L of i){const g=y.exec(L.trim());g&&g.length===6&&n(parseInt(g[1]),parseInt(g[2]),g[5],parseFloat(g[3]),parseFloat(g[4]))}}}),define(X[115],Q([0,1,8,22,3,64,2,23]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function y(g,E,w){return L({path:g,isDirectory:!1},E,w)}e.watchFile=y;function i(g,E,w){return L({path:g,isDirectory:!0},E,w)}e.watchFolder=i,e.CHANGE_BUFFER_DELAY=100;function L(g,E,w){const d=(0,v.basename)(g.path),m=new Map;let b=!1,p=[(0,k.toDisposable)(()=>{m.forEach(a=>(0,k.dispose)(a)),m.clear()})];try{const a=(0,R.watch)(g.path);p.push((0,k.toDisposable)(()=>{a.removeAllListeners(),a.close()}));const c=new Set;g.isDirectory&&(0,n.readdir)(g.path).then(l=>l.forEach(s=>c.add(s))),a.on("error",(l,s)=>{b||w(`Failed to watch ${g.path} for changes using fs.watch() (${l}, ${s})`)}),a.on("change",(l,s)=>{if(!b){let t="";if(s&&(t=s.toString(),D.isMacintosh&&(t=(0,S.normalizeNFC)(t))),!(!t||l!=="change"&&l!=="rename")){const r=g.isDirectory?(0,v.join)(g.path,t):g.path;if(g.isDirectory)if(l==="rename"){const o=m.get(r);o&&(0,k.dispose)(o);const u=setTimeout(async()=>{m.delete(r);const h=await(0,n.exists)(r);if(!b){let f;h?c.has(t)?f="changed":(f="added",c.add(t)):(c.delete(t),f="deleted"),E(f,r)}},e.CHANGE_BUFFER_DELAY);m.set(r,(0,k.toDisposable)(()=>clearTimeout(u)))}else{let o;c.has(t)?o="changed":(o="added",c.add(t)),E(o,r)}else if(l==="rename"||t!==d){const o=setTimeout(async()=>{const u=await(0,n.exists)(r);b||(u?(E("changed",r),p=[L(g,E,w)]):E("deleted",r))},e.CHANGE_BUFFER_DELAY);(0,k.dispose)(p),p=[(0,k.toDisposable)(()=>clearTimeout(o))]}else E("changed",r)}}})}catch(a){(0,n.exists)(g.path).then(c=>{c&&!b&&w(`Failed to watch ${g.path} for changes using fs.watch() (${a.toString()})`)})}return(0,k.toDisposable)(()=>{b=!0,p=(0,k.dispose)(p)})}}),define(X[116],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[117],Q([0,1,11,116,13]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function S(){v.ipcMain.on(R.CONTEXT_MENU_CHANNEL,(n,y,i,L,g)=>{const E=k(n,L,i);E.popup({window:(0,D.withNullAsUndefined)(v.BrowserWindow.fromWebContents(n.sender)),x:g?g.x:void 0,y:g?g.y:void 0,positioningItem:g?g.positioningItem:void 0,callback:()=>{E&&n.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,y)}})})}e.registerContextMenuListener=S;function k(n,y,i){const L=new v.Menu;return i.forEach(g=>{let E;g.type==="separator"?E=new v.MenuItem({type:g.type}):Array.isArray(g.submenu)?E=new v.MenuItem({submenu:k(n,y,g.submenu),label:g.label}):E=new v.MenuItem({label:g.label,type:g.type,accelerator:g.accelerator,checked:g.checked,enabled:g.enabled,visible:g.visible,click:(w,d,m)=>n.sender.send(y,g.id,m)}),L.append(E)}),L}}),define(X[33],Q([0,1,5,2,10,25,19,21,34,13,107,20]),function(j,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var E;(function(C){C[C.Promise=100]="Promise",C[C.PromiseCancel=101]="PromiseCancel",C[C.EventListen=102]="EventListen",C[C.EventDispose=103]="EventDispose"})(E=e.RequestType||(e.RequestType={}));function w(C){switch(C){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(C){C[C.Initialize=200]="Initialize",C[C.PromiseSuccess=201]="PromiseSuccess",C[C.PromiseError=202]="PromiseError",C[C.PromiseErrorObj=203]="PromiseErrorObj",C[C.EventFire=204]="EventFire"})(d=e.ResponseType||(e.ResponseType={}));function m(C){switch(C){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(C){C[C.Uninitialized=0]="Uninitialized",C[C.Idle=1]="Idle"})(b||(b={}));class p{constructor(P){this.buffer=P,this.pos=0}read(P){const M=this.buffer.slice(this.pos,this.pos+P);return this.pos+=M.byteLength,M}}class a{constructor(){this.buffers=[]}get buffer(){return n.VSBuffer.concat(this.buffers)}write(P){this.buffers.push(P)}}var c;(function(C){C[C.Undefined=0]="Undefined",C[C.String=1]="String",C[C.Buffer=2]="Buffer",C[C.VSBuffer=3]="VSBuffer",C[C.Array=4]="Array",C[C.Object=5]="Object"})(c||(c={}));function l(C){const P=n.VSBuffer.alloc(4);return P.writeUInt32BE(C,0),P}function s(C){return C.read(4).readUInt32BE(0)}function t(C){const P=n.VSBuffer.alloc(1);return P.writeUInt8(C,0),P}const r={Undefined:t(c.Undefined),String:t(c.String),Buffer:t(c.Buffer),VSBuffer:t(c.VSBuffer),Array:t(c.Array),Object:t(c.Object)},o=typeof Buffer!="undefined";function u(C,P){if(typeof P=="undefined")C.write(r.Undefined);else if(typeof P=="string"){const M=n.VSBuffer.fromString(P);C.write(r.String),C.write(l(M.byteLength)),C.write(M)}else if(o&&Buffer.isBuffer(P)){const M=n.VSBuffer.wrap(P);C.write(r.Buffer),C.write(l(M.byteLength)),C.write(M)}else if(P instanceof n.VSBuffer)C.write(r.VSBuffer),C.write(l(P.byteLength)),C.write(P);else if(Array.isArray(P)){C.write(r.Array),C.write(l(P.length));for(const M of P)u(C,M)}else{const M=n.VSBuffer.fromString(JSON.stringify(P));C.write(r.Object),C.write(l(M.byteLength)),C.write(M)}}function h(C){switch(C.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return C.read(s(C)).toString();case c.Buffer:return C.read(s(C)).buffer;case c.VSBuffer:return C.read(s(C));case c.Array:{const M=s(C),_=[];for(let T=0;T<M;T++)_.push(h(C));return _}case c.Object:return JSON.parse(C.read(s(C)).toString())}}class f{constructor(P,M,_=null,T=1e3){this.protocol=P,this.ctx=M,this.logger=_,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(O=>this.onRawMessage(O)),this.sendResponse({type:200})}registerChannel(P,M){this.channels.set(P,M),setTimeout(()=>this.flushPendingRequests(P),0)}sendResponse(P){switch(P.type){case 200:{const M=this.send([P.type]);this.logger&&this.logger.logOutgoing(M,0,1,m(P.type));return}case 201:case 202:case 204:case 203:{const M=this.send([P.type,P.id],P.data);this.logger&&this.logger.logOutgoing(M,P.id,1,m(P.type),P.data);return}}}send(P,M=void 0){const _=new a;return u(_,P),u(_,M),this.sendBuffer(_.buffer)}sendBuffer(P){try{return this.protocol.send(P),P.byteLength}catch(M){return 0}}onRawMessage(P){const M=new p(P),_=h(M),T=h(M),O=_[0];switch(O){case 100:return this.logger&&this.logger.logIncoming(P.byteLength,_[1],1,`${w(O)}: ${_[2]}.${_[3]}`,T),this.onPromise({type:O,id:_[1],channelName:_[2],name:_[3],arg:T});case 102:return this.logger&&this.logger.logIncoming(P.byteLength,_[1],1,`${w(O)}: ${_[2]}.${_[3]}`,T),this.onEventListen({type:O,id:_[1],channelName:_[2],name:_[3],arg:T});case 101:return this.logger&&this.logger.logIncoming(P.byteLength,_[1],1,`${w(O)}`),this.disposeActiveRequest({type:O,id:_[1]});case 103:return this.logger&&this.logger.logIncoming(P.byteLength,_[1],1,`${w(O)}`),this.disposeActiveRequest({type:O,id:_[1]})}}onPromise(P){const M=this.channels.get(P.channelName);if(!M){this.collectPendingRequest(P);return}const _=new S.CancellationTokenSource;let T;try{T=M.call(this.ctx,P.name,P.arg,_.token)}catch(K){T=Promise.reject(K)}const O=P.id;T.then(K=>{this.sendResponse({id:O,data:K,type:201}),this.activeRequests.delete(P.id)},K=>{K instanceof Error?this.sendResponse({id:O,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.sendResponse({id:O,data:K,type:203}),this.activeRequests.delete(P.id)});const B=(0,R.toDisposable)(()=>_.cancel());this.activeRequests.set(P.id,B)}onEventListen(P){const M=this.channels.get(P.channelName);if(!M){this.collectPendingRequest(P);return}const _=P.id,O=M.listen(this.ctx,P.name,P.arg)(B=>this.sendResponse({id:_,data:B,type:204}));this.activeRequests.set(P.id,O)}disposeActiveRequest(P){const M=this.activeRequests.get(P.id);M&&(M.dispose(),this.activeRequests.delete(P.id))}collectPendingRequest(P){let M=this.pendingRequests.get(P.channelName);M||(M=[],this.pendingRequests.set(P.channelName,M));const _=setTimeout(()=>{console.error(`Unknown channel: ${P.channelName}`),P.type===100&&this.sendResponse({id:P.id,data:{name:"Unknown channel",message:`Channel name '${P.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:P,timeoutTimer:_})}flushPendingRequests(P){const M=this.pendingRequests.get(P);if(M){for(const _ of M)switch(clearTimeout(_.timeoutTimer),_.request.type){case 100:this.onPromise(_.request);break;case 102:this.onEventListen(_.request);break}this.pendingRequests.delete(P)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(P=>P.dispose()),this.activeRequests.clear()}}e.ChannelServer=f;var I;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(I=e.RequestInitiator||(e.RequestInitiator={}));class A{constructor(P,M=null){this.protocol=P,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(_=>this.onBuffer(_)),this.logger=M}getChannel(P){const M=this;return{call(_,T,O){return M.isDisposed?Promise.reject(k.canceled()):M.requestPromise(P,_,T,O)},listen(_,T){return M.isDisposed?Promise.reject(k.canceled()):M.requestEvent(P,_,T)}}}requestPromise(P,M,_,T=S.CancellationToken.None){const O=this.lastRequestId++,K={id:O,type:100,channelName:P,name:M,arg:_};if(T.isCancellationRequested)return Promise.reject(k.canceled());let G;return new Promise((ee,re)=>{if(T.isCancellationRequested)return re(k.canceled());const x=()=>{const ye=me=>{switch(me.type){case 201:this.handlers.delete(O),ee(me.data);break;case 202:this.handlers.delete(O);const de=new Error(me.data.message);de.stack=me.data.stack,de.name=me.data.name,re(de);break;case 203:this.handlers.delete(O),re(me.data);break}};this.handlers.set(O,ye),this.sendRequest(K)};let ne=null;this.state===b.Idle?x():(ne=(0,D.createCancelablePromise)(ye=>this.whenInitialized()),ne.then(()=>{ne=null,x()}));const oe=()=>{ne?(ne.cancel(),ne=null):this.sendRequest({id:O,type:101}),re(k.canceled())},ue=T.onCancellationRequested(oe);G=(0,R.combinedDisposable)((0,R.toDisposable)(oe),ue),this.activeRequests.add(G)}).finally(()=>{this.activeRequests.delete(G)})}requestEvent(P,M,_){const T=this.lastRequestId++,B={id:T,type:102,channelName:P,name:M,arg:_};let K=null;const G=new v.Emitter({onFirstListenerAdd:()=>{K=(0,D.createCancelablePromise)(ee=>this.whenInitialized()),K.then(()=>{K=null,this.activeRequests.add(G),this.sendRequest(B)})},onLastListenerRemove:()=>{K?(K.cancel(),K=null):(this.activeRequests.delete(G),this.sendRequest({id:T,type:103}))}}),J=ee=>G.fire(ee.data);return this.handlers.set(T,J),G.event}sendRequest(P){switch(P.type){case 100:case 102:{const M=this.send([P.type,P.id,P.channelName,P.name],P.arg);this.logger&&this.logger.logOutgoing(M,P.id,0,`${w(P.type)}: ${P.channelName}.${P.name}`,P.arg);return}case 101:case 103:{const M=this.send([P.type,P.id]);this.logger&&this.logger.logOutgoing(M,P.id,0,w(P.type));return}}}send(P,M=void 0){const _=new a;return u(_,P),u(_,M),this.sendBuffer(_.buffer)}sendBuffer(P){try{return this.protocol.send(P),P.byteLength}catch(M){return 0}}onBuffer(P){const M=new p(P),_=h(M),T=h(M),O=_[0];switch(O){case 200:return this.logger&&this.logger.logIncoming(P.byteLength,0,0,m(O)),this.onResponse({type:_[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(P.byteLength,_[1],0,m(O),T),this.onResponse({type:_[0],id:_[1],data:T})}}onResponse(P){if(P.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(P.id);M&&M(P)}whenInitialized(){return this.state===b.Idle?Promise.resolve():v.Event.toPromise(this.onDidInitialize)}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(P=>P.dispose()),this.activeRequests.clear()}}e.ChannelClient=A;class F{constructor(P){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,P(({protocol:M,onDidClientDisconnect:_})=>{v.Event.once(M.onMessage)(O=>{const B=new p(O),K=h(B),G=new f(M,K),J=new A(M);this.channels.forEach((re,x)=>G.registerChannel(x,re));const ee={channelServer:G,channelClient:J,ctx:K};this._connections.add(ee),this._onDidAddConnection.fire(ee),_(()=>{G.dispose(),J.dispose(),this._connections.delete(ee),this._onDidRemoveConnection.fire(ee)})})})}get connections(){const P=[];return this._connections.forEach(M=>P.push(M)),P}getChannel(P,M){const _=this;return{call(T,O,B){let K;if((0,i.isFunction)(M)){let J=(0,y.getRandomElement)(_.connections.filter(M));K=J?Promise.resolve(J):v.Event.toPromise(v.Event.filter(_.onDidAddConnection,M))}else K=M.routeCall(_,T,O);const G=K.then(J=>J.channelClient.getChannel(P));return q(G).call(T,O,B)},listen(T,O){if((0,i.isFunction)(M))return _.getMulticastEvent(P,M,T,O);const B=M.routeEvent(_,T,O).then(K=>K.channelClient.getChannel(P));return q(B).listen(T,O)}}}getMulticastEvent(P,M,_,T){const O=this;let B=new R.DisposableStore;const K=new v.Emitter({onFirstListenerAdd:()=>{B=new R.DisposableStore;const G=new v.EventMultiplexer,J=new Map,ee=x=>{const oe=x.channelClient.getChannel(P).listen(_,T),ue=G.add(oe);J.set(x,ue)},re=x=>{const ne=J.get(x);!ne||(ne.dispose(),J.delete(x))};O.connections.filter(M).forEach(ee),v.Event.filter(O.onDidAddConnection,M)(ee,void 0,B),O.onDidRemoveConnection(re,void 0,B),G.event(K.fire,K,B),B.add(G)},onLastListenerRemove:()=>{B.dispose()}});return K.event}registerChannel(P,M){this.channels.set(P,M),this._connections.forEach(_=>{_.channelServer.registerChannel(P,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=F;class U{constructor(P,M,_=null){const T=new a;u(T,M),P.send(T.buffer),this.channelClient=new A(P,_),this.channelServer=new f(P,M,_)}getChannel(P){return this.channelClient.getChannel(P)}registerChannel(P,M){this.channelServer.registerChannel(P,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function q(C){return{call(P,M,_){return C.then(T=>T.call(P,M,_))},listen(P,M){const _=new v.Relay;return C.then(T=>_.input=T.listen(P,M)),_.event}}}e.getDelayedChannel=q;function Y(C){let P=!1;return{call(M,_,T){return P?C.call(M,_,T):(0,D.timeout)(0).then(()=>P=!0).then(()=>C.call(M,_,T))},listen(M,_){if(P)return C.listen(M,_);const T=new v.Relay;return(0,D.timeout)(0).then(()=>P=!0).then(()=>T.input=C.listen(M,_)),T.event}}}e.getNextTickChannel=Y;class ie{constructor(P){this.fn=P}routeCall(P){return this.route(P)}routeEvent(P){return this.route(P)}async route(P){for(const M of P.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await v.Event.toPromise(P.onDidAddConnection),await this.route(P)}}e.StaticRouter=ie;var ae;(function(C){function P(T,O){const B=T,K=O&&O.disableMarshalling,G=new Map;for(const J in B)_(J)&&G.set(J,v.Event.buffer(B[J],!0));return new class{listen(J,ee){const re=G.get(ee);if(re)return re;throw new Error(`Event not found: ${ee}`)}call(J,ee,re){const x=B[ee];if(typeof x=="function"){if(!K&&Array.isArray(re))for(let ne=0;ne<re.length;ne++)re[ne]=(0,L.revive)(re[ne]);return x.apply(B,re)}throw new Error(`Method not found: ${ee}`)}}}C.fromService=P;function M(T,O){const B=O&&O.disableMarshalling;return new Proxy({},{get(K,G){var J;if(typeof G=="string")return((J=O==null?void 0:O.properties)===null||J===void 0?void 0:J.has(G))?O.properties.get(G):_(G)?T.listen(G):async function(...ee){let re;O&&!(0,i.isUndefinedOrNull)(O.context)?re=[O.context,...ee]:re=ee;const x=await T.call(G,re);return B?x:(0,L.revive)(x)};throw new Error(`Property not found: ${String(G)}`)}})}C.toService=M;function _(T){return T[0]==="o"&&T[1]==="n"&&g.isUpperAsciiLetter(T.charCodeAt(2))}})(ae=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function N(C){if(Array.isArray(C))return C;if(C&&typeof C=="object"&&typeof C.toString=="function"){let P=C.toString();if(P!=="[object Object]")return P}return C}function z(C){return Array.isArray(C)?C.map(N):N(C)}function W(C,P,M,_,T,O,B){B=z(B);const K=V[T],G=K[_%K.length];let J=[`%c[${C}]%c[${String(P).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(_).padStart(5," ")} - ${O}`,"color: darkgreen","color: grey","color: grey",`color: ${G}`];/\($/.test(O)?(J=J.concat(B),J.push(")")):J.push(B),console.log.apply(console,J)}e.logWithColors=W;class ${constructor(P,M){this._outgoingPrefix=P,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(P,M,_,T,O){this._totalOutgoing+=P,W(this._outgoingPrefix,this._totalOutgoing,P,M,_,T,O)}logIncoming(P,M,_,T,O){this._totalIncoming+=P,W(this._incomingPrefix,this._totalIncoming,P,M,_,T,O)}}e.IPCLogger=$}),define(X[118],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class v{constructor(D,S){this.sender=D,this.onMessage=S}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(S){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=v}),define(X[119],Q([0,1,5,33,21]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class S{constructor(y){this.port=y,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",i=>D.VSBuffer.wrap(i.data)),y.start()}send(y){this.port.postMessage(y.buffer)}disconnect(){this.port.close()}}e.Protocol=S;class k extends R.IPCClient{constructor(y,i){const L=new S(y);super(L,i);this.protocol=L}dispose(){this.protocol.disconnect()}}e.Client=k}),define(X[82],Q([0,1,5,33,2,21,3,35]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let y=null;function i(){return y||(y=S.VSBuffer.alloc(0)),y}class L{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,u){if(o===0)return i();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const A=this._chunks[0];return u&&(this._chunks.shift(),this._totalLength-=o),A}if(this._chunks[0].byteLength>o){const A=this._chunks[0].slice(0,o);return u&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),A}let h=S.VSBuffer.alloc(o),f=0,I=0;for(;o>0;){const A=this._chunks[I];if(A.byteLength>o){const F=A.slice(0,o);h.set(F,f),f+=o,u&&(this._chunks[I]=A.slice(o),this._totalLength-=o),o-=o}else h.set(A,f),f+=A.byteLength,u?(this._chunks.shift(),this._totalLength-=A.byteLength):I++,o-=A.byteLength}return h}}e.ChunkStream=L;var g;(function(r){r[r.None=0]="None",r[r.Regular=1]="Regular",r[r.Control=2]="Control",r[r.Ack=3]="Ack",r[r.KeepAlive=4]="KeepAlive",r[r.Disconnect=5]="Disconnect",r[r.ReplayRequest=6]="ReplayRequest"})(g||(g={}));var E;(function(r){r[r.HeaderLength=13]="HeaderLength",r[r.AcknowledgeTime=2e3]="AcknowledgeTime",r[r.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",r[r.KeepAliveTime=5e3]="KeepAliveTime",r[r.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",r[r.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",r[r.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(E=e.ProtocolConstants||(e.ProtocolConstants={}));class w{constructor(o,u,h,f){this.type=o,this.id=u,this.ack=h,this.data=f,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends D.Disposable{constructor(o){super();this._onMessage=this._register(new v.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new L,this._register(this._socket.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const u=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=u.readUInt32BE(9),this._state.messageType=u.readUInt8(0),this._state.id=u.readUInt32BE(1),this._state.ack=u.readUInt32BE(5);else{const h=this._state.messageType,f=this._state.id,I=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new w(h,f,I,u)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._isDisposed=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(o){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(o){if(!this._isDisposed){o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=S.VSBuffer.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this._writeSoon(u,o.data)}}_bufferAdd(o,u){const h=this._totalLength===0;return this._data.push(o,u),this._totalLength+=o.byteLength+u.byteLength,h}_bufferTake(){const o=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,u){this._bufferAdd(o,u)&&k.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends D.Disposable{constructor(o){super();this._onMessage=new v.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new v.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new d(this._socket)),this._register(this._socketReader.onMessage(u=>{u.type===1&&this._onMessage.fire(u.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new w(1,0,0,o))}}e.Protocol=b;class p extends R.IPCClient{constructor(o,u,h=null){super(o,u,h);this.protocol=o}static fromSocket(o,u){return new p(new b(o),u)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=p;class a{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new v.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,n.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=a;class c{constructor(o){this.data=o,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let o=[],u=0,h=this._first;for(;h;)o[u++]=h.data,h=h.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const u=new c(o);if(!this._first){this._first=u,this._last=u;return}this._last.next=u,this._last=u}}class s{constructor(){this.lastRuns=[];const o=Date.now();for(let u=0;u<s._HISTORY_LENGTH;u++)this.lastRuns[u]=o-1e3*u;setInterval(()=>{for(let u=s._HISTORY_LENGTH;u>=1;u--)this.lastRuns[u]=this.lastRuns[u-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return s._INSTANCE||(s._INSTANCE=new s),s._INSTANCE}load(){const o=Date.now(),u=(1+s._HISTORY_LENGTH)*1e3;let h=0;for(let f=0;f<s._HISTORY_LENGTH;f++)o-this.lastRuns[f]<=u&&h++;return 1-h/s._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}s._HISTORY_LENGTH=10,s._INSTANCE=null;class t{constructor(o,u=null){this._loadEstimator=s.getInstance(),this._onControlMessage=new a,this.onControlMessage=this._onControlMessage.event,this._onMessage=new a,this.onMessage=this._onMessage.event,this._onDidDispose=new a,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new a,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new a,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),u&&this._socketReader.acceptChunk(u),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new w(5,0,0,i());this._socketWriter.write(o),this._socketWriter.flush()}_sendKeepAliveCheck(){if(!this._outgoingKeepAliveTimeout){const o=Date.now()-this._socketWriter.lastWriteTime;if(o>=5e3){const u=new w(4,0,0,i());this._socketWriter.write(u),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-o+5)}}_recvKeepAliveCheck(){if(!this._incomingKeepAliveTimeout){const o=Date.now()-this._socketReader.lastReadTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-o,0)+5)}}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,u){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new d(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(u)}endAcceptReconnection(){this._isReconnecting=!1;const o=this._outgoingUnackMsg.toArray();for(let u=0,h=o.length;u<h;u++)this._socketWriter.write(o[u]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const u=this._outgoingUnackMsg.peek();if(u&&u.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(o.type===1){if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const u=Date.now();u-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=u,this._socketWriter.write(new w(6,0,0,i())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data)}else if(o.type===2)this._onControlMessage.fire(o.data);else if(o.type===5)this._onDidDispose.fire();else if(o.type===6){const u=this._outgoingUnackMsg.toArray();for(let h=0,f=u.length;h<f;h++)this._socketWriter.write(u[h]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const u=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const h=new w(1,u,this._incomingAckId,o);this._outgoingUnackMsg.push(h),this._isReconnecting||(this._socketWriter.write(h),this._recvAckCheck())}sendControl(o){const u=new w(2,0,0,o);this._socketWriter.write(u)}_sendAckCheck(){if(!(this._incomingMsgId<=this._incomingAckId)&&!this._incomingAckTimeout){const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}}_recvAckCheck(){if(!(this._outgoingMsgId<=this._outgoingAckId)&&!this._outgoingAckTimeout){const o=this._outgoingUnackMsg.peek(),u=Date.now()-o.writtenTime;if(u>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-u,0)+5)}}_sendAck(){if(!(this._incomingMsgId<=this._incomingAckId)){this._incomingAckId=this._incomingMsgId;const o=new w(3,0,this._incomingAckId,i());this._socketWriter.write(o)}}}e.PersistentProtocol=t}),define(X[120],Q([0,1,11,5,33,118,2,21]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function y(L,g){const E=R.Event.fromNodeEventEmitter(v.ipcMain,g,(d,m)=>({event:d,message:m})),w=R.Event.filter(E,({event:d})=>d.sender.id===L);return R.Event.map(w,({message:d})=>d&&n.VSBuffer.wrap(d))}class i extends D.IPCServer{constructor(){super(i.getOnDidClientConnect())}static getOnDidClientConnect(){const g=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:hello",({sender:E})=>E);return R.Event.map(g,E=>{const w=E.id,d=i.Clients.get(w);d&&d.dispose();const m=new R.Emitter;i.Clients.set(w,(0,k.toDisposable)(()=>m.fire()));const b=y(w,"vscode:message"),p=R.Event.any(R.Event.signal(y(w,"vscode:disconnect")),m.event);return{protocol:new S.Protocol(E,b),onDidClientDisconnect:p}})}}e.Server=i,i.Clients=new Map}),define(X[83],Q([0,1,11,5,28,119]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class k extends S.Client{constructor(i,L){super({addEventListener:(g,E)=>i.addListener(g,E),removeEventListener:(g,E)=>i.removeListener(g,E),postMessage:g=>i.postMessage(g),start:()=>i.start(),close:()=>i.close()},L)}}e.Client=k;async function n(y){if(y.isDestroyed()||y.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const i=(0,D.generateUuid)();y.webContents.send("vscode:createMessageChannel",i);const L=R.Event.fromNodeEventEmitter(v.ipcMain,"vscode:createMessageChannelResult",(E,w)=>({nonce:w,port:E.ports[0]})),{port:g}=await R.Event.toPromise(R.Event.once(R.Event.filter(L,E=>E.nonce===i)));return g}e.connect=n}),define(X[84],Q([0,1,2,5,10,13]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var k;(function(L){L[L.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(k=e.StorageHint||(e.StorageHint={}));var n;(function(L){L[L.None=0]="None",L[L.Initialized=1]="Initialized",L[L.Closed=2]="Closed"})(n||(n={}));class y extends v.Disposable{constructor(g,E=Object.create(null)){super();this.database=g,this.options=E,this._onDidChangeStorage=this._register(new R.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=n.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(y.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(g=>this.onDidChangeItemsExternal(g)))}onDidChangeItemsExternal(g){var E,w;(E=g.changed)===null||E===void 0||E.forEach((d,m)=>this.accept(m,d)),(w=g.deleted)===null||w===void 0||w.forEach(d=>this.accept(d,void 0))}accept(g,E){if(this.state!==n.Closed){let w=!1;(0,S.isUndefinedOrNull)(E)?w=this.cache.delete(g):this.cache.get(g)!==E&&(this.cache.set(g,E),w=!0),w&&this._onDidChangeStorage.fire(g)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===n.None&&(this.state=n.Initialized,this.options.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(g,E){const w=this.cache.get(g);return(0,S.isUndefinedOrNull)(w)?E:w}getBoolean(g,E){const w=this.get(g);return(0,S.isUndefinedOrNull)(w)?E:w==="true"}getNumber(g,E){const w=this.get(g);return(0,S.isUndefinedOrNull)(w)?E:parseInt(w,10)}async set(g,E){if(this.state!==n.Closed){if((0,S.isUndefinedOrNull)(E))return this.delete(g);const w=String(E);if(this.cache.get(g)!==w)return this.cache.set(g,w),this.pendingInserts.set(g,w),this.pendingDeletes.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(g){if(this.state!==n.Closed&&!!this.cache.delete(g))return this.pendingDeletes.has(g)||this.pendingDeletes.add(g),this.pendingInserts.delete(g),this._onDidChangeStorage.fire(g),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=n.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(g){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const g={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(g).finally(()=>{var E;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(E=this.whenFlushedCallbacks.pop())===null||E===void 0||E()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(g=>this.whenFlushedCallbacks.push(g))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=y,y.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(g){g.insert&&g.insert.forEach((E,w)=>this.items.set(w,E)),g.delete&&g.delete.forEach(E=>this.items.delete(E))}async close(){}}e.InMemoryStorageDatabase=i}),define(X[121],Q([0,1,22,5,10,36,8,23]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class y{constructor(g,E=Object.create(null)){this.path=g,this.options=E,this.name=(0,k.basename)(this.path),this.logger=new i(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return R.Event.None}async getItems(){const g=await this.whenConnected,E=new Map;return(await this.all(g,"SELECT * FROM ItemTable")).forEach(d=>E.set(d.key,d.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${E.size} rows`),E}async updateItems(g){const E=await this.whenConnected;return this.doUpdateItems(E,g)}doUpdateItems(g,E){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${E.insert?(0,S.mapToString)(E.insert):"0"}), delete(${E.delete?(0,S.setToString)(E.delete):"0"})`),this.transaction(g,()=>{const w=E.insert,d=E.delete;if(w&&w.size>0){const m=[];m.push([]);let b=0;w.forEach((p,a)=>{let c=m[b];c.length>y.MAX_HOST_PARAMETERS&&(b++,c=[],m.push(c)),c.push(a,p)}),m.forEach(p=>{this.prepare(g,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,a=>a.run(p),()=>{const a=[];let c=0;return w.forEach((l,s)=>{a.push(s),c+=l.length}),`Keys: ${a.join(", ")} Length: ${c}`})})}if(d&&d.size){const m=[];m.push([]);let b=0;d.forEach(p=>{let a=m[b];a.length>y.MAX_HOST_PARAMETERS&&(b++,a=[],m.push(a)),a.push(p)}),m.forEach(p=>{this.prepare(g,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,a=>a.run(p),()=>{const a=[];return d.forEach(c=>{a.push(c)}),`Keys: ${a.join(", ")}`})})}})}async close(g){this.logger.trace(`[storage ${this.name}] close()`);const E=await this.whenConnected;return this.doClose(E,g)}doClose(g,E){return new Promise((w,d)=>{g.db.close(m=>(m&&this.handleSQLiteError(g,`[storage ${this.name}] close(): ${m}`),this.path===y.IN_MEMORY_PATH?w():!g.isErroneous&&!g.isInMemory?this.backup().then(w,b=>(this.logger.error(`[storage ${this.name}] backup(): ${b}`),w())):typeof E=="function"?v.promises.unlink(this.path).then(()=>this.doConnect(this.path).then(b=>{const p=()=>this.doClose(b,void 0);return this.doUpdateItems(b,{insert:E()}).then(()=>p(),a=>(p(),Promise.reject(a)))})).then(w,d):d(m||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const g=this.toBackupPath(this.path);return(0,n.copy)(this.path,g,{preserveSymlinks:!1})}toBackupPath(g){return`${g}.backup`}async checkIntegrity(g){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${g})`);const E=await this.whenConnected,w=await this.get(E,g?"PRAGMA integrity_check":"PRAGMA quick_check"),d=g?w.integrity_check:w.quick_check;return E.isErroneous?`${d} (last error: ${E.lastError})`:E.isInMemory?`${d} (in-memory!)`:d}async connect(g,E=!0){this.logger.trace(`[storage ${this.name}] open(${g}, retryOnBusy: ${E})`);try{return await this.doConnect(g)}catch(w){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${w}`),w.code==="SQLITE_BUSY"&&E)return await(0,D.timeout)(y.BUSY_OPEN_TIMEOUT),this.connect(g,!1);try{await v.promises.unlink(g);try{await v.promises.rename(this.toBackupPath(g),g)}catch(d){}return await this.doConnect(g)}catch(d){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${d}`),this.doConnect(y.IN_MEMORY_PATH)}}}handleSQLiteError(g,E){g.isErroneous=!0,g.lastError=E,this.logger.error(E)}doConnect(g){return new Promise((E,w)=>{new Promise((d,m)=>{j(["vscode-sqlite3"],d,m)}).then(d=>{const m={db:new(this.logger.isTracing?d.verbose().Database:d.Database)(g,b=>b?m.db?m.db.close(()=>w(b)):w(b):this.exec(m,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>E(m),p=>m.db.close(()=>w(p)))),isInMemory:g===y.IN_MEMORY_PATH};m.db.on("error",b=>this.handleSQLiteError(m,`[storage ${this.name}] Error (event): ${b}`)),this.logger.isTracing&&m.db.on("trace",b=>this.logger.trace(`[storage ${this.name}] Trace (event): ${b}`))},w)})}exec(g,E){return new Promise((w,d)=>{g.db.exec(E,m=>m?(this.handleSQLiteError(g,`[storage ${this.name}] exec(): ${m}`),d(m)):w())})}get(g,E){return new Promise((w,d)=>{g.db.get(E,(m,b)=>m?(this.handleSQLiteError(g,`[storage ${this.name}] get(): ${m}`),d(m)):w(b))})}all(g,E){return new Promise((w,d)=>{g.db.all(E,(m,b)=>m?(this.handleSQLiteError(g,`[storage ${this.name}] all(): ${m}`),d(m)):w(b))})}transaction(g,E){return new Promise((w,d)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),E(),g.db.run("END TRANSACTION",m=>m?(this.handleSQLiteError(g,`[storage ${this.name}] transaction(): ${m}`),d(m)):w())})})}prepare(g,E,w,d){const m=g.db.prepare(E),b=p=>{this.handleSQLiteError(g,`[storage ${this.name}] prepare(): ${p} (${E}). Details: ${d()}`)};m.on("error",b),w(m),m.finalize(p=>{p&&b(p),m.removeListener("error",b)})}}e.SQLiteStorageDatabase=y,y.IN_MEMORY_PATH=":memory:",y.BUSY_OPEN_TIMEOUT=2e3,y.MAX_HOST_PARAMETERS=256;class i{constructor(g){g&&typeof g.logTrace=="function"&&process.env[i.VSCODE_TRACE_STORAGE]&&(this.logTrace=g.logTrace),g&&typeof g.logError=="function"&&(this.logError=g.logError)}get isTracing(){return!!this.logTrace}trace(g){this.logTrace&&this.logTrace(g)}error(g){this.logError&&this.logError(g)}}i.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[122],Q([14,12]),function(j,e){return j.create("vs/base/common/date",e)}),define(X[123],Q([0,1,122]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,D=R*60,S=D*24,k=S*7,n=S*30,y=S*365;function i(g,E){typeof g!="number"&&(g=g.getTime());const w=Math.round((new Date().getTime()-g)/1e3);if(w<-30)return(0,v.localize)(0,null,i(new Date().getTime()+w*1e3,!1));if(w<30)return(0,v.localize)(1,null);let d;return w<R?(d=w,E?d===1?(0,v.localize)(2,null,d):(0,v.localize)(3,null,d):d===1?(0,v.localize)(4,null,d):(0,v.localize)(5,null,d)):w<D?(d=Math.floor(w/R),E?d===1?(0,v.localize)(6,null,d):(0,v.localize)(7,null,d):d===1?(0,v.localize)(8,null,d):(0,v.localize)(9,null,d)):w<S?(d=Math.floor(w/D),E?d===1?(0,v.localize)(10,null,d):(0,v.localize)(11,null,d):d===1?(0,v.localize)(12,null,d):(0,v.localize)(13,null,d)):w<k?(d=Math.floor(w/S),E?d===1?(0,v.localize)(14,null,d):(0,v.localize)(15,null,d):d===1?(0,v.localize)(16,null,d):(0,v.localize)(17,null,d)):w<n?(d=Math.floor(w/k),E?d===1?(0,v.localize)(18,null,d):(0,v.localize)(19,null,d):d===1?(0,v.localize)(20,null,d):(0,v.localize)(21,null,d)):w<y?(d=Math.floor(w/n),E?d===1?(0,v.localize)(22,null,d):(0,v.localize)(23,null,d):d===1?(0,v.localize)(24,null,d):(0,v.localize)(25,null,d)):(d=Math.floor(w/y),E?d===1?(0,v.localize)(26,null,d):(0,v.localize)(27,null,d):d===1?(0,v.localize)(28,null,d):(0,v.localize)(29,null,d))}e.fromNow=i;function L(g){return g.getFullYear()+"-"+String(g.getMonth()+1).padStart(2,"0")+"-"+String(g.getDate()).padStart(2,"0")+"T"+String(g.getHours()).padStart(2,"0")+":"+String(g.getMinutes()).padStart(2,"0")+":"+String(g.getSeconds()).padStart(2,"0")+"."+(g.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=L}),define(X[124],Q([14,12]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(X[66],Q([0,1,124,13,34]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(i,L){return L&&(i.stack||i.stacktrace)?v.localize(0,null,n(i),k(i.stack)||k(i.stacktrace)):n(i)}function k(i){return Array.isArray(i)?i.join(`
`):i}function n(i){return typeof i.code=="string"&&typeof i.errno=="number"&&typeof i.syscall=="string"?v.localize(1,null,i.message):i.message||v.localize(2,null)}function y(i=null,L=!1){if(!i)return v.localize(3,null);if(Array.isArray(i)){const g=D.coalesce(i),E=y(g[0],L);return g.length>1?v.localize(4,null,E,g.length):E}if(R.isString(i))return i;if(i.detail){const g=i.detail;if(g.error)return S(g.error,L);if(g.exception)return S(g.exception,L)}return i.stack?S(i,L):i.message?i.message:v.localize(5,null)}e.toErrorMessage=y}),define(X[125],Q([14,12]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(X[126],Q([0,1,125]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class R{constructor(k,n,y=n){this.modifierLabels=[null],this.modifierLabels[2]=k,this.modifierLabels[1]=n,this.modifierLabels[3]=y}toLabel(k,n,y){if(n.length===0)return null;const i=[];for(let L=0,g=n.length;L<g;L++){const E=n[L],w=y(E);if(w===null)return null;i[L]=D(E,w,this.modifierLabels[k])}return i.join(" ")}}e.ModifierLabelProvider=R,e.UILabelProvider=new R({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:v.localize(0,null),shiftKey:v.localize(1,null),altKey:v.localize(2,null),metaKey:v.localize(3,null),separator:"+"},{ctrlKey:v.localize(4,null),shiftKey:v.localize(5,null),altKey:v.localize(6,null),metaKey:v.localize(7,null),separator:"+"}),e.AriaLabelProvider=new R({ctrlKey:v.localize(8,null),shiftKey:v.localize(9,null),altKey:v.localize(10,null),metaKey:v.localize(11,null),separator:"+"},{ctrlKey:v.localize(12,null),shiftKey:v.localize(13,null),altKey:v.localize(14,null),metaKey:v.localize(15,null),separator:"+"},{ctrlKey:v.localize(16,null),shiftKey:v.localize(17,null),altKey:v.localize(18,null),metaKey:v.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new R({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new R({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(S,k,n){if(k===null)return"";const y=[];return S.ctrlKey&&y.push(n.ctrlKey),S.shiftKey&&y.push(n.shiftKey),S.altKey&&y.push(n.altKey),S.metaKey&&y.push(n.metaKey),k!==""&&y.push(k),y.join(n.separator)}}),define(X[127],Q([14,12]),function(j,e){return j.create("vs/base/node/processes",e)}),define(X[85],Q([0,1,8,22,23,46,127,35,13,45,30,3,80,9]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(s,t){if(g.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};t&&(r.cwd=t);const o=S.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],r);return new Promise(u=>{o.once("error",h=>{u({success:!1,error:h})}),o.once("exit",(h,f)=>{u(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?d(r.status):1})}else if(g.isLinux||g.isMacintosh)try{const r=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(o=>{S.execFile(r,[s.pid.toString()],{encoding:"utf8",shell:!0},(u,h,f)=>{o(u?{success:!1,error:u}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function b(s=n.env){return s.comspec||"cmd.exe"}e.getWindowsShell=b;class p{constructor(t,r,o,u){if(r!==void 0&&o!==void 0&&u!==void 0)this.cmd=t,this.args=r,this.shell=o,this.options=u;else{const h=t;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(n.env).forEach(f=>{h[f]=n.env[f]}),Object.keys(this.options.env).forEach(f=>{h[f]=this.options.env[f]}),this.options.env=h}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const r=t.lastIndexOf(v.sep);return r!==-1&&(t=t.substring(r+1)),p.WellKnowCommands[t]?t:"other"}start(t){return g.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(n.cwd()))?Promise.reject(new Error(k.localize(0,null))):this.useExec().then(r=>{let o,u;const h=new Promise((f,I)=>{o=f,u=I});if(r){let f=this.cmd;this.args&&(f=f+" "+this.args.join(" ")),this.childProcess=S.exec(f,this.options,(I,A,F)=>{this.childProcess=null;const U=I;U&&U.killed?u({killed:this.terminateRequested,stdout:A.toString(),stderr:F.toString()}):this.handleExec(o,t,I,A,F)})}else{let f=null;const I=A=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(A,o,t,u);const F={terminated:this.terminateRequested};y.isNumber(A)&&(F.cmdCode=A),o(F)};if(this.shell&&g.isWindows){const A=i.deepClone(this.options);A.windowsVerbatimArguments=!0,A.detached=!1;let F=!1,U=!1;const q=[];let Y=this.ensureQuotes(this.cmd);q.push(Y.value),F=Y.quoted,this.args&&this.args.forEach(ae=>{Y=this.ensureQuotes(ae),q.push(Y.value),U=U&&Y.quoted});const ie=["/s","/c"];F?U?ie.push('"'+q.join(" ")+'"'):q.length>1?ie.push('"'+q[0]+'" '+q.slice(1).join(" ")):ie.push('"'+q[0]+'"'):ie.push(q.join(" ")),f=S.spawn(b(),ie,A)}else this.cmd&&(f=S.spawn(this.cmd,this.args,this.options));f&&(this.childProcess=f,this.childProcessPromise=Promise.resolve(f),this.pidResolve&&(this.pidResolve(y.isNumber(f.pid)?f.pid:-1),this.pidResolve=void 0),f.on("error",A=>{this.childProcess=null,u({terminated:this.terminateRequested,error:A})}),f.pid&&(this.childProcess.on("close",I),this.handleSpawn(f,o,t,u,!0)))}return h})}handleClose(t,r,o,u){}ensureQuotes(t){return p.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,m(t,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!g.isWindows)return t(!1);const r=S.spawn(b(),["/s","/c"]);r.on("error",o=>t(!0)),r.on("exit",o=>t(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class a extends p{constructor(t,r,o,u){super(t,r,o,u);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,r,o,u,h){[u,h].forEach((f,I)=>{const A=new E.LineDecoder;A.write(f).forEach(q=>{r({line:q,source:I===0?0:1})});const U=A.end();U&&r({line:U,source:I===0?0:1})}),t({terminated:this.terminateRequested,error:o})}handleSpawn(t,r,o,u,h){const f=new E.LineDecoder,I=new E.LineDecoder;t.stdout.on("data",A=>{f.write(A).forEach(U=>o({line:U,source:0}))}),t.stderr.on("data",A=>{I.write(A).forEach(U=>o({line:U,source:1}))}),this.stdoutLineDecoder=f,this.stderrLineDecoder=I}handleClose(t,r,o,u){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&o({line:h,source:0});const f=this.stderrLineDecoder?this.stderrLineDecoder.end():null;f&&o({line:f,source:1})}}e.LineProcess=a;function c(s){let t=[],r=!1;const o=function(u){if(r){t.push(u);return}(!s.send(u,f=>{if(f&&console.error(f),r=!1,t.length>0){const I=t.slice(0);t=[],I.forEach(A=>o(A))}})||g.isWindows)&&(r=!0)};return{send:o}}e.createQueuedSender=c;var l;(function(s){async function t(r,o,u){if(v.isAbsolute(r))return r;if(o===void 0&&(o=n.cwd()),v.dirname(r)!=="."||(u===void 0&&y.isString(n.env.PATH)&&(u=n.env.PATH.split(v.delimiter)),u===void 0||u.length===0))return v.join(o,r);async function f(I){return await D.exists(I)?!(await R.promises.stat(I)).isDirectory():!1}for(let I of u){let A;if(v.isAbsolute(I)?A=v.join(I,r):A=v.join(o,I,r),await f(A))return A;let F=A+".com";if(await f(F)||(F=A+".exe",await f(F)))return F}return v.join(o,r)}s.findExecutable=t})(l=e.win32||(e.win32={}))}),define(X[128],Q([0,1,27,3,114,85]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function k(w,d){return w===3?R.isWindows?g():S.getWindowsShell(d):i(w,d)}e.getSystemShell=k;function n(w,d){return w===3?R.isWindows?E(d):S.getWindowsShell(d):i(w,d)}e.getSystemShellSync=n;let y=null;function i(w,d){if(R.isLinux&&w===1||R.isMacintosh&&w===2)return"/bin/bash";if(!y){let m;if(R.isWindows)m="/bin/bash";else{if(m=d.SHELL,!m)try{m=v.userInfo().shell}catch(b){}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}y=m}return y}let L=null;async function g(){return L||(L=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),L}function E(w){if(L)return L;const d=R.isWindows&&parseFloat(v.release())>=10,m=w.hasOwnProperty("PROCESSOR_ARCHITEW6432"),b=`${w.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?b:S.getWindowsShell(w)}}),define(X[86],Q([0,1,46,2,10,45,5,85,33,106,25,19,21,3]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(p){super({send:a=>{try{process.send&&process.send(a.buffer.toString("base64"))}catch(c){}},onMessage:k.Event.fromNodeEventEmitter(process,"message",a=>E.VSBuffer.wrap(Buffer.from(a,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class m{constructor(p,a){this.modulePath=p,this.options=a,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new k.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=a&&a.timeout?a.timeout:6e4;this.disposeDelayer=new D.Delayer(c),this.child=null,this._client=null}getChannel(p){const a=this;return{call(c,l,s){return a.requestPromise(p,c,l,s)},listen(c,l){return a.requestEvent(p,c,l)}}}requestPromise(p,a,c,l=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(g.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(p),t=(0,D.createCancelablePromise)(u=>s.call(a,c,u)),r=l.onCancellationRequested(()=>t.cancel()),o=(0,R.toDisposable)(()=>t.cancel());return this.activeRequests.add(o),t.finally(()=>{r.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(p,a,c){if(!this.disposeDelayer)return k.Event.None;this.disposeDelayer.cancel();let l;const s=new k.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(p).listen(a,c)(s.fire,s),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],a=Object.create(null);a.env=Object.assign(Object.assign({},(0,S.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(a.env=Object.assign(Object.assign({},a.env),this.options.env)),this.options&&this.options.freshExecArgv&&(a.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(a.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(a.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),a.execArgv===void 0&&(a.execArgv=process.execArgv.filter(h=>!/^--inspect(-brk)?=/.test(h))),w.isMacintosh&&a.env&&delete a.env.DYLD_LIBRARY_PATH,this.child=(0,v.fork)(this.modulePath,p,a);const c=new k.Emitter;k.Event.fromNodeEventEmitter(this.child,"message",h=>h)(h=>{if((0,i.isRemoteConsoleLog)(h)){(0,i.log)(h,`IPC Library: ${this.options.serverName}`);return}c.fire(E.VSBuffer.wrap(Buffer.from(h,"base64")))});const s=this.options.useQueue?(0,n.createQueuedSender)(this.child):this.child,t=h=>this.child&&this.child.connected&&s.send(h.buffer.toString("base64")),r=c.event,o={send:t,onMessage:r};this._client=new y.ChannelClient(o);const u=()=>this.disposeClient();process.once("exit",u),this.child.on("error",h=>console.warn('IPC "'+this.options.serverName+'" errored with '+h)),this.child.on("exit",(h,f)=>{process.removeListener("exit",u),this.activeRequests.forEach(I=>(0,R.dispose)(I)),this.activeRequests.clear(),h!==0&&f!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+h+" and signal "+f),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:h,signal:f})})}return this._client}getCachedChannel(p){let a=this.channels.get(p);return a||(a=this.client.getChannel(p),this.channels.set(p,a)),a}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=m}),define(X[129],Q([14,12]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(X[130],Q([14,12]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[131],Q([14,12]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[132],Q([14,12]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(X[133],Q([14,12]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(X[134],Q([14,12]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[135],Q([14,12]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(X[136],Q([14,12]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(X[137],Q([14,12]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(X[138],Q([14,12]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(X[139],Q([14,12]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[140],Q([14,12]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[141],Q([14,12]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[142],Q([14,12]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(X[143],Q([14,12]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[144],Q([14,12]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(X[145],Q([14,12]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(X[146],Q([14,12]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[147],Q([14,12]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(X[148],Q([14,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[149],Q([14,12]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[150],Q([0,1,5,2]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new v.Emitter,this._onReloadEmitter=new v.Emitter,this._onTerminateEmitter=new v.Emitter,this._onAttachEmitter=new v.Emitter}call(n,y,i){switch(y){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:i[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:i[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:i[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:i[0],port:i[1],subId:i[2]}))}throw new Error("Method not implemented.")}listen(n,y,i){switch(y){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class S extends R.Disposable{constructor(n){super();this.channel=n}reload(n){this.channel.call("reload",[n])}get onReload(){return this.channel.listen("reload")}close(n){this.channel.call("close",[n])}get onClose(){return this.channel.listen("close")}attachSession(n,y,i){this.channel.call("attach",[n,y,i])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(n,y){this.channel.call("terminate",[n,y])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(n,y,i){return this.channel.call("openExtensionDevelopmentHostWindow",[n,y,i])}}e.ExtensionHostDebugChannelClient=S});var ce=this&&this.__decorate||function(j,e,v,R){var D=arguments.length,S=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,v):R,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(j,e,v,R);else for(var n=j.length-1;n>=0;n--)(k=j[n])&&(S=(D<3?k(S):D>3?k(e,v,S):k(e,v))||S);return D>3&&S&&Object.defineProperty(e,v,S),S};define(X[151],Q([0,1,8,15,52,123,9,7,35]),function(j,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class i{constructor(d,m,b){this._args=d,this.paths=m,this.productService=b}get appRoot(){return(0,v.dirname)(k.FileAccess.asFileUri("",j).fsPath)}get userHome(){return n.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return n.URI.file((0,v.join)(this.userDataPath,"User"))}get tmpDir(){return n.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,R.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,v.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return n.URI.file((0,v.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,R.joinPath)(n.URI.file((0,v.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return n.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return n.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,R.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=y.env.VSCODE_PORTABLE;return d?n.URI.file((0,v.join)(d,"argv.json")):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,R.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return n.URI.file((0,v.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,v.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,v.resolve)(d):(0,v.normalize)((0,v.join)(k.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,v.resolve)(d):(0,v.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,v.resolve)(d);const m=y.env.VSCODE_EXTENSIONS;if(m)return m;const b=y.env.VSCODE_PORTABLE;return b?(0,v.join)(b,"extensions"):(0,R.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?n.URI.parse(m):n.URI.file((0,v.normalize)(m)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?n.URI.parse(d):n.URI.file((0,v.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return L(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!y.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,R.joinPath)(n.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return n.URI.file((0,v.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}ce([D.memoize],i.prototype,"appRoot",null),ce([D.memoize],i.prototype,"userHome",null),ce([D.memoize],i.prototype,"userDataPath",null),ce([D.memoize],i.prototype,"appSettingsHome",null),ce([D.memoize],i.prototype,"tmpDir",null),ce([D.memoize],i.prototype,"userRoamingDataHome",null),ce([D.memoize],i.prototype,"settingsResource",null),ce([D.memoize],i.prototype,"userDataSyncHome",null),ce([D.memoize],i.prototype,"userDataSyncLogResource",null),ce([D.memoize],i.prototype,"sync",null),ce([D.memoize],i.prototype,"machineSettingsResource",null),ce([D.memoize],i.prototype,"globalStorageHome",null),ce([D.memoize],i.prototype,"workspaceStorageHome",null),ce([D.memoize],i.prototype,"keybindingsResource",null),ce([D.memoize],i.prototype,"keyboardLayoutResource",null),ce([D.memoize],i.prototype,"argvResource",null),ce([D.memoize],i.prototype,"snippetsHome",null),ce([D.memoize],i.prototype,"isExtensionDevelopment",null),ce([D.memoize],i.prototype,"untitledWorkspacesHome",null),ce([D.memoize],i.prototype,"installSourcePath",null),ce([D.memoize],i.prototype,"builtinExtensionsPath",null),ce([D.memoize],i.prototype,"extensionsPath",null),ce([D.memoize],i.prototype,"extensionDevelopmentLocationURI",null),ce([D.memoize],i.prototype,"extensionDevelopmentKind",null),ce([D.memoize],i.prototype,"extensionTestsLocationURI",null),ce([D.memoize],i.prototype,"debugExtensionHost",null),ce([D.memoize],i.prototype,"serviceMachineIdResource",null),ce([D.memoize],i.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=i;function L(w,d){return E(w["inspect-extensions"],w["inspect-brk-extensions"],5870,d,w.debugId)}e.parseExtensionHostPort=L;function g(w,d){return E(w["inspect-search"],w["inspect-brk-search"],5876,d)}e.parseSearchPort=g;function E(w,d,m,b,p){const c=Number(d||w)||(b?null:m),l=c?Boolean(!!d):!1;return{port:c,break:l,debugId:p}}}),define(X[87],Q([0,1,236,132,3]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const S={o:(0,R.localize)(0,null),e:(0,R.localize)(1,null),t:(0,R.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,R.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,R.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,R.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,R.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,R.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,R.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,R.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,R.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,R.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,R.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,R.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,R.localize)(14,null)},category:{type:"string",cat:"e",description:(0,R.localize)(15,null)},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,R.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,R.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,R.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,R.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,R.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,R.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,R.localize)(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,R.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,R.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,R.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,R.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,R.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,R.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,R.localize)(30,null)},telemetry:{type:"boolean",cat:"t",description:(0,R.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const k={onUnknownOption:()=>{},onMultipleValues:()=>{}};function n(d,m,b=k){const p={},a=[],c=[];for(let r in m){const o=m[r];o.alias&&(p[r]=o.alias),o.type==="string"||o.type==="string[]"?(a.push(r),o.deprecates&&a.push(o.deprecates)):o.type==="boolean"&&(c.push(r),o.deprecates&&c.push(o.deprecates))}const l=v(d,{string:a,boolean:c,alias:p}),s={},t=l;s._=l._.map(r=>String(r)).filter(r=>r.length>0),delete t._;for(let r in m){const o=m[r];o.alias&&delete t[o.alias];let u=t[r];o.deprecates&&t.hasOwnProperty(o.deprecates)&&(u||(u=t[o.deprecates]),delete t[o.deprecates]),typeof u!="undefined"&&(o.type==="string[]"?u&&!Array.isArray(u)&&(u=[u]):o.type==="string"&&Array.isArray(u)&&(u=u.pop(),b.onMultipleValues(r,u)),s[r]=u),delete t[r]}for(let r in t)b.onUnknownOption(r);return s}e.parseArgs=n;function y(d,m){let b="";return m.args&&(Array.isArray(m.args)?b=` <${m.args.join("> <")}>`:b=` <${m.args}>`),m.alias?`-${m.alias} --${d}${b}`:`--${d}${b}`}function i(d,m){let b=0,p=[];for(const s in d){const t=d[s],r=y(s,t);b=Math.max(b,r.length),p.push([r,t.description])}let a=b+2+1;if(m-a<25)return p.reduce((s,t)=>s.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let c=m-a-1,l=[];for(const s of p){let t=s[0],r=g(s[1],c),o=L(a-t.length-2);l.push("  "+t+o+r[0]);for(let u=1;u<r.length;u++)l.push(L(a)+r[u])}return l}e.formatOptions=i;function L(d){return" ".repeat(d)}function g(d,m){let b=[];for(;d.length;){let p=d.length<m?d.length:d.lastIndexOf(" ",m),a=d.slice(0,p).trim();d=d.slice(p),b.push(a)}return b}function E(d,m,b,p,a=!0){const c=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${d} ${b}`];l.push(""),l.push(`${(0,R.localize)(32,null)}: ${m} [${(0,R.localize)(33,null)}][${(0,R.localize)(34,null)}...]`),l.push(""),a&&(D.isWindows?l.push((0,R.localize)(35,null,m)):l.push((0,R.localize)(36,null,m)),l.push(""));const s={};for(const t in p){const r=p[t];if(r.description&&r.cat){let o=s[r.cat];o||(s[r.cat]=o={}),o[t]=r}}for(let t in s){const r=t;let o=s[r];o&&(l.push(S[r]),l.push(...i(o,c)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=E;function w(d,m){return`${d||(0,R.localize)(37,null)}
${m||(0,R.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=w}),define(X[152],Q([0,1,87,60,150]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class S extends D.ExtensionHostDebugBroadcastChannel{constructor(n){super();this.windowsMainService=n}call(n,y,i){return y==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(i[0],i[1],i[2]):super.call(n,y,i)}async openExtensionDevelopmentHostWindow(n,y,i){const L=(0,v.parseArgs)(n,v.OPTIONS);L.debugRenderer=i;const g=L.extensionDevelopmentPath;if(!g)return{};const[E]=this.windowsMainService.openExtensionDevelopmentHostWindow(g,{context:5,cli:L,userEnv:Object.keys(y).length>0?y:void 0});if(!i)return{};const w=E.win;if(!w)return{};const d=w.webContents.debugger;let m=d.isAttached()?Infinity:0;const b=(0,R.createServer)(p=>{m++==0&&d.attach();let a=!1;const c=t=>{a||p.write(JSON.stringify(t)+"\0")},l=(t,r,o,u)=>c({method:r,params:o,sessionId:u});w.on("close",()=>{d.removeListener("message",l),p.end(),a=!0}),d.addListener("message",l);let s=Buffer.alloc(0);p.on("data",t=>{s=Buffer.concat([s,t]);for(let r=s.indexOf(0);r!==-1;r=s.indexOf(0)){let o;try{const u=s.slice(0,r).toString("utf8");s=s.slice(r+1),o=JSON.parse(u)}catch(u){console.error("error reading cdp line",u)}d.sendCommand(o.method,o.params,o.sessionId).then(u=>c({id:o.id,sessionId:o.sessionId,result:u})).catch(u=>c({id:o.id,sessionId:o.sessionId,error:{code:0,message:u.message}}))}}),p.on("error",t=>{console.error("error on cdp pipe:",t)}),p.on("close",()=>{a=!0,--m==0&&d.detach()})});return await new Promise(p=>b.listen(0,p)),w.on("close",()=>b.close()),{rendererDebugPort:b.address().port}}}e.ElectronExtensionHostDebugBroadcastChannel=S}),function(){"use strict";function j(e,v,R){function D(k){return e.resolve(S(k))}function S(k){const n=process.env.VSCODE_PORTABLE;if(n)return e.join(n,"user-data");const y=k["user-data-dir"];if(y)return y;let i=process.env.VSCODE_APPDATA;if(!i)switch(process.platform){case"win32":if(i=process.env.APPDATA,!i){const L=process.env.USERPROFILE;if(typeof L!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");i=e.join(L,"AppData","Roaming")}break;case"darwin":i=e.join(v.homedir(),"Library","Application Support");break;case"linux":i=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(i,R)}return{getUserDataPath:D}}if(typeof define=="function")define(X[153],Q([0,237,27,9,15]),function(e,v,R,D,S){const k=S.dirname(D.FileAccess.asFileUri("",e)),n=e.__$__nodeRequire(S.joinPath(k,"package.json").fsPath);return j(v,R,n.name)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),R=require("os");module.exports=j(v,R,e.name)}else throw new Error("Unknown context")}(),define(X[154],Q([0,1,27,153,151]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class S extends D.AbstractNativeEnvironmentService{constructor(n,y){super(n,{homeDir:(0,v.homedir)(),tmpDir:(0,v.tmpdir)(),userDataDir:(0,R.getUserDataPath)(n)},y)}}e.NativeEnvironmentService=S}),define(X[155],Q([0,1,22,27,8]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function S(k){const n=(0,D.join)((0,R.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return v.writeFileSync(n,""),k&&console.log(`Marker file for --wait created: ${n}`),n}catch(y){k&&console.error(`Failed to create marker file for --wait: ${y}`);return}}e.createWaitMarkerFile=S}),define(X[156],Q([0,1,135]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVersionValid=e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/;function D(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=D;function S(g){if(!D(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let E=g.match(R);return E?{hasCaret:E[1]==="^",hasGreaterEquals:E[1]===">=",majorBase:E[2]==="x"?0:parseInt(E[2],10),majorMustEqual:E[2]!=="x",minorBase:E[4]==="x"?0:parseInt(E[4],10),minorMustEqual:E[4]!=="x",patchBase:E[6]==="x"?0:parseInt(E[6],10),patchMustEqual:E[6]!=="x",preRelease:E[8]||null}:null}e.parseVersion=S;function k(g){if(!g)return null;let E=g.majorBase,w=g.majorMustEqual,d=g.minorBase,m=g.minorMustEqual,b=g.patchBase,p=g.patchMustEqual;return g.hasCaret&&(E===0||(m=!1),p=!1),{majorBase:E,majorMustEqual:w,minorBase:d,minorMustEqual:m,patchBase:b,patchMustEqual:p,isMinimum:g.hasGreaterEquals}}e.normalizeVersion=k;function n(g,E){let w;typeof g=="string"?w=k(S(g)):w=g;let d;if(typeof E=="string"?d=k(S(E)):d=E,!w||!d)return!1;let m=w.majorBase,b=w.minorBase,p=w.patchBase,a=d.majorBase,c=d.minorBase,l=d.patchBase,s=d.majorMustEqual,t=d.minorMustEqual,r=d.patchMustEqual;return d.isMinimum?m>a?!0:m<a?!1:b>c?!0:b<c?!1:p>=l:(m===1&&a===0&&(!s||!t||!r)&&(a=1,c=0,l=0,s=!0,t=!1,r=!1),m<a?!1:m>a?!s:b<c?!1:b>c?!t:p<l?!1:p>l?!r:!0)}e.isValidVersion=n;function y(g,E,w){return E.isBuiltin||typeof E.main=="undefined"?!0:L(g,E.engines.vscode,w)}e.isValidExtensionVersion=y;function i(g,E){return g==="*"||L(E,g)}e.isEngineValid=i;function L(g,E,w=[]){let d=k(S(E));if(!d)return w.push(v.localize(0,null,E)),!1;if(d.majorBase===0){if(!d.majorMustEqual||!d.minorMustEqual)return w.push(v.localize(1,null,E)),!1}else if(!d.majorMustEqual)return w.push(v.localize(2,null,E)),!1;return n(g,d)?!0:(w.push(v.localize(3,null,g,E)),!1)}e.isVersionValid=L}),define(X[157],Q([0,1,33,86,2,9]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(y,i,L,g){super();this.folders=y,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(y.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.setFolders(this.folders)}setVerboseLogging(y){this.verboseLogging=y,!this.isDisposed&&this.service&&this.service.setVerboseLogging(y)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${y}`})}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(X[158],Q([0,1,33,86,2,9]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class k extends D.Disposable{constructor(y,i,L,g,E={}){super();this.folders=y,this.onDidFilesChange=i,this.onLogMessage=L,this.verboseLogging=g,this.watcherOptions=E,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const y=this._register(new R.Client(S.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(y.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=k.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService((0,v.getNextTickChannel)(y.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(i=>!this.isDisposed&&this.onDidFilesChange(i))),this._register(this.service.onDidLogMessage(i=>this.onLogMessage(i))),this.service.setRoots(this.folders)}error(y){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${y}`})}setVerboseLogging(y){this.verboseLogging=y,this.service&&this.service.setVerboseLogging(y)}setFolders(y){this.folders=y,this.service&&this.service.setRoots(y)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=k,k.MAX_RESTARTS=5}),define(X[159],Q([0,1,46,80,79,9]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class k{constructor(y,i,L,g,E){this.watchedFolder=y,this.eventCallback=L,this.logCallback=g,this.verboseLogging=E,this.restartCounter=0,Array.isArray(i)?this.ignored=i.map(w=>D.parse(w)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${y}`),this.startWatcher()}startWatcher(){const y=[this.watchedFolder];this.verboseLogging&&y.push("-verbose"),this.handle=v.spawn(S.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",j).fsPath,y);const i=new R.LineDecoder;this.handle.stdout.on("data",L=>{const g=[];i.write(L).forEach(E=>{const w=E.split("|");if(w.length===2){const d=Number(w[0]),m=w[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(b=>b(m))){this.verboseLogging&&this.log(m);return}g.push({type:k.changeTypeMap[d],path:m})}else this.log(w[1])}}),g.length>0&&this.eventCallback(g)}),this.handle.on("error",L=>this.onError(L)),this.handle.stderr.on("data",L=>this.onError(L)),this.handle.on("exit",(L,g)=>this.onExit(L,g))}onError(y){this.error("process error: "+y.toString())}onExit(y,i){this.handle&&(this.error(`terminated unexpectedly (code: ${y}, signal: ${i})`),this.restartCounter<=k.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(y){this.logCallback({type:"error",message:`[File Watcher (C#)] ${y}`})}log(y){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${y}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=k,k.MAX_RESTARTS=5,k.changeTypeMap=[0,1,2]}),define(X[160],Q([0,1,159,8,20]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class S{constructor(n,y,i,L){this.onDidFilesChange=y,this.onLogMessage=i,this.verboseLogging=L,this.service=void 0,this.folder=n[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(R.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,R.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,n=>this.onFileEvents(n),n=>this.onLogMessage(n),this.verboseLogging)}setVerboseLogging(n){this.verboseLogging=n,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(n){this.isDisposed||n.length>0&&this.onDidFilesChange(n)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=S}),define(X[67],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class v{constructor(S,k=[],n=!1){this.ctor=S,this.staticArguments=k,this.supportsDelayedInstantiation=n}}e.SyncDescriptor=v;const R=(D,...S)=>new v(D,S);e.createSyncDescriptor=R}),define(X[161],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=v;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let k of this._nodes.values())k.outgoing.size===0&&S.push(k);return S}insertEdge(S,k){const n=this.lookupOrInsertNode(S),y=this.lookupOrInsertNode(k);n.outgoing.set(this._hashFn(k),y),y.incoming.set(this._hashFn(S),n)}removeNode(S){const k=this._hashFn(S);this._nodes.delete(k);for(let n of this._nodes.values())n.outgoing.delete(k),n.incoming.delete(k)}lookupOrInsertNode(S){const k=this._hashFn(S);let n=this._nodes.get(k);return n||(n=new v(S),this._nodes.set(k,n)),n}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[k,n]of this._nodes)S.push(`${k}, (incoming)[${[...n.incoming.keys()].join(", ")}], (outgoing)[${[...n.outgoing.keys()].join(",")}]`);return S.join(`
`)}}e.Graph=R}),define(X[4],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(n){n.serviceIds=new Map,n.DI_TARGET="$di$target",n.DI_DEPENDENCIES="$di$dependencies";function y(i){return i[n.DI_DEPENDENCIES]||[]}n.getServiceDependencies=y})(v=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(n,y,i,L){y[v.DI_TARGET]===y?y[v.DI_DEPENDENCIES].push({id:n,index:i,optional:L}):(y[v.DI_DEPENDENCIES]=[{id:n,index:i,optional:L}],y[v.DI_TARGET]=y)}function D(n){if(v.serviceIds.has(n))return v.serviceIds.get(n);const y=function(i,L,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(y,i,g,!1)};return y.toString=()=>n,v.serviceIds.set(n,y),y}e.createDecorator=D;function S(n){return n}e.refineServiceDecorator=S;function k(n){return function(y,i,L){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(n,y,L,!0)}}e.optional=k}),define(X[68],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,v.createDecorator)(e.ID);function R(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=R}),define(X[88],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,v.createDecorator)("encryptionMainService");class R{constructor(S){this.machineId=S}encryption(){return new Promise((S,k)=>j(["vscode-encrypt"],S,k))}async encrypt(S){try{return(await this.encryption()).encrypt(this.machineId,S)}catch(k){return S}}async decrypt(S){try{return(await this.encryption()).decrypt(this.machineId,S)}catch(k){return S}}}e.EncryptionMainService=R}),define(X[47],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,v.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,v.refineServiceDecorator)(e.IEnvironmentService)}),define(X[162],Q([0,1,134,4,9]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}e.isIExtensionIdentifier=S;var k;(function(g){g[g.NoneOrRelevance=0]="NoneOrRelevance",g[g.LastUpdatedDate=1]="LastUpdatedDate",g[g.Title=2]="Title",g[g.PublisherName=3]="PublisherName",g[g.InstallCount=4]="InstallCount",g[g.PublishedDate=5]="PublishedDate",g[g.AverageRating=6]="AverageRating",g[g.WeightedRating=12]="WeightedRating"})(k=e.SortBy||(e.SortBy={}));var n;(function(g){g[g.Default=0]="Default",g[g.Ascending=1]="Ascending",g[g.Descending=2]="Descending"})(n=e.SortOrder||(e.SortOrder={}));var y;(function(g){g.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var i;(function(g){g[g.None=0]="None",g[g.Install=1]="Install",g[g.Update=2]="Update"})(i=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class L extends Error{constructor(E,w){super(E);this.code=w}}e.ExtensionManagementError=L,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=D.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,v.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,v.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,R.createDecorator)("IExtensionManagementCLIService")}),define(X[163],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,v.createDecorator)("extensionUrlTrustService")}),define(X[164],Q([0,1,20,4]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.getExtensionWorkspaceTrustRequirement=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(L){return L&&typeof L=="object"&&typeof L.id=="string"&&(!L.uuid||typeof L.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(L){L[L.System=0]="System",L[L.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));class k{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,E){if(typeof g=="undefined"||g===null)return typeof E=="undefined"||E===null;if(typeof E=="undefined"||E===null)return!1;if(typeof g=="string"||typeof E=="string"){let w=typeof g=="string"?g:g.value,d=typeof E=="string"?E:E.value;return v.equalsIgnoreCase(w,d)}return g._lower===E._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=k;function n(L){return L.contributes&&L.contributes.localizations?L.contributes.localizations.length>0:!1}e.isLanguagePackExtension=n;function y(L){return L.contributes&&L.contributes.authentication?L.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y;function i(L){var g;return((g=L.workspaceTrust)===null||g===void 0?void 0:g.required)!==void 0?L.workspaceTrust.required:L.main?"onStart":!1}e.getExtensionWorkspaceTrustRequirement=i,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(X[165],Q([0,1,20,164]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(w,d){return w.uuid&&d.uuid?w.uuid===d.uuid:w.id===d.id?!0:(0,v.compareIgnoreCase)(w.id,d.id)===0}e.areSameExtensions=D;class S{constructor(d,m){this.version=m,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof S?D(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=S;function k(w,d){return`${w}.${d}`}e.getExtensionId=k;function n(w){return w.toLocaleLowerCase()}e.adoptToGalleryExtensionId=n;function y(w,d){return n(k(w,d))}e.getGalleryExtensionId=y;function i(w,d){const m=[],b=p=>{for(const a of m)if(a.some(c=>D(d(c),d(p))))return a;return null};for(const p of w){const a=b(p);a?a.push(p):m.push([p])}return m}e.groupByExtension=i;function L(w){return{id:w.identifier.id,name:w.manifest.name,galleryId:null,publisherId:w.publisherId,publisherName:w.manifest.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:w.manifest.extensionDependencies&&w.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=L;function g(w){return Object.assign({id:w.identifier.id,name:w.name,galleryId:w.identifier.uuid,publisherId:w.publisherId,publisherName:w.publisher,publisherDisplayName:w.publisherDisplayName,dependencies:!!(w.properties.dependencies&&w.properties.dependencies.length>0)},w.telemetryData)}e.getGalleryExtensionTelemetryData=g,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function E(w){const d=new Set;for(const m of w)m.malicious&&d.add(m.id.id);return d}e.getMaliciousExtensionsSet=E}),define(X[16],Q([0,1,137,8,7,4,20,13,36]),function(j,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,S.createDecorator)("fileService");function i(V){return V.create===!0}e.isFileOpenForWriteOptions=i;var L;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(L=e.FileType||(e.FileType={}));var g;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function E(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=E;function w(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=w;function d(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function m(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=m;var b;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(N,z){super(N);this.code=z}}e.FileSystemProviderError=p;function a(V,N){const z=new p(V.toString(),N);return l(z,N),z}e.createFileSystemProviderError=a;function c(V){return V||a((0,v.localize)(0,null),b.Unknown)}e.ensureFileSystemProviderError=c;function l(V,N){return V.name=N?`${N} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=l;function s(V){if(!V)return b.Unknown;if(V instanceof p)return V.code;const N=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!N)return b.Unknown;switch(N[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=s;function t(V){if(V instanceof I)return V.fileOperationResult;switch(s(V)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=t;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor(N,z,W){this.resource=N,this.operation=z,this.target=W}isOperation(N){return this.operation===N}}e.FileOperationEvent=o;var u;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class h{constructor(N,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=N;for(const W of N)switch(W.type){case 1:this.added||(this.added=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=y.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(W.resource,W);break}}contains(N,...z){return this.doContains(N,{includeChildren:!1},...z)}affects(N,...z){return this.doContains(N,{includeChildren:!0},...z)}doContains(N,z,...W){var $,C,P,M,_,T;if(!N)return!1;const O=W.length>0;return!!((!O||W.includes(1))&&((($=this.added)===null||$===void 0?void 0:$.get(N))||z.includeChildren&&((C=this.added)===null||C===void 0?void 0:C.findSuperstr(N)))||(!O||W.includes(0))&&(((P=this.updated)===null||P===void 0?void 0:P.get(N))||z.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr(N)))||(!O||W.includes(2))&&(((_=this.deleted)===null||_===void 0?void 0:_.findSubstr(N))||z.includeChildren&&((T=this.deleted)===null||T===void 0?void 0:T.findSuperstr(N))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(N){const z=[],W=N===1?this.added:N===0?this.updated:this.deleted;if(W)for(const[,$]of W)z.push($);return z}filter(N){return new h(this.changes.filter(z=>N(z)),this.ignorePathCasing)}}e.FileChangesEvent=h;function f(V,N,z){return!V||!N||V===N||N.length>V.length?!1:(N.charAt(N.length-1)!==R.sep&&(N+=R.sep),z?(0,k.startsWithIgnoreCase)(V,N):V.indexOf(N)===0)}e.isParent=f;class I extends Error{constructor(N,z,W){super(N);this.fileOperationResult=z,this.options=W}static isFileOperationError(N){return N instanceof Error&&!(0,n.isUndefinedOrNull)(N.fileOperationResult)}}e.FileOperationError=I;var A;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=U;async function q(V,N){if(!N.canHandleResource(D.URI.from({scheme:V.scheme})))return new Promise(z=>{const W=N.onDidChangeFileSystemProviderRegistrations($=>{$.scheme===V.scheme&&$.added&&(W.dispose(),z())})})}e.whenProviderRegistered=q,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Y{static formatSize(N){return(0,n.isNumber)(N)||(N=0),N<Y.KB?(0,v.localize)(1,null,N.toFixed(0)):N<Y.MB?(0,v.localize)(2,null,(N/Y.KB).toFixed(2)):N<Y.GB?(0,v.localize)(3,null,(N/Y.MB).toFixed(2)):N<Y.TB?(0,v.localize)(4,null,(N/Y.GB).toFixed(2)):(0,v.localize)(5,null,(N/Y.TB).toFixed(2))}}e.ByteSize=Y,Y.KB=1024,Y.MB=Y.KB*Y.KB,Y.GB=Y.MB*Y.KB,Y.TB=Y.GB*Y.KB;var ie;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function ae(V){return{maxFileSize:V===0?300*Y.MB:16*Y.GB,maxHeapSize:V===0?700*Y.MB:2*700*Y.MB}}e.getPlatformLimits=ae}),define(X[53],Q([0,1,238,133,16,87]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function k(E,w){const d={onUnknownOption:b=>{console.warn((0,R.localize)(0,null,b))},onMultipleValues:(b,p)=>{console.warn((0,R.localize)(1,null,b,p))}},m=(0,S.parseArgs)(E,S.OPTIONS,w?d:void 0);return m.goto&&m._.forEach(b=>v(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,R.localize)(2,null))),m["max-memory"]&&v(parseInt(m["max-memory"])>=D.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${D.MIN_MAX_MEMORY_SIZE_MB} MB.`),m}function n(E){const w=E.findIndex(d=>!/^-/.test(d));if(w>-1)return[...E.slice(0,w),...E.slice(w+1)]}function y(E){let[,...w]=E;process.env.VSCODE_DEV&&(w=n(w)||[]);const d=!g(process.env);return k(w,d)}e.parseMainProcessArgv=y;function i(E){const[,,...w]=E;return k(w,!0)}e.parseCLIProcessArgv=i;function L(E,...w){const d=E.indexOf("--");return d===-1?E.push(...w):E.splice(d,0,...w),E}e.addArg=L;function g(E){return E.VSCODE_CLI==="1"}e.isLaunchedFromCli=g}),define(X[69],Q([0,1,46,28,3,53,66,128]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(g,E,w){return E["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,S.isLaunchedFromCli)(w)&&!E["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,S.isLaunchedFromCli)(w)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),i||(i=L(g)),i)}e.resolveShellEnv=y;let i;async function L(g){const E=new Promise(async(w,d)=>{const m=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",m);const b=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",b);const p=(0,R.generateUuid)().replace(/-/g,"").substr(0,12),a=new RegExp(p+"(.*)"+p),c=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"}),l=`'${process.execPath}' -p '"${p}" + JSON.stringify(process.env) + "${p}"'`;g.trace("getUnixShellEnvironment#env",c),g.trace("getUnixShellEnvironment#spawn",l);const s=await(0,n.getSystemShell)(D.platform,c);g.trace("getUnixShellEnvironment#shell",s);const t=(0,v.spawn)(s,["-ilc",l],{detached:!0,stdio:["ignore","pipe",process.stderr],env:c}),r=[];t.on("error",()=>w({})),t.stdout.on("data",o=>r.push(o)),t.on("close",o=>{if(o!==0)return d(new Error("Failed to get environment"));const u=Buffer.concat(r).toString("utf8");g.trace("getUnixShellEnvironment#raw",u);const h=a.exec(u),f=h?h[1]:"{}";try{const I=JSON.parse(f);m?I.ELECTRON_RUN_AS_NODE=m:delete I.ELECTRON_RUN_AS_NODE,b?I.ELECTRON_NO_ATTACH_CONSOLE=b:delete I.ELECTRON_NO_ATTACH_CONSOLE,delete I.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",I),w(I)}catch(I){g.error("getUnixShellEnvironment#error",I),d(I)}})});try{return await E}catch(w){return g.error("getUnixShellEnvironment#error",(0,k.toErrorMessage)(w)),{}}}}),define(X[89],Q([0,1,138,21,16,19]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function k(L,g,E,w,d,m){let b;try{await n(L,g,E,w,d,m)}catch(p){b=p}finally{b&&d.errorTransformer&&(b=d.errorTransformer(b)),typeof b!="undefined"&&E.error(b),E.end()}}e.readFileIntoStream=k;async function n(L,g,E,w,d,m){y(m);const b=await L.open(g,{create:!1});try{y(m);let p=0,a=0,c=d&&typeof d.length=="number"?d.length:void 0,l=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),s=d&&typeof d.position=="number"?d.position:0,t=0;do a=await L.read(b,s,l.buffer,t,l.byteLength-t),s+=a,t+=a,p+=a,typeof c=="number"&&(c-=a),t===l.byteLength&&(await E.write(w(l)),l=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof c=="number"?c:d.bufferSize)),t=0);while(a>0&&(typeof c!="number"||c>0)&&y(m)&&i(p,d));if(t>0){let r=t;typeof c=="number"&&(r=Math.min(t,c)),E.write(w(l.slice(0,r)))}}catch(p){throw(0,D.ensureFileSystemProviderError)(p)}finally{await L.close(b)}}function y(L){if(L.isCancellationRequested)throw(0,S.canceled)();return!0}function i(L,g){if(g==null?void 0:g.limits){if(typeof g.limits.memory=="number"&&L>g.limits.memory)throw(0,D.createFileSystemProviderError)((0,v.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof g.limits.size=="number"&&L>g.limits.size)throw(0,D.createFileSystemProviderError)((0,v.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[90],Q([0,1,7,16,3]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function S(y){return y.map(i=>({type:i.type,resource:v.URI.file(i.path)}))}e.toFileChanges=S;function k(y){const i=new n;for(const L of y)i.processEvent(L);return i.normalize()}e.normalizeFileChanges=k;class n{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(i){const L=this.mapPathToChange.get(i.path);if(L){const g=L.type,E=i.type;g===1&&E===2?(this.mapPathToChange.delete(i.path),this.normalized.splice(this.normalized.indexOf(L),1)):g===2&&E===1?L.type=0:g===1&&E===0||(L.type=E)}else this.normalized.push(i),this.mapPathToChange.set(i.path,i)}normalize(){const i=[],L=[];return this.normalized.filter(g=>g.type!==2?(i.push(g),!1):!0).sort((g,E)=>g.path.length-E.path.length).filter(g=>L.some(E=>(0,R.isParent)(g.path,E,!D.isLinux))?!1:(L.push(g.path),!0)).concat(i)}}}),define(X[166],Q([0,1,90,2,23,111,115,10,8]),function(j,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class i extends R.Disposable{constructor(g,E,w,d){super();this.path=g,this.onDidFilesChange=E,this.onLogMessage=w,this.verboseLogging=d,this.fileChangesDelayer=this._register(new n.ThrottledDelayer(k.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(g){this.verboseLogging=g}async startWatching(){try{const{stat:g,symbolicLink:E}=await D.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let w=this.path;if(E)try{w=await(0,S.realpath)(w)}catch(d){if(this.onError(d),E.dangling)return}g.isDirectory()?this._register((0,k.watchFolder)(w,(d,m)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,y.join)(this.path,(0,y.basename)(m))})},d=>this.onError(d))):this._register((0,k.watchFile)(w,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(g){g.code!=="ENOENT"&&this.onError(g)}}onFileChange(g){this.fileChangesBuffer.push(g),this.verboseLogging&&this.onVerbose(`${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.path}`),this.fileChangesDelayer.trigger(async()=>{const E=this.fileChangesBuffer;this.fileChangesBuffer=[];const w=(0,v.normalizeFileChanges)(E);this.verboseLogging&&w.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),w.length>0&&this.onDidFilesChange(w)})}onError(g){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${g}`})}onVerbose(g){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${g}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=i}),define(X[70],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...D){this._entries=new Map;for(let[S,k]of D)this.set(S,k)}set(D,S){const k=this._entries.get(D);return this._entries.set(D,S),k}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=v}),define(X[167],Q([0,1,19,161,67,4,70,10]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class i extends Error{constructor(d){super("cyclic dependency between services");this.message=d.toString()}}class L{constructor(d=new k.ServiceCollection,m=!1,b){this._activeInstantiations=new Set,this._services=d,this._strict=m,this._parent=b,this._services.set(S.IInstantiationService,this)}createChild(d){return new L(d,this._strict,this)}invokeFunction(d,...m){let b=E.traceInvocation(d),p=!1;try{return d({get:(c,l)=>{if(p)throw(0,v.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(c,b);if(!s&&l!==S.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return s}},...m)}finally{p=!0,b.stop()}}createInstance(d,...m){let b,p;return d instanceof D.SyncDescriptor?(b=E.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(m),b)):(b=E.traceCreation(d),p=this._createInstance(d,m,b)),b.stop(),p}_createInstance(d,m=[],b){let p=S._util.getServiceDependencies(d).sort((l,s)=>l.index-s.index),a=[];for(const l of p){let s=this._getOrCreateServiceInstance(l.id,b);if(!s&&this._strict&&!l.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${l.id}.`);a.push(s)}let c=p.length>0?p[0].index:m.length;if(m.length!==c){console.warn(`[createInstance] First service dependency of ${d.name} at position ${c+1} conflicts with ${m.length} static arguments`);let l=c-m.length;l>0?m=m.concat(new Array(l)):m=m.slice(0,c)}return new d(...[...m,...a])}_setServiceInstance(d,m){if(this._services.get(d)instanceof D.SyncDescriptor)this._services.set(d,m);else if(this._parent)this._parent._setServiceInstance(d,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let m=this._services.get(d);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):m}_getOrCreateServiceInstance(d,m){let b=this._getServiceInstanceOrDescriptor(d);return b instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,b,m.branch(d,!0)):(m.branch(d,!1),b)}_safeCreateAndCacheServiceInstance(d,m,b){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,m,b)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,m,b){const p=new R.Graph(l=>l.id.toString());let a=0;const c=[{id:d,desc:m,_trace:b}];for(;c.length;){const l=c.pop();if(p.lookupOrInsertNode(l),a++>1e3)throw new i(p);for(let s of S._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const r={id:s.id,desc:t,_trace:l._trace.branch(s.id,!0)};p.insertEdge(l,r),c.push(r)}}}for(;;){const l=p.roots();if(l.length===0){if(!p.isEmpty())throw new i(p);break}for(const{data:s}of l){if(this._getServiceInstanceOrDescriptor(s.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,r)}p.removeNode(s)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,m,b=[],p,a){if(this._services.get(d)instanceof D.SyncDescriptor)return this._createServiceInstance(m,b,p,a);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,m,b,p,a);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(d,m=[],b,p){if(b){const a=new n.IdleValue(()=>this._createInstance(d,m,p));return new Proxy(Object.create(null),{get(c,l){if(l in c)return c[l];let s=a.value,t=s[l];return typeof t!="function"||(t=t.bind(s),c[l]=t),t},set(c,l,s){return a.value[l]=s,!0}})}else return this._createInstance(d,m,p)}}e.InstantiationService=L;var g;(function(w){w[w.Creation=0]="Creation",w[w.Invocation=1]="Invocation",w[w.Branch=2]="Branch"})(g||(g={}));class E{constructor(d,m){this.type=d,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return y?new E(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):E._None}static traceCreation(d){return y?new E(0,d.name):E._None}branch(d,m){let b=new E(2,d.toString());return this._dep.push([d,m,b]),b}stop(){let d=Date.now()-this._start;E._totals+=d;let m=!1;function b(a,c){let l=[],s=new Array(a+1).join("	");for(const[t,r,o]of c._dep)if(r&&o){m=!0,l.push(`${s}CREATES -> ${t}`);let u=b(a+1,o);u&&l.push(u)}else l.push(`${s}uses -> ${t}`);return l.join(`
`)}let p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${b(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${E._totals.toFixed(2)}ms)`];(d>2||m)&&console.log(p.join(`
`))}}E._None=new class extends E{constructor(){super(-1,null)}stop(){}branch(){return this}},E._totals=0}),define(X[168],Q([0,1,19,126,57]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class S extends D.ResolvedKeybinding{constructor(n,y){super();if(y.length===0)throw(0,v.illegalArgument)("parts");this._os=n,this._parts=y}getLabel(){return R.UILabelProvider.toLabel(this._os,this._parts,n=>this._getLabel(n))}getAriaLabel(){return R.AriaLabelProvider.toLabel(this._os,this._parts,n=>this._getAriaLabel(n))}getElectronAccelerator(){return this._parts.length>1?null:R.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,n=>this._getElectronAccelerator(n))}getUserSettingsLabel(){return R.UserSettingsLabelProvider.toLabel(this._os,this._parts,n=>this._getUserSettingsLabel(n))}isWYSIWYG(){return this._parts.every(n=>this._isWYSIWYG(n))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(n=>this._getPart(n))}_getPart(n){return new D.ResolvedKeybindingPart(n.ctrlKey,n.shiftKey,n.altKey,n.metaKey,this._getLabel(n),this._getAriaLabel(n))}getDispatchParts(){return this._parts.map(n=>this._getDispatchPart(n))}getSingleModifierDispatchParts(){return this._parts.map(n=>this._getSingleModifierDispatchPart(n))}}e.BaseResolvedKeybinding=S}),define(X[169],Q([0,1,57,168]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class D extends R.BaseResolvedKeybinding{constructor(k,n){super(n,k.parts)}_keyCodeToUILabel(k){if(this._os===2)switch(k){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return v.KeyCodeUtils.toString(k)}_getLabel(k){return k.isDuplicateModifierCase()?"":this._keyCodeToUILabel(k.keyCode)}_getAriaLabel(k){return k.isDuplicateModifierCase()?"":v.KeyCodeUtils.toString(k.keyCode)}_keyCodeToElectronAccelerator(k){if(k>=93&&k<=108)return null;switch(k){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return v.KeyCodeUtils.toString(k)}_getElectronAccelerator(k){return k.isDuplicateModifierCase()?null:this._keyCodeToElectronAccelerator(k.keyCode)}_getUserSettingsLabel(k){if(k.isDuplicateModifierCase())return"";const n=v.KeyCodeUtils.toUserSettingsUS(k.keyCode);return n&&n.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(k){return D.getDispatchStr(k)}static getDispatchStr(k){if(k.isModifierKey())return null;let n="";return k.ctrlKey&&(n+="ctrl+"),k.shiftKey&&(n+="shift+"),k.altKey&&(n+="alt+"),k.metaKey&&(n+="meta+"),n+=v.KeyCodeUtils.toString(k.keyCode),n}_getSingleModifierDispatchPart(k){return k.keyCode===5&&!k.shiftKey&&!k.altKey&&!k.metaKey?"ctrl":k.keyCode===4&&!k.ctrlKey&&!k.altKey&&!k.metaKey?"shift":k.keyCode===6&&!k.ctrlKey&&!k.shiftKey&&!k.metaKey?"alt":k.keyCode===57&&!k.ctrlKey&&!k.shiftKey&&!k.altKey?"meta":null}}e.USLayoutResolvedKeybinding=D}),define(X[170],Q([0,1,10]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function R(D,S){if(D.length===0)return Promise.resolve(!1);const k=[];let n=!1;for(let y of D){if(y===!0)return Promise.resolve(!0);(0,v.isThenable)(y)&&k.push(y.then(i=>{i&&(n=!0)},i=>{S(i),n=!0}))}return v.Promises.settled(k).then(()=>n)}e.handleVetos=R}),define(X[6],Q([0,1,4,2,3,5,66]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function n(){return new Date().toISOString()}var y;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class i extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(s){this.level!==s&&(this.level=s,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=i;class L extends i{constructor(s){super();this.logAlways=s}checkLogLevel(s){return this.logAlways||this.getLevel()<=s}trace(s,...t){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([s,...t]))}debug(s,...t){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([s,...t]))}info(s,...t){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([s,...t]))}warn(s,...t){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([s,...t]))}error(s,...t){if(this.checkLogLevel(y.Error))if(s instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=s.stack,this.log(y.Error,this.format(r))}else this.log(y.Error,this.format([s,...t]))}critical(s,...t){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([s,...t]))}flush(){}format(s){let t="";for(let r=0;r<s.length;r++){let o=s[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}t+=(r>0?" ":"")+o}return t}}e.AbstractMessageLogger=L;class g extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s),this.useColors=!D.isWindows}trace(s,...t){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}debug(s,...t){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}info(s,...t){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${n()}][0m`,s,...t):console.log(`[main ${n()}]`,s,...t))}warn(s,...t){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${n()}][0m`,s,...t):console.warn(`[main ${n()}]`,s,...t))}error(s,...t){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}critical(s,...t){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${n()}][0m`,s,...t):console.error(`[main ${n()}]`,s,...t))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class E extends i{constructor(s=e.DEFAULT_LOG_LEVEL){super();this.setLevel(s)}trace(s,...t){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",s,...t)}debug(s,...t){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",s,...t)}info(s,...t){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",s,...t)}warn(s,...t){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",s,...t)}error(s,...t){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",s,...t)}critical(s,...t){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",s,...t)}dispose(){}flush(){}}e.ConsoleLogger=E;class w extends i{constructor(s,t=e.DEFAULT_LOG_LEVEL){super();this.adapter=s,this.setLevel(t)}trace(s,...t){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(s),...t])}debug(s,...t){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(s),...t])}info(s,...t){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(s),...t])}warn(s,...t){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(s),...t])}error(s,...t){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(s),...t])}critical(s,...t){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(s),...t])}extractMessage(s){return typeof s=="string"?s:(0,k.toErrorMessage)(s,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=w;class d extends i{constructor(s){super();this.logServices=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const t of this.logServices)t.setLevel(s);super.setLevel(s)}trace(s,...t){for(const r of this.logServices)r.trace(s,...t)}debug(s,...t){for(const r of this.logServices)r.debug(s,...t)}info(s,...t){for(const r of this.logServices)r.info(s,...t)}warn(s,...t){for(const r of this.logServices)r.warn(s,...t)}error(s,...t){for(const r of this.logServices)r.error(s,...t)}critical(s,...t){for(const r of this.logServices)r.critical(s,...t)}flush(){for(const s of this.logServices)s.flush()}dispose(){for(const s of this.logServices)s.dispose()}}e.MultiplexLogService=d;class m extends R.Disposable{constructor(s){super();this.logger=s,this._register(s)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(s){this.logger.setLevel(s)}getLevel(){return this.logger.getLevel()}trace(s,...t){this.logger.trace(s,...t)}debug(s,...t){this.logger.debug(s,...t)}info(s,...t){this.logger.info(s,...t)}warn(s,...t){this.logger.warn(s,...t)}error(s,...t){this.logger.error(s,...t)}critical(s,...t){this.logger.critical(s,...t)}flush(){this.logger.flush()}}e.LogService=m;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(s){}getLevel(){return y.Info}trace(s,...t){}debug(s,...t){}info(s,...t){}warn(s,...t){}error(s,...t){}critical(s,...t){}dispose(){}flush(){}}e.NullLogService=b;function p(l){if(l.verbose)return y.Trace;if(typeof l.logLevel=="string"){const s=a(l.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function a(l){switch(l){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=a;function c(l){switch(l){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=c});var Z=this&&this.__param||function(j,e){return function(v,R){e(v,R,j)}};define(X[171],Q([0,1,136,172,2,16,5,15,36,34,6,21,58,10,25,9,89,63]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let a=class extends D.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new k.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new k.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new k.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new k.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new k.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new w.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,R.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s});const t=new D.DisposableStore;return t.add(s.onDidChangeFile(r=>this._onDidFilesChange.fire(new S.FileChangesEvent(r,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),(0,D.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,D.dispose)(t)})}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){s.push(t)}}),!this.provider.has(l)&&await w.Promises.settled(s)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,s){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return p.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,n.isAbsolutePath)(l))throw new S.FileOperationError((0,v.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,v.localize)(1,null,l.toString()),t}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s)||(0,S.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,S.hasOpenReadWriteCloseCapability)(s)||(0,S.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(t){throw(0,S.toFileSystemProviderErrorCode)(t)===S.FileSystemProviderErrorCode.FileNotFound?new S.FileOperationError((0,v.localize)(2,null,this.resourceForError(l)),1):(0,S.ensureFileSystemProviderError)(t)}}async doResolveFile(l,s){const t=await this.withProvider(l),r=this.isPathCaseSensitive(t),o=s==null?void 0:s.resolveTo,u=s==null?void 0:s.resolveSingleChildDescendants,h=s==null?void 0:s.resolveMetadata,f=await t.stat(l);let I;return this.toFileStat(t,l,f,void 0,!!h,(A,F)=>(I||(I=y.TernarySearchTree.forUris(()=>!r),I.set(l,!0),(0,i.isNonEmptyArray)(o)&&o.forEach(U=>I.set(U,!0))),Boolean(I.findSuperstr(A.resource)||I.get(A.resource))?!0:A.isDirectory&&u?F===1:!1))}async toFileStat(l,s,t,r,o,u){const{providerExtUri:h}=this.getExtUri(l),f={resource:s,name:h.basename(s),isFile:(t.type&S.FileType.File)!=0,isDirectory:(t.type&S.FileType.Directory)!=0,isSymbolicLink:(t.type&S.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,etag:(0,S.etag)({mtime:t.mtime,size:t.size})};if(f.isDirectory&&u(f,r)){try{const I=await l.readdir(s),A=await w.Promises.settled(I.map(async([F,U])=>{try{const q=h.joinPath(s,F),Y=o?await l.stat(q):{type:U};return await this.toFileStat(l,q,Y,I.length,o,u)}catch(q){return this.logService.trace(q),null}}));f.children=(0,i.coalesce)(A)}catch(I){this.logService.trace(I),f.children=[]}return f}return f}async resolveAll(l){return w.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch(t){return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(t){return t}return!0}async doValidateCreateFile(l,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(l))throw new S.FileOperationError((0,v.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=g.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const r=await this.writeFile(l,s);return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,r)),r}async writeFile(l,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:o}=this.getExtUri(r);try{await this.validateWriteFile(r,l,t)||await this.mkdirp(r,o.dirname(l));let h;if((0,S.hasReadWriteCapability)(r)&&!(s instanceof g.VSBuffer))if((0,E.isReadableStream)(s)){const f=await(0,E.peekStream)(s,3);f.ended?h=g.VSBuffer.concat(f.buffer):h=f}else h=(0,E.peekReadable)(s,f=>g.VSBuffer.concat(f),3);else h=s;!(0,S.hasOpenReadWriteCloseCapability)(r)||(0,S.hasReadWriteCapability)(r)&&h instanceof g.VSBuffer?await this.doWriteUnbuffered(r,l,t,h):await this.doWriteBuffered(r,l,t,h instanceof g.VSBuffer?(0,g.bufferToReadable)(h):h)}catch(u){throw new S.FileOperationError((0,v.localize)(4,null,this.resourceForError(l),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error((0,v.localize)(5,null,this.resourceForError(s)));let o;try{o=await l.stat(s)}catch(u){return}if((o.type&S.FileType.Directory)!=0)throw new S.FileOperationError((0,v.localize)(6,null,this.resourceForError(s)),0,t);if(t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&t.mtime<o.mtime&&t.etag!==(0,S.etag)({mtime:t.mtime,size:o.size}))throw new S.FileOperationError((0,v.localize)(7,null),3,t);return o}async readFile(l,s){const t=await this.withReadProvider(l);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,l,s):this.doReadFile(t,l,s)}async doReadFileAtomic(l,s,t){return new Promise((r,o)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const u=await this.doReadFile(l,s,t);r(u)}catch(u){o(u)}})})}async doReadFile(l,s,t){const r=await this.doReadFileStream(l,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},r),{value:await(0,g.streamToBuffer)(r.value)})}async readFileStream(l,s){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,s)}async doReadFileStream(l,s,t){const r=new d.CancellationTokenSource,o=this.validateReadFile(s,t).then(h=>h,h=>{throw r.cancel(),h});let u;try{t&&typeof t.etag=="string"&&t.etag!==S.ETAG_DISABLED&&await o,!((0,S.hasOpenReadWriteCloseCapability)(l)||(0,S.hasFileReadStreamCapability)(l))||(0,S.hasReadWriteCapability)(l)&&(t==null?void 0:t.preferUnbuffered)?u=this.readFileUnbuffered(l,s,t):(0,S.hasFileReadStreamCapability)(l)?u=this.readFileStreamed(l,s,r.token,t):u=this.readFileBuffered(l,s,r.token,t);const h=await o;return Object.assign(Object.assign({},h),{value:u})}catch(h){throw u&&await(0,E.consumeStream)(u),new S.FileOperationError((0,v.localize)(8,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(h).toString()),(0,S.toFileOperationResult)(h),t)}}readFileStreamed(l,s,t,r=Object.create(null)){const o=l.readFileStream(s,r,t);return(0,E.transform)(o,{data:u=>u instanceof g.VSBuffer?u:g.VSBuffer.wrap(u),error:u=>new S.FileOperationError((0,v.localize)(9,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),r)},u=>g.VSBuffer.concat(u))}readFileBuffered(l,s,t,r=Object.create(null)){const o=(0,g.newWriteableBufferStream)();return(0,b.readFileIntoStream)(l,s,o,u=>u,Object.assign(Object.assign({},r),{bufferSize:this.BUFFER_SIZE,errorTransformer:u=>new S.FileOperationError((0,v.localize)(10,null,this.resourceForError(s),(0,S.ensureFileSystemProviderError)(u).toString()),(0,S.toFileOperationResult)(u),r)}),t),o}readFileUnbuffered(l,s,t){const r=(0,E.newWriteableStream)(o=>g.VSBuffer.concat(o));return(async()=>{try{let o=await l.readFile(s);t&&typeof t.position=="number"&&(o=o.slice(t.position)),t&&typeof t.length=="number"&&(o=o.slice(0,t.length)),this.validateReadFileLimits(s,o.byteLength,t),r.end(g.VSBuffer.wrap(o))}catch(o){r.error(o),r.end()}})(),r}async validateReadFile(l,s){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new S.FileOperationError((0,v.localize)(11,null,this.resourceForError(l)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==S.ETAG_DISABLED&&s.etag===t.etag)throw new S.FileOperationError((0,v.localize)(12,null),2,s);return this.validateReadFileLimits(l,t.size,s),t}validateReadFileLimits(l,s,t){if(t==null?void 0:t.limits){let r;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&s>t.limits.size&&(r=7),typeof r=="number")throw new S.FileOperationError((0,v.localize)(13,null,this.resourceForError(l)),r)}}async canMove(l,s,t){return this.doCanMoveCopy(l,s,"move",t)}async canCopy(l,s,t){return this.doCanMoveCopy(l,s,"copy",t)}async doCanMoveCopy(l,s,t,r){if(l.toString()!==s.toString())try{const o=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),u=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(o,l,u,s,t,r)}catch(o){return o}return!0}async move(l,s,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(r,l,o,s,"move",!!t),h=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,u==="move"?2:3,h)),h}async copy(l,s,t){const r=await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),u=await this.doMoveCopy(r,l,o,s,"copy",!!t),h=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,u==="copy"?3:2,h)),h}async doMoveCopy(l,s,t,r,o,u){if(s.toString()===r.toString())return o;const{exists:h,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,s,t,r,o,u);if(h&&!f&&u&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),o==="copy"){if(l===t&&(0,S.hasFileFolderCopyCapability)(l))await l.copy(s,r,{overwrite:u});else{const I=await this.resolve(s);I.isDirectory?await this.doCopyFolder(l,I,t,r):await this.doCopyFile(l,s,t,r)}return o}else return l===t?(await l.rename(s,r,{overwrite:u}),o):(await this.doMoveCopy(l,s,t,r,"copy",u),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,t,r){if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(l,s,t,r);if((0,S.hasOpenReadWriteCloseCapability)(l)&&(0,S.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(l,s,t,r);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(l,s,t,r);if((0,S.hasReadWriteCapability)(l)&&(0,S.hasReadWriteCapability)(t))return this.doPipeUnbuffered(l,s,t,r)}async doCopyFolder(l,s,t,r){await t.mkdir(r),Array.isArray(s.children)&&await w.Promises.settled(s.children.map(async o=>{const u=this.getExtUri(t).providerExtUri.joinPath(r,o.name);return o.isDirectory?this.doCopyFolder(l,await this.resolve(o.resource),t,u):this.doCopyFile(l,o.resource,t,u)}))}async doValidateMoveCopy(l,s,t,r,o,u){let h=!1;if(l===t){const{providerExtUri:I,isPathCaseSensitive:A}=this.getExtUri(l);if(A||(h=I.isEqual(s,r)),h&&o==="copy")throw new Error((0,v.localize)(14,null,this.resourceForError(s),this.resourceForError(r)));if(!h&&I.isEqualOrParent(r,s))throw new Error((0,v.localize)(15,null,this.resourceForError(s),this.resourceForError(r)))}const f=await this.exists(r);if(f&&!h){if(!u)throw new S.FileOperationError((0,v.localize)(16,null,this.resourceForError(s),this.resourceForError(r)),4);if(l===t){const{providerExtUri:I}=this.getExtUri(l);if(I.isEqualOrParent(s,r))throw new Error((0,v.localize)(17,null,this.resourceForError(s),this.resourceForError(r)))}}return{exists:f,isSameResourceWithDifferentPathCase:h}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?n.extUri:n.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new S.FileOperationEvent(l,0,t)),t}async mkdirp(l,s){const t=[],{providerExtUri:r}=this.getExtUri(l);for(;!r.isEqual(s,r.dirname(s));)try{if(((await l.stat(s)).type&S.FileType.Directory)==0)throw new Error((0,v.localize)(18,null,this.resourceForError(s)));break}catch(o){if((0,S.toFileSystemProviderErrorCode)(o)!==S.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(r.basename(s)),s=r.dirname(s)}for(let o=t.length-1;o>=0;o--){s=r.joinPath(s,t[o]);try{await l.mkdir(s)}catch(u){if((0,S.toFileSystemProviderErrorCode)(u)!==S.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(t){return t}return!0}async doValidateDelete(l,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,v.localize)(19,null,this.resourceForError(l)));const o=await this.exists(l);if(!o)throw new S.FileOperationError((0,v.localize)(20,null,this.resourceForError(l)),1);if(!!!(s==null?void 0:s.recursive)&&o){const h=await this.resolve(l);if(h.isDirectory&&Array.isArray(h.children)&&h.children.length>0)throw new Error((0,v.localize)(21,null,this.resourceForError(l)))}return t}async del(l,s){const t=await this.doValidateDelete(l,s),r=!!(s==null?void 0:s.useTrash),o=!!(s==null?void 0:s.recursive);await t.delete(l,{recursive:o,useTrash:r}),this._onDidRunOperation.fire(new S.FileOperationEvent(l,1))}watch(l,s={recursive:!1,excludes:[]}){let t=!1,r=()=>{t=!0};return this.doWatch(l,s).then(o=>{t?(0,D.dispose)(o):r=()=>(0,D.dispose)(o)},o=>this.logService.error(o)),(0,D.toDisposable)(()=>r())}async doWatch(l,s){const t=await this.withProvider(l),r=this.toWatchKey(t,l,s),o=this.activeWatchers.get(r)||{count:0,disposable:t.watch(l,s)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,o),o.count+=1,(0,D.toDisposable)(()=>{o.count--,o.count===0&&((0,D.dispose)(o.disposable),this.activeWatchers.delete(r))})}toWatchKey(l,s,t){const{providerExtUri:r}=this.getExtUri(l);return[r.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>(0,D.dispose)(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{var o;const u=await l.open(s,{create:!0,unlock:(o=t==null?void 0:t.unlock)!==null&&o!==void 0?o:!1});try{(0,E.isReadableStream)(r)||(0,E.isReadableBufferedStream)(r)?await this.doWriteStreamBufferedQueued(l,u,r):await this.doWriteReadableBufferedQueued(l,u,r)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await l.close(u)}})}async doWriteStreamBufferedQueued(l,s,t){let r=0,o;if((0,E.isReadableBufferedStream)(t)){if(t.buffer.length>0){const u=g.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,s,u,u.byteLength,r,0),r+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise(async(u,h)=>{(0,E.listenStream)(o,{onData:async f=>{o.pause();try{await this.doWriteBuffer(l,s,f,f.byteLength,r,0)}catch(I){return h(I)}r+=f.byteLength,setTimeout(()=>o.resume())},onError:f=>h(f),onEnd:()=>u()})})}async doWriteReadableBufferedQueued(l,s,t){let r=0,o;for(;(o=t.read())!==null;)await this.doWriteBuffer(l,s,o,o.byteLength,r,0),r+=o.byteLength}async doWriteBuffer(l,s,t,r,o,u){let h=0;for(;h<r;)h+=await l.write(s,o+h,t.buffer,u+h,r-h)}async doWriteUnbuffered(l,s,t,r){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,t,r))}async doWriteUnbufferedQueued(l,s,t,r){var o;let u;r instanceof g.VSBuffer?u=r:(0,E.isReadableStream)(r)?u=await(0,g.streamToBuffer)(r):(0,E.isReadableBufferedStream)(r)?u=await(0,g.bufferedStreamToBuffer)(r):u=(0,g.readableToBuffer)(r),await l.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:(o=t==null?void 0:t.unlock)!==null&&o!==void 0?o:!1})}async doPipeBuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,t,r))}async doPipeBufferedQueued(l,s,t,r){let o,u;try{o=await l.open(s,{create:!1}),u=await t.open(r,{create:!0,unlock:!1});const h=g.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,I=0,A=0;do A=await l.read(o,f,h.buffer,I,h.byteLength-I),await this.doWriteBuffer(t,u,h,A,f,I),f+=A,I+=A,I===h.byteLength&&(I=0);while(A>0)}catch(h){throw(0,S.ensureFileSystemProviderError)(h)}finally{await w.Promises.settled([typeof o=="number"?l.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async doPipeUnbuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,t,r))}async doPipeUnbufferedQueued(l,s,t,r){return t.writeFile(r,await l.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,s,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,t,r))}async doPipeUnbufferedToBufferedQueued(l,s,t,r){const o=await t.open(r,{create:!0,unlock:!1});try{const u=await l.readFile(s);await this.doWriteBuffer(t,o,g.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,S.ensureFileSystemProviderError)(u)}finally{await t.close(o)}}async doPipeBufferedToUnbuffered(l,s,t,r){const o=await(0,g.streamToBuffer)(this.readFileBuffered(l,s,d.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,o)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new S.FileOperationError((0,v.localize)(22,null,this.resourceForError(s)),6);return l}resourceForError(l){return l.scheme===m.Schemas.file?l.fsPath:l.toString(!0)}};a=ce([Z(0,L.ILogService)],a),e.FileService=a}),define(X[173],Q([0,1,22,112,2,16,5,3,23,8,15,30,10,6,139,90,158,160,157,166,58,89,34,21]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class o extends D.Disposable{constructor(h,f){var I;super();this.logService=h,this.options=f,this.BUFFER_SIZE=((I=this.options)===null||I===void 0?void 0:I.bufferSize)||64*1024,this.onDidChangeCapabilities=k.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new k.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new k.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new E.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,n.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(h){try{const{stat:f,symbolicLink:I}=await y.SymlinkSupport.stat(this.toFilePath(h));return{type:this.toType(f,I),ctime:f.birthtime.getTime(),mtime:f.mtime.getTime(),size:f.size}}catch(f){throw this.toFileSystemProviderError(f)}}async readdir(h){try{const f=await(0,y.readdir)(this.toFilePath(h),{withFileTypes:!0}),I=[];return await Promise.all(f.map(async A=>{try{let F;A.isSymbolicLink()?F=(await this.stat((0,L.joinPath)(h,A.name))).type:F=this.toType(A),I.push([A.name,F])}catch(F){this.logService.trace(F)}})),I}catch(f){throw this.toFileSystemProviderError(f)}}toType(h,f){let I;return(f==null?void 0:f.dangling)?I=S.FileType.Unknown:h.isFile()?I=S.FileType.File:h.isDirectory()?I=S.FileType.Directory:I=S.FileType.Unknown,f&&(I|=S.FileType.SymbolicLink),I}async readFile(h){try{const f=this.toFilePath(h);return await v.promises.readFile(f)}catch(f){throw this.toFileSystemProviderError(f)}}readFileStream(h,f,I){const A=(0,l.newWriteableStream)(F=>r.VSBuffer.concat(F.map(U=>r.VSBuffer.wrap(U))).buffer);return(0,s.readFileIntoStream)(this,h,A,F=>F.buffer,Object.assign(Object.assign({},f),{bufferSize:this.BUFFER_SIZE}),I),A}async writeFile(h,f,I){let A;try{const F=this.toFilePath(h);if(!I.create||!I.overwrite){if(await(0,y.exists)(F)){if(!I.overwrite)throw(0,S.createFileSystemProviderError)((0,d.localize)(0,null),S.FileSystemProviderErrorCode.FileExists)}else if(!I.create)throw(0,S.createFileSystemProviderError)((0,d.localize)(1,null),S.FileSystemProviderErrorCode.FileNotFound)}A=await this.open(h,{create:!0,unlock:I.unlock}),await this.write(A,0,f,0,f.byteLength)}catch(F){throw await this.toFileSystemProviderWriteError(h,F)}finally{typeof A=="number"&&await this.close(A)}}async open(h,f){try{const I=this.toFilePath(h);if((0,S.isFileOpenForWriteOptions)(f)&&f.unlock)try{const{stat:U}=await y.SymlinkSupport.stat(I);U.mode&128||await v.promises.chmod(I,U.mode|128)}catch(U){this.logService.trace(U)}let A;if((0,S.isFileOpenForWriteOptions)(f)){if(n.isWindows)try{await v.promises.truncate(I,0),A="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}A||(A="w")}else A="r";const F=await(0,R.promisify)(v.open)(I,A);return this.mapHandleToPos.set(F,0),(0,S.isFileOpenForWriteOptions)(f)&&this.writeHandles.set(F,h),F}catch(I){throw(0,S.isFileOpenForWriteOptions)(f)?await this.toFileSystemProviderWriteError(h,I):this.toFileSystemProviderError(I)}}async close(h){try{if(this.mapHandleToPos.delete(h),this.writeHandles.delete(h)&&this.canFlush)try{await(0,R.promisify)(v.fdatasync)(h)}catch(f){this.canFlush=!1,this.logService.error(f)}return await(0,R.promisify)(v.close)(h)}catch(f){throw this.toFileSystemProviderError(f)}}async read(h,f,I,A,F){const U=this.normalizePos(h,f);let q=null;try{const Y=await(0,R.promisify)(v.read)(h,I,A,F,U);return typeof Y=="number"?q=Y:q=Y.bytesRead,q}catch(Y){throw this.toFileSystemProviderError(Y)}finally{this.updatePos(h,U,q)}}normalizePos(h,f){return f===this.mapHandleToPos.get(h)?null:f}updatePos(h,f,I){const A=this.mapHandleToPos.get(h);typeof A=="number"&&(typeof f=="number"||(typeof I=="number"?this.mapHandleToPos.set(h,A+I):this.mapHandleToPos.delete(h)))}async write(h,f,I,A,F){return(0,E.retry)(()=>this.doWrite(h,f,I,A,F),100,3)}async doWrite(h,f,I,A,F){const U=this.normalizePos(h,f);let q=null;try{const Y=await(0,R.promisify)(v.write)(h,I,A,F,U);return typeof Y=="number"?q=Y:q=Y.bytesWritten,q}catch(Y){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(h),Y)}finally{this.updatePos(h,U,q)}}async mkdir(h){try{await v.promises.mkdir(this.toFilePath(h))}catch(f){throw this.toFileSystemProviderError(f)}}async delete(h,f){try{const I=this.toFilePath(h);await this.doDelete(I,f)}catch(I){throw this.toFileSystemProviderError(I)}}async doDelete(h,f){f.recursive?await(0,y.rimraf)(h,y.RimRafMode.MOVE):await v.promises.unlink(h)}async rename(h,f,I){const A=this.toFilePath(h),F=this.toFilePath(f);if(A!==F)try{await this.validateTargetDeleted(h,f,"move",I.overwrite),await(0,y.move)(A,F)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(2,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(F)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(h,f,I){const A=this.toFilePath(h),F=this.toFilePath(f);if(A!==F)try{await this.validateTargetDeleted(h,f,"copy",I.overwrite),await(0,y.copy)(A,F,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,d.localize)(3,null,(0,i.basename)(A),(0,i.basename)((0,i.dirname)(F)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(h,f,I,A){const F=this.toFilePath(h),U=this.toFilePath(f);let q=!1;if(!!(this.capabilities&1024)||(q=(0,g.isEqual)(F,U,!0)),q&&I==="copy")throw(0,S.createFileSystemProviderError)((0,d.localize)(4,null),S.FileSystemProviderErrorCode.FileExists);if(!q&&await(0,y.exists)(U)){if(!A)throw(0,S.createFileSystemProviderError)((0,d.localize)(5,null),S.FileSystemProviderErrorCode.FileExists);await this.delete(f,{recursive:!0,useTrash:!1})}}watch(h,f){return f.recursive?this.watchRecursive(h,f.excludes):this.watchNonRecursive(h)}watchRecursive(h,f){const I={path:this.toFilePath(h),excludes:f},A=(0,t.insert)(this.recursiveFoldersToWatch,I);return this.refreshRecursiveWatchers(),(0,D.toDisposable)(()=>{A(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var h,f,I;if(this.recursiveWatcher instanceof a.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let A,F;((f=(h=this.options)===null||h===void 0?void 0:h.watcher)===null||f===void 0?void 0:f.usePolling)?(A=b.FileWatcher,F=(I=this.options)===null||I===void 0?void 0:I.watcher):this.recursiveFoldersToWatch.length===1?n.isWindows?A=p.FileWatcher:A=b.FileWatcher:A=a.FileWatcher,this.recursiveWatcher=new A(this.recursiveFoldersToWatch,U=>this._onDidChangeFile.fire((0,m.toFileChanges)(U)),U=>{U.type==="error"&&this._onDidWatchErrorOccur.fire(U.message),this.logService[U.type](U.message)},this.logService.getLevel()===w.LogLevel.Trace,F),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))}}watchNonRecursive(h){const f=new c.FileWatcher(this.toFilePath(h),A=>this._onDidChangeFile.fire((0,m.toFileChanges)(A)),A=>{A.type==="error"&&this._onDidWatchErrorOccur.fire(A.message),this.logService[A.type](A.message)},this.logService.getLevel()===w.LogLevel.Trace),I=this.logService.onDidChangeLogLevel(()=>{f.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)});return(0,D.combinedDisposable)(f,I)}toFilePath(h){return(0,i.normalize)(h.fsPath)}toFileSystemProviderError(h){if(h instanceof S.FileSystemProviderError)return h;let f;switch(h.code){case"ENOENT":f=S.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":f=S.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":f=S.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":f=S.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":f=S.FileSystemProviderErrorCode.NoPermissions;break;default:f=S.FileSystemProviderErrorCode.Unknown}return(0,S.createFileSystemProviderError)(h,f)}async toFileSystemProviderWriteError(h,f){let I=this.toFileSystemProviderError(f);if(h&&I.code===S.FileSystemProviderErrorCode.NoPermissions)try{const{stat:A}=await y.SymlinkSupport.stat(this.toFilePath(h));A.mode&128||(I=(0,S.createFileSystemProviderError)(f,S.FileSystemProviderErrorCode.FileWriteLocked))}catch(A){this.logService.trace(A)}return I}dispose(){super.dispose(),(0,D.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,D.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=o}),define(X[91],Q([0,1,6]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function R(S,k){switch(k){case v.LogLevel.Trace:return S.trace;case v.LogLevel.Debug:return S.debug;case v.LogLevel.Info:return S.info;case v.LogLevel.Warning:return S.warn;case v.LogLevel.Error:return S.error;case v.LogLevel.Critical:return S.critical;default:throw new Error("Invalid log level")}}class D extends v.AbstractLogger{constructor(k=v.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(k),this._register(this.onDidChangeLogLevel(n=>{this._logger&&this._logger.setLevel(n)}))}set logger(k){this._logger=k;for(const{level:n,args:y}of this.buffer)R(k,n).apply(k,y);this.buffer=[]}_log(k,...n){this._logger?R(this._logger,k).apply(this._logger,n):this.getLevel()<=k&&this.buffer.push({level:k,args:n})}trace(k,...n){this._log(v.LogLevel.Trace,k,...n)}debug(k,...n){this._log(v.LogLevel.Debug,k,...n)}info(k,...n){this._log(v.LogLevel.Info,k,...n)}warn(k,...n){this._log(v.LogLevel.Warning,k,...n)}error(k,...n){this._log(v.LogLevel.Error,k,...n)}critical(k,...n){this._log(v.LogLevel.Critical,k,...n)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(X[174],Q([0,1,6,16,10,21,15,2,4,91]),function(j,e,v,R,D,S,k,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const L=5*R.ByteSize.MB;let g=class extends v.AbstractLogger{constructor(d,m,b,p){super();this.name=d,this.resource=m,this.fileService=p,this.backupIndex=1,this.setLevel(b),this.queue=this._register(new D.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=v.LogLevel.Trace&&this._log(v.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=v.LogLevel.Debug&&this._log(v.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=v.LogLevel.Info&&this._log(v.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=v.LogLevel.Warning&&this._log(v.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=v.LogLevel.Error){const d=arguments[0];if(d instanceof Error){const m=Array.prototype.slice.call(arguments);m[0]=d.stack,this._log(v.LogLevel.Error,this.format(m))}else this._log(v.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=v.LogLevel.Critical&&this._log(v.LogLevel.Critical,this.format(arguments))}flush(){}log(d,m){this._log(d,this.format(m))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(d){if(d.fileOperationResult!==3)throw d}}_log(d,m){this.queue.queue(async()=>{await this.initializePromise;let b=await this.loadContent();b.length>L&&(await this.fileService.writeFile(this.getBackupResource(),S.VSBuffer.fromString(b)),b=""),b+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(d)}] ${m}
`,await this.fileService.writeFile(this.resource,S.VSBuffer.fromString(b))})}getCurrentTimestamp(){const d=p=>p<10?`0${p}`:p,m=p=>p<10?`00${p}`:p<100?`0${p}`:p,b=new Date;return`${b.getFullYear()}-${d(b.getMonth()+1)}-${d(b.getDate())} ${d(b.getHours())}:${d(b.getMinutes())}:${d(b.getSeconds())}.${m(b.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,k.joinPath)((0,k.dirname)(this.resource),`${(0,k.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(d){return""}}stringifyLogLevel(d){switch(d){case v.LogLevel.Critical:return"critical";case v.LogLevel.Debug:return"debug";case v.LogLevel.Error:return"error";case v.LogLevel.Info:return"info";case v.LogLevel.Trace:return"trace";case v.LogLevel.Warning:return"warning"}return""}format(d){let m="";for(let b=0;b<d.length;b++){let p=d[b];if(typeof p=="object")try{p=JSON.stringify(p)}catch(a){}m+=(b>0?" ":"")+p}return m}};g=ce([Z(3,R.IFileService)],g),e.FileLogger=g;let E=class extends n.Disposable{constructor(d,m,b){super();this.logService=d,this.instantiationService=m,this.fileService=b,this.loggers=new Map,this._register(d.onDidChangeLogLevel(p=>this.loggers.forEach(a=>a.setLevel(p))))}createLogger(d){let m=this.loggers.get(d.toString());return m||(m=new i.BufferLogService(this.logService.getLevel()),this.loggers.set(d.toString(),m),(0,R.whenProviderRegistered)(d,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(g,(0,k.basename)(d),d,this.logService.getLevel()))),m}dispose(){this.loggers.forEach(d=>d.dispose()),this.loggers.clear(),super.dispose()}};E=ce([Z(0,v.ILogService),Z(1,y.IInstantiationService),Z(2,R.IFileService)],E),e.FileLoggerService=E}),define(X[175],Q([0,1,6,5,7]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class S{constructor(E){this.service=E,this.onDidChangeLogLevel=R.Event.buffer(E.onDidChangeLogLevel,!0)}listen(E,w){switch(w){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${w}`)}async call(E,w,d){switch(w){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${w}`)}}e.LogLevelChannel=S;class k{constructor(E){this.channel=E}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(E){k.setLevel(this.channel,E)}static setLevel(E,w){return E.call("setLevel",w)}}e.LogLevelChannelClient=k;class n{constructor(E){this.loggerService=E,this.loggers=new Map}listen(E,w){throw new Error(`Event not found: ${w}`)}async call(E,w,d){switch(w){case"createLogger":this.createLogger(D.URI.revive(d[0]),d[1]);return;case"log":return this.log(D.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${w}`)}createLogger(E,w){this.loggers.set(E.toString(),this.loggerService.createLogger(E,w))}consoleLog(E,w){let d=console.log;switch(E){case v.LogLevel.Error:d=console.error;break;case v.LogLevel.Warning:d=console.warn;break;case v.LogLevel.Info:d=console.info;break}d.call(console,...w)}log(E,w){const d=this.loggers.get(E.toString());if(!d)throw new Error("Create the logger before logging");for(const[m,b]of w)switch(m){case v.LogLevel.Trace:d.trace(b);break;case v.LogLevel.Debug:d.debug(b);break;case v.LogLevel.Info:d.info(b);break;case v.LogLevel.Warning:d.warn(b);break;case v.LogLevel.Error:d.error(b);break;case v.LogLevel.Critical:d.critical(b);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=n;class y{constructor(E){this.channel=E}createConsoleMainLogger(){return new v.AdapterLogger({log:(E,w)=>{this.channel.call("consoleLog",[E,w])}})}createLogger(E,w){return new i(this.channel,E,w)}}e.LoggerChannelClient=y;class i extends v.AbstractMessageLogger{constructor(E,w,d){super(d==null?void 0:d.always);this.channel=E,this.file=w,this.isLoggerCreated=!1,this.buffer=[],this.channel.call("createLogger",[w,d]).then(()=>{this._log(this.buffer),this.isLoggerCreated=!0})}log(E,w){this._log([[E,w]])}_log(E){this.isLoggerCreated?this.channel.call("log",[this.file,E]):this.buffer.push(...E)}}class L extends v.LogService{constructor(E,w){super(w);this.parent=E,this._register(E.onDidChangeLogLevel(d=>w.setLevel(d)))}setLevel(E){super.setLevel(E),this.parent.setLevel(E)}}e.FollowerLogService=L}),define(X[92],Q([0,1,6,16]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(y,i,L,g){try{const E=await new Promise((w,d)=>{j(["spdlog"],w,d)});return E.setAsyncMode(8192,500),E.createRotatingLoggerAsync(y,i,L,g)}catch(E){console.error(E)}return null}function S(y,i,L,g){return j.__$__nodeRequire("spdlog").createRotatingLogger(y,i,L,g)}e.createRotatingLogger=S;function k(y,i,L){switch(i){case v.LogLevel.Trace:y.trace(L);break;case v.LogLevel.Debug:y.debug(L);break;case v.LogLevel.Info:y.info(L);break;case v.LogLevel.Warning:y.warn(L);break;case v.LogLevel.Error:y.error(L);break;case v.LogLevel.Critical:y.critical(L);break;default:throw new Error("Invalid log level")}}class n extends v.AbstractMessageLogger{constructor(i,L,g,E){super();this.name=i,this.filepath=L,this.rotating=g,this.buffer=[],this.setLevel(E),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(w=>{this._logger&&this._logger.setLevel(w)}))}_createSpdLogLogger(){const i=this.rotating?6:1,L=30/i*R.ByteSize.MB;return D(this.name,this.filepath,L,i).then(g=>{if(g){this._logger=g,this._logger.setLevel(this.getLevel());for(const{level:E,message:w}of this.buffer)k(this._logger,E,w);this.buffer=[]}})}log(i,L){this._logger?k(this._logger,i,L):this.getLevel()<=i&&this.buffer.push({level:i,message:L})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=n}),define(X[176],Q([0,1,6,2,15,9,174,92,16,28]),function(j,e,v,R,D,S,k,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let L=class extends R.Disposable{constructor(E,w){super();this.logService=E,this.fileService=w,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(E.onDidChangeLogLevel(d=>this.logLevelChangeableLoggers.forEach(m=>m.setLevel(d))))}createLogger(E,w){var d;let m=this.loggers.get(E.toString());return m||(E.scheme===S.Schemas.file?(m=new n.SpdLogLogger((w==null?void 0:w.name)||(0,i.generateUuid)(),E.fsPath,!(w==null?void 0:w.donotRotate),this.logService.getLevel()),(w==null?void 0:w.donotUseFormatters)&&m.clearFormatters()):m=new k.FileLogger((d=w==null?void 0:w.name)!==null&&d!==void 0?d:(0,D.basename)(E),E,this.logService.getLevel(),this.fileService),this.loggers.set(E.toString(),m),(w==null?void 0:w.always)?m.setLevel(v.LogLevel.Trace):this.logLevelChangeableLoggers.push(m)),m}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(E=>E.dispose()),this.loggers.clear(),super.dispose()}};L=ce([Z(0,v.ILogService),Z(1,y.IFileService)],L),e.LoggerService=L}),define(X[177],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function v(k){return k.submenu!==void 0}e.isMenubarMenuItemSubmenu=v;function R(k){return k.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=R;function D(k){return k.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function S(k){return!v(k)&&!R(k)&&!D(k)}e.isMenubarMenuItemAction=S}),define(X[93],Q([0,1,9,3,35,15]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let k;if(R.isWeb||typeof j=="undefined"||typeof j.__$__nodeRequire!="function")k={},Object.keys(k).length===0&&Object.assign(k,{version:"1.56.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});else{const n=(0,S.dirname)(v.FileAccess.asFileUri("",j));k=j.__$__nodeRequire((0,S.joinPath)(n,"product.json").fsPath);const y=j.__$__nodeRequire((0,S.joinPath)(n,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(k,{nameShort:`${k.nameShort} Dev`,nameLong:`${k.nameLong} Dev`,dataFolderName:`${k.dataFolderName}-dev`}),Object.assign(k,{version:y.version})}e.default=k}),define(X[17],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,v.createDecorator)("productService")}),define(X[178],Q([0,1,59,6,17]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let S=class{constructor(n,y){this.productService=n,this.logService=y,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(n,y){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const i=/^(.*)#([^#]+)$/.exec(y);if(!i)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",y),!1;const[,L,g]=i;let E=this.trustedExtensionUrlPublicKeys.get(n);if(!E){if(E=this.productService.trustedExtensionUrlPublicKeys[n],!E||E.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",n),!1;this.trustedExtensionUrlPublicKeys.set(n,[...E])}const w=Buffer.from(decodeURIComponent(g),"base64");if(w.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",y),!1;const d=w.slice(0,6),m=w.readUIntBE(0,6),b=Date.now()-m;if(b<0||b>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",y),!1;const p=w.slice(6),a=v.createVerify("SHA256");a.write(d),a.write(Buffer.from(L)),a.end();for(let c=0;c<E.length;c++){let l=E[c];if(l!==null){if(typeof l=="string")try{l=v.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),E[c]=l}catch(s){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${c+1} for ${n}:`,s),E[c]=null;continue}if(a.verify(l,p))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",y),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",y),!1}};S=ce([Z(0,D.IProductService),Z(1,R.ILogService)],S),e.ExtensionUrlTrustService=S}),define(X[54],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,v.createDecorator)("protocolMainService")}),define(X[179],Q([0,1,2,9,7,47,11,6,36,3,15,28]),function(j,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let E=class extends v.Disposable{constructor(d,m){super();this.logService=m,this.validRoots=y.TernarySearchTree.forUris(()=>!i.isLinux),this.validExtensions=new Set([".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(D.URI.file(d.appRoot)),this.addValidFileRoot(D.URI.file(d.extensionsPath)),this.addValidFileRoot(d.globalStorageHome),this.addValidFileRoot(d.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:d}=k.session;d.protocol.registerFileProtocol(R.Schemas.vscodeFileResource,(m,b)=>this.handleResourceRequest(m,b)),d.protocol.interceptFileProtocol(R.Schemas.file,(m,b)=>this.handleFileRequest(m,b)),this._register((0,v.toDisposable)(()=>{d.protocol.unregisterProtocol(R.Schemas.vscodeFileResource),d.protocol.uninterceptProtocol(R.Schemas.file)}))}addValidFileRoot(d){return this.validRoots.get(d)?v.Disposable.None:(this.validRoots.set(d,!0),(0,v.toDisposable)(()=>this.validRoots.delete(d)))}handleFileRequest(d,m){const b=D.URI.parse(d.url);return i.isPreferringBrowserCodeLoad?(this.logService.error(`Refused to load resource ${b.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3})):this.validRoots.findSubstr(b)?m({path:b.fsPath}):this.validExtensions.has((0,L.extname)(b))?m({path:b.fsPath}):(this.logService.error(`${R.Schemas.file}: Refused to load resource ${b.fsPath} from ${R.Schemas.file}: protocol (original URL: ${d.url})`),m({error:-3}))}handleResourceRequest(d,m){const b=D.URI.parse(d.url),p=R.FileAccess.asFileUri(b);return this.validRoots.findSubstr(p)?m({path:p.fsPath}):this.validExtensions.has((0,L.extname)(p))?m({path:p.fsPath}):(this.logService.error(`${R.Schemas.vscodeFileResource}: Refused to load resource ${p.fsPath} from ${R.Schemas.vscodeFileResource}: protocol (original URL: ${d.url})`),m({error:-3}))}createIPCObjectUrl(d){const m=D.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),b=m.toString(),p=async()=>d;return k.ipcMain.handle(b,p),this.logService.trace(`IPC Object URL: Registered new channel ${b}.`),{resource:m,update:a=>d=a,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${b}.`),k.ipcMain.removeHandler(b)}}}};E=ce([Z(0,S.INativeEnvironmentService),Z(1,n.ILogService)],E),e.ProtocolMainService=E}),define(X[37],Q([0,1,13,100]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(k,n){R.ok(v.isString(k)),R.ok(v.isObject(n)),R.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,n)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new D}),define(X[180],Q([0,1,37,5]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(n){return n.length>0&&n.charAt(n.length-1)==="#"?n.substring(0,n.length-1):n}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,i){this.schemasById[D(y)]=i,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new S;v.Registry.add(e.Extensions.JSONContribution,k)}),define(X[48],Q([0,1,130,5,37,13,180]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var n;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.MACHINE=2]="MACHINE",b[b.WINDOW=3]="WINDOW",b[b.RESOURCE=4]="RESOURCE",b[b.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",b[b.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(n=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const y=D.Registry.as(k.Extensions.JSONContribution);class i{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(p,a=!0){this.registerConfigurations([p],a)}registerConfigurations(p,a=!0){const c=[];p.forEach(l=>{c.push(...this.validateAndRegisterProperties(l,a)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(p){const a=[],c=l=>{if(l.properties)for(const s in l.properties)a.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,l.properties[s]);l.allOf&&l.allOf.forEach(s=>c(s))};for(const l of p){c(l);const s=this.configurationContributors.indexOf(l);s!==-1&&this.configurationContributors.splice(s,1)}y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}registerDefaultConfigurations(p){const a=[],c=[];for(const l of p)for(const s in l)if(a.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),l[s]);const t={type:"object",default:this.defaultValues[s],description:v.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};c.push(g(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=l[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}deregisterDefaultConfigurations(p){const a=[];for(const c of p)for(const l in c)if(a.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const s=this.configurationProperties[l];s&&(this.updatePropertyDefaultValue(l,s),this.updateSchema(l,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(a)}notifyConfigurationSchemaUpdated(...p){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(p){for(const a of p)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(p,a=!0,c=3){c=S.isUndefinedOrNull(p.scope)?c:p.scope;let l=[],s=p.properties;if(s)for(let r in s){if(a&&d(r)){delete s[r];continue}const o=s[r];if(this.updatePropertyDefaultValue(r,o),e.OVERRIDE_PROPERTY_PATTERN.test(r)?o.scope=void 0:o.scope=S.isUndefinedOrNull(o.scope)?c:o.scope,s[r].hasOwnProperty("included")&&!s[r].included){this.excludedConfigurationProperties[r]=s[r],delete s[r];continue}else this.configurationProperties[r]=s[r];!s[r].deprecationMessage&&s[r].markdownDeprecationMessage&&(s[r].deprecationMessage=s[r].markdownDeprecationMessage),l.push(r)}let t=p.allOf;if(t)for(let r of t)l.push(...this.validateAndRegisterProperties(r,a,c));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(p){const a=c=>{let l=c.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let s=c.allOf;s&&s.forEach(a)};a(p)}updateSchema(p,a){switch(e.allSettings.properties[p]=a,a.scope){case 1:e.applicationSettings.properties[p]=a;break;case 2:e.machineSettings.properties[p]=a;break;case 6:e.machineOverridableSettings.properties[p]=a;break;case 3:e.windowSettings.properties[p]=a;break;case 4:e.resourceSettings.properties[p]=a;break;case 5:e.resourceSettings.properties[p]=a,this.resourceLanguageSettingsSchema.properties[p]=a;break}}removeFromSchema(p,a){switch(delete e.allSettings.properties[p],a.scope){case 1:delete e.applicationSettings.properties[p];break;case 2:delete e.machineSettings.properties[p];break;case 6:delete e.machineOverridableSettings.properties[p];break;case 3:delete e.windowSettings.properties[p];break;case 4:case 5:delete e.resourceSettings.properties[p];break}}updateOverridePropertyPatternKey(){for(const p of this.overrideIdentifiers.values()){const a=`[${p}]`,c={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,c),e.allSettings.properties[a]=c,e.applicationSettings.properties[a]=c,e.machineSettings.properties[a]=c,e.machineOverridableSettings.properties[a]=c,e.windowSettings.properties[a]=c,e.resourceSettings.properties[a]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(p,a){let c=this.defaultValues[p];S.isUndefined(c)&&(c=a.default),S.isUndefined(c)&&(c=E(a.type)),a.default=c}}const L="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(L);function g(b){return b.substring(1,b.length-1)}e.overrideIdentifierFromKey=g;function E(b){switch(Array.isArray(b)?b[0]:b){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=E;const w=new i;D.Registry.add(e.Extensions.Configuration,w);function d(b){return b.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(b)?v.localize(5,null,b):w.getConfigurationProperties()[b]!==void 0?v.localize(6,null,b):null:v.localize(4,null)}e.validateProperty=d;function m(){const b=[],p=w.getConfigurationProperties();for(const a of Object.keys(p))b.push([a,p[a].scope]);return b.push(["launch",4]),b.push(["task",4]),b}e.getScopes=m}),define(X[24],Q([0,1,45,13,7,37,4,48]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function y(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof D.URI)}e.isConfigurationOverrides=y;var i;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(i=e.ConfigurationTarget||(e.ConfigurationTarget={}));function L(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=L;function g(r,o){const u=o?r?o.keys.filter(q=>r.keys.indexOf(q)===-1):[...o.keys]:[],h=r?o?r.keys.filter(q=>o.keys.indexOf(q)===-1):[...r.keys]:[],f=[];if(o&&r){for(const q of r.keys)if(o.keys.indexOf(q)!==-1){const Y=p(r.contents,q),ie=p(o.contents,q);v.equals(Y,ie)||f.push(q)}}const I=[],A=q=>{const Y={};for(const ie of q)for(const ae of ie.identifiers)Y[s(ae)]=ie;return Y},F=o?A(o.overrides):{},U=r?A(r.overrides):{};if(Object.keys(F).length)for(const q of u){const Y=F[q];Y&&I.push([(0,n.overrideIdentifierFromKey)(q),Y.keys])}if(Object.keys(U).length)for(const q of h){const Y=U[q];Y&&I.push([(0,n.overrideIdentifierFromKey)(q),Y.keys])}if(Object.keys(F).length&&Object.keys(U).length)for(const q of f){const Y=U[q],ie=F[q];if(Y&&ie){const ae=g({contents:Y.contents,keys:Y.keys,overrides:[]},{contents:ie.contents,keys:ie.keys,overrides:[]});I.push([(0,n.overrideIdentifierFromKey)(q),[...ae.added,...ae.removed,...ae.updated]])}}return{added:u,removed:h,updated:f,overrides:I}}e.compare=g;function E(r,o){const u=[];for(const h of Object.keys(r))if(n.OVERRIDE_PROPERTY_PATTERN.test(h)){const f={};for(const I in r[h])f[I]=r[h][I];u.push({identifiers:[(0,n.overrideIdentifierFromKey)(h).trim()],keys:Object.keys(f),contents:w(f,o)})}return u}e.toOverrides=E;function w(r,o){const u=Object.create(null);for(let h in r)d(u,h,r[h],o);return u}e.toValuesTree=w;function d(r,o,u,h){const f=o.split("."),I=f.pop();let A=r;for(let F=0;F<f.length;F++){let U=f[F],q=A[U];switch(typeof q){case"undefined":q=A[U]=Object.create(null);break;case"object":break;default:h(`Ignoring ${o} as ${f.slice(0,F+1).join(".")} is ${JSON.stringify(q)}`);return}A=q}if(typeof A=="object"&&A!==null)try{A[I]=u}catch(F){h(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(A)}`)}else h(`Ignoring ${o} as ${f.join(".")} is ${JSON.stringify(A)}`)}e.addToValueTree=d;function m(r,o){const u=o.split(".");b(r,u)}e.removeFromValueTree=m;function b(r,o){const u=o.shift();if(o.length===0){delete r[u];return}if(Object.keys(r).indexOf(u)!==-1){const h=r[u];typeof h=="object"&&!Array.isArray(h)&&(b(h,o),Object.keys(h).length===0&&delete r[u])}}function p(r,o,u){function h(A,F){let U=A;for(const q of F){if(typeof U!="object"||U===null)return;U=U[q]}return U}const f=o.split("."),I=h(r,f);return typeof I=="undefined"?u:I}e.getConfigurationValue=p;function a(r,o,u){Object.keys(o).forEach(h=>{h!=="__proto__"&&(h in r?R.isObject(r[h])&&R.isObject(o[h])?a(r[h],o[h],u):u&&(r[h]=o[h]):r[h]=o[h])})}e.merge=a;function c(){const r=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=c;function l(){const r=Object.create(null),o=S.Registry.as(n.Extensions.Configuration).getConfigurationProperties();for(let u in o){let h=o[u].default;d(r,u,h,f=>console.error(`Conflict in default settings: ${f}`))}return r}e.getDefaultValues=l;function s(r){return`[${r}]`}e.keyFromOverrideIdentifier=s;function t(r,o,u){const h=r.inspect(o),f=r.inspect(u);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:h.defaultValue}e.getMigratedSettingValue=t}),define(X[181],Q([0,1,44,36,34,13,45,7,48,24,37,2,5]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class w{constructor(t={},r=[],o=[]){this._contents=t,this._keys=r,this._overrides=o,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,i.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,r){const o=this.getContentsForOverrideIdentifer(r);return o?t?(0,i.getConfigurationValue)(o,t):o:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let o={};for(const u of D.distinct([...Object.keys(this.contents),...Object.keys(r)])){let h=this.contents[u],f=r[u];f&&(typeof h=="object"&&typeof f=="object"?(h=k.deepClone(h),this.mergeContents(h,f)):h=f),o[u]=h}return new w(o,this.keys,this.overrides)}merge(...t){const r=k.deepClone(this.contents),o=k.deepClone(this.overrides),u=[...this.keys];for(const h of t){this.mergeContents(r,h.contents);for(const f of h.overrides){const[I]=o.filter(A=>D.equals(A.identifiers,f.identifiers));I?this.mergeContents(I.contents,f.contents):o.push(k.deepClone(f))}for(const f of h.keys)u.indexOf(f)===-1&&u.push(f)}return new w(r,u,o)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const o of Object.keys(r)){if(o in t&&S.isObject(t[o])&&S.isObject(r[o])){this.mergeContents(t[o],r[o]);continue}t[o]=k.deepClone(r[o])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),(0,i.addToValueTree)(this.contents,t,r,o=>{throw new Error(o)})}removeValue(t){this.removeKey(t)&&(0,i.removeFromValueTree)(this.contents,t)}addKey(t){let r=this.keys.length;for(let o=0;o<r;o++)t.indexOf(this.keys[o])===0&&(r=o);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=w;class d extends w{constructor(){const t=(0,i.getDefaultValues)(),r=(0,i.getConfigurationKeys)(),o=[];for(const u of Object.keys(t))y.OVERRIDE_PROPERTY_PATTERN.test(u)&&o.push({identifiers:[(0,y.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(t[u]),contents:(0,i.toValuesTree)(t[u],h=>console.error(`Conflict in default settings file: ${h}`))});super(t,r,o)}}e.DefaultConfigurationModel=d;class m{constructor(t,r){this._name=t,this._scopes=r,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new w}get errors(){return this._parseErrors}parseContent(t){if(!S.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r)}}parseRaw(t){this._raw=t;const r=this.doParseRaw(t);this._configurationModel=new w(r.contents,r.keys,r.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(t){let r={},o=null,u=[],h=[],f=[];function I(F){Array.isArray(u)?u.push(F):o&&(u[o]=F)}let A={onObjectBegin:()=>{let F={};I(F),h.push(u),u=F,o=null},onObjectProperty:F=>{o=F},onObjectEnd:()=>{u=h.pop()},onArrayBegin:()=>{let F=[];I(F),h.push(u),u=F,o=null},onArrayEnd:()=>{u=h.pop()},onLiteralValue:I,onError:(F,U,q)=>{f.push({error:F,offset:U,length:q})}};if(t)try{v.visit(t,A),r=u[0]||{}}catch(F){console.error(`Error while parsing settings file ${this._name}: ${F}`),this._parseErrors=[F]}return r}doParseRaw(t){if(this._scopes){const h=L.Registry.as(y.Extensions.Configuration).getConfigurationProperties();t=this.filterByScope(t,h,!0,this._scopes)}const r=(0,i.toValuesTree)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`)),o=Object.keys(t),u=(0,i.toOverrides)(t,h=>console.error(`Conflict in settings file ${this._name}: ${h}`));return{contents:r,keys:o,overrides:u}}filterByScope(t,r,o,u){const h={};for(let f in t)if(y.OVERRIDE_PROPERTY_PATTERN.test(f)&&o)h[f]=this.filterByScope(t[f],r,!1,u);else{const I=this.getScope(f,r);(I===void 0||u.indexOf(I)!==-1)&&(h[f]=t[f])}return h}getScope(t,r){const o=r[t];return o?typeof o.scope!="undefined"?o.scope:3:void 0}}e.ConfigurationModelParser=m;class b extends g.Disposable{constructor(t,r,o,u){super();this.userSettingsResource=t,this.scopes=r,this.fileService=u,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new m(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(o.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(E.Event.filter(this.fileService.onDidFilesChange,h=>h.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(t.value.toString()||"{}"),this.parser.configurationModel}catch(t){return new w}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}e.UserSettings=b;class p{constructor(t,r,o=new w,u=new w,h=new R.ResourceMap,f=new w,I=new R.ResourceMap,A=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=o,this._workspaceConfiguration=u,this._folderConfigurations=h,this._memoryConfiguration=f,this._memoryConfigurationByResource=I,this._freeze=A,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,r,o){return this.getConsolidateConfigurationModel(r,o).getValue(t)}updateValue(t,r,o={}){let u;o.resource?(u=this._memoryConfigurationByResource.get(o.resource),u||(u=new w,this._memoryConfigurationByResource.set(o.resource,u))):u=this._memoryConfiguration,r===void 0?u.removeValue(t):u.setValue(t,r),o.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,o){const u=this.getConsolidateConfigurationModel(r,o),h=this.getFolderConfigurationModelForResource(r.resource,o),f=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,I=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),F=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),U=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),q=o?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,Y=h?r.overrideIdentifier?h.freeze().override(r.overrideIdentifier).getValue(t):h.freeze().getValue(t):void 0,ie=r.overrideIdentifier?f.override(r.overrideIdentifier).getValue(t):f.getValue(t),ae=u.getValue(t),V=D.distinct(D.flatten(u.overrides.map(N=>N.identifiers))).filter(N=>u.getOverrideValue(t,N)!==void 0);return{defaultValue:I,userValue:A,userLocalValue:F,userRemoteValue:U,workspaceValue:q,workspaceFolderValue:Y,memoryValue:ie,value:ae,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:A!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:U!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:q!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:Y!==void 0?{value:h==null?void 0:h.freeze().getValue(t),override:r.overrideIdentifier?h==null?void 0:h.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:ie!==void 0?{value:f.getValue(t),override:r.overrideIdentifier?f.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:V.length?V:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const o=r.filter(u=>y.OVERRIDE_PROPERTY_PATTERN.test(u)).map(u=>{const h=(0,y.overrideIdentifierFromKey)(u),f=this._defaultConfiguration.getKeysForOverrideIdentifier(h),I=t.getKeysForOverrideIdentifier(h),A=[...I.filter(F=>f.indexOf(F)===-1),...f.filter(F=>I.indexOf(F)===-1),...f.filter(F=>!k.equals(this._defaultConfiguration.override(h).getValue(F),t.override(h).getValue(F)))];return[h,A]});return this.updateDefaultConfiguration(t),{keys:r,overrides:o}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:h}=(0,i.compare)(this.localUserConfiguration,t),f=[...r,...o,...u];return f.length&&this.updateLocalUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:o,removed:u,overrides:h}=(0,i.compare)(this.remoteUserConfiguration,t);let f=[...r,...o,...u];return f.length&&this.updateRemoteUserConfiguration(t),{keys:f,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:o,removed:u,overrides:h}=(0,i.compare)(this.workspaceConfiguration,t);let f=[...r,...o,...u];return f.length&&this.updateWorkspaceConfiguration(t),{keys:f,overrides:h}}compareAndUpdateFolderConfiguration(t,r){const o=this.folderConfigurations.get(t),{added:u,updated:h,removed:f,overrides:I}=(0,i.compare)(o,r);let A=[...u,...h,...f];return(A.length||!o)&&this.updateFolderConfiguration(t,r),{keys:A,overrides:I}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:o,updated:u,removed:h,overrides:f}=(0,i.compare)(r,void 0);return{keys:[...o,...u,...h],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let o=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?o.override(t.overrideIdentifier):o}getConsolidatedConfigurationModelForResource({resource:t},r){let o=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const u=r.getFolder(t);u&&(o=this.getFolderConsolidatedConfiguration(u.uri)||o);const h=this._memoryConfigurationByResource.get(t);h&&(o=o.merge(h))}return o}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const o=this.getWorkspaceConsolidatedConfiguration(),u=this._folderConfigurations.get(t);u?(r=o.merge(u),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=o}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const o=r.getFolder(t);if(o)return this._folderConfigurations.get(o.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:o,overrides:u,keys:h}=this._folderConfigurations.get(r);return t.push([r,{contents:o,overrides:u,keys:h}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(o=>t.add(o))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o)),this._folderConfigurations.forEach(o=>o.getKeysForOverrideIdentifier(t).forEach(u=>r.add(u))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),o=this.parseConfigurationModel(t.user),u=this.parseConfigurationModel(t.workspace),h=t.folders.reduce((f,I)=>(f.set(n.URI.revive(I[0]),this.parseConfigurationModel(I[1])),f),new R.ResourceMap);return new p(r,o,new w,u,h,new w,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new w(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=p;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,r=new Map;for(const u of s)u.keys.forEach(h=>t.add(h)),u.overrides.forEach(([h,f])=>{const I=(0,R.getOrSet)(r,h,new Set);f.forEach(A=>I.add(A))});const o=[];return r.forEach((u,h)=>o.push([h,[...u.values()]])),{keys:[...t.values()],overrides:o}}e.mergeChanges=a;class c{constructor(t,r,o,u){this.change=t,this.previous=r,this.currentConfiguraiton=o,this.currentWorkspace=u,this._previousConfiguration=void 0;const h=new Set;t.keys.forEach(I=>h.add(I)),t.overrides.forEach(([,I])=>I.forEach(A=>h.add(A))),this.affectedKeys=[...h.values()];const f=new w;this.affectedKeys.forEach(I=>f.setValue(I,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=p.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var o;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const u=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(o=this.previous)===null||o===void 0?void 0:o.workspace):void 0,h=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!k.equals(u,h)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let o=(0,i.toValuesTree)({[r]:!0},()=>{}),u;for(;typeof o=="object"&&(u=Object.keys(o)[0]);){if(t=t[u],!t)return!1;o=o[u]}return!0}}e.ConfigurationChangeEvent=c;class l extends c{constructor(t,r,o,u){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=o,this.sourceConfig=u}}e.AllKeysConfigurationChangeEvent=l}),define(X[182],Q([0,1,37,48,2,24,181,5,10,15]),function(j,e,v,R,D,S,k,n,y,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class L extends D.Disposable{constructor(E,w){super();this.settingsResource=E,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new k.UserSettings(this.settingsResource,void 0,i.extUriBiasedIgnorePathCase,w)),this.configuration=new k.Configuration(new k.DefaultConfigurationModel,new k.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new y.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(R.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const E=await this.userConfiguration.loadConfiguration();this.configuration=new k.Configuration(new k.DefaultConfigurationModel,E)}getConfigurationData(){return this.configuration.toData()}getValue(E,w){const d=typeof E=="string"?E:void 0,m=(0,S.isConfigurationOverrides)(E)?E:(0,S.isConfigurationOverrides)(w)?w:{};return this.configuration.getValue(d,m,void 0)}updateValue(E,w,d,m){return Promise.reject(new Error("not supported"))}inspect(E){return this.configuration.inspect(E,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const E=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(E)}onDidChangeUserConfiguration(E){const w=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(E);this.trigger(d,w,1)}onDidDefaultConfigurationChange(E){const w=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new k.DefaultConfigurationModel,E);this.trigger(d,w,6)}trigger(E,w,d){const m=new k.ConfigurationChangeEvent(E,{data:w},this.configuration);m.source=d,m.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(E){switch(E){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=L}),define(X[183],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,v.createDecorator)("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(k,n=R.Unknown,y){super(k);this._message=k,this._code=n,this._detail=y,this.isHandled=n===R.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(k){return k instanceof D&&k._code===R.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof D&&k._code===R.NoResolverFound}static isHandled(k){return k instanceof D&&k.isHandled}}e.RemoteAuthorityResolverError=D}),define(X[184],Q([0,1,82,28,2,21,5,183,19,10,25]),function(j,e,v,R,D,S,k,n,y,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const g=30*1e3;var E;(function(T){T[T.Management=1]="Management",T[T.ExtensionHost=2]="ExtensionHost",T[T.Tunnel=3]="Tunnel"})(E=e.ConnectionType||(e.ConnectionType={}));function w(T){switch(T){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function d(T){const O=new L.CancellationTokenSource;return setTimeout(()=>O.cancel(),T),O.token}function m(T,O){if(T.isCancellationRequested||O.isCancellationRequested)return L.CancellationToken.Cancelled;const B=new L.CancellationTokenSource;return T.onCancellationRequested(()=>B.cancel()),O.onCancellationRequested(()=>B.cancel()),B.token}class b{constructor(O){this._state="pending",this._disposables=new D.DisposableStore,this.promise=new Promise((B,K)=>{this._resolvePromise=B,this._rejectPromise=K}),O.isCancellationRequested?this._timeout():this._disposables.add(O.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(O){this._state==="pending"?this._disposables.add(O):O.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(O))}reject(O){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(O))}}function p(T,O){const B=new b(O);return B.registerDisposable(T.onControlMessage(K=>{const G=JSON.parse(K.toString()),J=$(G);J?B.reject(J):B.resolve(G)})),B.promise}function a(T,O,B,K,G,J){const ee=new b(J);return O.connect(B,K,G,(re,x)=>{ee.didTimeout?(re&&T.error(re),x==null||x.dispose()):re||!x?ee.reject(re):ee.resolve(x)}),ee.promise}function c(T,O){const B=new b(O);return T.then(K=>{B.didTimeout||B.resolve(K)},K=>{B.didTimeout||B.reject(K)}),B.promise}async function l(T,O,B,K){const G=M(T,O);T.logService.trace(`${G} 1/6. invoking socketFactory.connect().`);let J;try{J=await a(T.logService,T.socketFactory,T.host,T.port,`reconnectionToken=${T.reconnectionToken}&reconnection=${T.reconnectionProtocol?"true":"false"}`,K)}catch(ne){throw T.logService.error(`${G} socketFactory.connect() failed or timed out. Error:`),T.logService.error(ne),ne}T.logService.trace(`${G} 2/6. socketFactory.connect() was successful.`);let ee,re;T.reconnectionProtocol?(T.reconnectionProtocol.beginAcceptReconnection(J,null),ee=T.reconnectionProtocol,re=!1):(ee=new v.PersistentProtocol(J,null),re=!0),T.logService.trace(`${G} 3/6. sending AuthRequest control message.`);const x={type:"auth",auth:T.connectionToken||"00000000000000000000"};ee.sendControl(S.VSBuffer.fromString(JSON.stringify(x)));try{const ne=await p(ee,m(K,d(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const ye=new Error("Unexpected handshake message");throw ye.code="VSCODE_CONNECTION_ERROR",ye}T.logService.trace(`${G} 4/6. received SignRequest control message.`);const oe=await c(T.signService.sign(ne.data),K),ue={type:"connectionType",commit:T.commit,signedData:oe,desiredConnectionType:O};return B&&(ue.args=B),T.logService.trace(`${G} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(S.VSBuffer.fromString(JSON.stringify(ue))),{protocol:ee,ownsProtocol:re}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(T.logService.error(`${G} the handshake timed out. Error:`),T.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(T.logService.error(`${G} received error control message when negotiating connection. Error:`),T.logService.error(ne)),re&&W(ee),ne}}async function s(T,O,B,K){const G=Date.now(),J=M(T,O),{protocol:ee,ownsProtocol:re}=await l(T,O,B,K),x=new b(K);return x.registerDisposable(ee.onControlMessage(ne=>{const oe=JSON.parse(ne.toString()),ue=$(oe);ue?(T.logService.error(`${J} received error control message when negotiating connection. Error:`),T.logService.error(ue),re&&W(ee),x.reject(ue)):(T.reconnectionProtocol&&T.reconnectionProtocol.endAcceptReconnection(),T.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${_(G)}!`),x.resolve({protocol:ee,firstMessage:oe}))})),x.promise}async function t(T,O){const{protocol:B}=await s(T,1,void 0,O);return{protocol:B}}async function r(T,O,B){const{protocol:K,firstMessage:G}=await s(T,2,O,B),J=G&&G.debugPort;return{protocol:K,debugPort:J}}async function o(T,O,B){const K=Date.now(),G=M(T,3),{protocol:J}=await l(T,3,O,B);return T.logService.trace(`${G} 6/6. handshake finished, connection is up and running after ${_(K)}!`),J}async function u(T,O,B){const{host:K,port:G,connectionToken:J}=await T.addressProvider.getAddress();return{commit:T.commit,host:K,port:G,connectionToken:J,reconnectionToken:O,reconnectionProtocol:B,socketFactory:T.socketFactory,signService:T.signService,logService:T.logService}}async function h(T,O,B){try{const K=(0,R.generateUuid)(),G=await u(T,K,null),{protocol:J}=await t(G,L.CancellationToken.None);return new N(T,O,B,K,J)}catch(K){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(K),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(K)),K}}e.connectRemoteAgentManagement=h;async function f(T,O){try{const B=(0,R.generateUuid)(),K=await u(T,B,null),{protocol:G,debugPort:J}=await r(K,O,L.CancellationToken.None);return new z(T,O,B,G,J)}catch(B){throw T.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),T.logService.error(B),V.triggerPermanentFailure(0,0,n.RemoteAuthorityResolverError.isHandled(B)),B}}e.connectRemoteAgentExtensionHost=f;async function I(T,O){const B=await u(T,(0,R.generateUuid)(),null);return await o(B,{port:O},L.CancellationToken.None)}e.connectRemoteAgentTunnel=I;function A(T){return(0,i.createCancelablePromise)(O=>new Promise((B,K)=>{const G=setTimeout(B,T*1e3);O.onCancellationRequested(()=>{clearTimeout(G),B()})}))}var F;(function(T){T[T.ConnectionLost=0]="ConnectionLost",T[T.ReconnectionWait=1]="ReconnectionWait",T[T.ReconnectionRunning=2]="ReconnectionRunning",T[T.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",T[T.ConnectionGain=4]="ConnectionGain"})(F=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class U{constructor(O,B){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.type=0}}e.ConnectionLostEvent=U;class q{constructor(O,B,K,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.durationSeconds=K,this.cancellableTimer=G,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=q;class Y{constructor(O,B,K){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.attempt=K,this.type=2}}e.ReconnectionRunningEvent=Y;class ie{constructor(O,B,K){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.attempt=K,this.type=4}}e.ConnectionGainEvent=ie;class ae{constructor(O,B,K,G){this.reconnectionToken=O,this.millisSinceLastIncomingData=B,this.attempt=K,this.handled=G,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class V extends D.Disposable{constructor(O,B,K,G){super();this._connectionType=O,this._onDidStateChange=this._register(new k.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=B,this.reconnectionToken=K,this.protocol=G,this._isReconnecting=!1,this._onDidStateChange.fire(new ie(this.reconnectionToken,0,0)),this._register(G.onSocketClose(()=>this._beginReconnecting())),this._register(G.onSocketTimeout(()=>this._beginReconnecting())),V._instances.push(this),V._permanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(O,B,K){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=O,this._permanentFailureAttempt=B,this._permanentFailureHandled=K,this._instances.forEach(G=>G._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(!V._permanentFailure){const O=P(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const B=[0,5,5,10,10,10,10,10,30],K=Date.now();let G=-1;do{G++;const J=G<B.length?B[G]:B[B.length-1];try{if(J>0){const re=A(J);this._onDidStateChange.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),J,re)),this._options.logService.info(`${O} waiting for ${J} seconds before reconnecting...`);try{await re}catch(x){}}if(V._permanentFailure){this._options.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this._options.logService.info(`${O} resolving connection...`);const ee=await u(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${O} connecting to ${ee.host}:${ee.port}...`),await this._reconnect(ee,d(g)),this._options.logService.info(`${O} reconnected!`),this._onDidStateChange.fire(new ie(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(ee){if(ee.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(Date.now()-K>108e5){this._options.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(n.RemoteAuthorityResolverError.isTemporarilyNotAvailable(ee)){this._options.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((ee.code==="ETIMEDOUT"||ee.code==="ENETUNREACH"||ee.code==="ECONNREFUSED"||ee.code==="ECONNRESET")&&ee.syscall==="connect"){this._options.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if((0,y.isPromiseCanceledError)(ee)){this._options.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(ee);continue}if(ee instanceof n.RemoteAuthorityResolverError){this._options.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,n.RemoteAuthorityResolverError.isHandled(ee));break}this._options.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(ee),V.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!V._permanentFailure)}}_gotoPermanentFailure(O,B,K){this._onDidStateChange.fire(new ae(this.reconnectionToken,O,B,K)),W(this.protocol)}}V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class N extends V{constructor(O,B,K,G,J){super(1,O,G,J);this.client=this._register(new v.Client(J,{remoteAuthority:B,clientId:K},O.ipcLogger))}async _reconnect(O,B){await t(O,B)}}e.ManagementPersistentConnection=N;class z extends V{constructor(O,B,K,G,J){super(2,O,K,G);this._startArguments=B,this.debugPort=J}async _reconnect(O,B){await r(O,this._startArguments,B)}}e.ExtensionHostPersistentConnection=z;function W(T){try{T.acceptDisconnect();const O=T.getSocket();T.dispose(),O.dispose()}catch(O){(0,y.onUnexpectedError)(O)}}function $(T){if(T&&T.type==="error"){const O=new Error(`Connection error: ${T.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function C(T,O){for(;T.length<O;)T+=" ";return T}function P(T,O,B){return`[remote-connection][${C(w(T),13)}][${O.substr(0,5)}\u2026][${B?"reconnect":"initial"}]`}function M(T,O){return`${P(O,T.reconnectionToken,!!T.reconnectionProtocol)}[${T.host}:${T.port}]`}function _(T){return`${Date.now()-T} ms`}}),define(X[71],Q([0,1,9]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function R(S){return S.scheme===v.Schemas.vscodeRemote?S.authority:void 0}e.getRemoteAuthority=R;function D(S){if(!!S){const k=S.indexOf("+");return k<0?S:S.substr(0,k)}}e.getRemoteName=D}),define(X[55],Q([0,1,5,3,4,6]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var k;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore"})(k=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function n(E){if(!(E.scheme!=="http"&&E.scheme!=="https")){const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(!!w)return{address:w[1],port:+w[2]}}}e.extractLocalHostUriMetaDataForPortMapping=n,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function y(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=y,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function i(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=i;function L(E,w){return w?w!==1&&E<1024:!R.isWindows&&E<1024}e.isPortPrivileged=L;let g=class{constructor(w){this.logService=w,this._onTunnelOpened=new v.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new v.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}setTunnelProvider(w,d){return this._tunnelProvider=w,w?(this._canElevate=d.elevation,this._canMakePublic=d.public,{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async w=>{const d=[],m=Array.from(this._tunnels.values());for(let b of m){const p=Array.from(b.values());for(let a of p){const c=await a.value;c&&d.push(c)}}w(d)})}async dispose(){for(const w of this._tunnels.values()){for(const{value:d}of w.values())await d.then(m=>m==null?void 0:m.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,d,m,b,p=!1,a=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${m} on local port ${b}.`),!!w){d||(d="localhost");const c=this.retainOrCreateTunnel(w,d,m,b,p,a);return c?c.then(l=>{if(!l){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(d,m);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(l);return(l.tunnelRemoteHost!==d||l.tunnelRemotePort!==m)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,public:w.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemotePort} `);const d=this._tunnels.get(w.tunnelRemoteHost);if(d){const m=d.get(w.tunnelRemotePort);m&&(m.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,m))}}}}async tryDisposeTunnel(w,d,m){if(m.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${d}.`);const b=m.value.then(async p=>{p&&(await p.dispose(!0),this._onTunnelClosed.fire({host:p.tunnelRemoteHost,port:p.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(d),b}}async closeTunnel(w,d){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d} `);const m=this._tunnels.get(w);if(m&&m.has(d)){const b=m.get(d);b.refcount=0,await this.tryDisposeTunnel(w,d,b)}}addTunnelToMap(w,d,m){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(d,{refcount:1,value:m})}async removeEmptyTunnelFromMap(w,d){const m=this._tunnels.get(w);m&&(await m.get(d)||m.delete(d),m.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,d){let m=[w];y(w)?(m.push(...e.LOCALHOST_ADDRESSES),m.push(...e.ALL_INTERFACES_ADDRESSES)):i(w)&&m.push(...e.ALL_INTERFACES_ADDRESSES);const b=m.map(p=>this._tunnels.get(p));for(const p of b){const a=p==null?void 0:p.get(d);if(a)return a}}canTunnel(w){return!!n(w)}createWithProvider(w,d,m,b,p,a){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${m} on local port ${b}.`);const l={elevationRequired:p?L(b===void 0?m:b):!1},s={remoteAddress:{host:d,port:m},localAddressPort:b,public:a},t=w.forwardPort(s,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(d,m,t),t}};g=ce([Z(0,S.ILogService)],g),e.AbstractTunnelService=g}),define(X[40],Q([0,1,142,4,48,37,21]),function(j,e,v,R,D,S,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function n(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}e.isSuccess=n;function y(g){return g.res.statusCode===204}async function i(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);return y(g)?null:(await(0,k.streamToBuffer)(g.stream)).toString()}e.asText=i;async function L(g){if(!n(g))throw new Error("Server returned "+g.res.statusCode);if(y(g))return null;const w=(await(0,k.streamToBuffer)(g.stream)).toString();try{return JSON.parse(w)}catch(d){throw d.message+=`:
`+w,d}}e.asJson=L,S.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"http",order:15,title:(0,v.localize)(0,null),type:"object",properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,v.localize)(1,null)},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,v.localize)(2,null)},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,v.localize)(3,null)},"http.proxySupport":{type:"string",enum:["off","on","override"],enumDescriptions:[(0,v.localize)(4,null),(0,v.localize)(5,null),(0,v.localize)(6,null)],default:"override",description:(0,v.localize)(7,null)},"http.systemCertificates":{type:"boolean",default:!0,description:(0,v.localize)(8,null)}}})}),define(X[185],Q([0,1,186,13]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(k,n){return k.protocol==="http:"?n.HTTP_PROXY||n.http_proxy||null:k.protocol==="https:"&&(n.HTTPS_PROXY||n.https_proxy||n.HTTP_PROXY||n.http_proxy)||null}async function S(k,n,y={}){const i=(0,v.parse)(k),L=y.proxyUrl||D(i,n);if(!L)return null;const g=(0,v.parse)(L);if(!/^https?:$/.test(g.protocol||""))return null;const E={host:g.hostname||"",port:g.port||(g.protocol==="https"?"443":"80"),auth:g.auth,rejectUnauthorized:(0,R.isBoolean)(y.strictSSL)?y.strictSSL:!0};return i.protocol==="http:"?new(await new Promise((w,d)=>{j(["http-proxy-agent"],w,d)}))(E):new(await new Promise((w,d)=>{j(["https-proxy-agent"],w,d)}))(E)}e.getProxyAgent=S}),define(X[187],Q([0,1,28,21]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(S,k,n){let y=n&&n.get("storage.serviceMachineId",0)||null;if(y)return y;try{const L=(await k.readFile(S.serviceMachineIdResource)).value.toString();y=(0,v.isUUID)(L)?L:null}catch(i){y=null}if(!y){y=(0,v.generateUuid)();try{await k.writeFile(S.serviceMachineIdResource,R.VSBuffer.fromString(y))}catch(i){}}return n&&n.store("storage.serviceMachineId",y,0,1),y}e.getServiceMachineId=D}),define(X[72],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,v.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[188],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class v{vsda(){return new Promise((D,S)=>j(["vsda"],D,S))}async sign(D){try{const S=await this.vsda(),k=new S.signer;if(k)return k.sign(D)}catch(S){}return D}}e.SignService=v}),define(X[38],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,v.createDecorator)("stateService")}),define(X[18],Q([0,1,11,6,38,5,4,170,3,2,10,13,35]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.UnloadReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,k.createDecorator)("lifecycleMainService");var w;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(w=e.UnloadReason||(e.UnloadReason={}));var d;(function(b){b[b.Starting=1]="Starting",b[b.Ready=2]="Ready",b[b.AfterWindowOpen=3]="AfterWindowOpen"})(d=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let m=class tt extends i.Disposable{constructor(p,a){super();this.logService=p,this.stateService=a,this._onBeforeShutdown=this._register(new S.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new S.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new S.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new S.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new S.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=null,this.pendingQuitPromiseResolve=null,this.pendingWillShutdownPromise=null,this.phaseWhen=new Map,this.handleRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}handleRestarted(){this._wasRestarted=!!this.stateService.getItem(tt.QUIT_FROM_RESTART_MARKER),this._wasRestarted&&this.stateService.removeItem(tt.QUIT_FROM_RESTART_MARKER)}registerListeners(){const p=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),y.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};v.app.addListener("before-quit",p);const a=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!y.isMacintosh)&&v.app.quit()};v.app.addListener("window-all-closed",a),v.app.once("will-quit",c=>{this.logService.trace("Lifecycle#app.on(will-quit)"),c.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),v.app.removeListener("before-quit",p),v.app.removeListener("window-all-closed",a),v.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const p=[];return this._onWillShutdown.fire({join(a){p.push(a)}}),this.pendingWillShutdownPromise=L.Promises.settled(p).then(()=>{},a=>this.logService.error(a)),this.pendingWillShutdownPromise}set phase(p){if(p<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase!==p){this.logService.trace(`lifecycle (main): phase changed (value: ${p})`),this._phase=p;const a=this.phaseWhen.get(this._phase);a&&(a.open(),this.phaseWhen.delete(this._phase))}}async when(p){if(!(p<=this._phase)){let a=this.phaseWhen.get(p);a||(a=new L.Barrier,this.phaseWhen.set(p,a)),await a.wait()}}registerWindow(p){const a=new i.DisposableStore;this.windowCounter++,a.add(p.onWillLoad(l=>this._onWillLoadWindow.fire({window:p,workspace:l.workspace})));const c=(0,g.assertIsDefined)(p.win);c.on("close",l=>{const s=p.id;if(this.windowToCloseRequest.has(s)){this.windowToCloseRequest.delete(s);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${p.id}`),l.preventDefault(),this.unload(p,1).then(t=>{if(t){this.windowToCloseRequest.delete(s);return}this.windowToCloseRequest.add(s),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${s}`),this._onBeforeCloseWindow.fire(p),p.close()})}),c.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${p.id}`),this.windowCounter--,a.dispose(),this.windowCounter===0&&(!y.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(p,a){await this.unload(p,3)||p.reload(a)}async unload(p,a){if(!p.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${p.id}`);const c=this._quitRequested?2:a;let l=await this.onBeforeUnloadWindowInRenderer(p,c);return l?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${p.id})`),this.handleWindowUnloadVeto(l)):(l=await this.onBeforeUnloadWindowInMain(p,c),l?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${p.id})`),this.handleWindowUnloadVeto(l)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${p.id})`),await this.onWillUnloadWindowInRenderer(p,c),!1))}handleWindowUnloadVeto(p){return p?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(p){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(p),this.pendingQuitPromiseResolve=null,this.pendingQuitPromise=null)}onBeforeUnloadWindowInRenderer(p,a){return new Promise(c=>{const l=this.oneTimeListenerTokenGenerator++,s=`vscode:ok${l}`,t=`vscode:cancel${l}`;v.ipcMain.once(s,()=>{c(!1)}),v.ipcMain.once(t,()=>{c(!0)}),p.send("vscode:onBeforeUnload",{okChannel:s,cancelChannel:t,reason:a})})}onBeforeUnloadWindowInMain(p,a){const c=[];return this._onBeforeUnloadWindow.fire({reason:a,window:p,veto(l){c.push(l)}}),(0,n.handleVetos)(c,l=>this.logService.error(l))}onWillUnloadWindowInRenderer(p,a){return new Promise(c=>{const s=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;v.ipcMain.once(s,()=>c()),p.send("vscode:onWillUnload",{replyChannel:s,reason:a})})}quit(p){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - from update: ${p}`),p&&this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0),this.pendingQuitPromise=new Promise(a=>{this.pendingQuitPromiseResolve=a,this.logService.trace("Lifecycle#quit() - calling app.quit()"),v.app.quit()}),this.pendingQuitPromise)}relaunch(p){this.logService.trace("Lifecycle#relaunch()");const a=process.argv.slice(1);if((p==null?void 0:p.addArgs)&&a.push(...p.addArgs),p==null?void 0:p.removeArgs)for(const l of p.removeArgs){const s=a.indexOf(l);s>=0&&a.splice(s,1)}let c=!1;v.app.once("quit",()=>{if(!c){this.stateService.setItem(tt.QUIT_FROM_RESTART_MARKER,!0);try{if(y.isWindows){const l=(0,E.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),v.app.relaunch({args:a})}}),this.quit().then(l=>c=l)}async kill(p){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const a of v.BrowserWindow.getAllWindows())if(a&&!a.isDestroyed()){let c;a.webContents&&!a.webContents.isDestroyed()?c=new Promise(l=>a.once("closed",l)):c=Promise.resolve(),a.destroy(),await c}})()]),v.app.exit(p)}};m.QUIT_FROM_RESTART_MARKER="quit.from.restart",m=ce([Z(0,R.ILogService),Z(1,D.IStateService)],m),e.LifecycleMainService=m}),define(X[189],Q([0,1,4,5,2,18]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,v.createDecorator)("keyboardLayoutMainService");let k=class extends D.Disposable{constructor(i){super();this._onDidChangeKeyboardLayout=this._register(new R.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,i.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const i=await new Promise((L,g)=>{j(["native-keymap"],L,g)});this._keyboardLayoutData=n(i),i.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=n(i),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};k=ce([Z(0,S.ILifecycleMainService)],k),e.KeyboardLayoutMainService=k;function n(y){const i=y.getKeyMap(),L=y.getCurrentKeyboardLayout();return{keyboardMapping:i,keyboardLayoutInfo:L}}}),define(X[190],Q([0,1,8,22,47,23,13,6]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class y{constructor(g,E){this.dbPath=g,this.onError=E,this._database=null,this.lastFlushedSerializedDatabase=null}get database(){return this._database||(this._database=this.loadSync()),this._database}async init(){if(!this._database){const g=await this.loadAsync();this._database||(this._database=g)}}loadSync(){try{return this.lastFlushedSerializedDatabase=R.readFileSync(this.dbPath).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}async loadAsync(){try{return this.lastFlushedSerializedDatabase=(await R.promises.readFile(this.dbPath)).toString(),JSON.parse(this.lastFlushedSerializedDatabase)}catch(g){return g.code!=="ENOENT"&&this.onError(g),{}}}getItem(g,E){const w=this.database[g];return(0,k.isUndefinedOrNull)(w)?E:w}setItem(g,E){if((0,k.isUndefinedOrNull)(E))return this.removeItem(g);(typeof E=="string"||typeof E=="number"||typeof E=="boolean")&&this.database[g]===E||(this.database[g]=E,this.saveSync())}removeItem(g){(0,k.isUndefined)(this.database[g])||(this.database[g]=void 0,this.saveSync())}saveSync(){const g=JSON.stringify(this.database,null,4);if(g!==this.lastFlushedSerializedDatabase)try{(0,S.writeFileSync)(this.dbPath,g),this.lastFlushedSerializedDatabase=g}catch(E){this.onError(E)}}}e.FileStorage=y;let i=class vt{constructor(g,E){this.fileStorage=new y(v.join(g.userDataPath,vt.STATE_FILE),w=>E.error(w))}init(){return this.fileStorage.init()}getItem(g,E){return this.fileStorage.getItem(g,E)}setItem(g,E){this.fileStorage.setItem(g,E)}removeItem(g){this.fileStorage.removeItem(g)}};i.STATE_FILE="storage.json",i=ce([Z(0,D.INativeEnvironmentService),Z(1,n.ILogService)],i),e.StateService=i}),define(X[94],Q([0,1,4,5,2,13,84,10]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const y="__$__targetStorageMarker";e.IStorageService=(0,v.createDecorator)("storageService");var i;(function(m){m[m.NONE=0]="NONE",m[m.SHUTDOWN=1]="SHUTDOWN"})(i=e.WillSaveStateReason||(e.WillSaveStateReason={}));var L;(function(m){m[m.GLOBAL=0]="GLOBAL",m[m.WORKSPACE=1]="WORKSPACE"})(L=e.StorageScope||(e.StorageScope={}));var g;(function(m){m[m.USER=0]="USER",m[m.MACHINE=1]="MACHINE"})(g=e.StorageTarget||(e.StorageTarget={}));class E extends D.Disposable{constructor(b={flushInterval:E.DEFAULT_FLUSH_INTERVAL}){super();this.options=b,this._onDidChangeValue=this._register(new R.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new R.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new R.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new n.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,n.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(b,p){p===y?(b===0?this._globalKeyTargets=void 0:b===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:b})):this._onDidChangeValue.fire({scope:b,key:p,target:this.getKeyTargets(b)[p]})}emitWillSaveState(b){this._onWillSaveState.fire({reason:b})}get(b,p,a){var c;return(c=this.getStorage(p))===null||c===void 0?void 0:c.get(b,a)}getBoolean(b,p,a){var c;return(c=this.getStorage(p))===null||c===void 0?void 0:c.getBoolean(b,a)}getNumber(b,p,a){var c;return(c=this.getStorage(p))===null||c===void 0?void 0:c.getNumber(b,a)}store(b,p,a,c){if((0,S.isUndefinedOrNull)(p)){this.remove(b,a);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(b,a,c),(l=this.getStorage(a))===null||l===void 0||l.set(b,p)})}remove(b,p){this.withPausedEmitters(()=>{var a;this.updateKeyTarget(b,p,void 0),(a=this.getStorage(p))===null||a===void 0||a.delete(b)})}withPausedEmitters(b){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{b()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(b,p){const a=[],c=this.getKeyTargets(b);for(const l of Object.keys(c))c[l]===p&&a.push(l);return a}updateKeyTarget(b,p,a){var c,l;const s=this.getKeyTargets(p);typeof a=="number"?s[b]!==a&&(s[b]=a,(c=this.getStorage(p))===null||c===void 0||c.set(y,JSON.stringify(s))):typeof s[b]=="number"&&(delete s[b],(l=this.getStorage(p))===null||l===void 0||l.set(y,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(b){return b===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(b){const p=this.get(y,b);if(p)try{return JSON.parse(p)}catch(a){}return Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(){var b,p,a,c;this._onWillSaveState.fire({reason:i.NONE}),await n.Promises.settled([(p=(b=this.getStorage(0))===null||b===void 0?void 0:b.whenFlushed())!==null&&p!==void 0?p:Promise.resolve(),(c=(a=this.getStorage(1))===null||a===void 0?void 0:a.whenFlushed())!==null&&c!==void 0?c:Promise.resolve()])}async logStorage(){var b,p,a,c,l,s;const t=(p=(b=this.getStorage(0))===null||b===void 0?void 0:b.items)!==null&&p!==void 0?p:new Map,r=(c=(a=this.getStorage(1))===null||a===void 0?void 0:a.items)!==null&&c!==void 0?c:new Map;return d(t,r,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=E,E.DEFAULT_FLUSH_INTERVAL=60*1e3;class w extends E{constructor(){super();this.globalStorage=new k.Storage(new k.InMemoryStorageDatabase),this.workspaceStorage=new k.Storage(new k.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(b=>this.emitDidChangeValue(1,b))),this._register(this.globalStorage.onDidChangeStorage(b=>this.emitDidChangeValue(0,b)))}getStorage(b){return b===0?this.globalStorage:this.workspaceStorage}getLogDetails(b){return b===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(b){}}e.InMemoryStorageService=w;async function d(m,b,p,a){const c=h=>{try{return JSON.parse(h)}catch(f){return h}},l=new Map,s=new Map;m.forEach((h,f)=>{l.set(f,h),s.set(f,c(h))});const t=new Map,r=new Map;b.forEach((h,f)=>{t.set(f,h),r.set(f,c(h))}),console.group(`Storage: Global (path: ${p})`);let o=[];l.forEach((h,f)=>{o.push({key:f,value:h})}),console.table(o),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${a})`);let u=[];t.forEach((h,f)=>{u.push({key:f,value:h})}),console.table(u),console.groupEnd(),console.log(r)}e.logStorage=d}),define(X[191],Q([0,1,3,35,28,7]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveCommonProperties=void 0;async function k(y,i,L,g,E,w,d,m,b){const p=Object.create(null);p["common.machineId"]=w,p.sessionID=(0,D.generateUuid)()+Date.now(),p.commitHash=g,p.version=E,p["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=(0,v.PlatformToString)(v.platform),p["common.nodePlatform"]=R.platform,p["common.nodeArch"]=L,p["common.product"]=b||"desktop";const a=n(d||[]);a&&(p["common.msftInternal"]=a);let c=0;const l=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),v.isLinuxSnap&&(p["common.snap"]="true");try{const s=await y.readFile(S.URI.file(m));p["common.source"]=s.value.toString().slice(0,30)}catch(s){}return p}e.resolveCommonProperties=k;function n(y){const i=R.env.USERDNSDOMAIN;if(!i)return!1;const L=i.toLowerCase();return y.some(g=>L===g)}}),define(X[31],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,v.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,v.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(X[192],Q([0,1,27,65,68,22,8,44,81,17,3,7,31,63,9,16,23]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function p(t,r){const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],u=new Map,h=new Map,f=2e4;function I(U,q,Y,ie){const ae=q.substring(U.length+1);return new Promise(async V=>{var N,z,W;let $;try{$=await(0,b.readdir)(q,{withFileTypes:!0})}catch(M){V();return}if(ie.count>=f){ie.count+=$.length,ie.maxReached=!0,V();return}let C=$.length;if(C===0){V();return}let P=$;ie.count+$.length>f&&(ie.maxReached=!0,C=f-ie.count,P=$.slice(0,C)),ie.count+=$.length;for(const M of P)if(M.isDirectory()){if(Y.includes(M.name)||await I(U,(0,k.join)(q,M.name),Y,ie),--C==0){V();return}}else{const _=M.name.lastIndexOf(".");if(_>=0){const T=M.name.substring(_+1);T&&u.set(T,((N=u.get(T))!==null&&N!==void 0?N:0)+1)}for(const T of o)((z=T.relativePathPattern)===null||z===void 0?void 0:z.test(ae))!==!1&&T.filePattern.test(M.name)&&h.set(T.tag,((W=h.get(T.tag))!==null&&W!==void 0?W:0)+1);if(--C==0){V();return}}})}const A={count:0,maxReached:!1};await I(t,t,r,A);const F=await l(t);return{configFiles:a(h),fileTypes:a(u),fileCount:A.count,maxFilesReached:A.maxReached,launchConfigFiles:F}}e.collectWorkspaceStats=p;function a(t){return[...w.Iterable.map(t.entries(),([r,o])=>({name:r,count:o}))].sort((r,o)=>o.count-r.count)}function c(){const t={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(R.virtualMachineHint.value()*100)}%`},r=v.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=c;function l(t){let r=new Map,o=(0,k.join)(t,".vscode","launch.json");return new Promise((u,h)=>{(0,S.exists)(o,f=>{if(f)(0,S.readFile)(o,(I,A)=>{if(I)return u([]);const F=[],U=(0,n.parse)(A.toString(),F);if(F.length)return console.log(`Unable to parse ${o}`),u([]);if((0,n.getNodeType)(U)==="object"&&U.configurations)for(const q of U.configurations){const Y=q.type;Y&&(r.has(Y)?r.set(Y,r.get(Y)+1):r.set(Y,1))}return u(a(r))});else return u([])})})}e.collectLaunchConfigs=l;let s=class{constructor(r,o){this.telemetryService=r,this.productService=o}formatMachineInfo(r){const o=[];return o.push(`OS Version:       ${r.os}`),o.push(`CPUs:             ${r.cpus}`),o.push(`Memory (System):  ${r.memory}`),o.push(`VM:               ${r.vmHint}`),o.join(`
`)}formatEnvironment(r){const o=[];o.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),o.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const u=v.cpus();return u&&u.length>0&&o.push(`CPUs:             ${u[0].model} (${u.length} x ${u[0].speed})`),o.push(`Memory (System):  ${(v.totalmem()/m.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/m.ByteSize.GB).toFixed(2)}GB free)`),L.isWindows||o.push(`Load (avg):       ${v.loadavg().map(h=>Math.round(h)).join(", ")}`),o.push(`VM:               ${Math.round(R.virtualMachineHint.value()*100)}%`),o.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),o.push(`Process Argv:     ${r.mainArguments.join(" ")}`),o.push(`GPU Status:       ${this.expandGPUFeatures(r.gpuFeatureStatus)}`),o.join(`
`)}async getPerformanceInfo(r,o){return Promise.all([(0,y.listProcesses)(r.mainPID),this.formatWorkspaceMetadata(r)]).then(async u=>{let[h,f]=u,I=this.formatProcessList(r,h);return o.forEach(A=>{if((0,D.isRemoteDiagnosticError)(A))I+=`
${A.errorMessage}`,f+=`
${A.errorMessage}`;else if(I+=`

Remote: ${A.hostName}`,A.processes&&(I+=`
${this.formatProcessList(r,A.processes)}`),A.workspaceMetadata){f+=`
|  Remote: ${A.hostName}`;for(const F of Object.keys(A.workspaceMetadata)){const U=A.workspaceMetadata[F];let q=`${U.fileCount} files`;U.maxFilesReached&&(q=`more than ${q}`),f+=`|    Folder (${F}): ${q}`,f+=this.formatWorkspaceStats(U)}}}),{processInfo:I,workspaceInfo:f}})}async getSystemInfo(r,o){const{memory:u,vmHint:h,os:f,cpus:I}=c(),A={os:f,memory:u,cpus:I,vmHint:h,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:o};return L.isWindows||(A.load=`${v.loadavg().map(F=>Math.round(F)).join(", ")}`),L.isLinux&&(A.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(A)}async getDiagnostics(r,o){const u=[];return(0,y.listProcesses)(r.mainPID).then(async h=>(u.push(""),u.push(this.formatEnvironment(r)),u.push(""),u.push(this.formatProcessList(r,h)),r.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(u.push(""),u.push("Workspace Stats: "),u.push(await this.formatWorkspaceMetadata(r))),o.forEach(f=>{if((0,D.isRemoteDiagnosticError)(f))u.push(`
${f.errorMessage}`);else if(u.push(`

`),u.push(`Remote:           ${f.hostName}`),u.push(this.formatMachineInfo(f.machineInfo)),f.processes&&u.push(this.formatProcessList(r,f.processes)),f.workspaceMetadata)for(const I of Object.keys(f.workspaceMetadata)){const A=f.workspaceMetadata[I];let F=`${A.fileCount} files`;A.maxFilesReached&&(F=`more than ${F}`),u.push(`Folder (${I}): ${F}`),u.push(this.formatWorkspaceStats(A))}}),u.push(""),u.push(""),u.join(`
`)))}formatWorkspaceStats(r){const o=[],u=60;let h=0;const f=(U,q)=>{const Y=` ${U}(${q})`;h+Y.length>u?(o.push(I),I="|                 ",h=I.length):h+=Y.length,I+=Y};let I="|      File types:";const A=10;let F=r.fileTypes.length>A?A:r.fileTypes.length;for(let U=0;U<F;U++){const q=r.fileTypes[U];f(q.name,q.count)}if(o.push(I),r.configFiles.length>=0&&(I="|      Conf files:",h=0,r.configFiles.forEach(U=>{f(U.name,U.count)}),o.push(I)),r.launchConfigFiles.length>0){let U="|      Launch Configs:";r.launchConfigFiles.forEach(q=>{U+=q.count>1?` ${q.name}(${q.count})`:` ${q.name}`}),o.push(U)}return o.join(`
`)}expandGPUFeatures(r){const o=Math.max(...Object.keys(r).map(u=>u.length));return Object.keys(r).map(u=>`${u}:  ${" ".repeat(o-u.length)}  ${r[u]}`).join(`
                  `)}formatWorkspaceMetadata(r){const o=[],u=[];return r.windows.forEach(h=>{h.folderURIs.length===0||!!h.remoteAuthority||(o.push(`|  Window (${h.title})`),h.folderURIs.forEach(f=>{const I=g.URI.revive(f);if(I.scheme===d.Schemas.file){const A=I.fsPath;u.push(p(A,["node_modules",".git"]).then(F=>{let U=`${F.fileCount} files`;F.maxFilesReached&&(U=`more than ${U}`),o.push(`|    Folder (${(0,k.basename)(A)}): ${U}`),o.push(this.formatWorkspaceStats(F))}).catch(F=>{o.push(`|      Error: Unable to collect workspace stats for folder ${A} (${F.toString()})`)}))}else o.push(`|    Folder (${I.toString()}): Workspace stats not available.`)}))}),Promise.all(u).then(h=>o.join(`
`)).catch(h=>`Unable to collect workspace stats: ${h}`)}formatProcessList(r,o){const u=new Map;r.windows.forEach(f=>u.set(f.pid,f.title));const h=[];return h.push("CPU %	Mem MB	   PID	Process"),o&&this.formatProcessItem(r.mainPID,u,h,o,0),h.join(`
`)}formatProcessItem(r,o,u,h,f){const I=f===0;let A;I?A=h.pid===r?`${this.productService.applicationName} main`:"remote agent":(A=`${"  ".repeat(f)} ${h.name}`,h.name==="window"&&(A=`${A} (${o.get(h.pid)})`));const F=process.platform==="win32"?h.mem:v.totalmem()*(h.mem/100);u.push(`${h.load.toFixed(0).padStart(5," ")}	${(F/m.ByteSize.MB).toFixed(0).padStart(6," ")}	${h.pid.toFixed(0).padStart(6," ")}	${A}`),Array.isArray(h.children)&&h.children.forEach(U=>this.formatProcessItem(r,o,u,U,f+1))}async reportWorkspaceStats(r){for(const{uri:o}of r.folders){const u=g.URI.revive(o);if(u.scheme===d.Schemas.file){const h=u.fsPath;try{const f=await p(h,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),f.fileTypes.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),f.launchConfigFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})}),f.configFiles.forEach(I=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:I.name,count:I.count})})}catch(f){}}}}};s=ce([Z(0,E.ITelemetryService),Z(1,i.IProductService)],s),e.DiagnosticsService=s}),define(X[193],Q([0,1,19,162,165,45,31,40,156,47,25,6,16,7,17,94,187,4,15]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var c;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished"})(c||(c={}));function l(...P){return String(P.reduce((M,_)=>M|_,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},r={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},u={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:c.None,criteria:[],assetTypes:[]};class h{constructor(M=u){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,_=this.state.pageSize){return new h(Object.assign(Object.assign({},this.state),{pageNumber:M,pageSize:_}))}withFilter(M,..._){const T=[...this.state.criteria,..._.length?_.map(O=>({filterType:M,value:O})):[{filterType:M}]];return new h(Object.assign(Object.assign({},this.state),{criteria:T}))}withSortBy(M){return new h(Object.assign(Object.assign({},this.state),{sortBy:M}))}withSortOrder(M){return new h(Object.assign(Object.assign({},this.state),{sortOrder:M}))}withFlags(...M){return new h(Object.assign(Object.assign({},this.state),{flags:M.reduce((_,T)=>_|T,0)}))}withAssetTypes(...M){return new h(Object.assign(Object.assign({},this.state),{assetTypes:M}))}get raw(){const{criteria:M,pageNumber:_,pageSize:T,sortBy:O,sortOrder:B,flags:K,assetTypes:G}=this.state;return{filters:[{criteria:M,pageNumber:_,pageSize:T,sortBy:O,sortOrder:B}],assetTypes:G,flags:K}}get searchText(){const M=this.state.criteria.filter(_=>_.filterType===s.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function f(P,M){const _=(P||[]).filter(T=>T.statisticName===M)[0];return _?_.value:0}function I(P){const M="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(T=>T.assetType.indexOf(M)===0).reduce((T,O)=>{const B=q(P,O.assetType);return B&&T.push([O.assetType.substring(M.length),B]),T},[])}function A(P){if(P.properties){const M=P.properties.filter(O=>O.key===t.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),T=M.filter(O=>_.test(O.value))[0];return T?{uri:T.value,fallbackUri:T.value}:null}return q(P,t.Repository)}function F(P){return{uri:`${P.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${P.fallbackAssetUri}/${t.VSIX}`}}function U(P){const M=q(P,t.Icon);if(M)return M;const _=R.DefaultIconPath;return{uri:_,fallbackUri:_}}function q(P,M){return P.files.filter(T=>T.assetType===M)[0]?{uri:`${P.assetUri}/${M}`,fallbackUri:`${P.fallbackAssetUri}/${M}`}:null}function Y(P,M){const _=P.properties?P.properties.filter(O=>O.key===M):[],T=_.length>0&&_[0].value;return T?T.split(",").map(O=>(0,D.adoptToGalleryExtensionId)(O)):[]}function ie(P){const M=P.properties?P.properties.filter(_=>_.key===r.Engine):[];return M.length>0&&M[0].value||""}function ae(P){const M=P.properties?P.properties.filter(T=>T.key===r.LocalizedLanguages):[],_=M.length>0&&M[0].value||"";return _?_.split(","):[]}function V(P){return P.indexOf("preview")!==-1}function N(P){const M=P.properties?P.properties.find(_=>_.key===r.WebExtension):void 0;return!!M&&M.value==="true"}function z(P){return P.files.some(M=>M.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,a.joinPath)(w.URI.parse(P.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function W(P,M,_,T,O){const B={manifest:q(M,t.Manifest),readme:q(M,t.Details),changelog:q(M,t.Changelog),license:q(M,t.License),repository:A(M),download:F(M),icon:U(M),coreTranslations:I(M)};return{identifier:{id:(0,D.getGalleryExtensionId)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:M.version,date:M.lastUpdated,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,description:P.shortDescription||"",installCount:f(P.statistics,"install"),rating:f(P.statistics,"averagerating"),ratingCount:f(P.statistics,"ratingcount"),assetUri:w.URI.parse(M.assetUri),webResource:z(M),assetTypes:M.files.map(({assetType:K})=>K),assets:B,properties:{dependencies:Y(M,r.Dependency),extensionPack:Y(M,r.ExtensionPack),engine:ie(M),localizedLanguages:ae(M),webExtension:N(M)},telemetryData:{index:(T.pageNumber-1)*T.pageSize+_,searchText:T.searchText,querySource:O},preview:V(P.flags)}}let $=class{constructor(M,_,T,O,B,K,G){this.requestService=M,this.logService=_,this.environmentService=T,this.telemetryService=O,this.fileService=B,this.productService=K;const J=K.extensionsGallery;this.extensionsGalleryUrl=J&&J.serviceUrl,this.extensionsControlUrl=J&&J.controlUrl,this.commonHeadersPromise=C(K.version,this.environmentService,this.fileService,G)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,_){const T=[];let{total:O,firstPage:B,getPage:K}=await this.query({names:M,pageSize:M.length},_);T.push(...B);for(let G=1;T.length<O&&(B=await K(G,_),B.length);G++)T.push(...B);return T}async getCompatibleExtension(M,_){const T=await this.getCompatibleExtensionByEngine(M,_);return(T==null?void 0:T.properties.webExtension)?T.webResource?T:null:T}async getCompatibleExtensionByEngine(M,_){const T=(0,R.isIExtensionIdentifier)(M)?null:M;if(T&&T.properties.engine&&(0,y.isEngineValid)(T.properties.engine,this.productService.version))return T;const{id:O,uuid:B}=T?T.identifier:M;let K=new h().withFlags(c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?K=K.withFilter(s.ExtensionId,B):K=K.withFilter(s.ExtensionName,O);const{galleryExtensions:G}=await this.queryGallery(K,L.CancellationToken.None),[J]=G;if(!J||!J.versions.length)return null;if(_){const re=J.versions.filter(x=>x.version===_)[0];if(re){const x=W(J,re,0,K);if(x.properties.engine&&(0,y.isEngineValid)(x.properties.engine,this.productService.version))return x}return null}const ee=await this.getLastValidExtensionVersion(J,J.versions);return ee?W(J,ee,0,K):null}async query(M,_){const T=L.CancellationToken.isCancellationToken(M)?{}:M,O=L.CancellationToken.isCancellationToken(M)?M:_;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let B=T.text||"";const K=(0,S.getOrDefault)(T,ne=>ne.pageSize,50);let G=new h().withFlags(c.IncludeLatestVersionOnly,c.IncludeAssetUri,c.IncludeStatistics,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,K).withFilter(s.Target,"Microsoft.VisualStudio.Code");B?(B=B.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,oe,ue)=>(G=G.withFilter(s.Category,ue||oe),"")),B=B.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,oe,ue)=>(G=G.withFilter(s.Tag,ue||oe),"")),B=B.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(s.Featured),"")),B=B.trim(),B&&(B=B.length<200?B:B.substring(0,200),G=G.withFilter(s.SearchText,B)),G=G.withSortBy(0)):T.ids?G=G.withFilter(s.ExtensionId,...T.ids):T.names?G=G.withFilter(s.ExtensionName,...T.names):G=G.withSortBy(4),typeof T.sortBy=="number"&&(G=G.withSortBy(T.sortBy)),typeof T.sortOrder=="number"&&(G=G.withSortOrder(T.sortOrder));const{galleryExtensions:J,total:ee}=await this.queryGallery(G,O),re=J.map((ne,oe)=>W(ne,ne.versions[0],oe,G,T.source)),x=async(ne,oe)=>{if(oe.isCancellationRequested)throw(0,v.canceled)();const ue=G.withPage(ne+1),{galleryExtensions:ye}=await this.queryGallery(ue,oe);return ye.map((me,de)=>W(me,me.versions[0],de,ue,T.source))};return{firstPage:re,total:ee,pageSize:G.pageSize,getPage:x}}async queryGallery(M,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,c.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,l(c.Unpublished));const T=await this.commonHeadersPromise,O=JSON.stringify(M.raw),B=Object.assign(Object.assign({},T),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(O.length)}),K=new Date().getTime();let G,J,ee=0;try{if(G=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:O,headers:B},_),G.res.statusCode&&G.res.statusCode>=400&&G.res.statusCode<500)return{galleryExtensions:[],total:ee};const re=await(0,n.asJson)(G);if(re){const x=re.results[0],ne=x.extensions,oe=x.resultMetadata&&x.resultMetadata.filter(ue=>ue.metadataType==="ResultCount")[0];return ee=oe&&oe.metadataItems.filter(ue=>ue.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:ee}}return{galleryExtensions:[],total:ee}}catch(re){throw J=re,re}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},M.telemetryData),{requestBodySize:String(O.length),duration:new Date().getTime()-K,success:!!G&&(0,n.isSuccess)(G),responseBodySize:G==null?void 0:G.res.headers["Content-Length"],statusCode:G?String(G.res.statusCode):void 0,errorCode:J?(0,v.isPromiseCanceledError)(J)?"canceled":(0,v.getErrorMessage)(J).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ee)}))}}async reportStatistic(M,_,T,O){if(!!this.isEnabled()){const B=await this.commonHeadersPromise,K=Object.assign(Object.assign({},B),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${M}/extensions/${_}/${T}/stats?statType=${O}`),headers:K},L.CancellationToken.None)}catch(G){}}}async download(M,_,T){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const O=(0,D.getGalleryExtensionTelemetryData)(M),B=new Date().getTime(),K=re=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},O),{duration:re})),G=T===1?"install":T===2?"update":"",J=G?{uri:`${M.assets.download.uri}&${G}=true`,fallbackUri:`${M.assets.download.fallbackUri}?${G}=true`}:M.assets.download,ee=await this.getAsset(J);await this.fileService.writeFile(_,ee.stream),K(new Date().getTime()-B)}async getReadme(M,_){if(M.assets.readme){const T=await this.getAsset(M.assets.readme,{},_);return await(0,n.asText)(T)||""}return""}async getManifest(M,_){if(M.assets.manifest){const T=await this.getAsset(M.assets.manifest,{},_),O=await(0,n.asText)(T);return O?JSON.parse(O):null}return null}async getCoreTranslation(M,_){const T=M.assets.coreTranslations.filter(O=>O[0]===_.toUpperCase())[0];if(T){const O=await this.getAsset(T[1]),B=await(0,n.asText)(O);return B?JSON.parse(B):null}return null}async getChangelog(M,_){if(M.assets.changelog){const T=await this.getAsset(M.assets.changelog,{},_);return await(0,n.asText)(T)||""}return""}async getAllVersions(M,_){let T=new h().withFlags(c.IncludeVersions,c.IncludeFiles,c.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");M.identifier.uuid?T=T.withFilter(s.ExtensionId,M.identifier.uuid):T=T.withFilter(s.ExtensionName,M.identifier.id);const O=[],{galleryExtensions:B}=await this.queryGallery(T,L.CancellationToken.None);return B.length&&(_?await Promise.all(B[0].versions.map(async K=>{let G;try{G=await this.getEngine(K)}catch(J){}G&&(0,y.isEngineValid)(G,this.productService.version)&&O.push({version:K.version,date:K.lastUpdated})})):O.push(...B[0].versions.map(K=>({version:K.version,date:K.lastUpdated})))),O}async getAsset(M,_={},T=L.CancellationToken.None){const O=await this.commonHeadersPromise,B={type:"GET"},K=Object.assign(Object.assign({},O),_.headers||{});_=Object.assign(Object.assign(Object.assign({},_),B),{headers:K});const G=M.uri,J=M.fallbackUri,ee=Object.assign(Object.assign({},_),{url:G});try{const re=await this.requestService.request(ee,T);if(re.res.statusCode===200)return re;const x=await(0,n.asText)(re);throw new Error(`Expected 200, got back ${re.res.statusCode} instead.

${x}`)}catch(re){if((0,v.isPromiseCanceledError)(re))throw re;const x=(0,v.getErrorMessage)(re);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:G,message:x});const ne=Object.assign(Object.assign({},_),{url:J});return this.requestService.request(ne,T)}}async getLastValidExtensionVersion(M,_){const T=this.getLastValidExtensionVersionFromProperties(M,_);return T||this.getLastValidExtensionVersionRecursively(M,_)}getLastValidExtensionVersionFromProperties(M,_){for(const T of _){const O=ie(T);if(!O)return null;if((0,y.isEngineValid)(O,this.productService.version))return T}return null}async getEngine(M){const _=ie(M);if(_)return _;const T=q(M,t.Manifest);if(!T)throw new Error("Manifest was not found");const O={"Accept-Encoding":"gzip"},B=await this.getAsset(T,{headers:O}),K=await(0,n.asJson)(B);if(K)return K.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(M,_){if(!_.length)return null;const T=_[0],O=await this.getEngine(T);return(0,y.isEngineValid)(O,this.productService.version)?(T.properties=T.properties||[],T.properties.push({key:r.Engine,value:O}),T):this.getLastValidExtensionVersionRecursively(M,_.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,n.asJson)(M),T=new Map;if(_)for(const O of _.malicious){const B=T.get(O)||{id:{id:O},malicious:!0,slow:!1};B.malicious=!0,T.set(O,B)}return[...T.values()]}};$=ce([Z(0,n.IRequestService),Z(1,g.ILogService),Z(2,i.IEnvironmentService),Z(3,k.ITelemetryService),Z(4,E.IFileService),Z(5,d.IProductService),Z(6,(0,p.optional)(m.IStorageService))],$),e.ExtensionGalleryService=$;async function C(P,M,_,T){const O={"X-Market-Client-Id":`VSCode ${P}`,"User-Agent":`VSCode ${P}`},B=await(0,b.getServiceMachineId)(M,_,T);return O["X-Market-User-Id"]=B,O}e.resolveMarketplaceHeaders=C}),define(X[194],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(S){this.appender=S}listen(S,k){throw new Error(`Event not found: ${k}`)}call(S,k,{eventName:n,data:y}){return this.appender.log(n,y),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class R{constructor(S){this.channel=S}log(S,k){return this.channel.call("log",{eventName:S,data:k}).then(void 0,n=>`Failed to log telemetry: ${console.warn(n)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=R}),define(X[195],Q([0,1,93,143,20,4,24,48,2,45,37]),function(j,e,v,R,D,S,k,n,y,i,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let g=class{constructor(d,m){this._configurationService=m,this._experimentProperties={},this._disposables=new y.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let b of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(b),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(b=>{const p=/^[a-f0-9]+$/i.test(b["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!p})}))}setExperimentProperty(d,m){this._experimentProperties[d]=m}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const m=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(E);this._userOptIn=m?m.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let m=d.sessionID,b=d["common.instanceId"],p=d["common.machineId"],a=d["common.firstSessionDate"],c=d["common.msftInternal"];return{sessionId:m,instanceId:b,machineId:p,firstSessionDate:a,msftInternal:c}}dispose(){this._disposables.dispose()}publicLog(d,m,b){return this.isOptedIn?this._commonProperties.then(p=>{m=(0,i.mixin)(m,p),m=(0,i.mixin)(m,this._experimentProperties),m=(0,i.cloneAndChange)(m,a=>{if(typeof a=="string")return this._cleanupInfo(a,b)}),this._appender.log(d,m)},p=>{console.error(p)}):Promise.resolve(void 0)}publicLog2(d,m,b){return this.publicLog(d,m,b)}publicLogError(d,m){return this.sendErrorTelemetry?this.publicLog(d,m,!0):Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}_cleanupInfo(d,m){let b=d;if(m){const p=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(d);if(!t)break;p.push([t.index,s.lastIndex])}const a=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,c=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(b="";;){const s=c.exec(d);if(!s)break;!a.test(s[0])&&p.every(([t,r])=>s.index<t||s.index>=r)&&(b+=d.substring(l,s.index)+"<REDACTED: user-file-path>",l=c.lastIndex)}l<d.length&&(b+=d.substr(l))}for(let p of this._cleanupPatterns)b=b.replace(p,"");return b}};g.IDLE_START_EVENT_NAME="UserIdleStart",g.IDLE_STOP_EVENT_NAME="UserIdleStop",g=ce([Z(1,(0,S.optional)(k.IConfigurationService))],g),e.TelemetryService=g;const E="telemetry";L.Registry.as(n.Extensions.Configuration).registerConfiguration({id:E,order:110,type:"object",title:(0,R.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,R.localize)(2,null,v.default.privacyStatementUrl):(0,R.localize)(1,null),default:!0,tags:["usesOnlineServices"]}}})}),define(X[95],Q([0,1,24,45,13,10]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,m){return Promise.resolve(void 0)}publicLog2(d,m){return this.publicLog(d,m)}publicLogError(d,m){return Promise.resolve(void 0)}publicLogError2(d,m){return this.publicLogError(d,m)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class k{async publicLog(m,b,p){}async publicLogError(m,b,p){}}e.NullEndpointTelemetryService=k;function n(...d){return{log:(m,b)=>d.forEach(p=>p.log(m,b)),flush:()=>S.Promises.settled(d.map(m=>m.flush()))}}e.combinedAppender=n,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function y(d,m){return m.onDidChangeConfiguration(b=>{b.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,v.ConfigurationTargetToString)(b.source),configurationKeys:E(b.sourceConfig)})})}e.configurationTelemetry=y;function i(d){const m=Object.create(null),b=Object.create(null),p=Object.create(null);g(d,p);for(let a in p){a=a.length>150?a.substr(a.length-149):a;const c=p[a];typeof c=="number"?b[a]=c:typeof c=="boolean"?b[a]=c?1:0:typeof c=="string"?m[a]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(m[a]=c)}return{properties:m,measurements:b}}e.validateTelemetryData=i;function L(d){if(!d)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(p=>{d.indexOf(`${p}+`)===0&&(m=p)}),m}e.cleanRemoteAuthority=L;function g(d,m,b=0,p){if(!!d)for(let a of Object.getOwnPropertyNames(d)){const c=d[a],l=p?p+a:a;Array.isArray(c)?m[l]=(0,R.safeStringify)(c):c instanceof Date?m[l]=c.toISOString():(0,D.isObject)(c)?b<2?g(c,m,b+1,l+"."):m[l]=(0,R.safeStringify)(c):m[l]=c}}function E(d){if(!d)return[];const m=[];return w(m,"",d),m}function w(d,m,b){b&&typeof b=="object"&&!Array.isArray(b)?Object.keys(b).forEach(p=>w(d,m?`${m}.${p}`:p,b[p])):d.push(m)}}),define(X[196],Q([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(X[197],Q([0,1,4,2,37,5,196,105]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,v.createDecorator)("themeService");var y;(function(b){function p(a){return a&&typeof a=="object"&&typeof a.id=="string"}b.isThemeColor=p})(y=e.ThemeColor||(e.ThemeColor={}));function i(b){return{id:b}}e.themeColorFromId=i;var L;(function(b){function p(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color=="undefined"||y.isThemeColor(t.color))}b.isThemeIcon=p;const a=new RegExp(`^\\$\\((${n.CSSIcon.iconNameExpression}(?:${n.CSSIcon.iconModifierExpression})?)\\)$`);function c(t){const r=a.exec(t);if(!!r){let[,o]=r;return{id:o}}}b.fromString=c;function l(t,r){let o=t.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),r&&(o=`${o}~${r}`),{id:o}}b.modify=l;function s(t,r){var o,u;return t.id===r.id&&((o=t.color)===null||o===void 0?void 0:o.id)===((u=r.color)===null||u===void 0?void 0:u.id)}b.isEqual=s,b.asClassNameArray=n.CSSIcon.asClassNameArray,b.asClassName=n.CSSIcon.asClassName,b.asCSSSelector=n.CSSIcon.asCSSSelector})(L=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=n.Codicon.file,e.FolderThemeIcon=n.Codicon.folder;function g(b){switch(b){case k.ColorScheme.DARK:return"vs-dark";case k.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=g,e.Extensions={ThemingContribution:"base.contributions.theming"};class E{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new S.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,R.toDisposable)(()=>{const a=this.themingParticipants.indexOf(p);this.themingParticipants.splice(a,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let w=new E;D.Registry.add(e.Extensions.ThemingContribution,w);function d(b){return w.onColorThemeChange(b)}e.registerThemingParticipant=d;class m extends R.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(a=>this.onThemeChange(a)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,a){let c=this.theme.getColor(p);return c&&a&&(c=a(c,this.theme)),c?c.toString():null}}e.Themable=m}),define(X[73],Q([0,1,3,11,38,4]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const k="#FFFFFF",n="#1E1E1E",y="#000000",i="theme",L="themeBackground";e.IThemeMainService=(0,S.createDecorator)("themeMainService");let g=class{constructor(w){this.stateService=w,R.ipcMain.on("vscode:changeColorTheme",(d,m,b)=>{typeof b=="string"&&this.storeBackgroundColor(JSON.parse(b))})}storeBackgroundColor(w){this.stateService.setItem(i,w.baseTheme),this.stateService.setItem(L,w.background)}getBackgroundColor(){if((v.isWindows||v.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme)return y;let w=this.stateService.getItem(L,null);if(!w){let d;(v.isWindows||v.isMacintosh)&&R.nativeTheme.shouldUseInvertedColorScheme?d="hc-black":d=this.stateService.getItem(i,"vs-dark").split(" ")[0],w=d==="hc-black"?y:d==="vs"?k:n}return v.isMacintosh&&w.toUpperCase()===n&&(w="#171717"),w}};g=ce([Z(0,D.IStateService)],g),e.ThemeMainService=g}),define(X[41],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var R;(function(S){S.Uninitialized="uninitialized",S.Idle="idle",S.CheckingForUpdates="checking for updates",S.AvailableForDownload="available for download",S.Downloading="downloading",S.Downloaded="downloaded",S.Updating="updating",S.Ready="ready"})(R=e.StateType||(e.StateType={}));var D;(function(S){S[S.Setup=0]="Setup",S[S.Archive=1]="Archive",S[S.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(S,k)=>({type:"idle",updateType:S,error:k}),CheckingForUpdates:S=>({type:"checking for updates",context:S}),AvailableForDownload:S=>({type:"available for download",update:S}),Downloading:S=>({type:"downloading",update:S}),Downloaded:S=>({type:"downloaded",update:S}),Updating:S=>({type:"updating",update:S}),Ready:S=>({type:"ready",update:S})},e.IUpdateService=(0,v.createDecorator)("updateService")}),define(X[198],Q([0,1,37,48,144,3]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v.Registry.as(R.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,D.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,D.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,D.localize)(2,null),(0,D.localize)(3,null),(0,D.localize)(4,null),(0,D.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,D.localize)(6,null),deprecationMessage:(0,D.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,D.localize)(8,null),description:(0,D.localize)(9,null),included:S.isWindows&&!S.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,D.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[199],Q([0,1,5,41]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(n){this.service=n}listen(n,y){switch(y){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${y}`)}call(n,y,i){switch(y){case"checkForUpdates":return this.service.checkForUpdates(i);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${y}`)}}e.UpdateChannel=D;class S{constructor(n){this.channel=n,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,this._state=R.State.Uninitialized,this.channel.listen("onStateChange")(y=>this.state=y),this.channel.call("_getInitialState").then(y=>this.state=y)}get state(){return this._state}set state(n){this._state=n,this._onStateChange.fire(n)}checkForUpdates(n){return this.channel.call("checkForUpdates",n)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=S}),define(X[96],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,v.createDecorator)("urlService")}),define(X[200],Q([0,1,7]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class R{constructor(n){this.handler=n}listen(n,y){throw new Error(`Event not found: ${y}`)}call(n,y,i){switch(y){case"handleURL":return this.handler.handleURL(v.URI.revive(i[0]),i[1])}throw new Error(`Call not found: ${y}`)}}e.URLHandlerChannel=R;class D{constructor(n){this.channel=n}handleURL(n,y){return this.channel.call("handleURL",[n.toJSON(),y])}}e.URLHandlerChannelClient=D;class S{constructor(n){this.next=n}async routeCall(n,y,i,L){if(y!=="handleURL")throw new Error(`Call not found: ${y}`);if(i){const g=v.URI.revive(i);if(g&&g.query){const E=/\bwindowId=(\d+)/.exec(g.query);if(E){const w=E[1],d=new RegExp(`window:${w}`),m=n.connections.find(b=>d.test(b.ctx));if(m)return m}}}return this.next.routeCall(n,y,i,L)}routeEvent(n,y){throw new Error(`Event not found: ${y}`)}}e.URLHandlerRouter=S}),define(X[201],Q([0,1,7,10,2,17]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class k extends D.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(i,L){const g=[...this.handlers.values()];return(0,R.first)(g.map(E=>()=>E.handleURL(i,L)),void 0,!1).then(E=>E||!1)}registerHandler(i){return this.handlers.add(i),(0,D.toDisposable)(()=>this.handlers.delete(i))}}e.AbstractURLService=k;let n=class extends k{constructor(i){super();this.productService=i}create(i){let{authority:L,path:g,query:E,fragment:w}=i||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return L&&g&&g.indexOf("/")!==0&&(g=`/${g}`),v.URI.from({scheme:this.productService.urlProtocol,authority:L,path:g,query:E,fragment:w})}};n=ce([Z(0,S.IProductService)],n),e.NativeURLService=n}),define(X[202],Q([0,1,5,11,7,2,3,10]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function y(L){try{return D.URI.parse(L)}catch(g){return null}}class i{constructor(g,E,w,d,m){if(this.urlService=E,this.uris=[],this.retryCount=0,this.flushDisposable=S.Disposable.None,this.disposables=new S.DisposableStore,this.uris=g,k.isWindows){const a=d.isBuilt?[]:[`"${d.appRoot}"`];a.push("--open-url","--"),R.app.setAsDefaultProtocolClient(m.urlProtocol,process.execPath,a)}const b=v.Event.map(v.Event.fromNodeEventEmitter(R.app,"open-url",(a,c)=>({event:a,url:c})),({event:a,url:c})=>(a.preventDefault(),c));this.disposables.add(b(a=>{const c=y(a);!c||this.urlService.open(c,{originalUrl:a})})),w.getWindows().filter(a=>a.isReady).length>0?this.flush():v.Event.once(w.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(!(this.retryCount++>10)){const g=[];for(const E of this.uris)await this.urlService.open(E.uri,{originalUrl:E.url})||g.push(E);g.length!==0&&(this.uris=g,this.flushDisposable=(0,n.disposableTimeout)(()=>this.flush(),500))}}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=i}),define(X[203],Q([0,1,108,8]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWebviewContentMimeType=void 0;const D=new Map([[".svg","image/svg+xml"],[".txt","text/plain"],[".css","text/css"],[".js","application/javascript"],[".json","application/json"],[".html","text/html"],[".htm","text/html"],[".xhtml","application/xhtml+xml"],[".oft","font/otf"],[".xml","application/xml"]]);function S(k){const n=(0,R.extname)(k.fsPath).toLowerCase();return D.get(n)||(0,v.getMediaMime)(k.fsPath)||v.MIME_UNKNOWN}e.getWebviewContentMimeType=S}),define(X[74],Q([0,1,30,9,8,7,16,203]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.loadLocalResource=e.readFileStream=e.WebviewFileReadResponse=e.WebviewResourceResponse=e.webviewPartitionId=void 0,e.webviewPartitionId="webview";var y;(function(m){let b;(function(c){c[c.Success=0]="Success",c[c.Failed=1]="Failed",c[c.AccessDenied=2]="AccessDenied",c[c.NotModified=3]="NotModified"})(b=m.Type||(m.Type={}));class p{constructor(l,s,t){this.stream=l,this.etag=s,this.mimeType=t,this.type=b.Success}}m.StreamSuccess=p,m.Failed={type:b.Failed},m.AccessDenied={type:b.AccessDenied};class a{constructor(l){this.mimeType=l,this.type=b.NotModified}}m.NotModified=a})(y=e.WebviewResourceResponse||(e.WebviewResourceResponse={}));var i;(function(m){let b;(function(a){a[a.Success=0]="Success",a[a.NotModified=1]="NotModified"})(b=m.Type||(m.Type={}));class p{constructor(c,l){this.stream=c,this.etag=l,this.type=b.Success}}m.StreamSuccess=p,m.NotModified={type:b.NotModified}})(i=e.WebviewFileReadResponse||(e.WebviewFileReadResponse={}));async function L(m,b,p){try{const a=await m.readFileStream(b,{etag:p});return new i.StreamSuccess(a.value,a.etag)}catch(a){if(a instanceof k.FileOperationError&&a.fileOperationResult===2)return i.NotModified;throw a}}e.readFileStream=L;async function g(m,b,p,a,c,l,s){l.debug(`loadLocalResource - being. requestUri=${m}`);let t=E(m,p.roots);if(l.debug(`loadLocalResource - found resource to load. requestUri=${m}, resourceToLoad=${t}`),!t)return y.AccessDenied;const r=(0,n.getWebviewContentMimeType)(m);if(p.rewriteUri&&(t=p.rewriteUri(t)),t.scheme===R.Schemas.http||t.scheme===R.Schemas.https){const o={};b&&(o["If-None-Match"]=b);const u=await c.request({url:t.toString(!0),headers:o},s);switch(l.debug(`loadLocalResource - Loaded over http(s). requestUri=${m}, response=${u.res.statusCode}`),u.res.statusCode){case 200:return new y.StreamSuccess(u.stream,u.res.headers.etag,r);case 304:return new y.NotModified(r);default:return y.Failed}}try{const o=await a.readFileStream(t,b);switch(l.debug(`loadLocalResource - Loaded using fileReader. requestUri=${m}`),o.type){case i.Type.Success:return new y.StreamSuccess(o.stream,o.etag,r);case i.Type.NotModified:return new y.NotModified(r);default:return l.error("loadLocalResource - Unknown file read response"),y.Failed}}catch(o){return l.debug(`loadLocalResource - Error using fileReader. requestUri=${m}`),console.log(o),y.Failed}}e.loadLocalResource=g;function E(m,b){const p=w(m);for(const a of b)if(d(a,p))return p}function w(m){return m.scheme===R.Schemas.vscodeWebviewResource?S.URI.parse(encodeURIComponent(m.path).replace(/%2F/gi,"/").replace(/^\/([a-z0-9\-]+)(\/{1,2})/i,(p,a,c)=>c.length===1?`${a}:///`:`${a}://`)).with({query:m.query,fragment:m.fragment}):m}function d(m,b){let p=m.fsPath+(m.fsPath.endsWith(D.sep)?"":D.sep),a=b.fsPath;return(0,v.isUNC)(m.fsPath)&&(0,v.isUNC)(b.fsPath)&&(p=p.toLowerCase(),a=a.toLowerCase()),a.startsWith(p)}}),define(X[204],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,v.createDecorator)("webviewManagerService")}),define(X[205],Q([0,1,9,7,55]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingManager=void 0;class S{constructor(n,y,i){this._getExtensionLocation=n,this._getMappings=y,this.tunnelService=i,this._tunnels=new Map}async getRedirect(n,y){const i=R.URI.parse(y),L=(0,D.extractLocalHostUriMetaDataForPortMapping)(i);if(!!L){for(const g of this._getMappings())if(g.webviewPort===L.port){const E=this._getExtensionLocation();if(E&&E.scheme===v.Schemas.vscodeRemote){const w=n&&await this.getOrCreateTunnel(n,g.extensionHostPort);if(w)return w.tunnelLocalPort===g.webviewPort?void 0:encodeURI(i.with({authority:`127.0.0.1:${w.tunnelLocalPort}`}).toString(!0))}if(g.webviewPort!==g.extensionHostPort)return encodeURI(i.with({authority:`${L.address}:${g.extensionHostPort}`}).toString(!0))}}}async dispose(){for(const n of this._tunnels.values())await n.dispose();this._tunnels.clear()}async getOrCreateTunnel(n,y){const i=this._tunnels.get(y);if(i)return i;const L=await this.tunnelService.openTunnel({getAddress:async()=>n},void 0,y);return L&&this._tunnels.set(y,L),L}}e.WebviewPortMappingManager=S}),define(X[206],Q([0,1,11,2,9,7,55,74,205]),function(j,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewPortMappingProvider=void 0;let i=class extends R.Disposable{constructor(g){super();this._tunnelService=g,this._webviewData=new Map,v.session.fromPartition(n.webviewPartitionId).webRequest.onBeforeRequest({urls:["*://localhost:*/*","*://127.0.0.1:*/*","*://0.0.0.0:*/*"]},async(w,d)=>{let m;try{if(w.lastCommittedOrigin)m=S.URI.parse(w.lastCommittedOrigin).authority;else if(typeof w.webContentsId=="number"){const a=v.webContents.fromId(w.webContentsId),c=S.URI.parse(a.getURL());c.scheme===D.Schemas.vscodeWebview&&(m=c.authority)}}catch(a){return d({})}if(!m)return d({});const b=this._webviewData.get(m);if(!b)return d({});const p=await b.manager.getRedirect(b.metadata.resolvedAuthority,w.url);return d(p?{redirectURL:p}:{})})}async registerWebview(g,E){const w=new y.WebviewPortMappingManager(()=>{var d;return(d=this._webviewData.get(g))===null||d===void 0?void 0:d.metadata.extensionLocation},()=>{var d;return((d=this._webviewData.get(g))===null||d===void 0?void 0:d.metadata.mappings)||[]},this._tunnelService);this._webviewData.set(g,{metadata:E,manager:w})}unregisterWebview(g){const E=this._webviewData.get(g);E&&(E.manager.dispose(),this._webviewData.delete(g))}async updateWebviewMetadata(g,E){const w=this._webviewData.get(g);w&&this._webviewData.set(g,Object.assign(Object.assign({},w),E))}};i=ce([Z(0,k.ITunnelService)],i),e.WebviewPortMappingProvider=i}),define(X[61],Q([0,1,3]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(i){return!!i.workspaceUri}e.isWorkspaceToOpen=R;function D(i){return!!i.folderUri}e.isFolderToOpen=D;function S(i){return!!i.fileUri}e.isFileToOpen=S;function k(i){const L=n(i),g=i.getValue("window.menuBarVisibility");return g==="default"||L==="native"&&g==="compact"||v.isMacintosh&&v.isNative?"classic":g}e.getMenuBarVisibility=k;function n(i){if(v.isWeb)return"custom";const L=i.getValue("window");if(L){if(v.isMacintosh&&L.nativeTabs===!0||v.isMacintosh&&L.nativeFullScreen===!1)return"native";const w=L.titleBarStyle;if(w==="native"||w==="custom")return w}return v.isLinux?"native":"custom"}e.getTitleBarStyle=n;function y(i=0){return Math.pow(1.2,i)}e.zoomLevelToZoomFactor=y}),define(X[32],Q([0,1,4]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=void 0;var R;(function(n){n[n.CLI=0]="CLI",n[n.DOCK=1]="DOCK",n[n.MENU=2]="MENU",n[n.DIALOG=3]="DIALOG",n[n.DESKTOP=4]="DESKTOP",n[n.API=5]="API"})(R=e.OpenContext||(e.OpenContext={}));const D=function(n=1){return{width:1024,height:768,mode:n}};e.defaultWindowState=D;var S;(function(n){n[n.Maximized=0]="Maximized",n[n.Normal=1]="Normal",n[n.Minimized=2]="Minimized",n[n.Fullscreen=3]="Fullscreen"})(S=e.WindowMode||(e.WindowMode={}));var k;(function(n){n[n.UNRESPONSIVE=1]="UNRESPONSIVE",n[n.CRASHED=2]="CRASHED",n[n.LOAD=3]="LOAD"})(k=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,v.createDecorator)("windowsMainService")}),define(X[207],Q([0,1,11,239,21,25,2,9,58,7,16,6,40,74,32]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;let m=class wt extends k.Disposable{constructor(p,a,c,l){super();this.fileService=p,this.logService=a,this.requestService=c,this.windowsMainService=l,this.webviewMetadata=new Map,this.requestIdPool=1,this.pendingResourceReads=new Map;const s=v.session.fromPartition(w.webviewPartitionId),t=this.handleWebviewRequest.bind(this);v.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t),s.protocol.registerFileProtocol(n.Schemas.vscodeWebview,t);const r=this.handleWebviewResourceRequest.bind(this);v.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),s.protocol.registerStreamProtocol(n.Schemas.vscodeWebviewResource,r),this._register((0,k.toDisposable)(()=>{v.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),s.protocol.unregisterProtocol(n.Schemas.vscodeWebviewResource),v.protocol.unregisterProtocol(n.Schemas.vscodeWebview),s.protocol.unregisterProtocol(n.Schemas.vscodeWebview)}))}streamToNodeReadable(p){return new class extends R.Readable{constructor(){super(...arguments);this.listening=!1}_read(a){this.listening||(this.listening=!0,(0,y.listenStream)(p,{onData:c=>{try{this.push(c.buffer)||p.pause()}catch(l){this.emit(l)}},onError:c=>{this.emit("error",c)},onEnd:()=>{try{this.push(null)}catch(c){this.emit(c)}}})),p.resume()}_destroy(a,c){p.destroy(),c(null)}}}async registerWebview(p,a){this.webviewMetadata.set(p,a)}unregisterWebview(p){this.webviewMetadata.delete(p)}async updateWebviewMetadata(p,a){const c=this.webviewMetadata.get(p);c&&this.webviewMetadata.set(p,Object.assign(Object.assign({},c),a))}async handleWebviewRequest(p,a){try{const c=i.URI.parse(p.url),l=wt.validWebviewFilePaths.get(c.path);if(typeof l=="string"){const s=c.path.startsWith("/electron-browser")?`vs/workbench/contrib/webview/electron-browser/pre/${l}`:`vs/workbench/contrib/webview/browser/pre/${l}`,t=n.FileAccess.asFileUri(s,j);return a(decodeURIComponent(t.fsPath))}}catch(c){}a({error:-10})}async handleWebviewResourceRequest(p,a){try{const c=i.URI.parse(p.url),l=p.headers["If-None-Match"],s=c.authority,t=this.webviewMetadata.get(s);if(t){let r;t.remoteConnectionData&&(r=h=>{var f;if(t.remoteConnectionData&&(h.scheme===n.Schemas.vscodeRemote||((f=t.extensionLocation)===null||f===void 0?void 0:f.scheme)===n.Schemas.vscodeRemote)){let I=t.remoteConnectionData.host;return I&&I.indexOf(":")!==-1&&(I=`[${I}]`),i.URI.parse(`http://${I}:${t.remoteConnectionData.port}`).with({path:"/vscode-remote-resource",query:`tkn=${t.remoteConnectionData.connectionToken}&path=${encodeURIComponent(h.path)}`})}return h});const o={readFileStream:async(h,f)=>{var I;if(h.scheme===n.Schemas.file)return(0,w.readFileStream)(this.fileService,h,f);const A=this.windowsMainService.getWindowById(t.windowId);if(!A)throw new L.FileOperationError("Could not find window for resource",1);const F=this.requestIdPool++,U=new Promise(Y=>{this.pendingResourceReads.set(F,{resolve:Y})});A.send(`vscode:loadWebviewResource-${s}`,F,c,f);const q=await U;switch(q.response){case"access-denied":throw new L.FileOperationError("Could not read file",6);case"not-found":throw new L.FileOperationError("Could not read file",1);case"not-modified":return w.WebviewFileReadResponse.NotModified;default:return new w.WebviewFileReadResponse.StreamSuccess((0,D.bufferToStream)(q.response),(I=q.responseDetails)===null||I===void 0?void 0:I.etag)}}},u=await(0,w.loadLocalResource)(c,l,{extensionLocation:t.extensionLocation,roots:t.localResourceRoots,remoteConnectionData:t.remoteConnectionData,rewriteUri:r},o,this.requestService,this.logService,S.CancellationToken.None);switch(u.type){case w.WebviewResourceResponse.Type.Success:{const h=u.etag?{ETag:u.etag,"Cache-Control":"no-cache"}:{},f=p.headers["If-None-Match"];return f&&u.etag===f?a({statusCode:304,data:void 0,headers:Object.assign({"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"},h)}):a({statusCode:200,data:this.streamToNodeReadable(u.stream),headers:Object.assign({"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"},h)})}case w.WebviewResourceResponse.Type.NotModified:return a({statusCode:304,data:void 0,headers:{"Content-Type":u.mimeType,"Access-Control-Allow-Origin":"*"}});case w.WebviewResourceResponse.Type.AccessDenied:return console.error("Webview: Cannot load resource outside of protocol root"),a({data:void 0,statusCode:401})}}}catch(c){}return a({data:void 0,statusCode:404})}didLoadResource(p,a,c){const l=this.pendingResourceReads.get(p);if(!l)throw new Error("Unknown request");this.pendingResourceReads.delete(p),l.resolve({response:a,responseDetails:c})}};m.validWebviewFilePaths=new Map([["/index.html","index.html"],["/electron-browser/index.html","index.html"],["/main.js","main.js"],["/host.js","host.js"]]),m=ce([Z(0,L.IFileService),Z(1,g.ILogService),Z(2,E.IRequestService),Z(3,d.IWindowsMainService)],m),e.WebviewProtocolProvider=m}),define(X[208],Q([0,1,11,2,7,16,6,55,40,74,206,207,32]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let w=class extends R.Disposable{constructor(m,b,p,a,c){super();this.windowsMainService=c,this.protocolProvider=this._register(new g.WebviewProtocolProvider(m,b,p,c)),this.portMappingProvider=this._register(new L.WebviewPortMappingProvider(a));const l=v.session.fromPartition(i.webviewPartitionId);l.setPermissionRequestHandler((s,t,r)=>r(t==="clipboard-read")),l.setPermissionCheckHandler((s,t)=>t==="clipboard-read")}async registerWebview(m,b,p){const a=p.extensionLocation?D.URI.from(p.extensionLocation):void 0;this.protocolProvider.registerWebview(m,Object.assign(Object.assign({},p),{windowId:b,extensionLocation:a,localResourceRoots:p.localResourceRoots.map(c=>D.URI.from(c))})),this.portMappingProvider.registerWebview(m,{extensionLocation:a,mappings:p.portMappings,resolvedAuthority:p.remoteConnectionData})}async unregisterWebview(m){this.protocolProvider.unregisterWebview(m),this.portMappingProvider.unregisterWebview(m)}async updateWebviewMetadata(m,b){var p;const a=b.extensionLocation?D.URI.from(b.extensionLocation):void 0;this.protocolProvider.updateWebviewMetadata(m,Object.assign(Object.assign({},b),{extensionLocation:a,localResourceRoots:(p=b.localResourceRoots)===null||p===void 0?void 0:p.map(c=>D.URI.from(c))})),this.portMappingProvider.updateWebviewMetadata(m,Object.assign(Object.assign({},b),{extensionLocation:a}))}async setIgnoreMenuShortcuts(m,b){let p;if(typeof m.windowId=="number"){const{windowId:a}=m,c=this.windowsMainService.getWindowById(a);if(!(c==null?void 0:c.win))throw new Error(`Invalid windowId: ${a}`);p=c.win.webContents}else{const{webContentsId:a}=m;if(p=v.webContents.fromId(a),!p)throw new Error(`Invalid webContentsId: ${a}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(b)}async didLoadResource(m,b,p){this.protocolProvider.didLoadResource(m,b,p)}};w=ce([Z(0,S.IFileService),Z(1,k.ILogService),Z(2,y.IRequestService),Z(3,n.ITunnelService),Z(4,E.IWindowsMainService)],w),e.WebviewMainService=w}),define(X[209],Q([0,1,5,2,10]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class S extends R.Disposable{constructor({onDidOpenWindow:n,onDidFocusWindow:y,getActiveWindowId:i}){super();this.disposables=this._register(new R.DisposableStore),v.Event.latch(v.Event.any(n,y))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>i()),(async()=>{try{const g=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:g}catch(g){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(n){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=n}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=S}),define(X[210],Q([0,1,7,15,4,36]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var k;(function(E){E[E.EMPTY=1]="EMPTY",E[E.FOLDER=2]="FOLDER",E[E.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function n(E){const w=E;return!!(w&&typeof w=="object"&&typeof w.id=="string"&&Array.isArray(w.folders))}e.isWorkspace=n;function y(E){const w=E;return!!(w&&typeof w=="object"&&v.URI.isUri(w.uri)&&typeof w.name=="string"&&typeof w.toResource=="function")}e.isWorkspaceFolder=y;class i{constructor(w,d,m,b){this._id=w,this._configuration=m,this._ignorePathCasing=b,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=d}update(w){this._id=w.id,this._configuration=w.configuration,this._ignorePathCasing=w._ignorePathCasing,this.folders=w.folders}get folders(){return this._folders}set folders(w){this._folders=w,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(w){this._configuration=w}getFolder(w){return w&&this._foldersMap.findSubstr(w.with({scheme:w.scheme,authority:w.authority,path:w.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const w of this.folders)this._foldersMap.set(w.uri,w)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=i;class L{constructor(w,d){this.raw=d,this.uri=w.uri,this.index=w.index,this.name=w.name}toResource(w){return(0,R.joinPath)(this.uri,w)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=L;function g(E){return new L({uri:E,index:0,name:(0,R.basenameOrAuthority)(E)},{uri:E.toString()})}e.toWorkspaceFolder=g}),define(X[29],Q([0,1,4,147,210,7,3,8,15,102,44,9,39,30,71]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const m=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function b(z){return(typeof z=="string"?(0,n.extname)(z):(0,y.extname)(z))===m}e.hasWorkspaceFileExtension=b,e.IWorkspacesService=(0,v.createDecorator)("workspacesService");function p(z){return z.hasOwnProperty("workspace")}e.isRecentWorkspace=p;function a(z){return z.hasOwnProperty("folderUri")}e.isRecentFolder=a;function c(z){return z.hasOwnProperty("fileUri")}e.isRecentFile=c;function l(z){const W=z;return typeof(W==null?void 0:W.id)=="string"&&S.URI.isUri(W.uri)}e.isSingleFolderWorkspaceIdentifier=l;function s(z){if(z.configuration)return{id:z.id,configPath:z.configuration};if(z.folders.length===1)return{id:z.id,uri:z.folders[0].uri}}e.toWorkspaceIdentifier=s;function t(z){const W=z;return typeof(W==null?void 0:W.id)=="string"&&S.URI.isUri(W.configPath)}e.isWorkspaceIdentifier=t;function r(z){const W=z;if(W==null?void 0:W.uri)return{id:W.id,uri:S.URI.revive(W.uri)};const $=z;if($==null?void 0:$.configPath)return{id:$.id,configPath:S.URI.revive($.configPath)};if(z==null?void 0:z.id)return{id:z.id}}e.reviveIdentifier=r;function o(z,W){return y.extUriBiasedIgnorePathCase.isEqualOrParent(z,W.untitledWorkspacesHome)}e.isUntitledWorkspace=o;function u(z){return h(z)||f(z)}e.isStoredWorkspaceFolder=u;function h(z){const W=z;return typeof(W==null?void 0:W.path)=="string"&&(!W.name||typeof W.name=="string")}e.isRawFileWorkspaceFolder=h;function f(z){const W=z;return typeof(W==null?void 0:W.uri)=="string"&&(!W.name||typeof W.name=="string")}e.isRawUriWorkspaceFolder=f;function I(z,W,$,C,P=!k.isWindows,M){if(z.scheme!==C.scheme)return{name:$,uri:z.toString(!0)};let _=W?void 0:M.relativePath(C,z);if(_!==void 0)_.length===0?_=".":k.isWindows&&z.scheme===g.Schemas.file&&!P&&(_=_.replace(/\//g,"\\"));else if(z.scheme===g.Schemas.file)_=z.fsPath,k.isWindows&&(_=(0,E.normalizeDriveLetter)(_),P&&(_=(0,w.toSlashes)(_)));else{if(!M.isEqualAuthority(z.authority,C.authority))return{name:$,uri:z.toString(!0)};_=z.path}return{name:$,path:_}}e.getStoredWorkspaceFolder=I;function A(z,W,$){let C=[],P=new Set;const M=$.dirname(W);for(let _ of z){let T=null;if(h(_))_.path&&(T=$.resolvePath(M,_.path));else if(f(_))try{T=S.URI.parse(_.uri),T.path[0]!=="/"&&(T=T.with({path:"/"+T.path}))}catch(O){console.warn(O)}if(T){let O=$.getComparisonKey(T);if(!P.has(O)){P.add(O);const B=_.name||$.basenameOrAuthority(T);C.push(new D.WorkspaceFolder({uri:T,name:B,index:C.length},_))}}}return C}e.toWorkspaceFolders=A;function F(z,W,$,C,P){let M=U(W,z);const _=P.dirname(W),T=P.dirname(C),O=[],B=q(M.folders);for(const ee of M.folders){const re=h(ee)?P.resolvePath(_,ee.path):S.URI.parse(ee.uri);let x;$?x=!1:x=!h(ee)||(0,n.isAbsolute)(ee.path),O.push(I(re,x,ee.name,T,B,P))}const K={insertSpaces:!1,tabSize:4,eol:k.isLinux||k.isMacintosh?`
`:`\r
`},G=i.setProperty(z,["folders"],O,K);let J=i.applyEdits(z,G);return M.remoteAuthority===(0,d.getRemoteAuthority)(C)&&(J=i.applyEdits(J,i.removeProperty(J,["remoteAuthority"],K))),J}e.rewriteWorkspaceFileForNewLocation=F;function U(z,W){let $=L.parse(W);if($&&Array.isArray($.folders))$.folders=$.folders.filter(C=>u(C));else throw new Error(`${z} looks like an invalid workspace file.`);return $}function q(z){return k.isWindows?z.some(W=>h(W)&&W.path.indexOf("/")>=0):!0}e.useSlashForPath=q;function Y(z){return z.workspace&&typeof z.workspace=="object"&&typeof z.workspace.id=="string"&&typeof z.workspace.configPath=="string"}function ie(z){return typeof z.folderUri=="string"}function ae(z){return typeof z.fileUri=="string"}function V(z,W){const $={workspaces:[],files:[]};if(z){const C=function(M,_){for(let T=0;T<M.length;T++)try{_(M[T],T)}catch(O){W.warn(`Error restoring recent entry ${JSON.stringify(M[T])}: ${O.toString()}. Skip entry.`)}},P=z;if(Array.isArray(P.entries))C(P.entries,M=>{const _=M.label,T=M.remoteAuthority;Y(M)?$.workspaces.push({label:_,remoteAuthority:T,workspace:{id:M.workspace.id,configPath:S.URI.parse(M.workspace.configPath)}}):ie(M)?$.workspaces.push({label:_,remoteAuthority:T,folderUri:S.URI.parse(M.folderUri)}):ae(M)&&$.files.push({label:_,remoteAuthority:T,fileUri:S.URI.parse(M.fileUri)})});else{const M=z;Array.isArray(M.workspaces3)&&C(M.workspaces3,(_,T)=>{const O=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[T]||void 0;typeof _=="object"&&typeof _.id=="string"&&typeof _.configURIPath=="string"?$.workspaces.push({label:O,workspace:{id:_.id,configPath:S.URI.parse(_.configURIPath)}}):typeof _=="string"&&$.workspaces.push({label:O,folderUri:S.URI.parse(_)})}),Array.isArray(M.files2)&&C(M.files2,(_,T)=>{const O=Array.isArray(M.fileLabels)&&M.fileLabels[T]||void 0;typeof _=="string"&&$.files.push({label:O,fileUri:S.URI.parse(_)})})}}return $}e.restoreRecentlyOpened=V;function N(z){const W={entries:[]};for(const $ of z.workspaces)a($)?W.entries.push({folderUri:$.folderUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority}):W.entries.push({workspace:{id:$.workspace.id,configPath:$.workspace.configPath.toString()},label:$.label,remoteAuthority:$.remoteAuthority});for(const $ of z.files)W.entries.push({fileUri:$.fileUri.toString(),label:$.label,remoteAuthority:$.remoteAuthority});return W}e.toStoreData=N}),define(X[49],Q([0,1,4,29]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,v.createDecorator)("backupMainService");function D(S){const k=S;return k&&(0,R.isWorkspaceIdentifier)(k.workspace)}e.isWorkspaceBackupInfo=D}),define(X[50],Q([0,1,4,11,10,38,3,8,64,23,13,131,29,39,2,78]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,v.createDecorator)("dialogMainService");let b=class ct{constructor(a){this.stateService=a,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new D.Queue}pickFileFolder(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)}),c)}pickFolder(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFolders:!0,title:(0,g.localize)(1,null)}),c)}pickFile(a,c){return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:(0,g.localize)(2,null)}),c)}pickWorkspace(a,c){const l=(0,g.localize)(3,null),s=(0,w.mnemonicButtonLabel)((0,g.localize)(4,null)),t=E.WORKSPACE_FILTER;return this.doPick(Object.assign(Object.assign({},a),{pickFiles:!0,title:l,filters:t,buttonLabel:s}),c)}async doPick(a,c){const l={title:a.title,buttonLabel:a.buttonLabel,filters:a.filters};l.defaultPath=a.defaultPath||this.stateService.getItem(ct.workingDirPickerStorageKey),(typeof a.pickFiles=="boolean"||typeof a.pickFolders=="boolean")&&(l.properties=void 0,a.pickFiles&&a.pickFolders&&(l.properties=["multiSelections","openDirectory","openFile","createDirectory"])),l.properties||(l.properties=["multiSelections",a.pickFolders?"openDirectory":"openFile","createDirectory"]),k.isMacintosh&&l.properties.push("treatPackageAsDirectory");const s=c||R.BrowserWindow.getFocusedWindow(),t=await this.showOpenDialog(l,(0,L.withNullAsUndefined)(s));if(t&&t.filePaths&&t.filePaths.length>0)return this.stateService.setItem(ct.workingDirPickerStorageKey,(0,n.dirname)(t.filePaths[0])),t.filePaths}getWindowDialogQueue(a){if(a){let c=this.windowDialogQueues.get(a.id);return c||(c=new D.Queue,this.windowDialogQueues.set(a.id,c)),c}else return this.noWindowDialogueQueue}showMessageBox(a,c){return this.getWindowDialogQueue(c).queue(async()=>c?R.dialog.showMessageBox(c,a):R.dialog.showMessageBox(a))}async showSaveDialog(a,c){const l=this.acquireFileDialogLock(a,c);if(!l)throw new Error("A file save dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showSaveDialog(c,a):s=await R.dialog.showSaveDialog(a),s.filePath=this.normalizePath(s.filePath),s})}finally{(0,d.dispose)(l)}}normalizePath(a){return a&&k.isMacintosh&&(a=(0,y.normalizeNFC)(a)),a}normalizePaths(a){return a.map(c=>this.normalizePath(c))}async showOpenDialog(a,c){a.defaultPath&&(await(0,i.exists)(a.defaultPath)||(a.defaultPath=void 0));const l=this.acquireFileDialogLock(a,c);if(!l)throw new Error("A file open dialog is already or will be showing for the window with the same configuration");try{return await this.getWindowDialogQueue(c).queue(async()=>{let s;return c?s=await R.dialog.showOpenDialog(c,a):s=await R.dialog.showOpenDialog(a),s.filePaths=this.normalizePaths(s.filePaths),s})}finally{(0,d.dispose)(l)}}acquireFileDialogLock(a,c){if(!c)return d.Disposable.None;let l=this.windowFileDialogLocks.get(c.id);l||(l=new Set,this.windowFileDialogLocks.set(c.id,l));const s=(0,m.hash)(a);if(!l.has(s))return l.add(s),(0,d.toDisposable)(()=>{l==null||l.delete(s),(l==null?void 0:l.size)===0&&this.windowFileDialogLocks.delete(c.id)})}};b.workingDirPickerStorageKey="pickerWorkingDir",b=ce([Z(0,S.IStateService)],b),e.DialogMainService=b}),define(X[211],Q([0,1,5,2,29]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class S extends R.Disposable{constructor(n,y){super();this.logService=n,this.storageMainService=y,this._onDidChangeGlobalStorage=this._register(new v.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(v.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(n,y)=>(n?n.push(y):n=[y],n),S.STORAGE_CHANGE_DEBOUNCE_TIME)(n=>{n.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(n))}))}serializeGlobalStorageEvents(n){const y=new Map,i=new Set;return n.forEach(L=>{const g=this.storageMainService.globalStorage.get(L.key);typeof g=="string"?y.set(L.key,g):i.add(L.key)}),{changed:Array.from(y.entries()),deleted:Array.from(i.values())}}listen(n,y){switch(y){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${y}`)}async call(n,y,i){const L=(0,D.reviveIdentifier)(i.workspace),g=await this.withStorageInitialized(L);switch(y){case"getItems":return Array.from(g.items.entries());case"updateItems":{const E=i;if(E.insert)for(const[w,d]of E.insert)g.set(w,d);E.delete&&E.delete.forEach(w=>g.delete(w));break}case"close":{if(L)return g.close();break}default:throw new Error(`Call not found: ${y}`)}}async withStorageInitialized(n){const y=n?this.storageMainService.workspaceStorage(n):this.storageMainService.globalStorage;try{await y.init()}catch(i){this.logService.error(`StorageIPC#init: Unable to init ${n?"workspace":"global"} storage due to ${i}`)}return y}}e.StorageDatabaseChannel=S,S.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[212],Q([0,1,22,23,5,2,6,121,84,8,94,31,28,29]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class d extends S.Disposable{constructor(a){super();this.logService=a,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new y.Storage(new y.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const a=await this.doCreate();this.storage.dispose(),this.storage=a,this._register(a.onDidChangeStorage(l=>this._onDidChangeStorage.fire({key:l}))),await this.doInit(a);const c=a.getBoolean(L.IS_NEW_KEY);c===void 0?a.set(L.IS_NEW_KEY,!0):c&&a.set(L.IS_NEW_KEY,!1)}catch(a){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${a}`)}})()),this.initializePromise}createLogginOptions(){return{logTrace:this.logService.getLevel()===k.LogLevel.Trace?a=>this.logService.trace(a):void 0,logError:a=>this.logService.error(a)}}doInit(a){return a.init()}get items(){return this.storage.items}get(a,c){return this.storage.get(a,c)}set(a,c){return this.storage.set(a,c)}delete(a){return this.storage.delete(a)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class m extends d{constructor(a,c,l){super(c);this.options=a,this.environmentService=l}async doCreate(){let a;return this.options.useInMemoryStorage?a=n.SQLiteStorageDatabase.IN_MEMORY_PATH:a=(0,i.join)(this.environmentService.globalStorageHome.fsPath,m.STORAGE_NAME),new y.Storage(new n.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}))}async doInit(a){await super.doInit(a),this.updateTelemetryState(a)}updateTelemetryState(a){a.get(g.instanceStorageKey,void 0)===void 0&&a.set(g.instanceStorageKey,(0,E.generateUuid)()),a.get(g.firstSessionDateStorageKey,void 0)===void 0&&a.set(g.firstSessionDateStorageKey,new Date().toUTCString());const s=a.get(g.currentSessionDateStorageKey,void 0),t=new Date().toUTCString();a.set(g.lastSessionDateStorageKey,typeof s=="undefined"?null:s),a.set(g.currentSessionDateStorageKey,t)}}e.GlobalStorageMain=m,m.STORAGE_NAME="state.vscdb";class b extends d{constructor(a,c,l,s){super(l);this.workspace=a,this.options=c,this.environmentService=s}async doCreate(){const{storageFilePath:a,wasCreated:c}=await this.prepareWorkspaceStorageFolder();return new y.Storage(new n.SQLiteStorageDatabase(a,{logging:this.createLogginOptions()}),{hint:c?y.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:n.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,i.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),c=(0,i.join)(a,b.WORKSPACE_STORAGE_NAME);return await(0,R.exists)(a)?{storageFilePath:c,wasCreated:!1}:(await v.promises.mkdir(a,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(a),{storageFilePath:c,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(a){let c;if((0,w.isSingleFolderWorkspaceIdentifier)(this.workspace)?c={folder:this.workspace.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.workspace)&&(c={workspace:this.workspace.configPath.toString()}),c)try{const l=(0,i.join)(a,b.WORKSPACE_META_NAME);await(0,R.exists)(l)||await(0,R.writeFile)(l,JSON.stringify(c,void 0,2))}catch(l){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${l}`)}}}e.WorkspaceStorageMain=b,b.WORKSPACE_STORAGE_NAME="state.vscdb",b.WORKSPACE_META_NAME="workspace.json"}),define(X[97],Q([0,1,43,2,47,4,18,6,212]),function(j,e,v,R,D,S,k,n,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,S.createDecorator)("storageMainService");let i=class extends R.Disposable{constructor(g,E,w){super();this.logService=g,this.environmentService=E,this.lifecycleMainService=w,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async g=>{g.workspace&&this.workspaceStorage(g.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(g=>{g.join(this.globalStorage.close());for(const[,E]of this.mapWorkspaceToStorage)g.join(E.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const g=new y.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,v.once)(g.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),g}createWorkspaceStorage(g){return new y.WorkspaceStorageMain(g,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(g){let E=this.mapWorkspaceToStorage.get(g.id);return E||(this.logService.trace(`StorageMainService: creating workspace storage (${g.id})`),E=this.createWorkspaceStorage(g),this.mapWorkspaceToStorage.set(g.id,E),(0,v.once)(E.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${g.id})`),this.mapWorkspaceToStorage.delete(g.id)})),E}};i=ce([Z(0,n.ILogService),Z(1,D.IEnvironmentService),Z(2,k.ILifecycleMainService)],i),e.StorageMainService=i}),define(X[98],Q([0,1,7,29,15]),function(j,e,v,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function S(y,i,L){for(const E of y){const w=E.openedWorkspace;if((0,R.isWorkspaceIdentifier)(w)){const d=L(w);if(d){if(d.folders.some(m=>D.extUriBiasedIgnorePathCase.isEqualOrParent(i,m.uri)))return E}else if(D.extUriBiasedIgnorePathCase.isEqualOrParent(i,w.configPath))return E}}const g=y.filter(E=>(0,R.isSingleFolderWorkspaceIdentifier)(E.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqualOrParent(i,E.openedWorkspace.uri));if(g.length)return g.sort((E,w)=>-(E.openedWorkspace.uri.path.length-w.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=S;function k(y,i){for(const L of y)if((0,R.isWorkspaceIdentifier)(L.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.configPath,i)||(0,R.isSingleFolderWorkspaceIdentifier)(L.openedWorkspace)&&D.extUriBiasedIgnorePathCase.isEqual(L.openedWorkspace.uri,i))return L}e.findWindowOnWorkspaceOrFolder=k;function n(y,i){var L,g;const E=w=>i.some(d=>D.extUriBiasedIgnorePathCase.isEqual(v.URI.file(d),v.URI.file(w)));for(const w of y)if((g=(L=w.config)===null||L===void 0?void 0:L.extensionDevelopmentPath)===null||g===void 0?void 0:g.some(d=>E(d)))return w}e.findWindowOnExtensionDevelopmentPath=n}),define(X[213],Q([0,1,11,2,3,15,7,24,18,6,38,32,29]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let w=class ut extends R.Disposable{constructor(c,l,s,t,r){super();this.windowsMainService=c,this.stateService=l,this.lifecycleMainService=s,this.logService=t,this.configurationService=r,this._state=d(this.stateService.getItem(ut.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){v.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(c=>this.onBeforeCloseWindow(c)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(c=>this.onBeforeCloseWindow(c))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const c={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!c.lastActiveWindow){let t=this.windowsMainService.getLastActiveWindow();(!t||t.isExtensionDevelopmentHost)&&(t=this.windowsMainService.getWindows().find(r=>!r.isExtensionDevelopmentHost)),t&&(c.lastActiveWindow=this.toWindowState(t))}const l=this.windowsMainService.getWindows().find(t=>t.isExtensionDevelopmentHost&&!t.isExtensionTestHost);l&&(c.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(c.openedWindows=this.windowsMainService.getWindows().filter(t=>!t.isExtensionDevelopmentHost).map(t=>this.toWindowState(t)));const s=b(c);this.stateService.setItem(ut.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(c){if(!this.lifecycleMainService.quitRequested){const l=this.toWindowState(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this._state.openedWindows.forEach(s=>{var t;const r=(0,E.isWorkspaceIdentifier)(c.openedWorkspace)&&((t=s.workspace)===null||t===void 0?void 0:t.id)===c.openedWorkspace.id,o=(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)&&s.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(s.folderUri,c.openedWorkspace.uri);(r||o)&&(s.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}}toWindowState(c){return{workspace:(0,E.isWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,E.isSingleFolderWorkspaceIdentifier)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const l=this.doGetNewWindowState(c),s=this.configurationService.getValue("window");let t;return l.hasDefaultState?t=!!((s==null?void 0:s.newWindowDimensions)&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(t=!!(this.lifecycleMainService.wasRestarted||(s==null?void 0:s.restoreFullscreen)),t&&D.isMacintosh&&this.windowsMainService.getWindows().some(r=>r.isFullScreen)&&(t=!1)),l.mode===3&&!t&&(l.mode=1),l}doGetNewWindowState(c){const l=this.windowsMainService.getLastActiveWindow();if(!c.extensionTestsPath){if(!!c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const h=c.workspace;if((0,E.isWorkspaceIdentifier)(h)){const I=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===h.id).map(A=>A.uiState);if(I.length)return I[0]}if((0,E.isSingleFolderWorkspaceIdentifier)(h)){const I=this.state.openedWindows.filter(A=>A.folderUri&&S.extUriBiasedIgnorePathCase.isEqual(A.folderUri,h.uri)).map(A=>A.uiState);if(I.length)return I[0]}else if(c.backupPath){const I=this.state.openedWindows.filter(A=>A.backupPath===c.backupPath).map(A=>A.uiState);if(I.length)return I[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let s;const t=v.screen.getAllDisplays();if(t.length===1)s=t[0];else{if(D.isMacintosh){const h=v.screen.getCursorScreenPoint();s=v.screen.getDisplayNearestPoint(h)}!s&&l&&(s=v.screen.getDisplayMatching(l.getBounds())),s||(s=v.screen.getPrimaryDisplay()||t[0])}let r=(0,g.defaultWindowState)();r.x=Math.round(s.bounds.x+s.bounds.width/2-r.width/2),r.y=Math.round(s.bounds.y+s.bounds.height/2-r.height/2);const o=this.configurationService.getValue("window");let u=!0;if(o==null?void 0:o.newWindowDimensions){if(o.newWindowDimensions==="maximized")r.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")r.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&l){const h=l.serializeWindowState();h.mode===3?r.mode=3:r=h,u=r.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(r=this.ensureNoOverlap(r)),r.hasDefaultState=!0,r}ensureNoOverlap(c){if(this.windowsMainService.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const l=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;l.some(s=>s.x===c.x||s.y===c.y);)c.x+=30,c.y+=30;return c}};w.windowsStateStorageKey="windowsState",w=ce([Z(0,g.IWindowsMainService),Z(1,L.IStateService),Z(2,y.ILifecycleMainService),Z(3,i.ILogService),Z(4,n.IConfigurationService)],w),e.WindowsStateHandler=w;function d(a){const c={openedWindows:[]},l=a||{openedWindows:[]};return l.lastActiveWindow&&(c.lastActiveWindow=m(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=m(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(c.openedWindows=l.openedWindows.map(s=>m(s))),c}e.restoreWindowsState=d;function m(a){const c={uiState:a.uiState};return a.backupPath&&(c.backupPath=a.backupPath),a.remoteAuthority&&(c.remoteAuthority=a.remoteAuthority),a.folder&&(c.folderUri=k.URI.parse(a.folder)),a.workspaceIdentifier&&(c.workspace={id:a.workspaceIdentifier.id,configPath:k.URI.parse(a.workspaceIdentifier.configURIPath)}),c}function b(a){return{lastActiveWindow:a.lastActiveWindow&&p(a.lastActiveWindow),lastPluginDevelopmentHostWindow:a.lastPluginDevelopmentHostWindow&&p(a.lastPluginDevelopmentHostWindow),openedWindows:a.openedWindows.map(c=>p(c))}}e.getWindowsStateStoreData=b;function p(a){return{workspaceIdentifier:a.workspace&&{id:a.workspace.id,configURIPath:a.workspace.configPath.toString()},folder:a.folderUri&&a.folderUri.toString(),backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.uiState}}}),define(X[56],Q([0,1,59,60,214,5,33,8,27,28,2,21,82,19,3]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class m{constructor(I){this.socket=I,this._errorListener=A=>{if(A){if(A.code==="EPIPE")return;(0,w.onUnexpectedError)(A)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(I){const A=F=>I(g.VSBuffer.wrap(F));return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(I){return this.socket.on("close",I),{dispose:()=>this.socket.off("close",I)}}onEnd(I){return this.socket.on("end",I),{dispose:()=>this.socket.off("end",I)}}write(I){if(!this.socket.destroyed)try{this.socket.write(I.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,w.onUnexpectedError)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,w.onUnexpectedError)(A)}}end(){this.socket.end()}drain(){return new Promise((I,A)=>{if(this.socket.bufferSize===0){I();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),I()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.NodeSocket=m;var b;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(b||(b={}));var p;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(p||(p={}));class a extends L.Disposable{constructor(I,A,F,U){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=I,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=A,this._recordInflateBytes=U,A?(this._zlibInflate=D.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",q=>{console.error(q),(0,w.onUnexpectedError)(q),this._onClose.fire()}),this._zlibInflate.on("data",q=>{this._pendingInflateData.push(q)}),F&&(this._zlibInflate.write(F.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=D.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",q=>{console.error(q),(0,w.onUnexpectedError)(q),this._onClose.fire()}),this._zlibDeflate.on("data",q=>{this._pendingDeflateData.push(q)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new E.ChunkStream,this._register(this.socket.onData(q=>this._acceptChunk(q))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?g.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):g.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this._onData.event(I)}onClose(I){return this._onClose.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){this._totalOutgoingDataBytes+=I.byteLength,this._zlibDeflate?(this._zlibDeflate.write(I.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let A=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,A=A.slice(0,A.length-4),this._isEnded||this._write(g.VSBuffer.wrap(A),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(I,!1)}_write(I,A){let F=2;I.byteLength<126?F+=0:I.byteLength<2**16?F+=2:F+=8;const U=g.VSBuffer.alloc(F);if(A?U.writeUInt8(194,0):U.writeUInt8(130,0),I.byteLength<126)U.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){U.writeUInt8(126,1);let q=1;U.writeUInt8(I.byteLength>>>8&255,++q),U.writeUInt8(I.byteLength>>>0&255,++q)}else{U.writeUInt8(127,1);let q=1;U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(0,++q),U.writeUInt8(I.byteLength>>>24&255,++q),U.writeUInt8(I.byteLength>>>16&255,++q),U.writeUInt8(I.byteLength>>>8&255,++q),U.writeUInt8(I.byteLength>>>0&255,++q)}this._totalOutgoingWireBytes+=U.byteLength+I.byteLength,this.socket.write(g.VSBuffer.concat([U,I]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(I){if(I.byteLength!==0){for(this._totalIncomingWireBytes+=I.byteLength,this._incomingData.acceptChunk(I);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const A=this._incomingData.peek(this._state.readLen),U=(A.readUInt8(0)&128)>>>7,q=A.readUInt8(1),Y=(q&128)>>>7,ie=q&127;this._state.state=2,this._state.readLen=2+(Y?4:0)+(ie===126?2:0)+(ie===127?8:0),this._state.fin=U,this._state.mask=0}else if(this._state.state===2){const A=this._incomingData.read(this._state.readLen),F=A.readUInt8(1),U=(F&128)>>>7;let q=F&127,Y=1;q===126?q=A.readUInt8(++Y)*2**8+A.readUInt8(++Y):q===127&&(q=A.readUInt8(++Y)*0+A.readUInt8(++Y)*0+A.readUInt8(++Y)*0+A.readUInt8(++Y)*0+A.readUInt8(++Y)*2**24+A.readUInt8(++Y)*2**16+A.readUInt8(++Y)*2**8+A.readUInt8(++Y));let ie=0;U&&(ie=A.readUInt8(++Y)*2**24+A.readUInt8(++Y)*2**16+A.readUInt8(++Y)*2**8+A.readUInt8(++Y)),this._state.state=3,this._state.readLen=q,this._state.mask=ie}else if(this._state.state===3){const A=this._incomingData.read(this._state.readLen);c(A,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(A.buffer)),this._zlibInflate.write(A.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const F=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=F.length,this._onData.fire(g.VSBuffer.wrap(F))})):(this._totalIncomingDataBytes+=A.byteLength,this._onData.fire(A))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=a;function c(f,I){if(I!==0){let A=f.byteLength>>>2;for(let ae=0;ae<A;ae++){const V=f.readUInt32BE(ae*4);f.writeUInt32BE(V^I,ae*4)}let F=A*4,U=f.byteLength-F;const q=I>>>24&255,Y=I>>>16&255,ie=I>>>8&255;U>=1&&f.writeUInt8(f.readUInt8(F)^q,F),U>=2&&f.writeUInt8(f.readUInt8(F+1)^Y,F+1),U>=3&&f.writeUInt8(f.readUInt8(F+2)^ie,F+2)}}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function s(){const f=(0,i.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let I;return e.XDG_RUNTIME_DIR?I=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):I=(0,n.join)((0,y.tmpdir)(),`vscode-ipc-${f}.sock`),r(I),I}e.createRandomIPCHandle=s;function t(f,I,A){const F=(0,v.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${A}-${I}-sock`;let U;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,n.join)(e.XDG_RUNTIME_DIR,`vscode-${F.substr(0,8)}-${A}-${I}.sock`):U=(0,n.join)(f,`${A}-${I}.sock`),r(U),U}e.createStaticIPCHandle=t;function r(f){const I=l[d.platform];typeof I=="number"&&f.length>=I&&console.warn(`WARNING: IPC handle "${f}" is longer than ${I} chars, try a shorter --user-data-dir`)}class o extends k.IPCServer{constructor(I){super(o.toClientConnectionEvent(I));this.server=I}static toClientConnectionEvent(I){const A=S.Event.fromNodeEventEmitter(I,"connection");return S.Event.map(A,F=>({protocol:new E.Protocol(new m(F)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(F,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=o;function u(f){return new Promise((I,A)=>{const F=(0,R.createServer)();F.on("error",A),F.listen(f,()=>{F.removeListener("error",A),I(new o(F))})})}e.serve=u;function h(f,I){return new Promise((A,F)=>{const U=(0,R.createConnection)(f,()=>{U.removeListener("error",F),A(E.Client.fromSocket(new m(U),I))});U.once("error",F)})}e.connect=h}),define(X[215],Q([0,1,56]),function(j,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverChannelClient=e.WindowDriverChannel=e.WindowDriverRegistryChannelClient=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class R{constructor(g){this.driver=g}listen(g,E){throw new Error("No event found")}call(g,E,w){switch(E){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(w);case"reloadWindow":return this.driver.reloadWindow(w);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(w[0],w[1]);case"click":return this.driver.click(w[0],w[1],w[2],w[3]);case"doubleClick":return this.driver.doubleClick(w[0],w[1]);case"setValue":return this.driver.setValue(w[0],w[1],w[2]);case"getTitle":return this.driver.getTitle(w[0]);case"isActiveElement":return this.driver.isActiveElement(w[0],w[1]);case"getElements":return this.driver.getElements(w[0],w[1],w[2]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1],w[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w[0],w[1]);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1],w[2])}throw new Error(`Call not found: ${E}`)}}e.DriverChannel=R;class D{constructor(g){this.channel=g}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(g){return this.channel.call("capturePage",g)}reloadWindow(g){return this.channel.call("reloadWindow",g)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(g,E){return this.channel.call("dispatchKeybinding",[g,E])}click(g,E,w,d){return this.channel.call("click",[g,E,w,d])}doubleClick(g,E){return this.channel.call("doubleClick",[g,E])}setValue(g,E,w){return this.channel.call("setValue",[g,E,w])}getTitle(g){return this.channel.call("getTitle",[g])}isActiveElement(g,E){return this.channel.call("isActiveElement",[g,E])}getElements(g,E,w){return this.channel.call("getElements",[g,E,w])}getElementXY(g,E,w,d){return this.channel.call("getElementXY",[g,E,w,d])}typeInEditor(g,E,w){return this.channel.call("typeInEditor",[g,E,w])}getTerminalBuffer(g,E){return this.channel.call("getTerminalBuffer",[g,E])}writeInTerminal(g,E,w){return this.channel.call("writeInTerminal",[g,E,w])}}e.DriverChannelClient=D;class S{constructor(g){this.registry=g}listen(g,E){throw new Error(`Event not found: ${E}`)}call(g,E,w){switch(E){case"registerWindowDriver":return this.registry.registerWindowDriver(w);case"reloadWindowDriver":return this.registry.reloadWindowDriver(w)}throw new Error(`Call not found: ${E}`)}}e.WindowDriverRegistryChannel=S;class k{constructor(g){this.channel=g}registerWindowDriver(g){return this.channel.call("registerWindowDriver",g)}reloadWindowDriver(g){return this.channel.call("reloadWindowDriver",g)}}e.WindowDriverRegistryChannelClient=k;class n{constructor(g){this.driver=g}listen(g,E){throw new Error(`No event found: ${E}`)}call(g,E,w){switch(E){case"click":return this.driver.click(w[0],w[1],w[2]);case"doubleClick":return this.driver.doubleClick(w);case"setValue":return this.driver.setValue(w[0],w[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(w);case"getElements":return this.driver.getElements(w[0],w[1]);case"getElementXY":return this.driver.getElementXY(w[0],w[1],w[2]);case"typeInEditor":return this.driver.typeInEditor(w[0],w[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(w);case"writeInTerminal":return this.driver.writeInTerminal(w[0],w[1])}throw new Error(`Call not found: ${E}`)}}e.WindowDriverChannel=n;class y{constructor(g){this.channel=g}click(g,E,w){return this.channel.call("click",[g,E,w])}doubleClick(g){return this.channel.call("doubleClick",g)}setValue(g,E){return this.channel.call("setValue",[g,E])}getTitle(){return this.channel.call("getTitle")}isActiveElement(g){return this.channel.call("isActiveElement",g)}getElements(g,E){return this.channel.call("getElements",[g,E])}getElementXY(g,E,w){return this.channel.call("getElementXY",[g,E,w])}typeInEditor(g,E){return this.channel.call("typeInEditor",[g,E])}getTerminalBuffer(g){return this.channel.call("getTerminalBuffer",g)}writeInTerminal(g,E){return this.channel.call("writeInTerminal",[g,E])}}e.WindowDriverChannelClient=y;async function i(L){const g=await(0,v.connect)(L,"driverClient"),E=g.getChannel("driver"),w=new D(E);return{client:g,driver:w}}e.connect=i}),define(X[26],Q([0,1,8,52,4,47,154,56]),function(j,e,v,R,D,S,k,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,D.refineServiceDecorator)(S.IEnvironmentService);class y extends k.NativeEnvironmentService{get cachedLanguagesPath(){return(0,v.join)(this.userDataPath,"clp")}get backupHome(){return(0,v.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,v.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,n.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get nodeCachedDataDir(){return process.env.VSCODE_NODE_CACHED_DATA_DIR||void 0}}ce([R.memoize],y.prototype,"cachedLanguagesPath",null),ce([R.memoize],y.prototype,"backupHome",null),ce([R.memoize],y.prototype,"backupWorkspacesPath",null),ce([R.memoize],y.prototype,"mainIPCHandle",null),ce([R.memoize],y.prototype,"sandbox",null),ce([R.memoize],y.prototype,"driverVerbose",null),ce([R.memoize],y.prototype,"disableUpdates",null),ce([R.memoize],y.prototype,"disableKeytar",null),ce([R.memoize],y.prototype,"nodeCachedDataDir",null),e.EnvironmentMainService=y}),define(X[216],Q([0,1,22,59,8,3,23,49,26,24,16,6,29,7,30,9,15]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let p=class{constructor(c,l,s){this.configurationService=l,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=b.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(t,r)=>(0,d.isEqual)(t,r,!S.isLinux)},this.backupHome=c.backupHome,this.workspacesJsonPath=c.backupWorkspacesPath}async initialize(){let c;try{c=JSON.parse(await v.promises.readFile(this.workspacesJsonPath,"utf8"))}catch(t){c=Object.create(null)}c.emptyWorkspaceInfos&&(this.emptyWindows=await this.validateEmptyWorkspaces(c.emptyWorkspaceInfos));let l=[];try{Array.isArray(c.rootURIWorkspaces)&&(l=c.rootURIWorkspaces.map(t=>({workspace:{id:t.id,configPath:w.URI.parse(t.configURIPath)},remoteAuthority:t.remoteAuthority})))}catch(t){}this.workspaces=await this.validateWorkspaces(l);let s=[];try{Array.isArray(c.folderURIWorkspaces)&&(s=c.folderURIWorkspaces.map(t=>w.URI.parse(t)))}catch(t){}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==L.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===L.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){var c;const l=this.configurationService.getValue();return((c=l==null?void 0:l.files)===null||c===void 0?void 0:c.hotExit)||L.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(c,l){this.workspaces.some(t=>c.workspace.id===t.workspace.id)||(this.workspaces.push(c),this.saveSync());const s=this.getBackupPath(c.workspace.id);return l&&this.moveBackupFolderSync(s,l),s}moveBackupFolderSync(c,l){if(v.existsSync(c)&&this.convertToEmptyWindowBackupSync(c),v.existsSync(l))try{v.renameSync(l,c)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(c){const l=c.id,s=this.workspaces.findIndex(t=>t.workspace.id===l);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(c){return this.folders.some(l=>this.backupUriComparer.isEqual(c,l))||(this.folders.push(c),this.saveSync()),this.getBackupPath(this.getFolderHash(c))}unregisterFolderBackupSync(c){const l=this.folders.findIndex(s=>this.backupUriComparer.isEqual(c,s));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(c,l){const s=c||this.getRandomEmptyWindowId();return this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:l}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(c){const l=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,c));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(c){return(0,D.join)(this.backupHome,c)}async validateWorkspaces(c){if(!Array.isArray(c))return[];const l=new Set,s=[];for(let t of c){const r=t.workspace;if(!(0,E.isWorkspaceIdentifier)(r))return[];if(!l.has(r.id)){l.add(r.id);const o=this.getBackupPath(r.id);await this.doHasBackups(o)?r.configPath.scheme!==m.Schemas.file||await(0,k.exists)(r.configPath.fsPath)?s.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return s}async validateFolders(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const r=this.backupUriComparer.getComparisonKey(t);if(!s.has(r)){s.add(r);const o=this.getBackupPath(this.getFolderHash(t));await this.doHasBackups(o)?t.scheme!==m.Schemas.file||await(0,k.exists)(t.fsPath)?l.push(t):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(c){if(!Array.isArray(c))return[];const l=[],s=new Set;for(let t of c){const r=t.backupFolder;if(typeof r!="string")return[];if(!s.has(r)){s.add(r);const o=this.getBackupPath(r);await this.doHasBackups(o)?l.push(t):await this.deleteStaleBackup(o)}}return l}async deleteStaleBackup(c){try{await(0,k.exists)(c)&&await(0,k.rimraf)(c,k.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{await v.promises.rename(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(c){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(t=>!!t.backupFolder&&this.backupPathComparer.isEqual(t.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{v.renameSync(c,s)}catch(t){return this.logService.error(`Backup: Could not rename backup folder: ${t.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const c=[];for(const l of this.workspaces)await this.hasBackups(l)&&c.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&c.push(l);return c}hasBackups(c){let l;return w.URI.isUri(c)?l=this.getBackupPath(this.getFolderHash(c)):(0,n.isWorkspaceBackupInfo)(c)?l=this.getBackupPath(c.workspace.id):l=c.backupFolder,this.doHasBackups(l)}async doHasBackups(c){try{const l=await(0,k.readdir)(c);for(const s of l)try{if((await(0,k.readdir)((0,D.join)(c,s))).length>0)return!0}catch(t){}}catch(l){}return!1}saveSync(){try{(0,k.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}async save(){try{await(0,k.writeFile)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(c){this.logService.error(`Backup: Could not save workspaces.json: ${c.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(c=>({id:c.workspace.id,configURIPath:c.workspace.configPath.toString(),remoteAuthority:c.remoteAuthority})),folderURIWorkspaces:this.folders.map(c=>c.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(c){let l;return c.scheme===m.Schemas.file?l=S.isLinux?c.fsPath:c.fsPath.toLowerCase():l=c.toString().toLowerCase(),(0,R.createHash)("md5").update(l).digest("hex")}};p=ce([Z(0,y.IEnvironmentMainService),Z(1,i.IConfigurationService),Z(2,g.ILogService)],p),e.BackupMainService=p}),define(X[42],Q([0,1,5,32,11,18,3,26,50,23,7,31,4,27,65,6,8,17,52,2]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,E.createDecorator)("nativeHostMainService");let l=class rt extends c.Disposable{constructor(t,r,o,u,h,f,I,A){super();this.sharedProcess=t,this.windowsMainService=r,this.dialogMainService=o,this.lifecycleMainService=u,this.environmentMainService=h,this.telemetryService=f,this.logService=I,this.productService=A,this.onDidOpenWindow=v.Event.map(this.windowsMainService.onDidOpenWindow,F=>F.id),this.onDidMaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-maximize",(F,U)=>U.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidUnmaximizeWindow=v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-unmaximize",(F,U)=>U.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidBlurWindow=v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-blur",(F,U)=>U.id),F=>!!this.windowsMainService.getWindowById(F)),this.onDidFocusWindow=v.Event.any(v.Event.map(v.Event.filter(v.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),F=>!!F),F=>F.id),v.Event.filter(v.Event.fromNodeEventEmitter(D.app,"browser-window-focus",(F,U)=>U.id),F=>!!this.windowsMainService.getWindowById(F))),this.onDidResumeOS=v.Event.fromNodeEventEmitter(D.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new v.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new v.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=v.Event.debounce(v.Event.any(v.Event.filter(v.Event.fromNodeEventEmitter(D.screen,"display-metrics-changed",(F,U,q)=>q),F=>!(Array.isArray(F)&&F.length===1&&F[0]==="workArea")),v.Event.fromNodeEventEmitter(D.screen,"display-added"),v.Event.fromNodeEventEmitter(D.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){D.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire({highContrast:D.nativeTheme.shouldUseInvertedColorScheme||D.nativeTheme.shouldUseHighContrastColors,dark:D.nativeTheme.shouldUseDarkColors})})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(r=>{var o,u;return{id:r.id,workspace:r.openedWorkspace,title:(u=(o=r.win)===null||o===void 0?void 0:o.getTitle())!==null&&u!==void 0?u:"",filename:r.getRepresentedFilename(),dirty:r.isDocumentEdited()}})}async getWindowCount(t){return this.windowsMainService.getWindowCount()}async getActiveWindowId(t){const r=D.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(r)return r.id}openWindow(t,r,o){return Array.isArray(r)?this.doOpenWindow(t,r,o):this.doOpenEmptyWindow(t,r)}async doOpenWindow(t,r,o=Object.create(null)){r.length>0&&this.windowsMainService.open({context:5,contextWindowId:t,urisToOpen:r,cli:this.environmentMainService.args,forceNewWindow:o.forceNewWindow,forceReuseWindow:o.forceReuseWindow,preferNewWindow:o.preferNewWindow,diffMode:o.diffMode,addMode:o.addMode,gotoLineMode:o.gotoLineMode,noRecentEntry:o.noRecentEntry,waitMarkerFileURI:o.waitMarkerFileURI,remoteAuthority:o.remoteAuthority||void 0})}async doOpenEmptyWindow(t,r){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:t},r)}async toggleFullScreen(t){const r=this.windowById(t);r&&r.toggleFullScreen()}async handleTitleDoubleClick(t){const r=this.windowById(t);r&&r.handleTitleDoubleClick()}async isMaximized(t){const r=this.windowById(t);return(r==null?void 0:r.win)?r.win.isMaximized():!1}async maximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.maximize()}async unmaximizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.unmaximize()}async minimizeWindow(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.minimize()}async focusWindow(t,r){var o;r&&typeof r.windowId=="number"&&(t=r.windowId);const u=this.windowById(t);u&&u.focus({force:(o=r==null?void 0:r.force)!==null&&o!==void 0?o:!1})}async setMinimumSize(t,r,o){const u=this.windowById(t);if(u==null?void 0:u.win){const[h,f]=u.win.getSize(),[I,A]=u.win.getMinimumSize(),[F,U]=[r!=null?r:I,o!=null?o:A],[q,Y]=[Math.max(h,F),Math.max(f,U)];(I!==F||A!==U)&&u.win.setMinimumSize(F,U),(h!==q||f!==Y)&&u.win.setSize(q,Y)}}async showMessageBox(t,r){return this.dialogMainService.showMessageBox(r,this.toBrowserWindow(t))}async showSaveDialog(t,r){return this.dialogMainService.showSaveDialog(r,this.toBrowserWindow(t))}async showOpenDialog(t,r){return this.dialogMainService.showOpenDialog(r,this.toBrowserWindow(t))}toBrowserWindow(t){const r=this.windowById(t);if(r==null?void 0:r.win)return r.win}async pickFileFolderAndOpen(t,r){const o=await this.dialogMainService.pickFileFolder(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFileFolder",r.telemetryExtraData),this.doOpenPicked(await Promise.all(o.map(async u=>await i.SymlinkSupport.existsDirectory(u)?{folderUri:L.URI.file(u)}:{fileUri:L.URI.file(u)})),r,t))}async pickFolderAndOpen(t,r){const o=await this.dialogMainService.pickFolder(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFolder",r.telemetryExtraData),this.doOpenPicked(o.map(u=>({folderUri:L.URI.file(u)})),r,t))}async pickFileAndOpen(t,r){const o=await this.dialogMainService.pickFile(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openFile",r.telemetryExtraData),this.doOpenPicked(o.map(u=>({fileUri:L.URI.file(u)})),r,t))}async pickWorkspaceAndOpen(t,r){const o=await this.dialogMainService.pickWorkspace(r);o&&(this.sendPickerTelemetry(o,r.telemetryEventName||"openWorkspace",r.telemetryExtraData),this.doOpenPicked(o.map(u=>({workspaceUri:L.URI.file(u)})),r,t))}doOpenPicked(t,r,o){this.windowsMainService.open({context:3,contextWindowId:o,cli:this.environmentMainService.args,urisToOpen:t,forceNewWindow:r.forceNewWindow})}sendPickerTelemetry(t,r,o){const u=t?t.length:0;this.telemetryService.publicLog(r,Object.assign(Object.assign({},o),{outcome:u?"success":"canceled",numberOfPaths:u}))}async showItemInFolder(t,r){D.shell.showItemInFolder(r)}async setRepresentedFilename(t,r){const o=this.windowById(t);o&&o.setRepresentedFilename(r)}async setDocumentEdited(t,r){const o=this.windowById(t);o&&o.setDocumentEdited(r)}async openExternal(t,r){return k.isLinuxSnap?this.safeSnapOpenExternal(r):D.shell.openExternal(r),!0}safeSnapOpenExternal(t){const r=process.env.GDK_PIXBUF_MODULE_FILE,o=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,D.shell.openExternal(t),process.env.GDK_PIXBUF_MODULE_FILE=r,process.env.GDK_PIXBUF_MODULEDIR=o}async moveItemToTrash(t,r){return D.shell.moveItemToTrash(r)}async isAdmin(){let t;return k.isWindows?t=(await new Promise((r,o)=>{j(["native-is-elevated"],r,o)}))():t=process.getuid()===0,t}async writeElevated(t,r,o,u){const h=await new Promise((f,I)=>{j(["sudo-prompt"],f,I)});return new Promise((f,I)=>{const A=[`"${this.cliPath}"`];(u==null?void 0:u.unlock)&&A.push("--file-chmod"),A.push("--file-write",`"${r.fsPath}"`,`"${o.fsPath}"`);const F={name:this.productService.nameLong.replace("-",""),icns:k.isMacintosh&&this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};h.exec(A.join(" "),F,(U,q,Y)=>{q&&this.logService.trace(`[sudo-prompt] received stdout: ${q}`),Y&&this.logService.trace(`[sudo-prompt] received stderr: ${Y}`),U?I(U):f(void 0)})})}get cliPath(){return k.isWindows?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):k.isLinux?this.environmentMainService.isBuilt?(0,b.join)((0,b.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,b.join)(this.environmentMainService.appRoot,"bin","code"):(0,b.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,w.totalmem)(),freemem:(0,w.freemem)(),loadavg:(0,w.loadavg)()}}async getOSProperties(){return{arch:(0,w.arch)(),platform:(0,w.platform)(),release:(0,w.release)(),type:(0,w.type)(),cpus:(0,w.cpus)()}}async getOSVirtualMachineHint(){return d.virtualMachineHint.value()}async killProcess(t,r,o){process.kill(r,o)}async readClipboardText(t,r){return D.clipboard.readText(r)}async writeClipboardText(t,r,o){return D.clipboard.writeText(r,o)}async readClipboardFindText(t){return D.clipboard.readFindText()}async writeClipboardFindText(t,r){return D.clipboard.writeFindText(r)}async writeClipboardBuffer(t,r,o,u){return D.clipboard.writeBuffer(r,Buffer.from(o),u)}async readClipboardBuffer(t,r){return D.clipboard.readBuffer(r)}async hasClipboard(t,r,o){return D.clipboard.has(r,o)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){D.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){D.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){D.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){D.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){D.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(t,r){const o=this.windowById(t);o&&o.updateTouchBar(r)}async notifyReady(t){const r=this.windowById(t);r&&r.setReady()}async relaunch(t,r){return this.lifecycleMainService.relaunch(r)}async reload(t,r){const o=this.windowById(t);if(o)return this.lifecycleMainService.reload(o,(r==null?void 0:r.disableExtensions)!==void 0?{_:[],"disable-extensions":r==null?void 0:r.disableExtensions}:void 0)}async closeWindow(t){this.closeWindowById(t,t)}async closeWindowById(t,r){const o=this.windowById(r);if(o==null?void 0:o.win)return o.win.close()}async quit(t){const r=this.windowsMainService.getLastActiveWindow();(r==null?void 0:r.isExtensionDevelopmentHost)&&this.windowsMainService.getWindowCount()>1&&r.win?r.win.close():setTimeout(()=>{this.lifecycleMainService.quit()},10)}async exit(t,r){await this.lifecycleMainService.kill(r)}async resolveProxy(t,r){var o,u;const h=this.windowById(t),f=(u=(o=h==null?void 0:h.win)===null||o===void 0?void 0:o.webContents)===null||u===void 0?void 0:u.session;if(f)return f.resolveProxy(r)}async openDevTools(t,r){const o=this.windowById(t);(o==null?void 0:o.win)&&o.win.webContents.openDevTools(r)}async toggleDevTools(t){const r=this.windowById(t);(r==null?void 0:r.win)&&r.win.webContents.toggleDevTools()}async sendInputEvent(t,r){const o=this.windowById(t);(o==null?void 0:o.win)&&(r.type==="mouseDown"||r.type==="mouseUp")&&o.win.webContents.sendInputEvent(r)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(t,r,o,u){if(!!k.isWindows){const h=await new Promise((f,I)=>{j(["vscode-windows-registry"],f,I)});try{return h.GetStringRegKey(r,o,u)}catch(f){return}}}async getPassword(t,r,o){const u=await this.withKeytar(),h=await u.getPassword(r,o);if(h)try{let{content:f,hasNextChunk:I}=JSON.parse(h);if(!f||!I)return h;let A=1;for(;I;){const F=await u.getPassword(r,`${o}-${A}`),U=JSON.parse(F);f+=U.content,I=U.hasNextChunk}return f}catch(f){return h}return h}async setPassword(t,r,o,u){const h=await this.withKeytar();if(k.isWindows&&u.length>rt.MAX_PASSWORD_LENGTH){let f=0,I=0,A=!0;for(;A;){const F=u.substring(f,f+rt.PASSWORD_CHUNK_SIZE);f+=rt.PASSWORD_CHUNK_SIZE,A=u.length-f>0;const U={content:F,hasNextChunk:A};await h.setPassword(r,I?`${o}-${I}`:o,JSON.stringify(U)),I++}}else await h.setPassword(r,o,u);this._onDidChangePassword.fire({service:r,account:o})}async deletePassword(t,r,o){const h=await(await this.withKeytar()).deletePassword(r,o);return h&&this._onDidChangePassword.fire({service:r,account:o}),h}async findPassword(t,r){return(await this.withKeytar()).findPassword(r)}async findCredentials(t,r){return(await this.withKeytar()).findCredentials(r)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((t,r)=>{j(["keytar"],t,r)})}windowById(t){if(typeof t=="number")return this.windowsMainService.getWindowById(t)}};l.MAX_PASSWORD_LENGTH=2500,l.PASSWORD_CHUNK_SIZE=l.MAX_PASSWORD_LENGTH-100,ce([a.memoize],l.prototype,"cliPath",null),l=ce([Z(1,R.IWindowsMainService),Z(2,y.IDialogMainService),Z(3,S.ILifecycleMainService),Z(4,n.IEnvironmentMainService),Z(5,g.ITelemetryService),Z(6,m.ILogService),Z(7,p.IProductService)],l),e.NativeHostMainService=l}),define(X[217],Q([0,1,2,5,78,11,6,32,42,88,28,17,25]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var w;(function(m){m[m.Initial=1]="Initial",m[m.StoredCredentialsUsed=2]="StoredCredentialsUsed",m[m.LoginDialogShown=3]="LoginDialogShown"})(w||(w={}));let d=class extends v.Disposable{constructor(b,p,a,c,l){super();this.logService=b,this.windowsMainService=p,this.nativeHostMainService=a,this.encryptionMainService=c,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=w.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const b=R.Event.fromNodeEventEmitter(S.app,"login",(p,a,c,l,s)=>({event:p,webContents:a,req:c,authInfo:l,callback:s}));this._register(b(this.onLogin,this))}async onLogin({event:b,authInfo:p,req:a,callback:c}){if(!!p.isProxy){if(!this.pendingProxyResolve&&this.state===w.LoginDialogShown&&a.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}b.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(p);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}c(l==null?void 0:l.username,l==null?void 0:l.password)}}async resolveProxyCredentials(b){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.doResolveProxyCredentials(b);if(p)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(b){var p,a,c,l;this.logService.trace("auth#doResolveProxyCredentials - enter",b);const s=String((0,D.hash)({scheme:b.scheme,host:b.host,port:b.port}));let t,r;try{const f=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s);if(f){const I=JSON.parse(await this.encryptionMainService.decrypt(f));t=I.username,r=I.password}}catch(f){this.logService.error(f)}if(this.state!==w.StoredCredentialsUsed&&typeof t=="string"&&typeof r=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=w.StoredCredentialsUsed,{username:t,password:r};const o=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!o){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${o.id} to handle proxy login`);const u={authInfo:b,username:(a=(p=this.sessionCredentials)===null||p===void 0?void 0:p.username)!==null&&a!==void 0?a:t,password:(l=(c=this.sessionCredentials)===null||c===void 0?void 0:c.password)!==null&&l!==void 0?l:r,replyChannel:`vscode:proxyAuthResponse:${(0,L.generateUuid)()}`};o.sendWhenReady("vscode:openProxyAuthenticationDialog",E.CancellationToken.None,u),this.state=w.LoginDialogShown;const h=await new Promise(f=>{var I;const A=async(F,U,q)=>{var Y;if(U===u.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${o.id}`),(Y=o.win)===null||Y===void 0||Y.webContents.off("ipc-message",A),q){const ie={username:q.username,password:q.password};try{if(q.remember){const ae=await this.encryptionMainService.encrypt(JSON.stringify(ie));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s,ae)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,s)}catch(ae){this.logService.error(ae)}f({username:ie.username,password:ie.password})}else f(void 0)};(I=o.win)===null||I===void 0||I.webContents.on("ipc-message",A)});return this.sessionCredentials=h,h}};d=ce([Z(0,k.ILogService),Z(1,n.IWindowsMainService),Z(2,y.INativeHostMainService),Z(3,i.IEncryptionMainService),Z(4,g.IProductService)],d),e.ProxyAuthHandler=d}),define(X[218],Q([0,1,215,32,56,2,33,57,169,3,5,77,103,10,18,42]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function b(c){return c<21}let p=class{constructor(l,s,t,r,o){this.windowServer=l,this.options=s,this.windowsMainService=t,this.lifecycleMainService=r,this.nativeHostMainService=o,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(l){return this.registeredWindowIds.add(l),this.reloadingWindowIds.delete(l),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(l){this.reloadingWindowIds.add(l)}async getWindowIds(){return this.windowsMainService.getWindows().map(l=>l.id).filter(l=>this.registeredWindowIds.has(l)&&!this.reloadingWindowIds.has(l))}async capturePage(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!(s==null?void 0:s.win))throw new Error("Invalid window");return(await s.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(l){await this.whenUnfrozen(l);const s=this.windowsMainService.getWindowById(l);if(!s)throw new Error("Invalid window");this.reloadingWindowIds.add(l),this.lifecycleMainService.reload(s)}async exitApplication(){return this.nativeHostMainService.quit(void 0)}async dispatchKeybinding(l,s){await this.whenUnfrozen(l);const t=E.KeybindingParser.parseUserBinding(s);for(let r of t)await this._dispatchKeybinding(l,r)}async _dispatchKeybinding(l,s){if(s instanceof g.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const t=this.windowsMainService.getWindowById(l);if(!(t==null?void 0:t.win))throw new Error("Invalid window");const r=t.win.webContents,o=new n.SimpleKeybinding(!1,!1,!1,!1,s.keyCode),h=new y.USLayoutResolvedKeybinding(o.toChord(),i.OS).getElectronAccelerator(),f=[];s.ctrlKey&&f.push("ctrl"),s.metaKey&&f.push("meta"),s.shiftKey&&f.push("shift"),s.altKey&&f.push("alt"),r.sendInputEvent({type:"keyDown",keyCode:h,modifiers:f}),b(s.keyCode)||r.sendInputEvent({type:"char",keyCode:h,modifiers:f}),r.sendInputEvent({type:"keyUp",keyCode:h,modifiers:f}),await(0,w.timeout)(100)}async click(l,s,t,r){await(await this.getWindowDriver(l)).click(s,t,r)}async doubleClick(l,s){await(await this.getWindowDriver(l)).doubleClick(s)}async setValue(l,s,t){await(await this.getWindowDriver(l)).setValue(s,t)}async getTitle(l){return await(await this.getWindowDriver(l)).getTitle()}async isActiveElement(l,s){return await(await this.getWindowDriver(l)).isActiveElement(s)}async getElements(l,s,t){return await(await this.getWindowDriver(l)).getElements(s,t)}async getElementXY(l,s,t,r){return await(await this.getWindowDriver(l)).getElementXY(s,t,r)}async typeInEditor(l,s,t){await(await this.getWindowDriver(l)).typeInEditor(s,t)}async getTerminalBuffer(l,s){return await(await this.getWindowDriver(l)).getTerminalBuffer(s)}async writeInTerminal(l,s,t){await(await this.getWindowDriver(l)).writeInTerminal(s,t)}async getWindowDriver(l){await this.whenUnfrozen(l);const s=`window:${l}`,t=new k.StaticRouter(o=>o===s),r=this.windowServer.getChannel("windowDriver",t);return new v.WindowDriverChannelClient(r)}async whenUnfrozen(l){for(;this.reloadingWindowIds.has(l);)await L.Event.toPromise(this.onDidReloadingChange.event)}};p=ce([Z(2,R.IWindowsMainService),Z(3,d.ILifecycleMainService),Z(4,m.INativeHostMainService)],p),e.Driver=p;async function a(c,l,s,t){const r=s.driverVerbose,o=t.createInstance(p,c,{verbose:r}),u=new v.WindowDriverRegistryChannel(o);c.registerChannel("windowDriverRegistry",u);const h=await(0,D.serve)(l),f=new v.DriverChannel(o);return h.registerChannel("driver",f),(0,S.combinedDisposable)(h,c)}e.serve=a}),define(X[219],Q([0,1,60,56]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,S,k,n){const y=L=>n(L,void 0),i=v.createConnection({host:D,port:S},()=>{i.removeListener("error",y);const L=Buffer.alloc(16);for(let d=0;d<16;d++)L[d]=Math.round(Math.random()*256);const g=L.toString("base64");let E=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${S}/?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];i.write(E.join(`\r
`)+`\r
\r
`);const w=d=>{d.toString().indexOf(`\r
\r
`)>=0&&(i.off("data",w),n(void 0,new R.NodeSocket(i)))};i.on("data",w)});i.once("error",y)}}}),define(X[220],Q([0,1,60,10,2,113,6,17,184,55,219,72]),function(j,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function E(b,p,a,c){return new w(b,p,a,c).waitForReady()}class w extends D.Disposable{constructor(p,a,c,l){super();this.suggestedLocalPort=l,this.public=!1,this._socketsDispose=new Map,this._options=p,this._server=v.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=s=>this._onConnection(s),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(a=>{a()})}async waitForReady(){var p;let a=await(0,S.findFreePortFaster)((p=this.suggestedLocalPort)!==null&&p!==void 0?p:this.tunnelRemotePort,2,1e3),c=null;return c=this._server.listen(a).address(),c||(a=0,c=this._server.listen(a).address()),this.tunnelLocalPort=c.port,await this._barrier.wait(),this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async _onConnection(p){p.pause();const a=await(0,y.connectRemoteAgentTunnel)(this._options,this.tunnelRemotePort),c=a.getSocket().socket,l=a.readEntireBuffer();a.dispose(),l.byteLength>0&&p.write(l.buffer),p.on("end",()=>{this._socketsDispose.delete(p.localAddress),c.end()}),p.on("close",()=>c.end()),p.on("error",()=>{this._socketsDispose.delete(p.localAddress),c.destroy()}),c.on("end",()=>p.end()),c.on("close",()=>p.end()),c.on("error",()=>{p.destroy()}),p.pipe(c),c.pipe(p),this._socketsDispose.set(p.localAddress,()=>{p.end(),c.end()})}}let d=class extends i.AbstractTunnelService{constructor(p,a,c,l){super(a);this.socketFactory=p,this.signService=c,this.productService=l}retainOrCreateTunnel(p,a,c,l,s,t){const r=this.getTunnelFromMap(a,c);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,a,c,l,s,t);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${a}:${c} on local port ${l}.`);const o={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:p,signService:this.signService,logService:this.logService,ipcLogger:null},u=E(o,a,c,l);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(a,c,u),u}}};d=ce([Z(1,k.ILogService),Z(2,g.ISignService),Z(3,n.IProductService)],d),e.BaseTunnelService=d;let m=class extends d{constructor(p,a,c){super(L.nodeSocketFactory,p,a,c)}};m=ce([Z(0,k.ILogService),Z(1,g.ISignService),Z(2,n.IProductService)],m),e.TunnelService=m}),define(X[221],Q([0,1,214,186,2,13,19,185,24,6,21,47,69]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let w=class extends D.Disposable{constructor(m,b,p){super();this.environmentService=b,this.logService=p,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,b){this.logService.trace("RequestService#request",m.url);const{proxyUrl:p,strictSSL:a}=this,c=m.agent?m.agent:await(0,n.getProxyAgent)(m.url||"",await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env),{proxyUrl:p,strictSSL:a});return m.agent=c,m.strictSSL=a,this.authorization&&(m.headers=Object.assign(Object.assign({},m.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(m,b)}async getNodeRequest(m){return((0,R.parse)(m.url).protocol==="https:"?await new Promise((a,c)=>{j(["https"],a,c)}):await new Promise((a,c)=>{j(["http"],a,c)})).request}_request(m,b){return new Promise(async(p,a)=>{let c;const l=(0,R.parse)(m.url),s=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,S.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(t.auth=m.user+":"+m.password),c=s(t,r=>{const o=(0,S.isNumber)(m.followRedirects)?m.followRedirects:3;if(r.statusCode&&r.statusCode>=300&&r.statusCode<400&&o>0&&r.headers.location)this._request(Object.assign(Object.assign({},m),{url:r.headers.location,followRedirects:o-1}),b).then(p,a);else{let u=r;r.headers["content-encoding"]==="gzip"&&(u=r.pipe((0,v.createGunzip)())),p({res:r,stream:(0,L.streamToBufferReadableStream)(u)})}}),c.on("error",a),m.timeout&&c.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&c.write(m.data),c.end(),b.onCancellationRequested(()=>{c.abort(),a((0,k.canceled)())})})}async resolveProxy(m){}};w=ce([Z(0,y.IConfigurationService),Z(1,g.INativeEnvironmentService),Z(2,i.ILogService)],w),e.RequestService=w}),define(X[222],Q([0,1,221,11]),function(j,e,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(k){return R.net.request}class S extends v.RequestService{request(n,y){return super.request(Object.assign(Object.assign({},n||{}),{getRawRequest:D}),y)}}e.RequestMainService=S}),define(X[223],Q([0,1,11,26,10,6,18,73,9,3,2,83,13,5,69,54]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let b=class extends L.Disposable{constructor(a,c,l,s,t,r,o){super();this.machineId=a,this.userEnv=c,this.environmentMainService=l,this.lifecycleMainService=s,this.logService=t,this.themeMainService=r,this.protocolMainService=o,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new w.Emitter),this.onDidError=w.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown())),v.ipcMain.on("vscode:createSharedProcessMessageChannel",async(a,c)=>this.onWindowConnection(a,c))}async onWindowConnection(a,c){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const l=await this.connect();if(a.sender.isDestroyed())return l.close();a.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[l])}onWillShutdown(){const a=this.window;!a||(!a.isDestroyed()&&!a.webContents.isDestroyed()&&a.webContents.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(a.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{a.close()}catch(c){}this.window=void 0},0))}whenReady(){return this._whenReady||(this._whenReady=new Promise(a=>v.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),a()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.userEnv=Object.assign(Object.assign({},this.userEnv),await(0,d.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env)),this.createWindow(),this.registerWindowListeners(),await new Promise(a=>v.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),a()}))})()),this._whenIpcReady}createWindow(){const a=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new v.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:y.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${a.resource.toString()}`],v8CacheOptions:i.browserCodeLoadingCacheStrategy,nodeIntegration:!0,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}});const c={machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,nodeCachedDataDir:this.environmentMainService.nodeCachedDataDir,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel()};a.update(c),this.window.loadURL(y.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=a=>{var c;this.logService.trace("SharedProcess#close prevented"),a.preventDefault(),((c=this.window)===null||c===void 0?void 0:c.isVisible())&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(a,c)=>this._onDidError.fire({type:2,details:c})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1,details:"SharedProcess: detected unresponsive window"})),this.window.webContents.on("did-fail-load",(a,c,l)=>this._onDidError.fire({type:3,details:`SharedProcess: failed to load: ${l}`})))}async connect(){await this.whenIpcReady;const a=(0,E.assertIsDefined)(this.window);return(0,g.connect)(a)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){var a,c;return(c=(a=this.window)===null||a===void 0?void 0:a.isVisible())!==null&&c!==void 0?c:!1}};b=ce([Z(2,R.IEnvironmentMainService),Z(3,k.ILifecycleMainService),Z(4,S.ILogService),Z(5,n.IThemeMainService),Z(6,m.IProtocolMainService)],b),e.SharedProcess=b}),define(X[75],Q([0,1,5,10,24,18,17,41,26,6,40,25]),function(j,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function E(d,m,b){return`${b.updateUrl}/api/update/${d}/${m}/${b.commit}`}e.createUpdateURL=E;let w=class{constructor(m,b,p,a,c,l){this.lifecycleMainService=m,this.configurationService=b,this.environmentMainService=p,this.requestService=a,this.logService=c,this.productService=l,this._state=n.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}initialize(){if(!!this.environmentMainService.isBuilt){if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const m=(0,D.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel"),b=this.getProductQuality(m);if(!b){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(b),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(n.State.Idle(this.getUpdateType())),m==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}m==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(null),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,p=>this.logService.error(p))}}getProductQuality(m){return m==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(m){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}isLatestVersion(){return this.url?this.requestService.request({url:this.url},g.CancellationToken.None).then(m=>m.res.statusCode===204):Promise.resolve(void 0)}getUpdateType(){return 1}doQuitAndInstall(){}};w=ce([Z(0,S.ILifecycleMainService),Z(1,D.IConfigurationService),Z(2,y.IEnvironmentMainService),Z(3,L.IRequestService),Z(4,i.ILogService),Z(5,k.IProductService)],w),e.AbstractUpdateService=w}),define(X[224],Q([0,1,11,2,5,52,24,18,41,31,26,6,75,40,17]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let m=class extends E.AbstractUpdateService{constructor(p,a,c,l,s,t,r){super(p,a,l,s,t,r);this.telemetryService=c,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"error",(p,a)=>a)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-available",(p,a,c)=>({url:a,version:c,productVersion:c}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(v.autoUpdater,"update-downloaded",(p,a,c,l)=>({releaseNotes:a,version:c,productVersion:c,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(p){this.logService.error("UpdateService error:",p);const c=(this.state.type==="checking for updates"?!!this.state.context:!0)?p:void 0;this.setState(y.State.Idle(1,c))}buildUpdateFeedUrl(p){let a;this.productService.darwinUniversalAssetId?a=this.productService.darwinUniversalAssetId:a=process.arch==="x64"?"darwin":"darwin-arm64";const c=(0,E.createUpdateURL)(a,p,this.productService);try{v.autoUpdater.setFeedURL({url:c})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return c}doCheckForUpdates(p){this.setState(y.State.CheckingForUpdates(p)),v.autoUpdater.checkForUpdates()}onUpdateAvailable(p){this.state.type==="checking for updates"&&this.setState(y.State.Downloading(p))}onUpdateDownloaded(p){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:p.version}),this.setState(y.State.Ready(p)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!this.state.context}),this.setState(y.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),v.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};ce([S.memoize],m.prototype,"onRawError",null),ce([S.memoize],m.prototype,"onRawUpdateNotAvailable",null),ce([S.memoize],m.prototype,"onRawUpdateAvailable",null),ce([S.memoize],m.prototype,"onRawUpdateDownloaded",null),m=ce([Z(0,n.ILifecycleMainService),Z(1,k.IConfigurationService),Z(2,i.ITelemetryService),Z(3,L.IEnvironmentMainService),Z(4,w.IRequestService),Z(5,g.ILogService),Z(6,d.IProductService)],m),e.DarwinUpdateService=m}),define(X[225],Q([0,1,17,24,18,41,31,26,6,75,40,25,42]),function(j,e,v,R,D,S,k,n,y,i,L,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let w=class extends i.AbstractUpdateService{constructor(m,b,p,a,c,l,s,t){super(m,b,a,c,l,t);this.telemetryService=p,this.nativeHostMainService=s}buildUpdateFeedUrl(m){return(0,i.createUpdateURL)(`linux-${process.arch}`,m,this.productService)}doCheckForUpdates(m){!this.url||(this.setState(S.State.CheckingForUpdates(m)),this.requestService.request({url:this.url},g.CancellationToken.None).then(L.asJson).then(b=>{!b||!b.url||!b.version||!b.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(1))):this.setState(S.State.AvailableForDownload(b))}).then(void 0,b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m});const p=m?b.message||b:void 0;this.setState(S.State.Idle(1,p))}))}async doDownloadUpdate(m){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):m.update.url&&this.nativeHostMainService.openExternal(void 0,m.update.url),this.setState(S.State.Idle(1))}};w=ce([Z(0,D.ILifecycleMainService),Z(1,R.IConfigurationService),Z(2,k.ITelemetryService),Z(3,n.IEnvironmentMainService),Z(4,L.IRequestService),Z(5,y.ILogService),Z(6,E.INativeHostMainService),Z(7,v.IProductService)],w),e.LinuxUpdateService=w}),define(X[226],Q([0,1,5,10,18,41,26,6,8,22,46,31]),function(j,e,v,R,D,S,k,n,y,i,L,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let E=class{constructor(m,b,p){if(this.lifecycleMainService=m,this.logService=p,this._state=S.State.Uninitialized,this._onStateChange=new v.Emitter,this.onStateChange=this._onStateChange.event,b.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(S.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,a=>this.logService.error(a))}get state(){return this._state}setState(m){this.logService.info("update#setState",m.type),this._state=m,this._onStateChange.fire(m)}scheduleCheckForUpdates(m=60*60*1e3){return(0,R.timeout)(m).then(()=>this.checkForUpdates(null)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(m){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(m)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(m){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(m=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${m}`),!m&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};E=ce([Z(0,D.ILifecycleMainService),Z(1,k.IEnvironmentMainService),Z(2,n.ILogService)],E);let w=class extends E{constructor(m,b,p,a,c,l){super(p,a,c);this.snap=m,this.snapRevision=b,this.telemetryService=l;const s=(0,i.watch)(y.dirname(this.snap)),t=v.Event.fromNodeEventEmitter(s,"change",(h,f)=>f),r=v.Event.filter(t,h=>h==="current"),u=v.Event.debounce(r,(h,f)=>f,2e3)(this.checkForUpdates,this);p.onWillShutdown(()=>{u.dispose(),s.close()})}doCheckForUpdates(m){this.setState(S.State.CheckingForUpdates(m)),this.isUpdateAvailable().then(b=>{b?this.setState(S.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(2)))},b=>{this.logService.error(b),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!m}),this.setState(S.State.Idle(2,b.message||b))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,L.spawn)("sleep 3 && "+y.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const m=await new Promise((p,a)=>(0,i.realpath)(`${y.dirname(this.snap)}/current`,(c,l)=>c?a(c):p(l))),b=y.basename(m);return this.snapRevision!==b}isLatestVersion(){return this.isUpdateAvailable().then(void 0,m=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};w=ce([Z(2,D.ILifecycleMainService),Z(3,k.IEnvironmentMainService),Z(4,n.ILogService),Z(5,g.ITelemetryService)],w),e.SnapUpdateService=w}),define(X[227],Q([0,1,22,8,23,52,24,18,17,41,31,26,6,75,40,109,27,46,25,10,16,7,42]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(f,I=1e3){for(;!f();)await(0,c.timeout)(I)}let o;function u(){return typeof o=="undefined"&&(o=v.existsSync(R.join(R.dirname(process.execPath),"unins000.exe"))?0:1),o}let h=class extends w.AbstractUpdateService{constructor(I,A,F,U,q,Y,ie,ae,V){super(I,A,U,q,Y,V);this.telemetryService=F,this.fileService=ie,this.nativeHostMainService=ae}get cachePath(){const I=R.join((0,b.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return v.promises.mkdir(I,{recursive:!0}).then(()=>I)}initialize(){super.initialize(),u()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(I){let A="win32";return process.arch!=="ia32"&&(A+=`-${process.arch}`),u()===1?A+="-archive":this.productService.target==="user"&&(A+="-user"),(0,w.createUpdateURL)(A,I,this.productService)}doCheckForUpdates(I){!this.url||(this.setState(i.State.CheckingForUpdates(I)),this.requestService.request({url:this.url},a.CancellationToken.None).then(d.asJson).then(A=>{const F=u();return!A||!A.url||!A.version||!A.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I}),this.setState(i.State.Idle(F)),Promise.resolve(null)):F===1?(this.setState(i.State.AvailableForDownload(A)),Promise.resolve(null)):(this.setState(i.State.Downloading(A)),this.cleanup(A.version).then(()=>this.getUpdatePackagePath(A.version).then(U=>D.exists(U).then(q=>{if(q)return Promise.resolve(U);const Y=A.url,ie=A.hash,ae=`${U}.tmp`;return this.requestService.request({url:Y},a.CancellationToken.None).then(V=>this.fileService.writeFile(s.URI.file(ae),V.stream)).then(ie?()=>(0,m.checksum)(ae,A.hash):()=>{}).then(()=>v.promises.rename(ae,U)).then(()=>U)})).then(U=>{const q=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:U},q&&A.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(i.State.Downloaded(A)):this.setState(i.State.Ready(A))})))}).then(void 0,A=>{this.logService.error(A),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!I});const F=I?A.message||A:void 0;this.setState(i.State.Idle(u(),F))}))}async doDownloadUpdate(I){I.update.url&&this.nativeHostMainService.openExternal(void 0,I.update.url),this.setState(i.State.Idle(u()))}async getUpdatePackagePath(I){const A=await this.cachePath;return R.join(A,`CodeSetup-${this.productService.quality}-${I}.exe`)}async cleanup(I=null){const A=I?Y=>!new RegExp(`${this.productService.quality}-${I}\\.exe$`).test(Y):()=>!0,F=await this.cachePath,q=(await D.readdir(F)).filter(A).map(async Y=>{try{await v.promises.unlink(R.join(F,Y))}catch(ie){}});await Promise.all(q)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const I=this.state.update;this.setState(i.State.Updating(I));const A=await this.cachePath;this.availableUpdate.updateFilePath=R.join(A,`CodeSetup-${this.productService.quality}-${I.version}.flag`),await D.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(i.State.Idle(u()))});const U=`${this.productService.win32MutexName}-ready`,q=await new Promise((Y,ie)=>{j(["windows-mutex"],Y,ie)});r(()=>q.isActive(U)).then(()=>this.setState(i.State.Ready(I)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?v.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return u()}};ce([S.memoize],h.prototype,"cachePath",null),h=ce([Z(0,n.ILifecycleMainService),Z(1,k.IConfigurationService),Z(2,L.ITelemetryService),Z(3,g.IEnvironmentMainService),Z(4,d.IRequestService),Z(5,E.ILogService),Z(6,l.IFileService),Z(7,t.INativeHostMainService),Z(8,y.IProductService)],h),e.Win32UpdateService=h}),define(X[51],Q([0,1,29,26,8,23,22,3,5,6,59,44,9,2,15,4,149,17,11,13,49,50,98]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,m.createDecorator)("workspacesManagementMainService");let r=class extends w.Disposable{constructor(f,I,A,F,U){super();this.environmentMainService=f,this.logService=I,this.backupMainService=A,this.dialogMainService=F,this.productService=U,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new y.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new y.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(f){if(!this.isWorkspacePath(f)||f.scheme!==E.Schemas.file)return null;let I;try{I=(0,k.readFileSync)(f.fsPath,"utf8")}catch(A){return null}return this.doResolveWorkspace(f,I)}isWorkspacePath(f){return(0,v.isUntitledWorkspace)(f,this.environmentMainService)||(0,v.hasWorkspaceFileExtension)(f)}doResolveWorkspace(f,I){try{const A=this.doParseStoredWorkspace(f,I),F=o(f);return{id:F.id,configPath:F.configPath,folders:(0,v.toWorkspaceFolders)(A.folders,F.configPath,d.extUriBiasedIgnorePathCase),remoteAuthority:A.remoteAuthority}}catch(A){this.logService.warn(A.toString())}return null}doParseStoredWorkspace(f,I){const A=(0,g.parse)(I);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(F=>(0,v.isStoredWorkspaceFolder)(F));else throw new Error(`${f.toString(!0)} looks like an invalid workspace file.`);return A}async createUntitledWorkspace(f,I){const{workspace:A,storedWorkspace:F}=this.newUntitledWorkspace(f,I),U=A.configPath.fsPath;return await k.promises.mkdir((0,D.dirname)(U),{recursive:!0}),await(0,S.writeFile)(U,JSON.stringify(F,null,"	")),A}createUntitledWorkspaceSync(f,I){const{workspace:A,storedWorkspace:F}=this.newUntitledWorkspace(f,I),U=A.configPath.fsPath;return(0,k.mkdirSync)((0,D.dirname)(U),{recursive:!0}),(0,S.writeFileSync)(U,JSON.stringify(F,null,"	")),A}newUntitledWorkspace(f=[],I){const A=(Date.now()+Math.round(Math.random()*1e3)).toString(),F=(0,d.joinPath)(this.untitledWorkspacesHome,A),U=(0,d.joinPath)(F,v.UNTITLED_WORKSPACE_NAME),q=[];for(const Y of f)q.push((0,v.getStoredWorkspaceFolder)(Y.uri,!0,Y.name,F,!n.isWindows,d.extUriBiasedIgnorePathCase));return{workspace:o(U),storedWorkspace:{folders:q,remoteAuthority:I}}}async getWorkspaceIdentifier(f){return o(f)}isUntitledWorkspace(f){return(0,v.isUntitledWorkspace)(f.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(f){!this.isUntitledWorkspace(f)||(this.doDeleteUntitledWorkspaceSync(f),this._onDidDeleteUntitledWorkspace.fire(f))}async deleteUntitledWorkspace(f){this.deleteUntitledWorkspaceSync(f)}doDeleteUntitledWorkspaceSync(f){const I=(0,d.originalFSPath)(f.configPath);try{(0,S.rimrafSync)((0,D.dirname)(I));const A=(0,D.join)(this.environmentMainService.workspaceStorageHome.fsPath,f.id);(0,k.existsSync)(A)&&(0,S.writeFileSync)((0,D.join)(A,"obsolete"),"")}catch(A){this.logService.warn(`Unable to delete untitled workspace ${I} (${A}).`)}}getUntitledWorkspacesSync(){const f=[];try{const I=(0,S.readdirSync)(this.untitledWorkspacesHome.fsPath).map(A=>(0,d.joinPath)(this.untitledWorkspacesHome,A,v.UNTITLED_WORKSPACE_NAME));for(const A of I){const F=o(A),U=this.resolveLocalWorkspaceSync(A);U?f.push({workspace:F,remoteAuthority:U.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(F)}}catch(I){I.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${I}).`)}return f}async enterWorkspace(f,I,A){if(!f||!f.win||!f.isReady||!await this.isValidTargetWorkspacePath(f,I,A))return null;const U=this.doEnterWorkspace(f,o(A));return U?(this._onDidEnterWorkspace.fire({window:f,workspace:U.workspace}),U):null}async isValidTargetWorkspacePath(f,I,A){if(!A)return!0;if((0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&d.extUriBiasedIgnorePathCase.isEqual(f.openedWorkspace.configPath,A))return!1;if((0,t.findWindowOnWorkspaceOrFolder)(I,A)){const F={title:this.productService.nameLong,type:"info",buttons:[(0,b.localize)(0,null)],message:(0,b.localize)(1,null,(0,d.basename)(A)),detail:(0,b.localize)(2,null),noLink:!0};return await this.dialogMainService.showMessageBox(F,(0,c.withNullAsUndefined)(a.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(f,I){if(!f.config)return null;f.focus();let A;return f.config.extensionDevelopmentPath||(A=this.backupMainService.registerWorkspaceBackupSync({workspace:I,remoteAuthority:f.remoteAuthority},f.config.backupPath)),(0,v.isWorkspaceIdentifier)(f.openedWorkspace)&&this.isUntitledWorkspace(f.openedWorkspace)&&this.deleteUntitledWorkspaceSync(f.openedWorkspace),f.config.workspace=I,f.config.backupPath=A,{workspace:I,backupPath:A}}};r=ce([Z(0,R.IEnvironmentMainService),Z(1,i.ILogService),Z(2,l.IBackupMainService),Z(3,s.IDialogMainService),Z(4,p.IProductService)],r),e.WorkspacesManagementMainService=r;function o(h){function f(){let I=h.scheme===E.Schemas.file?(0,d.originalFSPath)(h):h.toString();return n.isLinux||(I=I.toLowerCase()),(0,L.createHash)("md5").update(I).digest("hex")}return{id:f(),configPath:h}}e.getWorkspaceIdentifier=o;function u(h,f){function I(){if(h.scheme!==E.Schemas.file)return(0,L.createHash)("md5").update(h.toString()).digest("hex");if(!f)try{f=(0,k.statSync)(h.fsPath)}catch(U){return}let F;return n.isLinux?F=f.ino:n.isMacintosh?F=f.birthtime.getTime():n.isWindows&&(typeof f.birthtimeMs=="number"?F=Math.floor(f.birthtimeMs):F=f.birthtime.getTime()),(0,L.createHash)("md5").update(h.fsPath).update(F?String(F):"").digest("hex")}const A=I();if(typeof A=="string")return{id:A,uri:h}}e.getSingleFolderWorkspaceIdentifier=u}),define(X[99],Q([0,1,6,96,3,4,32,23,51,24,7,11,34,53,25,29,13]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,S.createDecorator)(e.ID);let p=class{constructor(c,l,s,t,r){this.logService=c,this.windowsMainService=l,this.urlService=s,this.workspacesManagementMainService=t,this.configurationService=r}async start(c,l){this.logService.trace("Received data from other instance: ",c,l),D.isMacintosh&&g.app.focus({steal:!0});const s=this.parseOpenUrl(c);if(s.length){let t=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(t=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),t.then(()=>{for(const{uri:r,url:o}of s)this.urlService.open(r,{originalUrl:o})})}else return this.startOpenWindow(c,l)}parseOpenUrl(c){return c["open-url"]&&c._urls&&c._urls.length>0?(0,E.coalesce)(c._urls.map(l=>{try{return{uri:L.URI.parse(l),url:l}}catch(s){return null}})):[]}async startOpenWindow(c,l){const s=(0,w.isLaunchedFromCli)(l)?0:4;let t=[];const r=c.wait&&c.waitMarkerFilePath?L.URI.file(c.waitMarkerFilePath):void 0,o=c.remote||void 0;if(c.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(c.extensionDevelopmentPath,{context:s,cli:c,userEnv:l,waitMarkerFileURI:r,remoteAuthority:o});else if(!c._.length&&!c["folder-uri"]&&!c["file-uri"]){let u=!1;if(c["new-window"]||c["unity-launch"])u=!0;else if(c["reuse-window"])u=!1;else{const h=this.configurationService.getValue("window");switch((h==null?void 0:h.openWithoutArgumentsInNewWindow)||"default"){case"on":u=!0;break;case"off":u=!1;break;default:u=!D.isMacintosh}}if(u)t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:!0,forceEmpty:!0,waitMarkerFileURI:r,remoteAuthority:o});else{const h=this.windowsMainService.getLastActiveWindow();h?(h.focus(),t=[h]):t=this.windowsMainService.open({context:s,cli:c,forceEmpty:!0,remoteAuthority:o})}}else t=this.windowsMainService.open({context:s,cli:c,userEnv:l,forceNewWindow:c["new-window"],preferNewWindow:!c["reuse-window"]&&!c.wait,forceReuseWindow:c["reuse-window"],diffMode:c.diff,addMode:c.add,noRecentEntry:!!c["skip-add-to-recently-opened"],waitMarkerFileURI:r,gotoLineMode:c.goto,remoteAuthority:o});if(r&&t.length===1&&t[0])return Promise.race([t[0].whenClosedOrLoaded,(0,n.whenDeleted)(r.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const c=[];return g.BrowserWindow.getAllWindows().forEach(l=>{const s=this.windowsMainService.getWindowById(l.id);s?c.push(this.codeWindowToInfo(s)):c.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:c,screenReader:!!g.app.accessibilitySupportEnabled,gpuFeatureStatus:g.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(c){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(t=>new Promise(r=>{const o=t.remoteAuthority;if(o){const u=`vscode:getDiagnosticInfoResponse${t.id}`,h={includeProcesses:c.includeProcesses,folders:c.includeWorkspaceMetadata?this.getFolderURIs(t):void 0};t.sendWhenReady("vscode:getDiagnosticInfo",d.CancellationToken.None,{replyChannel:u,args:h}),g.ipcMain.once(u,(f,I)=>{I||r({hostName:o,errorMessage:`Unable to resolve connection to '${o}'.`}),r(I)}),setTimeout(()=>{r({hostName:o,errorMessage:`Fetching remote diagnostics for '${o}' timed out.`})},5e3)}else r(void 0)})))).filter(t=>!!t)}getFolderURIs(c){const l=[],s=c.openedWorkspace;if((0,m.isSingleFolderWorkspaceIdentifier)(s))l.push(s.uri);else if((0,m.isWorkspaceIdentifier)(s)){const t=this.workspacesManagementMainService.resolveLocalWorkspaceSync(s.configPath);t&&t.folders.forEach(o=>{l.push(o.uri)})}return l}codeWindowToInfo(c){const l=this.getFolderURIs(c),s=(0,b.assertIsDefined)(c.win);return this.browserWindowToInfo(s,l,c.remoteAuthority)}browserWindowToInfo(c,l=[],s){return{pid:c.webContents.getOSProcessId(),title:c.getTitle(),folderURIs:l,remoteAuthority:s}}};p=ce([Z(0,v.ILogService),Z(1,k.IWindowsMainService),Z(2,R.IURLService),Z(3,y.IWorkspacesManagementMainService),Z(4,i.IConfigurationService)],p),e.LaunchMainService=p}),define(X[228],Q([0,1,140,27,17,11,99,68,26,3,6,81,50,4,61,9,42,54,2]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,w.createDecorator)("issueMainService");let c=class pt{constructor(s,t,r,o,u,h,f,I,A,F){this.machineId=s,this.userEnv=t,this.environmentMainService=r,this.launchMainService=o,this.logService=u,this.diagnosticsService=h,this.dialogMainService=f,this.nativeHostMainService=I,this.productService=A,this.protocolMainService=F,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){S.ipcMain.on("vscode:issueSystemInfoRequest",async s=>{const[t,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),o=await this.diagnosticsService.getSystemInfo(t,r);this.safeSend(s,"vscode:issueSystemInfoResponse",o)}),S.ipcMain.on("vscode:listProcesses",async s=>{const t=[];try{const r=await this.launchMainService.getMainProcessId();t.push({name:(0,v.localize)(0,null),rootProcess:await(0,g.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(u=>{(0,n.isRemoteDiagnosticError)(u)?t.push({name:u.hostName,rootProcess:u}):u.processes&&t.push({name:u.hostName,rootProcess:u.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(s,"vscode:listProcessesResponse",t)}),S.ipcMain.on("vscode:issueReporterClipboard",async s=>{const t={message:(0,v.localize)(1,null),type:"warning",buttons:[(0,v.localize)(2,null),(0,v.localize)(3,null)]};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(t,this.issueReporterWindow);this.safeSend(s,"vscode:issueReporterClipboardResponse",r.response===0)}}),S.ipcMain.on("vscode:issuePerformanceInfoRequest",async s=>{const t=await this.getPerformanceInfo();this.safeSend(s,"vscode:issuePerformanceInfoResponse",t)}),S.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const s={message:(0,v.localize)(4,null),type:"warning",buttons:[(0,v.localize)(5,null),(0,v.localize)(6,null)]};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(s,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),S.ipcMain.on("vscode:workbenchCommand",(s,t)=>{const{id:r,from:o,args:u}=t;let h;switch(o){case"issueReporter":h=this.issueReporterParentWindow;break;case"processExplorer":h=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${o}`)}h&&h.webContents.send("vscode:runAction",{id:r,from:o,args:u})}),S.ipcMain.on("vscode:openExternal",(s,t)=>{this.nativeHostMainService.openExternal(void 0,t)}),S.ipcMain.on("vscode:closeIssueReporter",s=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),S.ipcMain.on("vscode:closeProcessExplorer",s=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),S.ipcMain.on("vscode:windowsInfoRequest",async s=>{const t=await this.launchMainService.getMainProcessInfo();this.safeSend(s,"vscode:windowsInfoResponse",t.windows)})}safeSend(s,t,...r){s.sender.isDestroyed()||s.sender.send(t,...r)}async openReporter(s){var t;if(!this.issueReporterWindow&&(this.issueReporterParentWindow=S.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const r=new a.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(u,o,s.styles.backgroundColor,(0,v.localize)(7,null),s.zoomLevel);const h={appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,machineId:this.machineId,userEnv:this.userEnv,data:s,features:{},disableExtensions:this.environmentMainService.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:{nameShort:this.productService.nameShort,version:this.productService.darwinUniversalAssetId?`${this.productService.version} (Universal)`:this.productService.version,commit:this.productService.commit,date:this.productService.date,reportIssueUrl:this.productService.reportIssueUrl,reportMarketplaceIssueUrl:this.productService.reportMarketplaceIssueUrl}};o.update(h),this.issueReporterWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j,!0).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,r.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,r.dispose())})}(t=this.issueReporterWindow)===null||t===void 0||t.focus()}async openProcessExplorer(s){var t;if(!this.processExplorerWindow&&(this.processExplorerParentWindow=S.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const r=new a.DisposableStore,o=r.add(this.protocolMainService.createIPCObjectUrl()),u=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(u,o,s.styles.backgroundColor,(0,v.localize)(8,null),s.zoomLevel);const h={appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,machineId:this.machineId,data:s};o.update(h),this.processExplorerWindow.loadURL(m.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j,!0).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,r.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,r.dispose())})}(t=this.processExplorerWindow)===null||t===void 0||t.focus()}createBrowserWindow(s,t,r,o,u){const h=new S.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:s.width,height:s.height,minWidth:300,minHeight:200,x:s.x,y:s.y,title:o,backgroundColor:r||pt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:m.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${t.resource.toString()}`],v8CacheOptions:"bypassHeatCheck",enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,d.zoomLevelToZoomFactor)(u),sandbox:!0,contextIsolation:!0}});return h.setMenuBarVisibility(!1),h}async getSystemStatus(){const[s,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(s,t)}getWindowPosition(s,t,r){let o;const u=S.screen.getAllDisplays();if(u.length===1)o=u[0];else{if(i.isMacintosh){const I=S.screen.getCursorScreenPoint();o=S.screen.getDisplayNearestPoint(I)}!o&&s&&(o=S.screen.getDisplayMatching(s.getBounds())),o||(o=S.screen.getPrimaryDisplay()||u[0])}const h={width:t,height:r},f=o.bounds;return h.x=f.x+f.width/2-h.width/2,h.y=f.y+f.height/2-h.height/2,f.width>0&&f.height>0&&(h.x<f.x&&(h.x=f.x),h.y<f.y&&(h.y=f.y),h.x>f.x+f.width&&(h.x=f.x),h.y>f.y+f.height&&(h.y=f.y),h.width>f.width&&(h.width=f.width),h.height>f.height&&(h.height=f.height)),h}async getPerformanceInfo(){try{const[s,t]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(s,t)}catch(s){throw this.logService.warn("issueService#getPerformanceInfo ",s.message),s}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=ce([Z(2,y.IEnvironmentMainService),Z(3,k.ILaunchMainService),Z(4,L.ILogService),Z(5,n.IDiagnosticsService),Z(6,E.IDialogMainService),Z(7,b.INativeHostMainService),Z(8,D.IProductService),Z(9,p.IProtocolMainService)],c),e.IssueMainService=c}),define(X[229],Q([0,1,27,8,145,172,5,7,11,26,6,24,17,61,2,3,32,29,51,49,193,73,31,50,39,197,18,97,16,9,53,25,42,54]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t,r,o,u,h,f,I,A,F,U,q,Y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var ie;(function(V){V[V.NONE=0]="NONE",V[V.LOADING=1]="LOADING",V[V.NAVIGATING=2]="NAVIGATING",V[V.READY=3]="READY"})(ie||(ie={}));let ae=class extends d.Disposable{constructor(N,z,W,$,C,P,M,_,T,O,B,K,G,J,ee){super();this.logService=z,this.environmentMainService=W,this.fileService=$,this.configurationService=P,this.themeMainService=M,this.workspacesManagementMainService=_,this.backupMainService=T,this.telemetryService=O,this.dialogMainService=B,this.lifecycleMainService=K,this.nativeHostMainService=G,this.productService=J,this.protocolMainService=ee,this._onWillLoad=this._register(new k.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new k.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new k.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new k.Emitter),this.onDidDestroy=this._onDidDestroy.event,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this._lastFocusTime=-1,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.readyState=0;{const[re,x]=this.restoreWindowState(N.state);this.windowState=re,this.logService.trace("window#ctor: using window state",re);const ne=this.windowState.mode===0||this.windowState.mode===3,oe=this.configurationService.getValue("window"),ue={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:w.WindowMinimumSize.WIDTH,minHeight:w.WindowMinimumSize.HEIGHT,show:!ne,title:this.productService.nameLong,webPreferences:Object.assign({preload:A.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:m.browserCodeLoadingCacheStrategy,enableWebSQL:!1,enableRemoteModule:!1,spellcheck:!1,nativeWindowOpen:!0,webviewTag:!0,zoomFactor:(0,w.zoomLevelToZoomFactor)(oe==null?void 0:oe.zoomLevel)},this.environmentMainService.sandbox?{sandbox:!0,contextIsolation:!0}:{nodeIntegration:!0})};m.browserCodeLoadingCacheStrategy&&this.logService.info(`window#ctor: using vscode-file protocol and V8 cache options: ${m.browserCodeLoadingCacheStrategy}`),m.isLinux?ue.icon=(0,R.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):m.isWindows&&!this.environmentMainService.isBuilt&&(ue.icon=(0,R.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.useNativeFullScreen()&&(ue.fullscreenable=!1),m.isMacintosh&&(ue.acceptFirstMouse=!0,(oe==null?void 0:oe.clickThroughInactive)===!1&&(ue.acceptFirstMouse=!1));const ye=m.isMacintosh&&(oe==null?void 0:oe.nativeTabs)===!0;ye&&(ue.tabbingIdentifier=this.productService.nameShort);const me=(0,w.getTitleBarStyle)(this.configurationService)==="custom";if(me&&(ue.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,m.isMacintosh||(ue.frame=!1)),this._win=new y.BrowserWindow(ue),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),m.isMacintosh&&me&&this._win.setSheetOffset(22),m.isMacintosh&&x&&(!ye||y.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(de=>typeof de=="number")){const de=this.windowState;this._win.setBounds({width:de.width,height:de.height,x:de.x,y:de.y})}ne&&(this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show()),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,l.resolveMarketplaceHeaders)(this.productService.version,this.environmentMainService,this.fileService,{get:re=>C.globalStorage.get(re),store:(re,x)=>C.globalStorage.set(re,x)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.backupPath}get openedWorkspace(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.workspace}get remoteAuthority(){var N;return(N=this.currentConfig)===null||N===void 0?void 0:N.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){var N;return!!((N=this.currentConfig)===null||N===void 0?void 0:N.extensionDevelopmentPath)}get isExtensionTestHost(){var N;return!!((N=this.currentConfig)===null||N===void 0?void 0:N.extensionTestsPath)}get isExtensionDevelopmentTestFromCli(){var N;return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!((N=this.currentConfig)===null||N===void 0?void 0:N.debugId)}setRepresentedFilename(N){m.isMacintosh?this._win.setRepresentedFilename(N):this.representedFilename=N}getRepresentedFilename(){return m.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(N){m.isMacintosh&&this._win.setDocumentEdited(N),this.documentEdited=N}isDocumentEdited(){return m.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(N){m.isMacintosh&&(N==null?void 0:N.force)&&y.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(N=>{if(this.isReady)return N(this);this.whenReadyCallbacks.push(N)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(N=>{function z(){W.dispose(),$.dispose(),N()}const W=this.onDidClose(()=>z()),$=this.onWillLoad(()=>z())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(W,$)=>this.onWindowError(2,$)),this._win.webContents.on("did-fail-load",(W,$,C)=>this.onWindowError(3,C)),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const N=new Set([A.Schemas.file,A.Schemas.vscodeFileResource,A.Schemas.vscodeRemoteResource,A.Schemas.vscodeWebviewResource,"devtools"]);this._win.webContents.session.webRequest.onBeforeRequest((W,$)=>{const C=n.URI.parse(W.url);return C.path.endsWith(".svg")&&!(N.has(C.scheme)||C.path.includes(A.Schemas.vscodeRemoteResource))?$({cancel:!0}):$({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((W,$)=>{const C=W.responseHeaders,P=C["content-type"]||C["Content-Type"];if(P&&Array.isArray(P)){const M=n.URI.parse(W.url);if(M.path.endsWith(".svg")&&N.has(M.scheme))return C["Content-Type"]=["image/svg+xml"],$({cancel:!1,responseHeaders:C});if(!M.path.includes(A.Schemas.vscodeRemoteResource)&&P.some(_=>_.toLowerCase().includes("image/svg")))return $({cancel:!0})}return $({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),m.isMacintosh&&this._register(this.nativeHostMainService.onDidChangeDisplay(()=>{!this._win||!this.useNativeFullScreen()&&this.isFullScreen&&(this.setFullScreen(!1),this.setFullScreen(!0))})),this._win.on("maximize",W=>{this.currentConfig&&(this.currentConfig.maximized=!0),y.app.emit("browser-window-maximize",W,this._win)}),this._win.on("unmaximize",W=>{this.currentConfig&&(this.currentConfig.maximized=!1),y.app.emit("browser-window-unmaximize",W,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",U.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",U.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(W=>this.onDidDeleteUntitledWorkspace(W)));const z=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:z},async(W,$)=>{const C=await this.marketplaceHeadersPromise;$({cancel:!1,requestHeaders:Object.assign(W.requestHeaders,C)})})}async onWindowError(N,z){switch(N){case 2:this.logService.error(`CodeWindow: renderer process crashed (detail: ${typeof z=="string"?z:z==null?void 0:z.reason})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load workbench window: ${typeof z=="string"?z:z==null?void 0:z.reason}`);break}if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.telemetryService.publicLog2("windowerror",{type:N,reason:typeof z!="string"?z==null?void 0:z.reason:void 0}),N===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const W=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,D.localize)(0,null)),(0,o.mnemonicButtonLabel)((0,D.localize)(1,null)),(0,o.mnemonicButtonLabel)((0,D.localize)(2,null))],message:(0,D.localize)(3,null),detail:(0,D.localize)(4,null),noLink:!0},this._win);if(!this._win)return;W.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):W.response===2&&this.destroyWindow()}else if(N===2){let W;typeof z=="string"||!z?W=(0,D.localize)(5,null):W=(0,D.localize)(6,null,z.reason);const $=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,o.mnemonicButtonLabel)((0,D.localize)(7,null)),(0,o.mnemonicButtonLabel)((0,D.localize)(8,null))],message:W,detail:(0,D.localize)(9,null),noLink:!0},this._win);if(!this._win)return;$.response===0?this.reload():$.response===1&&this.destroyWindow()}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(N){var z;((z=this.openedWorkspace)===null||z===void 0?void 0:z.id)===N.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N));let z=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;(z==null?void 0:z.endsWith("/"))&&(z=z.substr(0,z.length-1));const W=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.currentHttpProxy||W!==this.currentNoProxy)){this.currentHttpProxy=z,this.currentNoProxy=W;const $=z||"",C=W?`${W},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${C}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:C,pacScript:""})}}addTabbedWindow(N){m.isMacintosh&&N.win&&this._win.addTabbedWindow(N.win)}load(N,z=Object.create(null)){var W,$;const C=($=(W=this.currentConfig)!==null&&W!==void 0?W:this.pendingLoadConfig)===null||$===void 0?void 0:$.userEnv;C&&(0,F.isLaunchedFromCli)(C)&&!(0,F.isLaunchedFromCli)(N.userEnv)&&(N.userEnv=Object.assign(Object.assign({},C),N.userEnv)),process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(N.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),this.readyState===0?this.currentConfig=N:(this.pendingLoadConfig=N,this.readyState=2),this.isDocumentEdited()&&(!z.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfigObjectUrl(N,z),(0,S.mark)("code/willOpenNewWindow"),this._win.loadURL(A.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0)),!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&(this.showTimeoutHandle=setTimeout(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)),this._onWillLoad.fire({workspace:N.workspace})}async reload(N){const z=Object.assign({},this.currentConfig);z.workspace=await this.validateWorkspace(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToWait,this.isExtensionDevelopmentHost&&N&&(z.verbose=N.verbose,z.debugId=N.debugId,z["inspect-extensions"]=N["inspect-extensions"],z["inspect-brk-extensions"]=N["inspect-brk-extensions"],z["extensions-dir"]=N["extensions-dir"]),z.isInitialStartup=!1,this.load(z,{isReload:!0,disableExtensions:N==null?void 0:N["disable-extensions"]})}async validateWorkspace(N){if((0,p.isWorkspaceIdentifier)(N.workspace)){const z=N.workspace.configPath;if(z.scheme===A.Schemas.file&&!await this.fileService.exists(z))return}else if((0,p.isSingleFolderWorkspaceIdentifier)(N.workspace)){const z=N.workspace.uri;if(z.scheme===A.Schemas.file&&!await this.fileService.exists(z))return}return N.workspace}updateConfigObjectUrl(N,z){var W;const $=Object.assign(Object.assign({},this.environmentMainService.args),N);z.disableExtensions!==void 0&&($["disable-extensions"]=z.disableExtensions),$.windowId=this._win.id,$.sessionId=`window:${this._win.id}`,$.logLevel=this.logService.getLevel(),$.logsPath=this.environmentMainService.logsPath;const C=this.configurationService.getValue("window"),P=C==null?void 0:C.zoomLevel;typeof P=="number"&&($.zoomLevel=P),$.fullscreen=this.isFullScreen,$.colorScheme={dark:y.nativeTheme.shouldUseDarkColors,highContrast:y.nativeTheme.shouldUseInvertedColorScheme||y.nativeTheme.shouldUseHighContrastColors},$.autoDetectHighContrast=(W=C==null?void 0:C.autoDetectHighContrast)!==null&&W!==void 0?W:!0,$.accessibilitySupport=y.app.accessibilitySupportEnabled,$.maximized=this._win.isMaximized(),$.perfMarks=(0,S.getMarks)(),$.partsSplashPath=(0,R.join)(this.environmentMainService.userDataPath,"rapid_render.json"),$.os={release:(0,v.release)()},$.forceEnableDeveloperKeybindings=Array.isArray($.extensionDevelopmentPath),this.configObjectUrl.update($)}serializeWindowState(){if(!this._win)return(0,b.defaultWindowState)();if(this.isFullScreen){let W;try{W=y.screen.getDisplayMatching(this.getBounds())}catch(P){}const $=(0,b.defaultWindowState)();return{mode:3,display:W?W.id:void 0,width:this.windowState.width||$.width,height:this.windowState.height||$.height,x:this.windowState.x||0,y:this.windowState.y||0}}const N=Object.create(null);let z;if(!m.isMacintosh&&this._win.isMaximized()?z=0:z=1,z===0?N.mode=0:N.mode=1,z===1||z===0){let W;z===1?W=this.getBounds():W=this._win.getNormalBounds(),N.x=W.x,N.y=W.y,N.width=W.width,N.height=W.height}return N}restoreWindowState(N){let z=!1;if(N)try{const W=y.screen.getAllDisplays();z=W.length>1,N=this.validateWindowState(N,W)}catch(W){this.logService.warn(`Unexpected error validating window state: ${W}
${W.stack}`)}return[N||(0,b.defaultWindowState)(),z]}validateWindowState(N,z){var W,$;if(this.logService.trace(`window#validateWindowState: validating window state on ${z.length} display(s)`,N),typeof N.x!="number"||typeof N.y!="number"||typeof N.width!="number"||typeof N.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(N.width<=0||N.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(z.length===1){const _=this.getWorkingArea(z[0]);if(_){this.logService.trace("window#validateWindowState: 1 monitor working area",_);function C(){!N||typeof N.x!="number"||typeof N.y!="number"||!_||(N.x<_.x&&(N.x=_.x),N.y<_.y&&(N.y=_.y))}C(),N.width>_.width&&(N.width=_.width),N.height>_.height&&(N.height=_.height),N.x>_.x+_.width-128&&(N.x=_.x+_.width-N.width),N.y>_.y+_.height-128&&(N.y=_.y+_.height-N.height),C()}return N}if(N.display&&N.mode===3){const _=z.find(T=>T.id===N.display);if(_&&typeof((W=_.bounds)===null||W===void 0?void 0:W.x)=="number"&&typeof(($=_.bounds)===null||$===void 0?void 0:$.y)=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const T=(0,b.defaultWindowState)(3);return T.x=_.bounds.x,T.y=_.bounds.y,T}}let P,M;try{P=y.screen.getDisplayMatching({x:N.x,y:N.y,width:N.width,height:N.height}),M=this.getWorkingArea(P)}catch(_){}if(P&&M&&N.x+N.width>M.x&&N.y+N.height>M.y&&N.x<M.x+M.width&&N.y<M.y+M.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",M),N}getWorkingArea(N){if(N.workArea.width>0&&N.workArea.height>0)return N.workArea;if(N.bounds.width>0&&N.bounds.height>0)return N.bounds}getBounds(){const[N,z]=this._win.getPosition(),[W,$]=this._win.getSize();return{x:N,y:z,width:W,height:$}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(N){this.useNativeFullScreen()?this.setNativeFullScreen(N):this.setSimpleFullScreen(N),this.sendWhenReady(N?"vscode:enterFullScreen":"vscode:leaveFullScreen",U.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(N){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(N)}setSimpleFullScreen(N){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(N),this._win.webContents.focus()}useNativeFullScreen(){const N=this.configurationService.getValue("window");return!N||typeof N.nativeFullScreen!="boolean"||N.nativeTabs?!0:N.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let N=(0,w.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(N)<0&&(N="classic"),N}setMenuBarVisibility(N,z=!0){m.isMacintosh||(N==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,D.localize)(10,null)),N==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(N)}):this.doSetMenuBarVisibility(N))}doSetMenuBarVisibility(N){const z=this.isFullScreen;switch(N){case"classic":this._win.setMenuBarVisibility(!z),this._win.autoHideMenuBar=z;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(y.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(N,z,...W){this.isReady?this.send(N,...W):this.ready().then(()=>{z.isCancellationRequested||this.send(N,...W)})}send(N,...z){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel ${N} for window that is destroyed`);return}this._win.webContents.send(N,...z)}}updateTouchBar(N){!m.isMacintosh||this.touchBarGroups.forEach((z,W)=>{const $=N[W];z.segments=this.createTouchBarGroupSegments($)})}createTouchBar(){if(!!m.isMacintosh){for(let N=0;N<10;N++){const z=this.createTouchBarGroup();this.touchBarGroups.push(z)}this._win.setTouchBar(new y.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(N=[]){const z=this.createTouchBarGroupSegments(N),W=new y.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:$=>{this.sendWhenReady("vscode:runAction",U.CancellationToken.None,{id:W.segments[$].id,from:"touchbar"})}});return W}createTouchBarGroupSegments(N=[]){return N.map(W=>{var $,C;let P;W.icon&&!u.ThemeIcon.isThemeIcon(W.icon)&&((C=($=W.icon)===null||$===void 0?void 0:$.dark)===null||C===void 0?void 0:C.scheme)===A.Schemas.file&&(P=y.nativeImage.createFromPath(n.URI.revive(W.icon.dark).fsPath),P.isEmpty()&&(P=void 0));let M;return typeof W.title=="string"?M=W.title:M=W.title.value,{id:W.id,label:P?void 0:M,icon:P}})}dispose(){super.dispose(),this.showTimeoutHandle&&clearTimeout(this.showTimeoutHandle),this._win=null}};ae=ce([Z(1,L.ILogService),Z(2,i.IEnvironmentMainService),Z(3,I.IFileService),Z(4,f.IStorageMainService),Z(5,g.IConfigurationService),Z(6,s.IThemeMainService),Z(7,a.IWorkspacesManagementMainService),Z(8,c.IBackupMainService),Z(9,t.ITelemetryService),Z(10,r.IDialogMainService),Z(11,h.ILifecycleMainService),Z(12,q.INativeHostMainService),Z(13,E.IProductService),Z(14,Y.IProtocolMainService)],ae),e.CodeWindow=ae}),define(X[62],Q([0,1,148,34,38,11,6,39,5,3,29,51,10,15,7,9,23,18,4,2]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,a.createDecorator)("workspacesHistoryMainService");let l=class He extends c.Disposable{constructor(f,I,A,F){super();this.stateService=f,this.logService=I,this.workspacesManagementMainService=A,this.lifecycleMainService=F,this._onDidChangeRecentlyOpened=this._register(new y.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new E.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!i.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const I=[],A=[];for(let F of f)if((0,L.isRecentWorkspace)(F))!this.workspacesManagementMainService.isUntitledWorkspace(F.workspace)&&r(I,F.workspace)===-1&&I.push(F);else if((0,L.isRecentFolder)(F))o(I,F.folderUri)===-1&&I.push(F);else{const U=u(A,F.fileUri)>=0,q=F.fileUri.scheme===m.Schemas.file&&He.COMMON_FILES_FILTER.indexOf((0,w.basename)(F.fileUri))>=0;!U&&!q&&(A.push(F),i.isWindows&&F.fileUri.scheme===m.Schemas.file&&S.app.addRecentDocument(F.fileUri.fsPath))}this.addEntriesFromStorage(I,A),I.length>He.MAX_TOTAL_RECENT_ENTRIES&&(I.length=He.MAX_TOTAL_RECENT_ENTRIES),A.length>He.MAX_TOTAL_RECENT_ENTRIES&&(A.length=He.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:I,files:A}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const I=q=>{const Y=t(q);for(const ie of f)if(w.extUriBiasedIgnorePathCase.isEqual(ie,Y))return!1;return!0},A=this.getRecentlyOpened(),F=A.workspaces.filter(I),U=A.files.filter(I);(F.length!==A.workspaces.length||U.length!==A.files.length)&&(this.saveRecentlyOpened({files:U,workspaces:F}),this._onDidChangeRecentlyOpened.fire(),i.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!!i.isMacintosh){S.app.clearRecentDocuments();const f=this.getRecentlyOpened(),I=[];let A=0;for(let U=0;U<f.workspaces.length&&A<He.MAX_MACOS_DOCK_RECENT_WORKSPACES;U++){const q=t(f.workspaces[U]);if(q.scheme===m.Schemas.file){const Y=(0,w.originalFSPath)(q);await(0,b.exists)(Y)&&(I.push(Y),A++)}}const F=[];for(let U=0;U<f.files.length&&A<He.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;U++){const q=t(f.files[U]);if(q.scheme===m.Schemas.file){const Y=(0,w.originalFSPath)(q);if(He.COMMON_FILES_FILTER.includes((0,w.basename)(q))||I.includes(Y))continue;await(0,b.exists)(Y)&&(F.push(Y),A++)}}F.reverse().forEach(U=>S.app.addRecentDocument(U)),I.reverse().forEach(U=>S.app.addRecentDocument(U))}}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),S.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){var I,A;const F=[],U=[],q=(I=f==null?void 0:f.config)===null||I===void 0?void 0:I.workspace;(0,L.isWorkspaceIdentifier)(q)&&!this.workspacesManagementMainService.isUntitledWorkspace(q)?F.push({workspace:q}):(0,L.isSingleFolderWorkspaceIdentifier)(q)&&F.push({folderUri:q.uri});const Y=(A=f==null?void 0:f.config)===null||A===void 0?void 0:A.filesToOpenOrCreate;if(Y)for(let ie of Y){const ae=ie.fileUri;ae&&u(U,ae)===-1&&U.push({fileUri:ae})}return this.addEntriesFromStorage(F,U),{workspaces:F,files:U}}addEntriesFromStorage(f,I){let A=this.getRecentlyOpenedFromStorage();for(let F of A.workspaces){let U=(0,L.isRecentFolder)(F)?o(f,F.folderUri):r(f,F.workspace);U>=0?f[U].label=f[U].label||F.label:f.push(F)}for(let F of A.files){let U=u(I,F.fileUri);U>=0?I[U].label=I[U].label||F.label:I.push(F)}}getRecentlyOpenedFromStorage(){const f=this.stateService.getItem(He.recentlyOpenedStorageKey);return(0,L.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const I=(0,L.toStoreData)(f);this.stateService.setItem(He.recentlyOpenedStorageKey,I)}updateWindowsJumpList(){if(!!i.isWindows){const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,v.localize)(0,null),description:(0,v.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let I=[];for(let U of S.app.getJumpListSettings().removedItems){const q=U.args;if(q){const Y=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(q);Y&&I.push(d.URI.parse(Y[2]))}}this.removeRecentlyOpened(I);let A=!1;const F=(0,R.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(U=>{const q=(0,L.isRecentWorkspace)(U)?U.workspace:U.folderUri,{title:Y,description:ie}=this.getWindowsJumpListLabel(q,U.label);let ae;return d.URI.isUri(q)?ae=`--folder-uri "${q.toString()}"`:(A=!0,ae=`--file-uri "${q.configPath.toString()}"`),{type:"task",title:Y.substr(0,255),description:ie.substr(0,255),program:process.execPath,args:ae,iconPath:"explorer.exe",iconIndex:0}}));F.length>0&&f.push({type:"custom",name:A?(0,v.localize)(2,null):(0,v.localize)(3,null),items:F})}f.push({type:"recent"});try{S.app.setJumpList(f)}catch(I){this.logService.warn("updateWindowsJumpList#setJumpList",I)}}}getWindowsJumpListLabel(f,I){if(I)return{title:(0,n.splitName)(I).name,description:I};if(d.URI.isUri(f))return{title:(0,w.basename)(f),description:s(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,v.localize)(4,null),description:""};let A=(0,w.basename)(f.configPath);return A.endsWith(L.WORKSPACE_EXTENSION)&&(A=A.substr(0,A.length-L.WORKSPACE_EXTENSION.length-1)),{title:(0,v.localize)(5,null,A),description:s(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=ce([Z(0,D.IStateService),Z(1,k.ILogService),Z(2,g.IWorkspacesManagementMainService),Z(3,p.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function s(h){return h.scheme==="file"?(0,n.normalizeDriveLetter)(h.fsPath):h.toString()}function t(h){return(0,L.isRecentFolder)(h)?h.folderUri:(0,L.isRecentFile)(h)?h.fileUri:h.workspace.configPath}function r(h,f){return h.findIndex(I=>(0,L.isRecentWorkspace)(I)&&I.workspace.id===f.id)}function o(h,f){return h.findIndex(I=>(0,L.isRecentFolder)(I)&&w.extUriBiasedIgnorePathCase.isEqual(I.folderUri,f))}function u(h,f){return h.findIndex(I=>w.extUriBiasedIgnorePathCase.isEqual(I.fileUri,f))}}),define(X[230],Q([0,1,141,3,26,11,61,24,31,41,17,10,6,39,32,62,177,7,38,18,42,25]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let r=class ht{constructor(h,f,I,A,F,U,q,Y,ie,ae,V){this.updateService=h,this.configurationService=f,this.windowsMainService=I,this.environmentMainService=A,this.telemetryService=F,this.workspacesHistoryMainService=U,this.stateService=q,this.lifecycleMainService=Y,this.logService=ie,this.nativeHostMainService=ae,this.productService=V,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new g.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new g.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(R.isMacintosh||(0,k.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const h=this.stateService.getItem(ht.lastKnownMenubarStorageKey);h&&(h.menus&&(this.menubarMenus=h.menus),h.keybindings&&(this.keybindings=h.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(U,q,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(U,q,Y)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:q==null?void 0:q.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(U,q,Y)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(U,q,Y)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(Y),telemetryExtraData:{from:t}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const h=this.productService.twitterUrl;h&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(h,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const I=this.productService.reportIssueUrl;I&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(I,"openReportIssues"));const A=this.productService.licenseUrl;A&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(R.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${A}${U}lang=${R.language}`,"openLicenseUrl")}else this.openUrl(A,"openLicenseUrl")});const F=this.productService.privacyStatementUrl;F&&A&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{if(R.language){const U=A.indexOf("?")>0?"&":"?";this.openUrl(`${F}${U}lang=${R.language}`,"openPrivacyStatement")}else this.openUrl(F,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(h=>this.onDidChangeWindowsCount(h)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let h=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof h!="boolean"&&(h=!0),h}get currentEnableNativeTabs(){if(!R.isMacintosh)return!1;let h=this.configurationService.getValue("window.nativeTabs");return typeof h!="boolean"&&(h=!1),h}updateMenu(h,f){this.menubarMenus=h.menus,this.keybindings=h.keybindings,this.stateService.setItem(ht.lastKnownMenubarStorageKey,h),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(h){!R.isMacintosh||(h.oldCount===0&&h.newCount>0||h.oldCount>0&&h.newCount===0)&&(this.closedLastWindow=h.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!R.isMacintosh||(this.noActiveWindow=!S.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const h=S.Menu.getApplicationMenu();if(h&&this.oldMenus.push(h),Object.keys(this.menubarMenus).length===0){S.Menu.setApplicationMenu(R.isMacintosh?new S.Menu:null);return}const f=new S.Menu;let I;if(R.isMacintosh){const O=new S.Menu;I=new S.MenuItem({label:this.productService.nameShort,submenu:O}),this.setMacApplicationMenu(O),f.append(I)}if(R.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const O=new S.Menu;O.append(new S.MenuItem({label:this.mnemonicLabel(v.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),S.app.dock.setMenu(O)}const A=new S.Menu,F=new S.MenuItem({label:this.mnemonicLabel(v.localize(1,null)),submenu:A});this.setMenuById(A,"File"),f.append(F);const U=new S.Menu,q=new S.MenuItem({label:this.mnemonicLabel(v.localize(2,null)),submenu:U});this.setMenuById(U,"Edit"),f.append(q);const Y=new S.Menu,ie=new S.MenuItem({label:this.mnemonicLabel(v.localize(3,null)),submenu:Y});this.setMenuById(Y,"Selection"),f.append(ie);const ae=new S.Menu,V=new S.MenuItem({label:this.mnemonicLabel(v.localize(4,null)),submenu:ae});this.setMenuById(ae,"View"),f.append(V);const N=new S.Menu,z=new S.MenuItem({label:this.mnemonicLabel(v.localize(5,null)),submenu:N});this.setMenuById(N,"Go"),f.append(z);const W=new S.Menu,$=new S.MenuItem({label:this.mnemonicLabel(v.localize(6,null)),submenu:W});this.setMenuById(W,"Run"),f.append($);const C=new S.Menu,P=new S.MenuItem({label:this.mnemonicLabel(v.localize(7,null)),submenu:C});this.setMenuById(C,"Terminal"),f.append(P);let M;if(this.shouldDrawMenu("Window")){const O=new S.Menu;M=new S.MenuItem({label:this.mnemonicLabel(v.localize(8,null)),submenu:O,role:"window"}),this.setMacWindowMenu(O)}M&&f.append(M);const _=new S.Menu,T=new S.MenuItem({label:this.mnemonicLabel(v.localize(9,null)),submenu:_,role:"help"});this.setMenuById(_,"Help"),f.append(T),f.items&&f.items.length>0?S.Menu.setApplicationMenu(f):S.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(h){const f=this.createMenuItem(v.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),I=this.getUpdateMenuItems();let A;if(this.shouldDrawMenu("Preferences")){const N=new S.Menu;this.setMenuById(N,"Preferences"),A=new S.MenuItem({label:this.mnemonicLabel(v.localize(11,null)),submenu:N})}const F=new S.Menu,U=new S.MenuItem({label:v.localize(12,null),role:"services",submenu:F}),q=new S.MenuItem({label:v.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),Y=new S.MenuItem({label:v.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),ie=new S.MenuItem({label:v.localize(15,null),role:"unhide"}),ae=new S.MenuItem(this.likeAction("workbench.action.quit",{label:v.localize(16,null,this.productService.nameLong),click:()=>{const N=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!S.BrowserWindow.getFocusedWindow()||(N==null?void 0:N.isMinimized()))&&this.nativeHostMainService.quit(void 0)}})),V=[f];V.push(...I),A&&V.push(o(),A),V.push(o(),U,o(),q,Y,ie,o(),ae),V.forEach(N=>h.append(N))}shouldDrawMenu(h){if(!R.isMacintosh&&(0,k.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(h){case"File":case"Help":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[h];case"Window":if(R.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[h]}}setMenu(h,f){f.forEach(I=>{if((0,b.isMenubarMenuItemSeparator)(I))h.append(o());else if((0,b.isMenubarMenuItemSubmenu)(I)){const A=new S.Menu,F=new S.MenuItem({label:this.mnemonicLabel(I.label),submenu:A});this.setMenu(A,I.submenu.items),h.append(F)}else(0,b.isMenubarMenuItemRecentAction)(I)?h.append(this.createOpenRecentMenuItem(I)):(0,b.isMenubarMenuItemAction)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(h),R.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[I.id]?h.append(new S.MenuItem(this.likeAction(I.id,{label:this.mnemonicLabel(I.label),click:this.fallbackMenuHandlers[I.id]}))):h.append(this.createMenuItem(I.label,I.id,!1,I.checked)):h.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)):h.append(this.createMenuItem(I.label,I.id,I.enabled!==!1,!!I.checked)))})}setMenuById(h,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(h,this.menubarMenus[f].items)}insertCheckForUpdatesItems(h){const f=this.getUpdateMenuItems();f.length&&(f.forEach(I=>h.append(I)),h.append(o()))}createOpenRecentMenuItem(h){const f=p.URI.revive(h.uri),I=h.id,A=I==="openRecentFile"?{fileUri:f}:I==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new S.MenuItem(this.likeAction(I,{label:h.label,click:(F,U,q)=>{const Y=this.isOptionClick(q);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[A],forceNewWindow:Y,gotoLineMode:!1,remoteAuthority:h.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(h){return!!(h&&(!R.isMacintosh&&(h.ctrlKey||h.shiftKey)||R.isMacintosh&&(h.metaKey||h.altKey)))}createRoleMenuItem(h,f,I){const A={label:this.mnemonicLabel(h),role:I,enabled:!0};return new S.MenuItem(this.withKeybinding(f,A))}setMacWindowMenu(h){const f=new S.MenuItem({label:v.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),I=new S.MenuItem({label:v.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),A=new S.MenuItem({label:v.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),F=this.createMenuItem(v.localize(20,null),"workbench.action.switchWindow"),U=[];this.currentEnableNativeTabs&&(U.push(o()),U.push(this.createMenuItem(v.localize(21,null),"workbench.action.newWindowTab")),U.push(this.createRoleMenuItem(v.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),U.push(this.createRoleMenuItem(v.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),U.push(this.createRoleMenuItem(v.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),U.push(this.createRoleMenuItem(v.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,I,o(),F,...U,o(),A].forEach(q=>h.append(q))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate");const f=this.windowsMainService.getLastActiveWindow(),I=f&&`window:${f.id}`;this.updateService.checkForUpdates(I)},0)})];case"checking for updates":return[new S.MenuItem({label:v.localize(27,null),enabled:!1})];case"available for download":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new S.MenuItem({label:v.localize(29,null),enabled:!1})];case"downloaded":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new S.MenuItem({label:v.localize(31,null),enabled:!1})];case"ready":return[new S.MenuItem({label:this.mnemonicLabel(v.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(h,f,I,A){const F=this.mnemonicLabel(h),U=typeof f=="function"?f:(V,N,z)=>{const W=V?V.userSettingsLabel:null;let $=f;Array.isArray(f)&&($=this.isOptionClick(z)?f[1]:f[0]),W&&z.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:W}):this.runActionInRenderer({type:"commandId",commandId:$})},q=typeof I=="boolean"?I:this.windowsMainService.getWindowCount()>0,Y=typeof A=="boolean"?A:!1,ie={label:F,click:U,enabled:q};Y&&(ie.type="checkbox",ie.checked=Y);let ae;return typeof f=="string"?ae=f:Array.isArray(f)&&(ae=f[0]),R.isMacintosh&&(ae==="editor.action.clipboardCutAction"?ie.role="cut":ae==="editor.action.clipboardCopyAction"?ie.role="copy":ae==="editor.action.clipboardPasteAction"&&(ie.role="paste"),ae==="undo"?ie.click=this.makeContextAwareClickHandler(U,{inDevTools:V=>V.undo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("undo:")}):ae==="redo"?ie.click=this.makeContextAwareClickHandler(U,{inDevTools:V=>V.redo(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("redo:")}):ae==="editor.action.selectAll"&&(ie.click=this.makeContextAwareClickHandler(U,{inDevTools:V=>V.selectAll(),inNoWindow:()=>S.Menu.sendActionToFirstResponder("selectAll:")}))),new S.MenuItem(this.withKeybinding(ae,ie))}makeContextAwareClickHandler(h,f){return(I,A,F)=>{const U=S.BrowserWindow.getFocusedWindow();if(!U)return f.inNoWindow();if(U.webContents.isDevToolsFocused()&&U.webContents.devToolsWebContents)return f.inDevTools(U.webContents.devToolsWebContents);h(I,A||U,F)}}runActionInRenderer(h){let f=S.BrowserWindow.getFocusedWindow();if(!f){const A=this.windowsMainService.getLastActiveWindow();(A==null?void 0:A.isMinimized())&&(f=A.win)}const I=f?this.windowsMainService.getWindowById(f.id):void 0;if(I){if(this.logService.trace("menubar#runActionInRenderer",h),R.isMacintosh&&!this.environmentMainService.isBuilt&&!I.isReady&&(h.type==="commandId"&&h.commandId==="workbench.action.toggleDevTools"||h.type!=="commandId"&&h.userSettingsLabel==="alt+cmd+i"))return;if(h.type==="commandId"){const A={id:h.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,A)}else{const A={userSettingsLabel:h.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,A)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",h)}withKeybinding(h,f){const I=typeof h=="string"?this.keybindings[h]:void 0;if(I==null?void 0:I.label){if(I.isNative!==!1)f.accelerator=I.label,f.userSettingsLabel=I.userSettingsLabel;else if(typeof f.label=="string"){const A=f.label.indexOf("[");A>=0?f.label=`${f.label.substr(0,A)} [${I.label}]`:f.label=`${f.label} [${I.label}]`}}else f.accelerator=void 0;return f}likeAction(h,f,I=!f.accelerator){I&&(f=this.withKeybinding(h,f));const A=f.click;return f.click=(F,U,q)=>{this.reportMenuActionTelemetry(h),A&&A(F,U,q)},f}openUrl(h,f){this.nativeHostMainService.openExternal(void 0,h),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(h){this.telemetryService.publicLog2("workbenchActionExecuted",{id:h,from:t})}mnemonicLabel(h){return(0,w.mnemonicMenuLabel)(h,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=ce([Z(0,i.IUpdateService),Z(1,n.IConfigurationService),Z(2,d.IWindowsMainService),Z(3,D.IEnvironmentMainService),Z(4,y.ITelemetryService),Z(5,m.IWorkspacesHistoryMainService),Z(6,a.IStateService),Z(7,c.ILifecycleMainService),Z(8,E.ILogService),Z(9,l.INativeHostMainService),Z(10,L.IProductService)],r),e.Menubar=r;function o(){return new S.MenuItem({type:"separator"})}}),define(X[231],Q([0,1,230,6,4,18]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,D.createDecorator)("menubarMainService");let k=class{constructor(y,i,L){this.instantiationService=y,this.lifecycleMainService=i,this.logService=L,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(v.Menubar)}async updateMenubar(y,i){this.logService.trace("menubarService#updateMenubar",y),(await this.menubar).updateMenu(i,y)}};k=ce([Z(0,D.IInstantiationService),Z(1,S.ILifecycleMainService),Z(2,R.ILogService)],k),e.MenubarMainService=k}),define(X[232],Q([0,1,22,8,146,34,49,26,38,229,11,18,24,6,61,98,5,17,62,3,29,4,9,7,15,71,213,51,43,2,50,13,30,39,25,16,35,54]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t,r,o,u,h,f,I,A,F,U,q,Y,ie,ae,V,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function z(C){return(0,l.isWorkspaceIdentifier)(C==null?void 0:C.workspace)}function W(C){return(0,l.isSingleFolderWorkspaceIdentifier)(C==null?void 0:C.workspace)}let $=class Ze extends A.Disposable{constructor(P,M,_,T,O,B,K,G,J,ee,re,x,ne,oe,ue){super();this.machineId=P,this.initialUserEnv=M,this.logService=_,this.stateService=T,this.environmentMainService=O,this.lifecycleMainService=B,this.backupMainService=K,this.configurationService=G,this.workspacesHistoryMainService=J,this.workspacesManagementMainService=ee,this.instantiationService=re,this.dialogMainService=x,this.fileService=ne,this.productService=oe,this.protocolMainService=ue,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new h.WindowsStateHandler(this,this.stateService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(P=>this._onDidSignalReadyWindow.fire(P.window))),this._register(this.onDidSignalReadyWindow(P=>{var M,_;if(((M=P.config)===null||M===void 0?void 0:M.extensionDevelopmentPath)||((_=P.config)===null||_===void 0?void 0:_.extensionTestsPath)){const T=new A.DisposableStore;if(T.add(b.Event.any(P.onDidClose,P.onDidDestroy)(()=>T.dispose())),P.config.extensionDevelopmentPath)for(const O of P.config.extensionDevelopmentPath)T.add(this.protocolMainService.addValidFileRoot(r.URI.file(O)));P.config.extensionTestsPath&&T.add(this.protocolMainService.addValidFileRoot(r.URI.file(P.config.extensionTestsPath)))}}))}openEmptyWindow(P,M){let _=this.environmentMainService.args;const T=(M==null?void 0:M.remoteAuthority)||void 0,O=!0,B=M==null?void 0:M.forceReuseWindow,K=!B;return this.open(Object.assign(Object.assign({},P),{cli:_,forceEmpty:O,forceNewWindow:K,forceReuseWindow:B,remoteAuthority:T}))}open(P){this.logService.trace("windowsManager#open"),P.addMode&&(P.initialStartup||!this.getLastActiveWindow())&&(P.addMode=!1);const M=[],_=[],T=[],O=[],B=[];let K,G=0;const J=this.getPathsToOpen(P);this.logService.trace("windowsManager#open pathsToOpen",J);for(const oe of J)W(oe)?P.addMode?M.push(oe):_.push(oe):z(oe)?T.push(oe):oe.fileUri?(K||(K={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:oe.remoteAuthority}),K.filesToOpenOrCreate.push(oe)):oe.backupPath?B.push({backupFolder:(0,R.basename)(oe.backupPath),remoteAuthority:oe.remoteAuthority}):G++;P.diffMode&&(K==null?void 0:K.filesToOpenOrCreate.length)===2&&(K.filesToDiff=K.filesToOpenOrCreate,K.filesToOpenOrCreate=[]),K&&P.waitMarkerFileURI&&(K.filesToWait={paths:[...K.filesToDiff,...K.filesToOpenOrCreate],waitMarkerFileUri:P.waitMarkerFileURI}),P.initialStartup?(O.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),T.push(...O),B.push(...this.backupMainService.getEmptyWindowBackupPaths())):B.length=0;const{windows:ee,filesOpenedInWindow:re}=this.doOpen(P,T,_,B,G,K,M);if(this.logService.trace(`windowsManager#open used window count ${ee.length} (workspacesToOpen: ${T.length}, foldersToOpen: ${_.length}, emptyToRestore: ${B.length}, emptyToOpen: ${G})`),ee.length>1)if(re)re.focus();else{const oe=this.windowsStateHandler.state.lastActiveWindow&&!P.forceEmpty&&!P.cli._.length&&!P.cli["file-uri"]&&!P.cli["folder-uri"]&&!(P.urisToOpen&&P.urisToOpen.length);let ue=!0,ye=!0;if(oe){const me=ee.filter(de=>this.windowsStateHandler.state.lastActiveWindow&&de.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);me.length&&(me[0].focus(),ue=!1,ye=!1)}if(ue)for(let me=ee.length-1;me>=0;me--){const de=ee[me];if(!(de.openedWorkspace&&O.some(we=>de.openedWorkspace&&we.workspace.id===de.openedWorkspace.id)||de.backupPath&&B.some(we=>de.backupPath&&we.backupFolder===(0,R.basename)(de.backupPath)))){de.focus(),ye=!1;break}}ye&&ee[ee.length-1].focus()}const x=K&&K.filesToDiff.length>0;if(!ee.some(oe=>oe.isExtensionDevelopmentHost)&&!x&&!P.noRecentEntry){const oe=[];for(const ue of J)z(ue)?oe.push({label:ue.label,workspace:ue.workspace,remoteAuthority:ue.remoteAuthority}):W(ue)?oe.push({label:ue.label,folderUri:ue.workspace.uri,remoteAuthority:ue.remoteAuthority}):ue.fileUri&&oe.push({label:ue.label,fileUri:ue.fileUri,remoteAuthority:ue.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(oe)}const ne=P.waitMarkerFileURI;return P.context===0&&ne&&ee.length===1&&ee[0]&&ee[0].whenClosedOrLoaded.then(()=>this.fileService.del(ne),()=>{}),ee}doOpen(P,M,_,T,O,B,K){const G=[];let J;function ee(me,de){G.push(me),de&&(J=me,B=void 0)}let{openFolderInNewWindow:re,openFilesInNewWindow:x}=this.shouldOpenNewWindow(P);if(!P.initialStartup&&K.length>0){const me=K[0].remoteAuthority,de=this.getLastActiveWindowForAuthority(me);de&&ee(this.doAddFoldersToExistingWindow(de,K.map(we=>we.workspace.uri)))}const ne=_.length+M.length+T.length;if(B&&ne===0){const me=B.filesToOpenOrCreate[0]||B.filesToDiff[0],de=this.getWindows().filter(De=>B&&De.remoteAuthority===B.remoteAuthority);let we;(me==null?void 0:me.fileUri)&&!x&&((P.context===4||P.context===0||P.context===1)&&(we=(0,m.findWindowOnFile)(de,me.fileUri,De=>De.configPath.scheme===t.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(De.configPath):null)),we||(we=this.doGetLastActiveWindow(de))),we?(0,l.isWorkspaceIdentifier)(we.openedWorkspace)?M.push({workspace:we.openedWorkspace,remoteAuthority:we.remoteAuthority}):(0,l.isSingleFolderWorkspaceIdentifier)(we.openedWorkspace)?_.push({workspace:we.openedWorkspace,remoteAuthority:we.remoteAuthority}):ee(this.doOpenFilesInExistingWindow(P,we,B),!0):ee(this.openInBrowserWindow({userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,filesToOpen:B,forceNewWindow:!0,remoteAuthority:B.remoteAuthority,forceNewTabbedWindow:P.forceNewTabbedWindow}),!0)}const oe=(0,S.distinct)(M,me=>me.workspace.id);if(oe.length>0){const me=(0,S.coalesce)(oe.map(de=>(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.configPath)));if(me.length>0){const de=me[0],we=(B==null?void 0:B.remoteAuthority)===de.remoteAuthority?B:void 0;ee(this.doOpenFilesInExistingWindow(P,de,we),!!we),re=!0}oe.forEach(de=>{if(!me.some(Le=>Le.openedWorkspace&&Le.openedWorkspace.id===de.workspace.id)){const we=de.remoteAuthority,De=(B==null?void 0:B.remoteAuthority)===we?B:void 0;ee(this.doOpenFolderOrWorkspace(P,de,re,De),!!De),re=!0}})}const ue=(0,S.distinct)(_,me=>o.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(ue.length>0){const me=(0,S.coalesce)(ue.map(de=>(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),de.workspace.uri)));if(me.length>0){const de=me[0],we=(B==null?void 0:B.remoteAuthority)===de.remoteAuthority?B:void 0;ee(this.doOpenFilesInExistingWindow(P,de,we),!!we),re=!0}ue.forEach(de=>{if(!me.some(Le=>(0,l.isSingleFolderWorkspaceIdentifier)(Le.openedWorkspace)&&o.extUriBiasedIgnorePathCase.isEqual(Le.openedWorkspace.uri,de.workspace.uri))){const we=de.remoteAuthority,De=(B==null?void 0:B.remoteAuthority)===we?B:void 0;ee(this.doOpenFolderOrWorkspace(P,de,re,De),!!De),re=!0}})}const ye=(0,S.distinct)(T,me=>me.backupFolder);if(ye.length>0&&ye.forEach(me=>{const de=me.remoteAuthority,we=(B==null?void 0:B.remoteAuthority)===de?B:void 0;ee(this.openInBrowserWindow({userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,filesToOpen:we,remoteAuthority:de,forceNewWindow:!0,forceNewTabbedWindow:P.forceNewTabbedWindow,emptyWindowBackupInfo:me}),!!we),re=!0}),G.length===0||B){B&&!O&&O++;const me=B?B.remoteAuthority:P.remoteAuthority;for(let de=0;de<O;de++)ee(this.doOpenEmpty(P,re,me,B),!!B),re=!0}return{windows:(0,S.distinct)(G),filesOpenedInWindow:J}}doOpenFilesInExistingWindow(P,M,_){var T;this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),M.focus();const O={filesToOpenOrCreate:_==null?void 0:_.filesToOpenOrCreate,filesToDiff:_==null?void 0:_.filesToDiff,filesToWait:_==null?void 0:_.filesToWait,termProgram:(T=P==null?void 0:P.userEnv)===null||T===void 0?void 0:T.TERM_PROGRAM};return M.sendWhenReady("vscode:openFiles",ie.CancellationToken.None,O),M}doAddFoldersToExistingWindow(P,M){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),P.focus();const _={foldersToAdd:M};return P.sendWhenReady("vscode:addFolders",ie.CancellationToken.None,_),P}doOpenEmpty(P,M,_,T,O){return!M&&!O&&typeof P.contextWindowId=="number"&&(O=this.getWindowById(P.contextWindowId)),this.openInBrowserWindow({userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,remoteAuthority:_,forceNewWindow:M,forceNewTabbedWindow:P.forceNewTabbedWindow,filesToOpen:T,windowToUse:O})}doOpenFolderOrWorkspace(P,M,_,T,O){return!_&&!O&&typeof P.contextWindowId=="number"&&(O=this.getWindowById(P.contextWindowId)),this.openInBrowserWindow({workspace:M.workspace,userEnv:P.userEnv,cli:P.cli,initialStartup:P.initialStartup,remoteAuthority:M.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:P.forceNewTabbedWindow,filesToOpen:T,windowToUse:O})}getPathsToOpen(P){var M;let _,T=!1,O=!1;if(P.urisToOpen&&P.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(P),T=!0):P.forceEmpty?_=[Object.create(null)]:P.cli._.length||P.cli["folder-uri"]||P.cli["file-uri"]?(_=this.doExtractPathsFromCLI(P.cli),_.length===0&&_.push(Object.create(null)),T=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),O=!0),!P.addMode&&T){const B=_.filter(K=>W(K));if(B.length>1){const K=B[0].remoteAuthority;if(B.every(G=>G.remoteAuthority===K)){const G=this.workspacesManagementMainService.createUntitledWorkspaceSync(B.map(J=>({uri:J.workspace.uri})));_.push({workspace:G,remoteAuthority:K}),_=_.filter(J=>!W(J))}}}return P.initialStartup&&!O&&((M=this.configurationService.getValue("window"))===null||M===void 0?void 0:M.restoreWindows)==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter(B=>z(B)||W(B)||B.backupPath)),_}doExtractPathsFromAPI(P){const M=[],_={gotoLineMode:P.gotoLineMode,remoteAuthority:P.remoteAuthority};for(const T of(0,S.coalesce)(P.urisToOpen||[])){const O=this.resolveOpenable(T,_);if(O)O.label=T.label,M.push(O);else{const B=this.resourceFromOpenable(T),K={title:this.productService.nameLong,type:"info",buttons:[(0,D.localize)(0,null)],message:B.scheme===t.Schemas.file?(0,D.localize)(1,null):(0,D.localize)(2,null),detail:B.scheme===t.Schemas.file?(0,D.localize)(3,null,(0,Y.getPathLabel)(B.fsPath,this.environmentMainService)):(0,D.localize)(4,null,B.toString()),noLink:!0};this.dialogMainService.showMessageBox(K,(0,U.withNullAsUndefined)(L.BrowserWindow.getFocusedWindow()))}}return M}doExtractPathsFromCLI(P){const M=[],_={ignoreFileNotFound:!0,gotoLineMode:P.goto,remoteAuthority:P.remote||void 0,forceOpenWorkspaceAsFile:!1},T=P["folder-uri"];if(T)for(const K of T){const G=this.cliArgToUri(K);if(G){const J=this.resolveOpenable({folderUri:G},_);J&&M.push(J)}}const O=P["file-uri"];if(O)for(const K of O){const G=this.cliArgToUri(K);if(G){const J=this.resolveOpenable((0,l.hasWorkspaceFileExtension)(K)?{workspaceUri:G}:{fileUri:G},_);J&&M.push(J)}}const B=P._;for(const K of B){const G=P.remote?this.doResolvePathRemote(K,P.remote):this.doResolveFilePath(K,_);G&&M.push(G)}return M}cliArgToUri(P){try{const M=r.URI.parse(P);if(!M.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${P}`);return}return M}catch(M){this.logService.error(`Invalid URI input string: ${P}, ${M.message}`)}}doGetPathsFromLastSession(){const P=this.getRestoreWindowsSetting();switch(P){case"none":return[];case"one":case"all":case"preserve":case"folders":const M=[];P!=="one"&&M.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&M.push(this.windowsStateHandler.state.lastActiveWindow);const _=[];for(const T of M)if(T.workspace){const O=this.resolveOpenable({workspaceUri:T.workspace.configPath},{remoteAuthority:T.remoteAuthority});z(O)&&_.push(O)}else if(T.folderUri){const O=this.resolveOpenable({folderUri:T.folderUri},{remoteAuthority:T.remoteAuthority});W(O)&&_.push(O)}else P!=="folders"&&T.backupPath&&_.push({backupPath:T.backupPath,remoteAuthority:T.remoteAuthority});return _}}getRestoreWindowsSetting(){let P;if(this.lifecycleMainService.wasRestarted)P="all";else{const M=this.configurationService.getValue("window");P=(M==null?void 0:M.restoreWindows)||"all",["preserve","all","folders","one","none"].includes(P)||(P="all")}return P}resolveOpenable(P,M={}){let _=this.resourceFromOpenable(P);return _.scheme===t.Schemas.file?((0,d.isFileToOpen)(P)&&(M=Object.assign(Object.assign({},M),{forceOpenWorkspaceAsFile:!0})),this.doResolveFilePath(_.fsPath,M)):this.doResolveRemoteOpenable(P,M)}doResolveRemoteOpenable(P,M){let _=this.resourceFromOpenable(P);const T=(0,u.getRemoteAuthority)(_)||M.remoteAuthority;if(_=(0,o.removeTrailingPathSeparator)((0,o.normalizePath)(_)),(0,d.isFileToOpen)(P)){if(M.gotoLineMode){const{path:O,line:B,column:K}=(0,q.parseLineAndColumnAware)(_.path);return{fileUri:_.with({path:O}),lineNumber:B,columnNumber:K,remoteAuthority:T}}return{fileUri:_,remoteAuthority:T}}else if((0,d.isWorkspaceToOpen)(P))return{workspace:(0,f.getWorkspaceIdentifier)(_),remoteAuthority:T};return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(_),remoteAuthority:T}}resourceFromOpenable(P){return(0,d.isWorkspaceToOpen)(P)?P.workspaceUri:(0,d.isFolderToOpen)(P)?P.folderUri:P.fileUri}doResolveFilePath(P,M){let _,T;if(M.gotoLineMode){const O=(0,q.parseLineAndColumnAware)(P);_=O.line,T=O.column,P=O.path}P=(0,q.sanitizeFilePath)((0,R.normalize)(P),(0,V.cwd)());try{const O=(0,v.statSync)(P);if(O.isFile()){if(!M.forceOpenWorkspaceAsFile){const B=this.workspacesManagementMainService.resolveLocalWorkspaceSync(r.URI.file(P));if(B)return{workspace:{id:B.id,configPath:B.configPath},remoteAuthority:B.remoteAuthority,exists:!0}}return{fileUri:r.URI.file(P),lineNumber:_,columnNumber:T,exists:!0}}else if(O.isDirectory())return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(r.URI.file(P),O),exists:!0}}catch(O){const B=r.URI.file(P);if(this.workspacesHistoryMainService.removeRecentlyOpened([B]),M.ignoreFileNotFound)return{fileUri:B,exists:!1}}}doResolvePathRemote(P,M,_){const T=P.charCodeAt(0);T!==47&&((0,q.isWindowsDriveLetter)(T)&&P.charCodeAt(P.charCodeAt(1))===58&&(P=(0,q.toSlashes)(P)),P=`/${P}`);const O=r.URI.from({scheme:t.Schemas.vscodeRemote,authority:M,path:P});if(P.charCodeAt(P.length-1)!==47){if((0,l.hasWorkspaceFileExtension)(P))return _?{fileUri:O,remoteAuthority:M}:{workspace:(0,f.getWorkspaceIdentifier)(O),remoteAuthority:M};if(R.posix.basename(P).indexOf(".")!==-1)return{fileUri:O,remoteAuthority:M}}return{workspace:(0,f.getSingleFolderWorkspaceIdentifier)(O),remoteAuthority:M}}shouldOpenNewWindow(P){const M=this.configurationService.getValue("window"),_=(M==null?void 0:M.openFoldersInNewWindow)||"default",T=(M==null?void 0:M.openFilesInNewWindow)||"off";let O=(P.preferNewWindow||P.forceNewWindow)&&!P.forceReuseWindow;!P.forceNewWindow&&!P.forceReuseWindow&&(_==="on"||_==="off")&&(O=_==="on");let B=!1;return P.forceNewWindow||P.forceReuseWindow?B=!!P.forceNewWindow&&!P.forceReuseWindow:(c.isMacintosh?P.context===1&&(B=!0):P.context!==3&&P.context!==2&&!(P.userEnv&&P.userEnv.TERM_PROGRAM==="vscode")&&(B=!0),!P.cli.extensionDevelopmentPath&&(T==="on"||T==="off")&&(B=T==="on")),{openFolderInNewWindow:!!O,openFilesInNewWindow:B}}openExtensionDevelopmentHostWindow(P,M){const _=(0,m.findWindowOnExtensionDevelopmentPath)(this.getWindows(),P);if(_)return this.lifecycleMainService.reload(_,M.cli),_.focus(),[_];let T=M.cli["folder-uri"]||[],O=M.cli["file-uri"]||[],B=M.cli._;if(!B.length&&!T.length&&!O.length&&!M.cli.extensionTestsPath){const ee=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,re=ee&&(ee.workspace||ee.folderUri);re&&(r.URI.isUri(re)?re.scheme===t.Schemas.file?B=[re.fsPath]:T=[re.toString()]:re.configPath.scheme===t.Schemas.file?B=[(0,o.originalFSPath)(re.configPath)]:O=[re.configPath.toString()])}let K=M.remoteAuthority;for(const ee of P)if(ee.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const re=r.URI.parse(ee),x=(0,u.getRemoteAuthority)(re);x&&(K?x!==K&&this.logService.error("more than one extension development path authority"):K=x)}B=B.filter(ee=>{const re=r.URI.file(ee);return(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:(0,u.getRemoteAuthority)(re)===K}),T=T.filter(ee=>{const re=this.cliArgToUri(ee);return re&&!!(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,u.getRemoteAuthority)(re)===K:!1}),O=O.filter(ee=>{const re=this.cliArgToUri(ee);return re&&!!(0,m.findWindowOnWorkspaceOrFolder)(this.getWindows(),re)?!1:re?(0,u.getRemoteAuthority)(re)===K:!1}),M.cli._=B,M.cli["folder-uri"]=T,M.cli["file-uri"]=O;const G=!B.length&&!T.length&&!O.length,J={context:M.context,cli:M.cli,forceNewWindow:!0,forceEmpty:G,userEnv:M.userEnv,noRecentEntry:!0,waitMarkerFileURI:M.waitMarkerFileURI,remoteAuthority:K};return this.open(J)}openInBrowserWindow(P){var M;const _=Object.assign({},P.cli);_.appRoot=this.environmentMainService.appRoot,_.machineId=this.machineId,_.nodeCachedDataDir=this.environmentMainService.nodeCachedDataDir,_.mainPid=process.pid,_.execPath=process.execPath,_.userEnv=Object.assign(Object.assign({},this.initialUserEnv),P.userEnv),_.isInitialStartup=P.initialStartup,_.workspace=P.workspace,_.remoteAuthority=P.remoteAuthority;const T=P.filesToOpen;T&&(_.filesToOpenOrCreate=T.filesToOpenOrCreate,_.filesToDiff=T.filesToDiff,_.filesToWait=T.filesToWait),P.emptyWindowBackupInfo&&(_.backupPath=(0,R.join)(this.environmentMainService.backupHome,P.emptyWindowBackupInfo.backupFolder));let O;if(!P.forceNewWindow&&!P.forceNewTabbedWindow&&(O=P.windowToUse||this.getLastActiveWindow(),O&&O.focus()),O){const B=O.config;!_.extensionDevelopmentPath&&B&&!!B.extensionDevelopmentPath&&(_.extensionDevelopmentPath=B.extensionDevelopmentPath,_.verbose=B.verbose,_["inspect-brk-extensions"]=B["inspect-brk-extensions"],_.debugId=B.debugId,_["inspect-extensions"]=B["inspect-extensions"],_["extensions-dir"]=B["extensions-dir"])}else{const B=this.windowsStateHandler.getNewWindowState(_),K=O=this.instantiationService.createInstance(i.CodeWindow,{state:B,extensionDevelopmentPath:_.extensionDevelopmentPath,isExtensionTestHost:!!_.extensionTestsPath});if(P.forceNewTabbedWindow){const J=this.getLastActiveWindow();J&&J.addTabbedWindow(K)}Ze.WINDOWS.push(K),this._onDidOpenWindow.fire(K),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,I.once)(K.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(K)),(0,I.once)(K.onDidClose)(()=>this.onWindowClosed(K)),(0,I.once)(K.onDidDestroy)(()=>this._onDidDestroyWindow.fire(K));const G=(0,U.assertIsDefined)((M=K.win)===null||M===void 0?void 0:M.webContents);G.removeAllListeners("devtools-reload-page"),G.on("devtools-reload-page",()=>this.lifecycleMainService.reload(K)),this.lifecycleMainService.registerWindow(K)}return O.isReady?this.lifecycleMainService.unload(O,4).then(B=>{B||this.doOpenInBrowserWindow(O,_,P)}):this.doOpenInBrowserWindow(O,_,P),O}doOpenInBrowserWindow(P,M,_){if(!M.extensionDevelopmentPath)if((0,l.isWorkspaceIdentifier)(M.workspace))M.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:M.workspace,remoteAuthority:M.remoteAuthority});else if((0,l.isSingleFolderWorkspaceIdentifier)(M.workspace))M.backupPath=this.backupMainService.registerFolderBackupSync(M.workspace.uri);else{const T=_.emptyWindowBackupInfo&&_.emptyWindowBackupInfo.backupFolder;M.backupPath=this.backupMainService.registerEmptyWindowBackupSync(T,M.remoteAuthority)}P.load(M)}onWindowClosed(P){const M=Ze.WINDOWS.indexOf(P);Ze.WINDOWS.splice(M,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const P=L.BrowserWindow.getFocusedWindow();if(P)return this.getWindowById(P.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(P){return this.doGetLastActiveWindow(this.getWindows().filter(M=>M.remoteAuthority===P))}doGetLastActiveWindow(P){const M=Math.max.apply(Math,P.map(_=>_.lastFocusTime));return P.find(_=>_.lastFocusTime===M)}sendToFocused(P,...M){const _=this.getFocusedWindow()||this.getLastActiveWindow();_&&_.sendWhenReady(P,ie.CancellationToken.None,...M)}sendToAll(P,M,_){for(const T of this.getWindows())_&&_.indexOf(T.id)>=0||T.sendWhenReady(P,ie.CancellationToken.None,M)}getWindows(){return Ze.WINDOWS}getWindowCount(){return Ze.WINDOWS.length}getWindowById(P){const M=this.getWindows().filter(_=>_.id===P);return(0,S.firstOrDefault)(M)}getWindowByWebContents(P){const M=L.BrowserWindow.fromWebContents(P);if(!!M)return this.getWindowById(M.id)}};$.WINDOWS=[],$=ce([Z(2,w.ILogService),Z(3,y.IStateService),Z(4,n.IEnvironmentMainService),Z(5,g.ILifecycleMainService),Z(6,k.IBackupMainService),Z(7,E.IConfigurationService),Z(8,a.IWorkspacesHistoryMainService),Z(9,f.IWorkspacesManagementMainService),Z(10,s.IInstantiationService),Z(11,F.IDialogMainService),Z(12,ae.IFileService),Z(13,p.IProductService),Z(14,N.IProtocolMainService)],$),e.WindowsMainService=$}),define(X[233],Q([0,1,51,32,62,49]),function(j,e,v,R,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let k=class{constructor(y,i,L,g){this.workspacesManagementMainService=y,this.windowsMainService=i,this.workspacesHistoryMainService=L,this.backupMainService=g,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(y,i){const L=this.windowsMainService.getWindowById(y);return L?this.workspacesManagementMainService.enterWorkspace(L,this.windowsMainService.getWindows(),i):null}createUntitledWorkspace(y,i,L){return this.workspacesManagementMainService.createUntitledWorkspace(i,L)}deleteUntitledWorkspace(y,i){return this.workspacesManagementMainService.deleteUntitledWorkspace(i)}getWorkspaceIdentifier(y,i){return this.workspacesManagementMainService.getWorkspaceIdentifier(i)}async getRecentlyOpened(y){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(y))}async addRecentlyOpened(y,i){return this.workspacesHistoryMainService.addRecentlyOpened(i)}async removeRecentlyOpened(y,i){return this.workspacesHistoryMainService.removeRecentlyOpened(i)}async clearRecentlyOpened(y){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};k=ce([Z(0,v.IWorkspacesManagementMainService),Z(1,R.IWindowsMainService),Z(2,D.IWorkspacesHistoryMainService),Z(3,S.IBackupMainService)],k),e.WorkspacesMainService=k}),define(X[234],Q([0,1,27,22,11,3,232,18,69,41,199,33,120,83,223,99,4,70,67,6,38,26,24,96,200,31,95,194,195,191,17,217,2,32,7,29,233,65,227,225,224,228,175,19,202,218,231,117,8,15,129,9,226,97,211,216,49,62,201,51,68,152,42,50,13,39,208,204,16,44,28,21,88,209,189,53,30,25,163,178,43,71,72]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t,r,o,u,h,f,I,A,F,U,q,Y,ie,ae,V,N,z,W,$,C,P,M,_,T,O,B,K,G,J,ee,re,x,ne,oe,ue,ye,me,de,we,De,Le,We,Ne,Ve,xe,Xe,Ge,st,Be,it,H,te,se,le,fe,pe,be,Te,Oe,Ue,je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let ot=class extends q.Disposable{constructor(ge,ve,Me,he,Ee,Se,Ie,Pe,ke,_e){super();this.mainProcessNodeIpcServer=ge,this.userEnv=ve,this.mainInstantiationService=Me,this.logService=he,this.environmentMainService=Ee,this.lifecycleMainService=Se,this.configurationService=Ie,this.stateService=Pe,this.fileService=ke,this.productService=_e,this.registerListeners()}registerListeners(){(0,M.setUnexpectedErrorHandler)(he=>this.onUnexpectedError(he)),process.on("uncaughtException",he=>this.onUnexpectedError(he)),process.on("unhandledRejection",he=>(0,M.onUnexpectedError)(he)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,B.registerContextMenuListener)(),D.app.on("accessibility-support-changed",(he,Ee)=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.sendToAll("vscode:accessibilitySupportChanged",Ee)}),D.app.on("activate",(he,Ee)=>{var Se;this.logService.trace("app#activate"),Ee||(Se=this.windowsMainService)===null||Se===void 0||Se.openEmptyWindow({context:1})}),D.app.on("remote-require",(he,Ee,Se)=>{this.logService.trace("app#on(remote-require): prevented"),he.preventDefault()}),D.app.on("remote-get-global",(he,Ee,Se)=>{this.logService.trace(`app#on(remote-get-global): prevented on ${Se}`),he.preventDefault()}),D.app.on("remote-get-builtin",(he,Ee,Se)=>{this.logService.trace(`app#on(remote-get-builtin): prevented on ${Se}`),Se!=="clipboard"&&he.preventDefault()}),D.app.on("remote-get-current-window",he=>{this.logService.trace("app#on(remote-get-current-window): prevented"),he.preventDefault()}),D.app.on("remote-get-current-web-contents",he=>{this.environmentMainService.args.driver||(this.logService.trace("app#on(remote-get-current-web-contents): prevented"),he.preventDefault())}),D.app.on("web-contents-created",(he,Ee)=>{Ee.on("will-attach-webview",(Ie,Pe,ke)=>{const _e=Fe=>{if(!Fe)return!1;const ze=ie.URI.parse(Fe);if(ze.scheme===ee.Schemas.vscodeWebview)return ze.path==="/index.html"||ze.path==="/electron-browser/index.html";const Ke=ze.fsPath.toLowerCase(),Re=ie.URI.file(this.environmentMainService.appRoot).fsPath.toLowerCase();return Ke.startsWith(Re+K.sep)};delete Pe.preload,Pe.nodeIntegration=!1,!(_e(ke.src)&&_e(Pe.preloadURL))&&(delete Pe.preloadURL,this.logService.error("webContents#web-contents-created: Prevented webview attach"),Ie.preventDefault())}),Ee.on("will-navigate",Ie=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Ie.preventDefault()}),Ee.on("new-window",(Ie,Pe)=>{var ke;Ie.preventDefault(),(ke=this.nativeHostMainService)===null||ke===void 0||ke.openExternal(void 0,Pe)});const Se="about:blank?webviewFrame";D.session.defaultSession.setPermissionRequestHandler((Ie,Pe,ke,_e)=>_e.requestingUrl===Se?ke(Pe==="clipboard-read"):ke(!1)),D.session.defaultSession.setPermissionCheckHandler((Ie,Pe,ke,_e)=>_e.requestingUrl===Se?Pe==="clipboard-read":!1)});let ge=[],ve=null;D.app.on("open-file",(he,Ee)=>{this.logService.trace("app#open-file: ",Ee),he.preventDefault(),ge.push(this.getWindowOpenableFromPathSync(Ee)),ve!==null&&(clearTimeout(ve),ve=null),ve=setTimeout(()=>{var Se;(Se=this.windowsMainService)===null||Se===void 0||Se.open({context:1,cli:this.environmentMainService.args,urisToOpen:ge,gotoLineMode:!1,preferNewWindow:!0}),ge=[],ve=null},100)}),D.app.on("new-window-for-tab",()=>{var he;(he=this.windowsMainService)===null||he===void 0||he.openEmptyWindow({context:4})});let Me=!1;D.ipcMain.on("vscode:fetchShellEnv",async he=>{var Ee;const Se=he.sender;let Ie=!1;function Pe($e){clearTimeout(_e),clearTimeout(ze),Ie||(Ie=!0,Se.isDestroyed()||Se.send("vscode:acceptShellEnv",$e))}const ke=new pe.CancellationTokenSource,_e=setTimeout(()=>{var $e;Me||(($e=this.windowsMainService)===null||$e===void 0||$e.sendToFocused("vscode:showShellEnvSlowWarning",ke.token),Me=!0)},3e3),Fe=(Ee=this.windowsMainService)===null||Ee===void 0?void 0:Ee.getWindowByWebContents(he.sender),ze=setTimeout(()=>{ke.dispose(!0),Fe==null||Fe.sendWhenReady("vscode:showShellEnvTimeoutError",pe.CancellationToken.None),Pe({})},1e4);let Ke,Re;(Fe==null?void 0:Fe.config)?(Ke=Fe.config,Re=Object.assign(Object.assign({},process.env),Fe.config.userEnv)):(Ke=this.environmentMainService.args,Re=process.env);const Qe=await(0,y.resolveShellEnv)(this.logService,Ke,Re);Pe(Qe)}),D.ipcMain.handle("vscode:writeNlsFile",async(he,Ee,Se)=>{const Ie=this.validateNlsPath([Ee]);if(!Ie||typeof Se!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Ie,it.VSBuffer.fromString(Se))}),D.ipcMain.handle("vscode:readNlsFile",async(he,...Ee)=>{const Se=this.validateNlsPath(Ee);if(!Se)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Se)).value.toString()}),D.ipcMain.on("vscode:toggleDevTools",he=>he.sender.toggleDevTools()),D.ipcMain.on("vscode:openDevTools",he=>he.sender.openDevTools()),D.ipcMain.on("vscode:reloadWindow",he=>he.sender.reload())}validateNlsPath(ge){let ve;for(const Me of ge)typeof Me=="string"&&(typeof ve!="string"?ve=Me:ve=(0,K.join)(ve,Me));if(!(typeof ve!="string"||!(0,K.isAbsolute)(ve)||!(0,fe.isEqualOrParent)(ve,this.environmentMainService.cachedLanguagesPath,!S.isLinux)))return ie.URI.file(ve)}onUnexpectedError(ge){var ve;if(ge){const Me={message:`[uncaught exception in main]: ${ge.message}`,stack:ge.stack};(ve=this.windowsMainService)===null||ve===void 0||ve.sendToFocused("vscode:reportError",JSON.stringify(Me))}this.logService.error(`[uncaught exception in main]: ${ge}`),ge.stack&&this.logService.error(ge.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const ge=this.productService.win32AppUserModelId;S.isWindows&&ge&&D.app.setAppUserModelId(ge);try{S.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!D.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&D.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(ke){this.logService.error(ke)}const ve=new E.Server;this.logService.trace("Resolving machine identifier...");const Me=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Me}`);const{sharedProcess:he,sharedProcessReady:Ee,sharedProcessClient:Se}=this.setupSharedProcess(Me),Ie=await this.initServices(Me,he,Ee);if(this.environmentMainService.driverHandle){const ke=await(0,T.serve)(ve,this.environmentMainService.driverHandle,this.environmentMainService,Ie);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(ke)}this._register(Ie.createInstance(U.ProxyAuthHandler)),Ie.invokeFunction(ke=>this.initChannels(ke,ve,Se));const Pe=Ie.invokeFunction(ke=>this.openFirstWindow(ke,ve));Ie.invokeFunction(ke=>this.afterWindowOpen(ke,he)),this.environmentMainService.args.trace&&Ie.invokeFunction(ke=>this.stopTracingEventually(ke,Pe))}async resolveMachineId(){let ge=this.stateService.getItem(u.machineIdKey);return(!ge||S.isMacintosh&&ge==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(ge=await(0,N.getMachineId)(),this.stateService.setItem(u.machineIdKey,ge)),ge}setupSharedProcess(ge){const ve=this._register(this.mainInstantiationService.createInstance(d.SharedProcess,ge,this.userEnv)),Me=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Ee=await ve.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new w.Client(Ee,"main")})(),he=(async()=>(await ve.whenReady(),Me))();return{sharedProcess:ve,sharedProcessReady:he,sharedProcessClient:Me}}async initServices(ge,ve,Me){const he=new p.ServiceCollection;switch(process.platform){case"win32":he.set(i.IUpdateService,new a.SyncDescriptor(z.Win32UpdateService));break;case"linux":S.isLinuxSnap?he.set(i.IUpdateService,new a.SyncDescriptor(re.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):he.set(i.IUpdateService,new a.SyncDescriptor(W.LinuxUpdateService));break;case"darwin":he.set(i.IUpdateService,new a.SyncDescriptor($.DarwinUpdateService));break}he.set(Y.IWindowsMainService,new a.SyncDescriptor(k.WindowsMainService,[ge,this.userEnv])),he.set(We.IDialogMainService,new a.SyncDescriptor(We.DialogMainService)),he.set(m.ILaunchMainService,new a.SyncDescriptor(m.LaunchMainService)),he.set(we.IDiagnosticsService,g.ProxyChannel.toService((0,g.getDelayedChannel)(Me.then(Se=>Se.getChannel("diagnostics"))))),he.set(C.IIssueMainService,new a.SyncDescriptor(C.IssueMainService,[ge,this.userEnv])),he.set(H.IEncryptionMainService,new a.SyncDescriptor(H.EncryptionMainService,[ge])),he.set(se.IKeyboardLayoutMainService,new a.SyncDescriptor(se.KeyboardLayoutMainService)),he.set(Le.INativeHostMainService,new a.SyncDescriptor(Le.NativeHostMainService,[ve])),he.set(Xe.IWebviewManagerService,new a.SyncDescriptor(xe.WebviewMainService)),he.set(ae.IWorkspacesService,new a.SyncDescriptor(V.WorkspacesMainService)),he.set(de.IWorkspacesManagementMainService,new a.SyncDescriptor(de.WorkspacesManagementMainService)),he.set(ye.IWorkspacesHistoryMainService,new a.SyncDescriptor(ye.WorkspacesHistoryMainService)),he.set(O.IMenubarMainService,new a.SyncDescriptor(O.MenubarMainService)),he.set(be.IExtensionUrlTrustService,new a.SyncDescriptor(Te.ExtensionUrlTrustService)),he.set(x.IStorageMainService,new a.SyncDescriptor(x.StorageMainService));const Ee=new oe.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(he.set(ue.IBackupMainService,Ee),he.set(r.IURLService,new a.SyncDescriptor(me.NativeURLService)),!this.environmentMainService.isExtensionDevelopment&&!this.environmentMainService.args["disable-telemetry"]&&!!this.productService.enableTelemetry){const Se=(0,g.getDelayedChannel)(Me.then(Fe=>Fe.getChannel("telemetryAppender"))),Ie=new f.TelemetryAppenderClient(Se),Pe=(0,A.resolveCommonProperties)(this.fileService,(0,v.release)(),process.arch,this.productService.commit,this.productService.version,ge,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),ke=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],_e={appender:Ie,commonProperties:Pe,piiPaths:ke,sendErrorTelemetry:!0};he.set(u.ITelemetryService,new a.SyncDescriptor(I.TelemetryService,[_e]))}else he.set(u.ITelemetryService,h.NullTelemetryService);return await Ee.initialize(),this.mainInstantiationService.createChild(he)}initChannels(ge,ve,Me){const he=g.ProxyChannel.fromService(ge.get(m.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",he);const Ee=new L.UpdateChannel(ge.get(i.IUpdateService));ve.registerChannel("update",Ee);const Se=g.ProxyChannel.fromService(ge.get(C.IIssueMainService));ve.registerChannel("issue",Se);const Ie=g.ProxyChannel.fromService(ge.get(H.IEncryptionMainService));ve.registerChannel("encryption",Ie);const Pe=g.ProxyChannel.fromService(ge.get(je.ISignService));ve.registerChannel("sign",Pe);const ke=g.ProxyChannel.fromService(ge.get(se.IKeyboardLayoutMainService));ve.registerChannel("keyboardLayout",ke),this.nativeHostMainService=ge.get(Le.INativeHostMainService);const _e=g.ProxyChannel.fromService(this.nativeHostMainService);ve.registerChannel("nativeHost",_e),Me.then(qe=>qe.registerChannel("nativeHost",_e));const Fe=g.ProxyChannel.fromService(ge.get(ae.IWorkspacesService));ve.registerChannel("workspaces",Fe);const ze=g.ProxyChannel.fromService(ge.get(O.IMenubarMainService));ve.registerChannel("menubar",ze);const Ke=g.ProxyChannel.fromService(ge.get(r.IURLService));ve.registerChannel("url",Ke);const Re=g.ProxyChannel.fromService(ge.get(be.IExtensionUrlTrustService));ve.registerChannel("extensionUrlTrust",Re);const Qe=g.ProxyChannel.fromService(ge.get(Xe.IWebviewManagerService));ve.registerChannel("webview",Qe);const $e=this._register(new ne.StorageDatabaseChannel(this.logService,ge.get(x.IStorageMainService)));ve.registerChannel("storage",$e),Me.then(qe=>qe.registerChannel("storage",$e));const Je=new P.LogLevelChannel(ge.get(c.ILogService));ve.registerChannel("logLevel",Je),Me.then(qe=>qe.registerChannel("logLevel",Je));const et=new P.LoggerChannel(ge.get(c.ILoggerService));ve.registerChannel("logger",et),Me.then(qe=>qe.registerChannel("logger",et));const nt=new De.ElectronExtensionHostDebugBroadcastChannel(ge.get(Y.IWindowsMainService));ve.registerChannel("extensionhostdebugservice",nt)}openFirstWindow(ge,ve){const Me=this.windowsMainService=ge.get(Y.IWindowsMainService),he=ge.get(r.IURLService),Ee=ge.get(Le.INativeHostMainService);this.lifecycleMainService.phase=2;const Se=[],Ie=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Ce=>{try{return{uri:ie.URI.parse(Ce),url:Ce}}catch(Ye){return null}}).filter(Ce=>{if(!Ce||this.shouldBlockURI(Ce.uri))return!1;const Ye=this.getWindowOpenableFromProtocolLink(Ce.uri);return Ye?(Se.push(Ye),!1):!0}),Pe=this,ke=this.environmentMainService;he.registerHandler({async handleURL(Ce,Ye){if(Pe.shouldBlockURI(Ce))return!0;const mt=Pe.getWindowOpenableFromProtocolLink(Ce);if(mt){const[lt]=Me.open({context:5,cli:Object.assign({},ke.args),urisToOpen:[mt],gotoLineMode:!0});return lt.focus(),!0}if(S.isMacintosh&&Me.getWindowCount()===0){const[lt]=Me.open({context:5,cli:Object.assign({},ke.args),forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ue.getRemoteAuthority)(Ce)});return await lt.ready(),he.open(Ce,Ye)}return!1}});const _e=this._register(new te.ActiveWindowManager({onDidOpenWindow:Ee.onDidOpenWindow,onDidFocusWindow:Ee.onDidFocusWindow,getActiveWindowId:()=>Ee.getActiveWindowId(-1)})),Fe=new g.StaticRouter(Ce=>_e.getActiveClientId().then(Ye=>Ce===Ye)),ze=new o.URLHandlerRouter(Fe),Ke=ve.getChannel("urlHandler",ze);he.registerHandler(new o.URLHandlerChannelClient(Ke)),this._register(new _.ElectronURLListener(Ie,he,Me,this.environmentMainService,this.productService));const Re=this.environmentMainService.args,Qe=global.macOpenFiles,$e=(0,le.isLaunchedFromCli)(process.env)?0:4,Je=Re._.length,et=!!Re["folder-uri"],nt=!!Re["file-uri"],qe=Re["skip-add-to-recently-opened"]===!0,at=Re.wait&&Re.waitMarkerFilePath?ie.URI.file(Re.waitMarkerFilePath):void 0,gt=Re.remote||void 0;return Se.length>0?Me.open({context:$e,cli:Re,urisToOpen:Se,gotoLineMode:!0,initialStartup:!0}):Re["new-window"]&&!Je&&!et&&!nt?Me.open({context:$e,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:qe,waitMarkerFileURI:at,initialStartup:!0,remoteAuthority:gt}):Qe.length&&!Je&&!et&&!nt?Me.open({context:1,cli:Re,urisToOpen:Qe.map(Ce=>this.getWindowOpenableFromPathSync(Ce)),noRecentEntry:qe,waitMarkerFileURI:at,initialStartup:!0}):Me.open({context:$e,cli:Re,forceNewWindow:Re["new-window"]||!Je&&Re["unity-launch"],diffMode:Re.diff,noRecentEntry:qe,waitMarkerFileURI:at,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:gt})}shouldBlockURI(ge){return!!(ge.authority===ee.Schemas.file&&S.isWindows&&D.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,Ve.mnemonicButtonLabel)((0,J.localize)(0,null)),(0,Ve.mnemonicButtonLabel)((0,J.localize)(1,null))],cancelId:1,message:(0,J.localize)(2,null,(0,Ve.getPathLabel)(ge.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,J.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(ge){if(!!ge.path){if(ge.authority===ee.Schemas.file)return{fileUri:ie.URI.file(ge.fsPath)};if(ge.authority===ee.Schemas.vscodeRemote){const ve=ge.path.indexOf(K.posix.sep,1);if(ve!==-1){const Me=ge.path.substring(1,ve),he=ge.path.substring(ve),Ee=ie.URI.from({scheme:ee.Schemas.vscodeRemote,authority:Me,path:he,query:ge.query,fragment:ge.fragment});return(0,ae.hasWorkspaceFileExtension)(he)?{workspaceUri:Ee}:{folderUri:Ee}}}}}getWindowOpenableFromPathSync(ge){try{if((0,R.statSync)(ge).isDirectory())return{folderUri:ie.URI.file(ge)};if((0,ae.hasWorkspaceFileExtension)(ge))return{workspaceUri:ie.URI.file(ge)}}catch(ve){}return{fileUri:ie.URI.file(ge)}}async afterWindowOpen(ge,ve){var Me;this.lifecycleMainService.phase=3;const he=ge.get(u.ITelemetryService);this._register(ve.onDidError(({type:Ie,details:Pe})=>{let ke;typeof Pe=="string"?ke=Pe:ke=`SharedProcess: crashed (detail: ${Pe.reason})`,(0,M.onUnexpectedError)(new Error(ke)),he.publicLog2("sharedprocesserror",{type:Ie,reason:typeof Pe!="string"?Pe==null?void 0:Pe.reason:void 0,visible:ve.isVisible()})}));const Ee=this.productService.win32MutexName;if(S.isWindows&&Ee)try{const Ie=j.__$__nodeRequire("windows-mutex").Mutex,Pe=new Ie(Ee);(0,Oe.once)(this.lifecycleMainService.onWillShutdown)(()=>Pe.release())}catch(Ie){this.logService.error(Ie)}D.protocol.registerHttpProtocol(ee.Schemas.vscodeRemoteResource,(Ie,Pe)=>{Pe({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})});const Se=ge.get(i.IUpdateService);(Se instanceof z.Win32UpdateService||Se instanceof W.LinuxUpdateService||Se instanceof $.DarwinUpdateService)&&Se.initialize(),(0,y.resolveShellEnv)(this.logService,this.environmentMainService.args,process.env);try{const Pe=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,st.stripComments)(Pe))["enable-crash-reporter"]===void 0){const _e=(Me=this.configurationService.getValue("telemetry.enableCrashReporter"))!==null&&Me!==void 0?Me:!0,Fe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${_e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,Be.generateUuid)()}"`,"}"],ze=Pe.substring(0,Pe.length-2).concat(`,
`,Fe.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,it.VSBuffer.fromString(ze))}}catch(Ie){this.logService.error(Ie)}}stopTracingEventually(ge,ve){this.logService.info("Tracing: waiting for windows to get ready...");const Me=ge.get(We.IDialogMainService);let he=!1;const Ee=async Ie=>{if(!he){he=!0;const Pe=await D.contentTracing.stopRecording((0,G.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Ie?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Pe}`):Me.showMessageBox({type:"info",message:(0,J.localize)(4,null),detail:(0,J.localize)(5,null,Pe),buttons:[(0,J.localize)(6,null)]},(0,Ne.withNullAsUndefined)(D.BrowserWindow.getFocusedWindow()))}},Se=setTimeout(()=>Ee(!0),3e4);Promise.all(ve.map(Ie=>Ie.ready())).then(()=>{clearTimeout(Se),Ee(!1)})}};ot=ce([Z(2,b.IInstantiationService),Z(3,c.ILogService),Z(4,s.IEnvironmentMainService),Z(5,n.ILifecycleMainService),Z(6,t.IConfigurationService),Z(7,l.IStateService),Z(8,Ge.IFileService),Z(9,F.IProductService)],ot),e.CodeApplication=ot}),define(X[240],Q([0,1,11,22,12,3,93,53,155,18,33,56,167,70,67,6,190,38,24,182,40,222,234,39,92,91,19,73,43,72,188,192,171,173,9,16,55,220,17,30,20,8,34,26,66,95,176,35,54,179,198]),function(j,e,v,R,D,S,k,n,y,i,L,g,E,w,d,m,b,p,a,c,l,s,t,r,o,u,h,f,I,A,F,U,q,Y,ie,ae,V,N,z,W,$,C,P,M,_,T,O,B,K,G){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class J{main(){try{this.startup()}catch(x){console.error(x.message),v.app.exit(1)}}async startup(){(0,h.setUnexpectedErrorHandler)(we=>console.error(we));const[x,ne,oe,ue,ye,me,de]=this.createServices();try{try{await this.initServices(oe,ue,ye)}catch(we){throw this.handleStartupDataDirError(oe,de.nameLong,we),we}await x.invokeFunction(async we=>{const De=we.get(m.ILogService),Le=we.get(i.ILifecycleMainService),We=we.get(ae.IFileService),Ne=await this.doStartup(De,oe,Le,x,de,!0);return me.logger=new o.SpdLogLogger("main",(0,C.join)(oe.logsPath,"main.log"),!0,me.getLevel()),(0,I.once)(Le.onWillShutdown)(()=>{We.dispose(),ue.dispose()}),x.createInstance(t.CodeApplication,Ne,ne).startup()})}catch(we){x.invokeFunction(this.quit,we)}}createServices(){const x=new w.ServiceCollection,ne=Object.assign({_serviceBrand:void 0},k.default);x.set(z.IProductService,ne);const oe=new M.EnvironmentMainService(this.resolveArgs(),ne),ue=this.patchEnvironment(oe);x.set(M.IEnvironmentMainService,oe);const ye=new u.BufferLogService,me=new m.MultiplexLogService([new m.ConsoleMainLogger((0,m.getLogLevel)(oe)),ye]);process.once("exit",()=>me.dispose()),x.set(m.ILogService,me);const de=new q.FileService(me);x.set(ae.IFileService,de);const we=new Y.DiskFileSystemProvider(me);de.registerProvider(ie.Schemas.file,we),x.set(m.ILoggerService,new O.LoggerService(me,de));const De=new c.ConfigurationService(oe.settingsResource,de);x.set(a.IConfigurationService,De),x.set(i.ILifecycleMainService,new d.SyncDescriptor(i.LifecycleMainService));const Le=new b.StateService(oe,me);return x.set(p.IStateService,Le),x.set(l.IRequestService,new d.SyncDescriptor(s.RequestMainService)),x.set(f.IThemeMainService,new d.SyncDescriptor(f.ThemeMainService)),x.set(A.ISignService,new d.SyncDescriptor(F.SignService)),x.set(V.ITunnelService,new d.SyncDescriptor(N.TunnelService)),x.set(K.IProtocolMainService,new d.SyncDescriptor(G.ProtocolMainService)),[new E.InstantiationService(x,!0),ue,oe,De,Le,ye,ne]}patchEnvironment(x){const ne={VSCODE_IPC_HOOK:x.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(oe=>{const ue=process.env[oe];typeof ue=="string"&&(ne[oe]=ue)}),Object.assign(process.env,ne),ne}initServices(x,ne,oe){const ue=Promise.all([x.extensionsPath,x.nodeCachedDataDir,x.logsPath,x.globalStorageHome.fsPath,x.workspaceStorageHome.fsPath,x.backupHome].map(de=>de?R.promises.mkdir(de,{recursive:!0}):void 0)),ye=ne.initialize(),me=oe.init();return Promise.all([ue,ye,me])}async doStartup(x,ne,oe,ue,ye,me){let de;try{de=await(0,g.serve)(ne.mainIPCHandle),(0,I.once)(oe.onWillShutdown)(()=>de.dispose())}catch(we){if(we.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ne,ye.nameLong,we),we;let De;try{De=await(0,g.connect)(ne.mainIPCHandle,"main")}catch(Ne){if(!me||S.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,D.localize)(0,null,ye.nameShort),(0,D.localize)(1,null),ye.nameLong),Ne;try{(0,R.unlinkSync)(ne.mainIPCHandle)}catch(Ve){throw x.warn("Could not delete obsolete instance handle",Ve),Ve}return this.doStartup(x,ne,oe,ue,ye,!1)}if(ne.extensionTestsLocationURI&&!ne.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw x.error(Ne),De.dispose(),new Error(Ne)}let Le;!ne.args.wait&&!ne.args.status&&(Le=setTimeout(()=>{this.showStartupWarningDialog((0,D.localize)(2,null,ye.nameShort),(0,D.localize)(3,null),ye.nameLong)},1e4));const We=L.ProxyChannel.toService(De.getChannel("launch"),{disableMarshalling:!0});if(ne.args.status)return ue.invokeFunction(async()=>{const Ne=new U.DiagnosticsService(T.NullTelemetryService,ye),Ve=await We.getMainProcessInfo(),xe=await We.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),Xe=await Ne.getDiagnostics(Ve,xe);throw console.log(Xe),new h.ExpectedError});throw S.isWindows&&await this.windowsAllowSetForegroundWindow(We,x),x.trace("Sending env to running instance..."),await We.start(ne.args,process.env),De.dispose(),Le&&clearTimeout(Le),new h.ExpectedError("Sent env to running instance. Terminating...")}if(ne.args.status)throw x.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),de}handleStartupDataDirError(x,ne,oe){if(oe.code==="EACCES"||oe.code==="EPERM"){const ue=(0,P.coalesce)([x.userDataPath,x.extensionsPath,g.XDG_RUNTIME_DIR]).map(ye=>(0,r.getPathLabel)(ye,x));this.showStartupWarningDialog((0,D.localize)(4,null),(0,D.localize)(5,null,(0,_.toErrorMessage)(oe),ue.join(`
`)),ne)}}showStartupWarningDialog(x,ne,oe){v.dialog.showMessageBoxSync({title:oe,type:"warning",buttons:[(0,r.mnemonicButtonLabel)((0,D.localize)(6,null))],message:x,detail:ne,noLink:!0})}async windowsAllowSetForegroundWindow(x,ne){if(S.isWindows){const oe=await x.getMainProcessId();ne.trace("Sending some foreground love to the running instance:",oe);try{(await new Promise((ue,ye)=>{j(["windows-foreground-love"],ue,ye)})).allowSetForegroundWindow(oe)}catch(ue){ne.error(ue)}}}quit(x,ne){const oe=x.get(m.ILogService),ue=x.get(i.ILifecycleMainService);let ye=0;ne&&(ne.isExpected?ne.message&&oe.trace(ne.message):(ye=1,ne.stack?oe.error(ne.stack):oe.error(`Startup error: ${ne.toString()}`))),ue.kill(ye)}resolveArgs(){const x=this.validatePaths((0,n.parseMainProcessArgv)(process.argv));if(x.wait&&!x.waitMarkerFilePath){const ne=(0,y.createWaitMarkerFile)(x.verbose);ne&&((0,n.addArg)(process.argv,"--waitMarkerFilePath",ne),x.waitMarkerFilePath=ne)}return x}validatePaths(x){if(x["open-url"]&&(x._urls=x._,x._=[]),!x.remote){const ne=this.doValidatePaths(x._,x.goto);x._=ne}return x}doValidatePaths(x,ne){const oe=(0,B.cwd)(),ue=x.map(de=>{let we=String(de),De;ne&&(De=(0,W.parseLineAndColumnAware)(we),we=De.path),we&&(we=this.preparePath(oe,we));const Le=(0,W.sanitizeFilePath)(we,oe),We=(0,C.basename)(Le);return We&&!(0,W.isValidBasename)(We)?null:ne&&De?(De.path=Le,this.toPath(De)):Le}),ye=S.isWindows||S.isMacintosh,me=(0,P.distinct)(ue,de=>de&&ye?de.toLowerCase():de||"");return(0,P.coalesce)(me)}preparePath(x,ne){return S.isWindows&&(ne=(0,$.rtrim)(ne,'"')),ne=(0,$.trim)((0,$.trim)(ne," "),"	"),S.isWindows&&(ne=(0,C.resolve)(x,ne),ne=(0,$.rtrim)(ne,".")),ne}toPath(x){const ne=[x.path];return typeof x.line=="number"&&ne.push(String(x.line)),typeof x.column=="number"&&ne.push(String(x.column)),ne.join(":")}}new J().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/0640cdeb8ba34f2f00cf4de73783632c4a692c52/core/vs/code/electron-main/main.js.map
